/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.jdcm.charts;
import java.io.Serializable;
import java.awt.Shape;

/**
 * Mesure is a mesurement in 2D or 3D
 */
public class Mesure implements Serializable {
// for serializable interface
    private static final long serialVersionUID = 1L;
    private double valeur = -1;
    private java.awt.geom.Point2D point = null;
    /**
     * the comment value for a mesurment
     */
    public String tag = null;
    /**
     * the displayed shape for this value (point/square/...)
     */
    public Shape shape = null;
    public java.awt.Color color=null;
    private Object Parent=null;

    /**
     *Create a new 2D mesure
     * @param x value of the mesurment
     * @param y value of the mesurment
     * @param comment the tag for this value
     */
    public Mesure(double x, double y, String comment) {
        //   position = x;
        point = new java.awt.geom.Point2D.Double(x, 0.0);
        valeur = y;
        tag = comment;

    }

    /**
     * Create a new 3D mesure
     * @param x value of the mesurment
     * @param y value of the mesurment
     * @param z value of the mesurment
     * @param comment the tag for this value
     */
    public Mesure(double x, double y, double z, String comment) {
        point = new java.awt.geom.Point2D.Double(x, y);
        valeur = z;
        tag = comment;

    }
    /**
     * assign a donnees a list of mesurement for add(/remove?)
     * @param p
     */
    public void settParent(Object p){
        Parent=p;
    }
    /**
     *return the y (or zif 3D ) value of this mesurment
     * @return the z value for this mesurement
     */
    public double getval() {
        return valeur;
    }

    /**
     * set a new value for the mesument
     * @param val
     */
    public void setval(double val) {
        valeur = val;
    }

    /**
     * for 2D, return the x position of the mesurement
     * @return the abciss of this mesurment
     */
    public double getposition() {
        return point.getX();
    }

    /**
     * for 2D, change(?) the x position of the mesurement
     * @param val the new abciss value of this mesurment
     */
    public void setposition(double val) {
        point = new java.awt.geom.Point2D.Double(val, 0.0);
    }

    /**
     * for 3D, get the point of this mesurment
     * @return the new point for this mesurment
     */
    public java.awt.geom.Point2D getpoint() {
        return point;
    }

    /**
     * for 3D, change(?) the point of this mesurment
     * @param valx the x value of the point
     * @param valy the y value of this point
     */
    public void setpoint(double valx, double valy) {
        point = new java.awt.geom.Point2D.Double(valx, valy);
        if (Parent instanceof Donnees){
            ((Donnees)Parent).mesure_update();
        }
    }
}