/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jdcm.common;

import java.awt.event.MouseEvent;
import javax.swing.JButton;
import java.util.ArrayList;

/**
 * Propose buton that allow multiple states
 * state is changed by click
 * 
 * @author Marc GIBOIN
 */
public class G_JRollingButton extends JButton {
    private static final long serialVersionUID = 1L;
    ArrayList<Object> displs = new ArrayList<>();
    ArrayList<Object> values = new ArrayList<>();

    public G_JRollingButton() {
        super();
        setText("");
       // for (java.awt.event.MouseListener m:this.getMouseListeners()){
       //    this.removeMouseListener(m);
        // Recuperer les "on mouse over et overwrite le mouse Realese
       // }
        addMouseListener(new java.awt.event.MouseAdapter()  {

            @Override
            public void mouseReleased(MouseEvent e) {
                followingItem(e);
                fireActionPerformed(new java.awt.event.ActionEvent(e.getSource(), 0, "sent by "));
            }
        });

        addValuedItem((new D_Utils()).getIcon("elevation_on.gif"), null);
    }

    public int getsize() {
        return displs.size();
    }

    private void displayIndex(int idx) {
        if (displs.get(idx) instanceof javax.swing.Icon) {
            this.setIcon((javax.swing.Icon) displs.get(idx));
            this.setText("");
        } else {
            this.setText(displs.get(idx).toString());
            this.setIcon(null);
        }
    }


    public void followingItem(java.awt.event.MouseEvent evt) {

        int idx = getindex();
        //ifnotfound=>-1=> 0
        if (displs.isEmpty()) {
            return;
        }
        if (evt!=null){
            if (evt.getButton()==java.awt.event.MouseEvent.BUTTON1){
                idx++;
            }else{
                idx--;
            }
        }
        if (idx >= displs.size()) {
            idx = 0;
        }else if (idx<0){
            idx=displs.size()-1;
        }
        displayIndex(idx);
    }

    public final void addValuedItem(Object item, Object val) {
        if (item == null) {
            return;
        } else if (displs.indexOf(item) != -1 || values.indexOf(val) != -1) {
            return;
        }
        if (displs.size() == 1 && values.get(0) == null) {
            values.clear();
            displs.clear();
        }
        displs.add(item);
        values.add(val);
        if (displs.size() == 1) {
            followingItem(null);
        }
    }
    public void setValue(Object val){
        int idx=values.indexOf(val);
        if (idx>=0){
            displayIndex(idx);
        }
    }
    private int getindex() {
        Object o = this.getIcon();
        if (o == null) {
            o = this.getText();
        }
        return displs.indexOf(o);
    }

    public Object getValue() {
        int idx = getindex();
        if (idx < 0) {
            return null;
        } else {
            return values.get(idx);
        }
    }
}
