package com.jdcm.common;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Color;

/**
 * an edge to be displayed and resize a frame (here a for options)
 *
 * @author Marc GIBOIN
 */
public class G_coinBorder implements javax.swing.border.Border {

    protected int thickness;
    protected Color BorderColor;
    // java.awt.Window WBorderHook;
    boolean isresising = false;
    Float op = 1.0f;

    public G_coinBorder(Color color, int thick) {
        thickness = thick;
        BorderColor = color;
    }

    public void setResize(boolean bool) {
        isresising = bool;
    }

    public boolean isResize() {
        return isresising;
    }

    @Override
    public void paintBorder(Component c, Graphics g, int x, int y, int width, int height) {
        g.setColor(BorderColor);
        if (g instanceof java.awt.Graphics2D) {
            java.awt.Stroke defaultStroke = ((java.awt.Graphics2D) g).getStroke();
            ((java.awt.Graphics2D) g).setStroke(new java.awt.BasicStroke(thickness));
            /*   ((java.awt.Graphics2D) g).setStroke(
             new java.awt.BasicStroke(thickness, java.awt.BasicStroke.CAP_ROUND,
             java.awt.BasicStroke.JOIN_BEVEL,1.0f, new float[]{10.0f,10.0f},0.0f));*/
            g.drawRect(x, y, width - 1, height - 1);
            ((java.awt.Graphics2D) g).setStroke(defaultStroke);
        }
    }

    @Override
    public Insets getBorderInsets(Component c) {
        return new Insets(thickness, thickness, thickness, thickness);
    }

    @Override
    public boolean isBorderOpaque() {
        return true;
    }
}
