/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jdcm.editors;

import com.jdcm.eltrx.C_Main;
import com.jdcm.eltrx.C_Port;
import com.jdcm.eltrx.C_Stack;
import java.awt.event.ActionEvent;

/**
 *
 * @author MGiboin
 */
public class B_CAP_replay extends javax.swing.JPanel implements I_ObjectReceiver {
    
     private static final long serialVersionUID = 1L;
      private final javax.swing.JCheckBoxMenuItem menuLog = new javax.swing.JCheckBoxMenuItem("Log");
    private C_Port Parent = null;
    private C_Stack stack = null;
    C_Main main = null;
    C_Port portLTCP;
    C_Port portTRC;
   

    /**
     * Creates new form B_ETH_replay
     */
    public B_CAP_replay() {
        initComponents();
        jCB_ObjectEditor1.setValue((new com.jdcm.common.D_Utils()).getFile("255byte.cap", "traces"));
        this.setName("CAPTURE REPLAY");
    }

    public java.awt.Image getIcon() {
        return (new com.jdcm.common.D_Utils()).getImage("dir_bidir.gif");
    }

    public java.util.List<javax.swing.JMenuItem> getMenus() {
        java.util.List<javax.swing.JMenuItem> items = new java.util.ArrayList<>();
        final javax.swing.JMenuItem item0 = new javax.swing.JMenuItem("Objectif");
        item0.setActionCommand("?");
        item0.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String txt = "repete un conversation précédement enregistrée (format CAP)\r\n"
                        + "transmet les trames d'un équipement de la conversation\r\n"
                        + "cet équipement est défini par role (adresse MAC)"
                        + "attend une réponse a la lecture d'une trame d'un autre équipement\r\n"
                        + "Aucune doc de référence n'est réalisée à ce jour";
                javax.swing.JOptionPane.showMessageDialog(null, txt, "Objectif", javax.swing.JOptionPane.INFORMATION_MESSAGE);
            }
        });
        menuLog.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                setLogs(menuLog.isSelected());
            }
        });
        items.add(item0);
        items.add(menuLog);
        menuLog.setActionCommand("?");
        menuLog.setEnabled(true);
        return items;
    }

    private void setStart(boolean bool) {
        Object ob = jCB_ObjectEditor1.getValue();
        if (jToggleButton1.isSelected() != bool) {
            jToggleButton1.setSelected(bool);
        }
        java.io.File file = null;
        if (ob instanceof java.io.File) {
            file = (java.io.File) ob;
        }
        if (file == null || file.canRead() == false) {
            if (jToggleButton1.isSelected()) {
                setStart(false);
            }
            return;
        }
        stack.setStack_Enabled(bool);
        if (bool) {
            portLTCP = (C_Port) main.addCX("Port", "LTCP", "IPL4");
            portLTCP.setTCP_Listner(true);
            portLTCP.setTCP_Port(jTextField1.getText());
            portTRC = (C_Port) main.addCX("Port", "FILE", "File");
            portTRC.setFile_addr(file);
            portTRC.setFile_read(true);
            portTRC.setFile_write(false);
            portTRC.setFile_EOFstop(false);
            try {
                stack.addStack("FILE", "DESC", "anal", 4.0);
                com.jdcm.modifiers.stacks.Stack_DESC desc = (com.jdcm.modifiers.stacks.Stack_DESC) stack.getTarget(portTRC, "anal");
                desc.setfrommedia(false);
                desc.setDESC_Protofirst("Dump.xml");
                desc.setDESC_Protolast("ETHII.xml");
                desc.setDESC_sendas("as_buffer");
                desc.setDESC_TIT(true);
                desc.setDESC_TITval(100);
                if (jTextField2.getText().length() > 0) {
                    desc.setDESC_fcond("ETHI.src");
                    desc.setDESC_WaitAnsw(true);
                    desc.setDESC_WaitLimit(true);
                    desc.setDESC_WaitLimitval(20000);
                    desc.setDESC_fcondval(jTextField2.getText().getBytes());
                } else {
                    desc.setDESC_fcond("-N/A-");
                    desc.setDESC_WaitAnsw(false);
                }
                desc.setDESC_fdata("ETHI.data");
                desc.setDESC_EOFstop(true);
                setLogs(menuLog.isSelected());
            } catch (Exception ex) {
            }

            portTRC.CXstart();
            portLTCP.CXstart();
        } else {
            if (portTRC != null) {
                portTRC.CXstop();
                portTRC.CXend();
                portTRC = null;
            }
            if (portLTCP != null) {
                portLTCP.CXstop();
                portLTCP.CXend();
                portLTCP = null;
            }

        }
    }

    private void setLogs(boolean bool) {
        if (portTRC == null || portTRC.getPortName().compareTo("FILE") != 0) {
            return;
        }
        if (bool) {
            if (stack.getTarget(portTRC, "log") == null) {
                try {
                    stack.addStack("FILE", "Log", "log", 5.0);
                    com.jdcm.modifiers.stacks.Stack_Log log = (com.jdcm.modifiers.stacks.Stack_Log) stack.getTarget(portTRC, "log");
                    log.setStack_Start(true);
                } catch (Exception ex) {
                }
            } else {
                com.jdcm.modifiers.stacks.Stack_Log log = (com.jdcm.modifiers.stacks.Stack_Log) stack.getTarget(portTRC, "log");
                log.setStack_Start(true);
            }
        } else {
            main.removeStack("log", portTRC.getIndex() + 1);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jToggleButton1 = new javax.swing.JToggleButton();
        jTextField1 = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();

        setMaximumSize(new java.awt.Dimension(500, 50));
        setMinimumSize(new java.awt.Dimension(350, 23));
        setPreferredSize(new java.awt.Dimension(350, 23));
        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.LINE_AXIS));

        jLabel1.setText("Role : ");
        add(jLabel1);
        add(jCB_ObjectEditor1);

        jToggleButton1.setText("Start");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        add(jToggleButton1);

        jTextField1.setText("148");
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jTextField1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                jTextField1KeyReleased(evt);
            }
        });
        add(jTextField1);

        jLabel2.setText("TCP : ");
        add(jLabel2);

        jTextField2.setText("%00:04");
        jTextField2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField2ActionPerformed(evt);
            }
        });
        add(jTextField2);
    }// </editor-fold>//GEN-END:initComponents

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        setStart(jToggleButton1.isSelected());
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jTextField1KeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextField1KeyReleased
        try {
            Integer.parseInt(jTextField1.getText());
        } catch (NumberFormatException ex) {
            jTextField1.setText("2000");
        }
    }//GEN-LAST:event_jTextField1KeyReleased

    private void jTextField2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextField2ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JToggleButton jToggleButton1;
    // End of variables declaration//GEN-END:variables

    @Override
    public void receiveObj(Object obj) {
        if (obj instanceof C_Port) {
            Parent = (C_Port) obj;
            main = ((C_Main) Parent.getMain());
            stack = (C_Stack) main.getCMDChilds("Stacks").get(0);
        } else if (obj instanceof String && obj.toString().compareTo("/CLOSE TALC/") == 0) {
            setStart(false);
            stack.setStack_Enabled(false);
        }
    }
}
