package com.jdcm.editors;

import com.jdcm.common.C_Packet;
import com.jdcm.common.D_Utils;
import com.jdcm.eltrx.*;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import javax.swing.event.ChangeEvent;
import javax.swing.tree.*;
import javax.swing.JDialog;
import javax.swing.TransferHandler;
import java.net.URLClassLoader;

/**
 * F_Object.java Created on 23 juillet 2007, 20:46
 *
 * Create / Edit / Display Java Objects<br>
 * TO SOLVE : pb WITH APPLET
 *
 * @author Marc GIBOIN
 */
public class F_Object extends javax.swing.JFrame {
    // the current describe object= initObj or superclass of init Object (in general tree)
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private Object Obj = null;
    private D_Debug TDeb;
    private D_Utils TUtils = new D_Utils();
    private F_Compile<Class<?>> compiler = null;
    private I_ObjectReceiver Parent;
    private javax.swing.table.DefaultTableModel emptymodel = new javax.swing.table.DefaultTableModel(
            new Object[0][0],
            new String[]{
        "Empty"
    });
    private com.jdcm.editors.ACE_ObjRenderer<Object> render = new com.jdcm.editors.ACE_ObjRenderer<>();
    private com.jdcm.editors.ACE_ObjEditor<Object> editor61 = new com.jdcm.editors.ACE_ObjEditor<>();
    private com.jdcm.editors.ACE_ObjEditor<Object> editor82 = new com.jdcm.editors.ACE_ObjEditor<>();
    private com.jdcm.editors.ACE_ObjEditor<Object> editor62 = new com.jdcm.editors.ACE_ObjEditor<>();
    private com.jdcm.editors.ACE_ObjEditor<Object> editor63 = new com.jdcm.editors.ACE_ObjEditor<>();
    private com.jdcm.editors.ACE_ObjEditor<Object> editor_detail = new com.jdcm.editors.ACE_ObjEditor<>(true, true);

    /**
     * Creates new form F_Object
     */
    public F_Object() {
        // Obj = "Exemple";
        TDeb = new D_Debug("Test : F_Object");
        initComponents();
        initialisation();
        this.setVisible(true);
    }

    /**
     * create the form for applet/sub form<br>
     * if isapplet then close do not exit system <br>
     *
     * @param isaplet if isApplet don't close...
     */
    public F_Object(boolean isaplet) {
        Obj = "";
        TDeb = new D_Debug("Test : F_Object");
        initComponents();
        initialisation();
        showObj();
        this.setVisible(isaplet == false);
        jButton5.setEnabled(isaplet == false);
    }

    public F_Object(Object obj) {
        TDeb = new D_Debug("Test : F_Object");
        initComponents();
        initialisation();
        if (obj instanceof Class<?>) {
            Obj = obj;
            seeclass();
        } else {
            Obj = obj;
            showObj();
        }
        findClass(obj);
        jSplitPane1.setLastDividerLocation(0);
        jSplitPane1.setDividerLocation(0.9);
        this.setVisible(true);

    }

    public F_Object(I_ObjectReceiver parent, Object obj) {
        Obj = obj;
        Parent = parent;
        /*------------Port is not an (GUI) Object recever!!! ----------
         * -----------------------BAD for debugging--------------------
         if (Parent != null && Parent instanceof C_Port) {
         C_Port port = (C_Port) Parent;
         TDeb = new D_Debug("F-Obj: [" + port.getIndex() + "]");
         TDeb.setconsole(port.getConsole());
         } else {*/
        TDeb = new D_Debug("Test : F_Object");
        // }
        initComponents();
        initialisation();
        showObj();
        findClass(obj);
        this.setVisible(true);
    }

    public static Object showDialog(java.awt.Window window, Object ob, boolean isedit) {
        final F_Object pane = new F_Object(ob);
        pane.setVisible(false);
        class ObjectDialog extends JDialog {

            private static final long serialVersionUID = 1L;

            public ObjectDialog(java.awt.Frame w) {
                super(w, "Object", true);
                init();
            }

            public ObjectDialog(java.awt.Dialog w) {
                super(w, "Object", true);
                init();

            }

            private void init() {
                setRootPane(pane.getRootPane());
                setBounds(pane.getBounds());
            }
        }
        ObjectDialog dialogbox;
        if (window instanceof java.awt.Frame) {
            //     System.out.println("==> old frame");
            dialogbox = new ObjectDialog((java.awt.Frame) window);
        } else if (window instanceof java.awt.Dialog) {
            //     System.out.println("==> old dialog");
            dialogbox = new ObjectDialog((java.awt.Dialog) window);
        } else {
            //    System.out.println("==> new frame");
            dialogbox = new ObjectDialog(new java.awt.Frame());
        }
        // if alwaysOnTop => Pb with Popup...
        //      dialogbox.setAlwaysOnTop(false);
        // dialogbox.setUndecorated(true);
        ObjectTracker otr = new ObjectTracker(pane, dialogbox);
        pane.activeDialog(otr, isedit);
        dialogbox.setVisible(true);
        return otr.getObject();
    }

    private void activeDialog(ObjectTracker ok, boolean isediting) {
        if (isediting) {
            jButton1.setActionCommand("Dialog_objOK");
            jButton6.setActionCommand("Dialog_serOK");
            jButton1.addActionListener(ok);
            jButton6.addActionListener(ok);

        }
        jButton1.setEnabled(isediting);
        jButton6.setEnabled(isediting);
    }

    private void initialisation() {
        if (javax.swing.JFrame.getOwnerlessWindows().length == 1) {
            this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        }
        setMethRes(true);
        Array2tree(java.lang.Package.getPackages(), "Package");
        jToggleButton1.setIcon(TUtils.getIcon("compile.gif"));
        jToggleButton2.setIcon(TUtils.getIcon("package.gif"));
        jToggleButton2.setSelectedIcon(TUtils.getIcon("Class.gif"));
        jButton18.setIcon(TUtils.getIcon("refresh.gif"));
        jButton21.setIcon(TUtils.getIcon("Object.gif"));
        jButton1.setIcon(TUtils.getIcon("Send_obj.gif"));
        jButton3.setIcon(TUtils.getIcon("build_on.gif"));
        jButton6.setIcon(TUtils.getIcon("Send_ser.gif"));
        jButton7.setIcon(TUtils.getIcon("ser2obj.gif"));
        jButton2.setIcon(TUtils.getIcon("usb.gif"));
        jButton11.setIcon(TUtils.getIcon("Open.gif"));
        jButton17.setIcon(TUtils.getIcon("buildarray.gif"));
        jButton19.setIcon(TUtils.getIcon("seearray.gif"));
        jButton7.setEnabled(false);
        jComboBox1.setRenderer(render);
        jComboBox1.addItem(null);
        jComboBox1.addItem(new int[]{1});
        jComboBox1.addItem(new long[]{1L});
        jComboBox1.addItem(new byte[]{1});
        jComboBox1.addItem(new float[]{1.0F});
        jComboBox1.addItem(new double[]{1.0});
        jComboBox1.addItem(new char[]{'A'});
        jComboBox1.addItem(new java.util.Date(System.currentTimeMillis()));
        jComboBox1.addItem((new com.jdcm.common.D_Utils()).getIcon("Main_CX.gif"));
        jComboBox1.addItem((new com.jdcm.common.D_Utils()).getImage("JPanel.gif"));
        jTable3.setModel(new javax.swing.table.DefaultTableModel(new Object[][]{}, "Class;FileName".split(";")));
        // for defaults URL
        jCB_ObjectEditor1.setValue(new java.net.URLClassLoader(new java.net.URL[0]));//new java.net.URLClassLoader(getdefaultURLs()));
        setSourceLoader(false);
        jTree3.setCellRenderer(render);
        // ! care if editable => no Pop up
        jTree3.setCellEditor(new ACE_ObjEditor<>());
        jTree3.setEditable(true);
        jButton1.setEnabled(Parent != null);
        jButton6.setEnabled(Parent != null);
        jTable6.setTransferHandler(new com.jdcm.common.C_TransferHandler(TransferHandler.COPY) {
            // for serializable interface
            private static final long serialVersionUID = 1L;

            @Override
            public Object getDataToExport(java.awt.Component srccomp) {
                return getObject();
            }

            @Override
            public boolean setInportedData(Object transfered, java.awt.Component target) {
                if (transfered != null) {
                    setObject(transfered);
                }
                return true;
            }
        });
        setIconImage(TUtils.getImage("Obj_edit.gif"));
    }

    private boolean issourceloader() {
        return jToggleButton2.isSelected();
    }

    private boolean isautocreate() {
        return jCheckBox11.isSelected();
    }

    private void setSourceLoader(boolean bool) {
        if (bool != issourceloader()) {
            jToggleButton2.isSelected();
        }
        jCB_ObjectEditor1.setEnabled(bool);
        getclassestree();
        jTable3.setModel(new javax.swing.table.DefaultTableModel());
    }

    private URLClassLoader getURLLoader() {
        return (URLClassLoader) jCB_ObjectEditor1.getValue();
    }

    private void resize() {
        jSplitPane1.setDividerLocation(jSplitPane1.getHeight() - 50);
        jSplitPane3.setDividerLocation(jSplitPane3.getHeight() - 50);
    }

    private boolean isMethRes() {
        return jCheckBox10.isSelected();
    }

    private void setMethRes(boolean bool) {
        if (bool == isMethRes()) {
            jCheckBox10.setSelected(bool);
            //ShowMethods(Obj.getClass());
        }
        if (bool) {
            jSplitPane4.setDividerLocation(0.5);
        } else {
            jSplitPane4.setDividerLocation(1.0);
        }
    }

    private int getArraysize() {
        return (Integer) jSpinner1.getValue();
    }

    public Object getObject() {
        return Obj;
    }

    public byte[] getSerial() {
        if (jTable6.getColumn("Serial") != null) {
            int colidx = jTable6.getColumn("Serial").getModelIndex();
            if (jTable6.getValueAt(0, colidx) instanceof byte[]) {
                return (byte[]) jTable6.getValueAt(0, colidx);
            } else {
                TDeb.wri("No Serialiez Object for Dialogbox");
                return null;
            }
        } else {
            return null;
        }
    }

    public void setObject(Object o) {
        Obj = o;
        showObj();
        findClass(o);
    }
    // interface to redraw ...

    private void findClass(Object obj) {
        Class<?> c = null;
        if (obj == null) {
            return;
        } else if (obj instanceof Class<?>) {
            c = (Class<?>) obj;
        } else if (obj instanceof Object) {
            c = obj.getClass();
        }
        if (c != null && c.isArray() == false) {
            String[] names = c.getCanonicalName().split("\\.");
            javax.swing.tree.DefaultMutableTreeNode[] path = new javax.swing.tree.DefaultMutableTreeNode[names.length];
            path[0] = new javax.swing.tree.DefaultMutableTreeNode("[Packages]");
            for (int i = 0; i < path.length - 1; i++) {
                path[i + 1] = new javax.swing.tree.DefaultMutableTreeNode(names[i]);
            }
            javax.swing.tree.TreePath p = new javax.swing.tree.TreePath(path);
            //NOT WORKING :jTree2.setExpandsSelectedPaths(true);
            jTree2.setSelectionPath(p);

            //NOT WORKING :  jTree2.expandPath(p));
            searchClasses();
            for (int i = 0; i < jTable3.getRowCount(); i++) {
                if (jTable3.getValueAt(i, 0) != null) {
                    if (c.toString().compareTo(jTable3.getValueAt(i, 0).toString()) == 0) {
                        jTable3.setRowSelectionInterval(i, i);
                        javax.swing.JViewport viewport2 = this.jScrollPane8.getViewport();
                        java.awt.Rectangle rect2 = jTable3.getCellRect(i, 0, true);
                        java.awt.Point pos2 = rect2.getLocation();
                        viewport2.setViewPosition(pos2);
                    }
                }
            }
        }
    }

    public javax.swing.JPanel getPanel() {
        return null;
    }

    public void setBorder(javax.swing.border.Border createLineBorder) {
    }

    private java.lang.reflect.Member[] getmethods(Class<?> cl, Class<? extends java.lang.reflect.Member> type, boolean askedpubstatic) {
        java.util.List<java.lang.reflect.Member> list = new java.util.ArrayList<>();
        java.lang.reflect.Member[] src1 = null;
        java.lang.reflect.Member[] src2 = null;
        if (type == java.lang.reflect.Method.class) {
            src1 = cl.getMethods();
            src2 = cl.getDeclaredMethods();

            //src2=cl.getDeclaredMethods();
        } else if (type == java.lang.reflect.Constructor.class) {
            src1 = cl.getConstructors();
            src2 = cl.getDeclaredConstructors();
        } else if (type == java.lang.reflect.Field.class) {
            src1 = cl.getFields();
            src2 = cl.getDeclaredFields();
        }
        src1 = TUtils.addtab(src1, src2);
        for (java.lang.reflect.Member o : src1) {
            boolean isstat = java.lang.reflect.Modifier.isStatic(o.getModifiers());
            boolean ispub = java.lang.reflect.Modifier.isPrivate(o.getModifiers()) == false;
            if ((isstat && ispub) && askedpubstatic || (askedpubstatic == false && (isstat && ispub) == false)) {
                if (list.indexOf(o) < 0) {
                    list.add(o);
                }
            }
        }
        return list.toArray(new java.lang.reflect.Member[]{});
    }

    private void showObj() {
        cleardetails();
        if (Obj == null) {
            //?? enable table if no object ??
            jTable6.setModel(new javax.swing.table.DefaultTableModel(
                    new Object[][]{
                {"no class", null, null}
            },
                    new String[]{
                "Class", "Object", "Serial"
            }));
            jTable6.getColumn("Object").setCellRenderer(render);
            jTable6.getColumn("Object").setCellEditor(editor61);
            return;
        }
        String[] arr = Obj.getClass().getCanonicalName().split("\\.");
        java.util.List<String> path = java.util.Arrays.asList(arr);
        if (path.isEmpty() == false) {
            java.util.ArrayList<DefaultMutableTreeNode> nds = new java.util.ArrayList<>();
            Object o = jTree2.getModel().getRoot();
            javax.swing.tree.TreePath t = new javax.swing.tree.TreePath(new Object[]{o});
            for (int i = 0; i < path.size() - 1; i++) {
                for (int n = 0; n < jTree2.getModel().getChildCount(o); n++) {
                    if (((DefaultMutableTreeNode) jTree2.getModel().getChild(o, n)).getUserObject().toString().compareTo(path.get(i).toString()) == 0) {
                        o = jTree2.getModel().getChild(o, n);
                        t = t.pathByAddingChild(o);
                    }
                }
            }
            jTree2.setSelectionPath(t);
            jTree2.expandPath(t);
        }

        for (int i = 0; i < jTabbedPane1.getTabCount(); i++) {
            jTabbedPane1.setEnabledAt(i, true);
        }
        //  Array2tree(java.lang.Package.getPackages(),"Package");
        //  Array2tree(Obj.getClass().getConstructors(),"Constructor");
        //  Array2tree(Obj.getClass().getDeclaredConstructors(), "Constructor");
        jTree3.setModel(new javax.swing.tree.DefaultTreeModel(new DefaultMutableTreeNode(Obj)));
        Array2tree(Obj.getClass().getFields(), "Fields");
        Array2tree(Obj.getClass().getDeclaredFields(), "Decl-Fields");
        Array2tree(Obj.getClass().getMethods(), "Methods");
        Array2tree(Obj.getClass().getDeclaredClasses(), "Decl-Methods");
        Array2tree(Obj.getClass().getClasses(), "Classes");
        Array2tree(Obj.getClass().getDeclaredClasses(), "Decl-Classes");
        Array2tree(Obj.getClass().getInterfaces(), "Interfaces");
        Array2tree(Obj.getClass().getAnnotations(), "Annotations");
        Array2tree(Obj.getClass().getDeclaredAnnotations(), "Dec-Annot");
        Array2tree(Obj.getClass().getEnumConstants(), "EnumConstant");
        Array2tree(Obj.getClass().getSigners(), "Signers");
        DefaultMutableTreeNode obj = (DefaultMutableTreeNode) jTree3.getModel().getRoot();

        obj = addSuperClass(Obj.getClass(), obj);
        jTree3.setModel(new javax.swing.tree.DefaultTreeModel(obj));
        Array2tree(java.lang.Package.getPackages(), "Package");
        /*if isArray()
         *int max=java.lang.reflect.Array.getLength(Obj)-1;
         *if (max<0){
         */
        jSpinner1.setValue(0);
        if (Obj instanceof byte[]) {
            jButton7.setEnabled(true);
        } else {
            jButton7.setEnabled(false);
        }

        //?? enable table if no object ??
        jTable6.setModel(new javax.swing.table.DefaultTableModel(
                new Object[][]{
            {Obj.getClass(), Obj, null}
        },
                new String[]{
            "Class", "Object", "Serial"
        }));
        jTable6.getColumn("Object").setCellRenderer(render);
        jTable6.getColumn("Object").setCellEditor(editor61);
        jTable6.getColumn("Class").setCellRenderer(render);
        jTable6.getColumn("Class").setCellEditor(editor62);
        jTable6.getColumn("Serial").setCellRenderer(render);
        jTable6.getColumn("Serial").setCellEditor(editor63);
        jTable6.getColumn("Object").getCellEditor().addCellEditorListener(new javax.swing.event.CellEditorListener() {
            @Override
            public void editingStopped(ChangeEvent e) {
                SeeNewObj(null);
            }

            @Override
            public void editingCanceled(ChangeEvent e) {
            }
        });
        jTable6.enableInputMethods(true);
        MajSerial(Obj);
        //jList1.setModel(new javax.swing.DefaultListModel());
    }

    private void adjustrowheight() {
        int h = jScrollPane9.getHeight() - jTable6.getTableHeader().getHeight() - jSplitPane1.getDividerSize() + 7;
        if (h > 1) {
            jTable6.setRowHeight(h);
        }
        h = jScrollPane14.getHeight() - jTable8.getTableHeader().getHeight() - jSplitPane3.getDividerSize() + 7;
        if (h > 1) {
            jTable8.setRowHeight(h);
        }
    }

    public DefaultMutableTreeNode addSuperClass(Class<?> c, DefaultMutableTreeNode parent) {
        if (c == null) {
            return null;
        }
        Class<?> s = c.getSuperclass();
        if (s == null) {
            return parent;
        } else {
            DefaultMutableTreeNode node = new DefaultMutableTreeNode(s);
            node.add(parent);
            return addSuperClass(s, node);
        }
    }

    public void addPanel(javax.swing.JPanel p) {
        if (p == null) {
            return;
        }
        jTabbedPane1.add("CXPacket", p);
    }

    /**
     * extract all classes of an Object tree and display it implemented
     * interfaces the initial Object tree is Madatory
     */
    private void Interfaces2tree() {
        DefaultMutableTreeNode srcnode = ((DefaultMutableTreeNode) jTree2.getModel().getRoot());
        DefaultMutableTreeNode clnode = (DefaultMutableTreeNode) srcnode.getChildAt(0);
        DefaultMutableTreeNode intnode = (DefaultMutableTreeNode) srcnode.getChildAt(1);
        java.util.Enumeration<?> e = clnode.preorderEnumeration();//<DefaultMutableTreeNode>
        while (e.hasMoreElements()) {
            DefaultMutableTreeNode classenode = (DefaultMutableTreeNode) e.nextElement();
            if (classenode.getUserObject() instanceof Class<?>) {
                Class<?> cl = (Class<?>) classenode.getUserObject();
                for (Class<?> cli : cl.getInterfaces()) {
                    boolean searching = true;
                    for (int i = 0; searching && i < intnode.getChildCount(); i++) {
                        DefaultMutableTreeNode thechild = (DefaultMutableTreeNode) intnode.getChildAt(i);
                        if (thechild.getUserObject() == cli) {
                            thechild.add(new DefaultMutableTreeNode(cl));
                            searching = false;
                        }
                    }
                }
            }
        }
        jTree2.setModel(new javax.swing.tree.DefaultTreeModel(intnode));
        jTree2.repaint();
    }

    /**
     * extract all classes of an package tree (package or URL loader) and
     * display it from superclass the initial tree pakage (provider by
     * loader2tree or Package2tree is Madatory
     */
    private void Object2tree() {
        DefaultMutableTreeNode srcnode = ((DefaultMutableTreeNode) jTree2.getModel().getRoot()).getFirstLeaf();
        DefaultMutableTreeNode base, clnode, itfnode;
        jTable3.setModel(emptymodel);
        javax.swing.ImageIcon im = TUtils.getIcon("Classes.gif");
        im.setDescription("Classes");
        clnode = new DefaultMutableTreeNode(im);
        im = TUtils.getIcon("Interfaces.gif");
        im.setDescription("Interfaces");
        itfnode = new DefaultMutableTreeNode(im);
        base = new DefaultMutableTreeNode("[Object]");
        base.add(clnode);
        base.add(itfnode);
        jTree2.setModel(new javax.swing.tree.DefaultTreeModel(base));
        while (srcnode != null) {
            String packpath = "";
            //start to 1 to avoid root
            for (int i = 1; i < srcnode.getPath().length; i++) {
                packpath = packpath + srcnode.getPath()[i].toString() + "/";
            }
            if (packpath.endsWith("/")) {
                packpath = packpath.substring(0, packpath.length() - 1);
            }
            java.util.ArrayList<com.jdcm.common.C_textClass> cls = TUtils.getClasses(getURLLoader(), packpath);
            for (com.jdcm.common.C_textClass cl : cls) {
                Class<?> c = cl.getThisClasse();
                if (c != null) {//&&
                    DefaultMutableTreeNode node = new DefaultMutableTreeNode(c);
                    if (c.isInterface()) {
                        int pos = 0;
                        for (int j = 0; j < itfnode.getChildCount(); j++) {
                            Class<?> classes = (Class<?>) ((DefaultMutableTreeNode) itfnode.getChildAt(j)).getUserObject();
                            if (classes.getSimpleName().compareTo((c).getSimpleName()) < 0) {
                                pos++;
                            }
                        }
                        itfnode.insert(node, pos);
                    } else {
                        node = addSuperClass(c, node);
                        if (node != null) {
                            Object[] liste = node.getFirstLeaf().getUserObjectPath();
                            node = clnode;//(DefaultMutableTreeNode) jTree2.getModel().getRoot();
                            for (Object classe : liste) {
                                boolean searching = true;
                                for (int j = 0; searching && j < node.getChildCount(); j++) {
                                    if (((DefaultMutableTreeNode) node.getChildAt(j)).getUserObject() == classe) {
                                        node = (DefaultMutableTreeNode) node.getChildAt(j);
                                        searching = false;
                                    }
                                }
                                if (searching) {
                                    DefaultMutableTreeNode toadd = new DefaultMutableTreeNode(classe);
                                    int pos = 0;
                                    for (int j = 0; j < node.getChildCount(); j++) {
                                        Class<?> classes = (Class<?>) ((DefaultMutableTreeNode) node.getChildAt(j)).getUserObject();
                                        if (classes.getSimpleName().compareTo(((Class<?>) classe).getSimpleName()) < 0) {
                                            pos++;
                                        }
                                    }
                                    node.insert(toadd, pos);
                                    node = toadd;
                                }
                            }
                        }
                    }
                }
            }
            srcnode = srcnode.getNextLeaf();
        }
        jTree2.setCellRenderer(render);
        jTree2.repaint();

    }

    private void applyMethod() {
        Object o = jTable8.getValueAt(0, 1);
        javax.swing.tree.TreePath t = jTree3.getSelectionPath();
        if (t == null) {
            return;
        }

        DefaultMutableTreeNode n = (DefaultMutableTreeNode) t.getLastPathComponent();
        if (n == null) {
            return;
        }

        Object fnct = n.getUserObject();
        if (fnct == null) {
            return;
        }

        java.lang.reflect.Method c = (java.lang.reflect.Method) fnct;
        String methodname = c.getName();
        if (methodname.startsWith("is")) {
            methodname = "set" + methodname.substring(2);
        }

        if (methodname.startsWith("get")) {
            methodname = "set" + methodname.substring(3);
        }

        java.lang.Class<?> cla = null;
        if (o != null) {
            cla = o.getClass();
            if (o instanceof Boolean) {
                cla = boolean.class;
            }
        }

        try {
            c = Obj.getClass().getMethod(methodname, cla);
        } catch (NoSuchMethodException | SecurityException ex) {
            TDeb.wri("could not find methods : '" + methodname + "' in: " + Obj.toString());
            return;

        }
        try {
            c.invoke(Obj, o);
        } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
            TDeb.wri("could not invoke : '" + methodname + "' in: " + Obj.toString());
            return;
        }
        showObj();
    }

    private void Array2tree(Object[] fcts, String label) {
        String title = label;
        if (fcts == null || fcts.length == 0) {
            return;
        }
        javax.swing.tree.TreeModel m = jTree3.getModel();
        DefaultMutableTreeNode rt;
        if (m == null && Obj != null) {
            rt = new DefaultMutableTreeNode(Obj);
        } else if (m != null) {
            rt = (DefaultMutableTreeNode) m.getRoot();
        } else {
            rt = null;
        }
        String type = java.lang.reflect.Array.get(fcts, 0).getClass().getSimpleName();
        javax.swing.ImageIcon im;
        if (type.endsWith("ss")) {
            im = TUtils.getIcon(type + "es" + ".gif");
        } else if (fcts instanceof java.lang.annotation.Annotation[]) {
            im = TUtils.getIcon("Annotations.gif");
        } else {
            im = TUtils.getIcon(type + "s" + ".gif");
        }
        if (title.startsWith("Interfaces")) {
            im = TUtils.getIcon("Interfaces.gif");
        }
        title += "[" + java.lang.reflect.Array.getLength(fcts) + "]";
        if (im == null) {
            im = TUtils.getIcon("interrogation.gif");
        }
        im.setDescription(title);

        DefaultMutableTreeNode node = new DefaultMutableTreeNode(im);
        for (Object fct : fcts) {
            String name1 = fct.toString();
            if (fct instanceof java.lang.reflect.Member) {
                name1 = ((java.lang.reflect.Member) fct).getName();
            }
            String name2;
            int pos = 0;
            boolean isend = false;
            while (pos < node.getChildCount() && isend == false) {
                Object fct2 = ((DefaultMutableTreeNode) node.getChildAt(pos)).getUserObject();
                if (fct2 instanceof java.lang.reflect.Member) {
                    name2 = ((java.lang.reflect.Member) fct2).getName();
                } else {
                    name2 = node.getChildAt(pos).toString();
                }

                if (name2.toString().compareTo(name1) < 0) {
                    pos++;
                } else {
                    isend = true;
                }

            }
            node.insert(new DefaultMutableTreeNode(fct), pos);
        }

        rt.add(node);
        jTree3.setModel(new javax.swing.tree.DefaultTreeModel(rt));
        jTree3.repaint();
    }

    /**
     * invoke the selected function/constructor... mode=0=> on the display for
     * function with param[0] mode=1=>param table edited
     */
    private void Exec_Detail() {
        DefaultMutableTreeNode n = (DefaultMutableTreeNode) jTree3.getSelectionPath().getLastPathComponent();
        Object fnct = n.getUserObject();
        if (this.isMethRes()) {
            if (fnct instanceof java.lang.reflect.Method) {
                java.lang.reflect.Method m = (java.lang.reflect.Method) fnct;
                Object[] param = new Object[m.getParameterTypes().length];
                for (int i = 0; i < m.getParameterTypes().length; i++) {
                    param[i] = jTable1.getValueAt(i, 1);
                }

                try {
                    if (m.getGenericReturnType().toString().compareTo("null") != 0) {
                        Object res;

                        try {
                            res = m.invoke(Obj, param);
                        } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException th) {
                            res = th;
                            TDeb.wri("Pb while invoking " + m + " => " + th.getMessage());
                        } //catch (THrowable th2) {
                       //     res = th2;
                       // }
                        if (res == null) {
                            if (m.getReturnType() == void.class) {
                                jTable8.setValueAt(void.class, 0, 1);
                            } else {
                                jTable8.setValueAt("[" + m.getReturnType().getSimpleName() + "]=>null", 0, 1);
                            }
                        } else {
                            jTable8.setValueAt(res, 0, 1);
                        }

                    }

                } catch (SecurityException e) {
                    //  } catch (NoSuchMethodException e) {      e.printStackTrace();
                } catch (Exception e) {
                }
            }
            if (fnct instanceof java.lang.reflect.Constructor<?>) {
                java.lang.reflect.Constructor<?> c = (java.lang.reflect.Constructor<?>) fnct;
                Object[] param = new Object[c.getParameterTypes().length];
                for (int i = 0; i
                        < c.getParameterTypes().length; i++) {
                    param[i] = jTable1.getValueAt(i, 1);
                }

                try {
                    Obj = c.newInstance(param);
                } catch (SecurityException e) {
                    //  } catch (NoSuchMethodException e) {      e.printStackTrace();
                    return;
                } catch (IllegalAccessException | IllegalArgumentException | InstantiationException | InvocationTargetException e) {
                    return;
                }

                SeeNewObj(Obj);
                this.repaint();
            }

        }
        jTable1.setModel(emptymodel);
        jButton20.setEnabled(false);
    }

    private void selectDetail(javax.swing.tree.TreePath t) {
        if (t == null) {
            return;
        }

        DefaultMutableTreeNode n = (DefaultMutableTreeNode) t.getLastPathComponent();
        if (n == null) {
            return;
        }

        Object fnct = n.getUserObject();
        if (fnct == null) {
            return;
        }

        jTable1.setModel(emptymodel);
        String[] columns = null;
        Object[] val = null;
        if (fnct instanceof java.lang.reflect.Method) {
            java.lang.reflect.Method m = (java.lang.reflect.Method) fnct;
            if (isMethRes() && m.getParameterTypes().length > 0) {
                Object[][] modelobj = new Object[m.getParameterTypes().length][3];
                if (m.getName().startsWith("set") && m.getParameterTypes().length == 1) {
                    String fctname = null;
                    try {
                        fctname = "get" + m.getName().substring(3);
                        java.lang.reflect.Method meth;
                        try {
                            meth = Obj.getClass().getMethod(fctname, new Class<?>[0]);
                        } catch (NoSuchMethodException | SecurityException ex) {
                            meth = Obj.getClass().getMethod("is" + fctname.substring(3), new Class<?>[0]);
                        }

                        modelobj[0][1] = meth.invoke(Obj, new Object[0]);
                    } catch (NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                        TDeb.wri(fctname + "not available : " + ex);
                    }

                }
                for (int i = 0; i
                        < m.getParameterTypes().length; i++) {
                    modelobj[i][0] = m.getParameterTypes()[i].getName();
                    if (modelobj[i][1] == null) {
                        modelobj[i][1] = TUtils.createObj(m.getParameterTypes()[i]);
                    }

                    if (modelobj[i][1] == null) {
                        javax.swing.JButton b = new javax.swing.JButton();
                        final Class<?> btcl = m.getParameterTypes()[i];
                        b.addActionListener(new java.awt.event.ActionListener() {
                            @Override
                            public void actionPerformed(java.awt.event.ActionEvent event) {
                                F_Object f_Object = new F_Object(btcl);
                            }
                        });
                        b.setToolTipText(m.getParameterTypes()[i].getCanonicalName());
                        modelobj[i][1] = b;
                    }

                }

                jTable1.setModel(new javax.swing.table.DefaultTableModel(
                        modelobj, new String[]{"Type", "Value"}));
                jTable1.getColumn("Value").setCellRenderer(render);
                jTable1.getColumn("Value").setCellEditor(editor_detail);
            }

            columns = new String[]{"Name", "Result"};
            val = new Object[6];
            val[0] = m.getName();
            Object o;
            if (isMethRes()) {
                o = "Wait..";
            } else {
                o = "/";
            }
            if (Obj == null) {
                o = "N/A";
            }
            val[1] = o;
        }

        if (fnct instanceof java.lang.reflect.Field) {
            java.lang.reflect.Field f = (java.lang.reflect.Field) fnct;
            columns = new String[]{"Name", "Result"};
            try {
                val = new Object[]{f.getName(), f.get(Obj)};
            } catch (java.lang.IllegalAccessException ex) {
                TDeb.wri("No access for value" + ex.getMessage());
                columns = new String[]{"Exception"};
                val = new Object[]{ex};
            } catch ( IllegalArgumentException e) {//Throwable
                TDeb.wri("Pb getting value" + e.getMessage());
                columns = new String[]{"Exception"};
                val = new Object[]{e};
            }
        }

        if (fnct instanceof java.lang.annotation.Annotation) {
            java.lang.annotation.Annotation f = (java.lang.annotation.Annotation) fnct;
            columns = new String[]{"Name", "??"};
            val = new Object[]{fnct.toString(), "???"};
        }

        if (fnct instanceof java.lang.reflect.Constructor<?>) {
            java.lang.reflect.Constructor<?> c = (java.lang.reflect.Constructor<?>) fnct;

            if (isMethRes() && c.getParameterTypes().length > 0) {
                Object[][] model = new Object[c.getParameterTypes().length][3];
                for (int i = 0; i < c.getParameterTypes().length; i++) {
                    model[i][0] = c.getParameterTypes()[i].getName();
                    model[i][1] = TUtils.createObj(c.getParameterTypes()[i]);
                    model[i][2] = c.getParameterTypes()[i].getCanonicalName();
                }
                jTable1.setModel(new javax.swing.table.DefaultTableModel(model, new String[]{"Type", "Value"}));
                jTable1.getColumn("Value").setCellRenderer(render);
                jTable1.getColumn("Value").setCellEditor(editor_detail);
            }

            columns = new String[]{"Name"};
            val = new Object[]{c.getName()};
        }

        if (fnct instanceof Package) {
            Package p = (Package) fnct;
            columns = new String[]{"Name"};
            val = new Object[]{p.getName()};
        }

        if (fnct instanceof Class<?>) {
            Class<?> c = (Class<?>) fnct;
            columns = new String[]{"Name"};
            val = new Object[]{c.getName()};

        }
        if (val == null) {
            return;
        }

        Object[][] o = new Object[1][val.length];
        o[0] = val;
        jTable8.editingCanceled(null);
        jTable8.setModel(new javax.swing.table.DefaultTableModel(
                o, columns));
        try {
            jTable8.getColumn("Result").setCellRenderer(render);
            jTable8.getColumn("Result").setCellEditor(editor82);
            jTable8.getColumn("Result").getCellEditor().addCellEditorListener(new javax.swing.event.CellEditorListener() {
                @Override
                public void editingStopped(ChangeEvent e) {
                    applyMethod();
                }

                @Override
                public void editingCanceled(ChangeEvent e) {
                }
            });
        } catch (java.lang.IllegalArgumentException ex) {
            //when there is no "Result" columns
        }
        jButton20.setEnabled(true);
    }

    private void searchClasses() {
        if (jTree2.getSelectionPath() == null) {
            return;
        }
        Object[] o = jTree2.getSelectionPath().getPath();
        Object[][] modi;
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree2.getSelectionPath().getLastPathComponent();
        if (node != null && node.getUserObject() instanceof Class<?>) {
            java.util.ArrayList<Class<?>> classes = new java.util.ArrayList<>();
            java.util.Enumeration<?> e = node.preorderEnumeration();
            while (e.hasMoreElements()) {
                Class<?> cl = (Class<?>) ((DefaultMutableTreeNode) e.nextElement()).getUserObject();
                classes.add(cl);
            }
            modi = new Object[classes.size()][2];
            for (int i = 0; i < classes.size(); i++) {
                modi[i][0] = classes.get(i);
                modi[i][1] = classes.get(i).getName().substring(0, classes.get(i).getName().length() - classes.get(i).getSimpleName().length());
            }
        } else {
            String packpath = "";
            //start to 1 to avoid root
            for (int i = 1; i < o.length; i++) {
                packpath = packpath + o[i].toString() + ".";
            }
            if (packpath.endsWith(".")) {
                packpath = packpath.substring(0, packpath.length() - 1);
            }
            java.util.List<com.jdcm.common.C_textClass> res = TUtils.getClasses(getURLLoader(), packpath);
            modi = new Object[res.size()][2];
            int i = 0;
            for (com.jdcm.common.C_textClass cl : res) {
                modi[i][0] = cl;
                modi[i][1] = cl.getClassFile();
                i++;
            }
        }
        final Object[][] modifiers = modi;
        javax.swing.table.DefaultTableModel mod = new javax.swing.table.DefaultTableModel(
                modifiers, new Object[]{"Classes", "File"});
        jTable3.setModel(mod);
        jTable3.getColumn("Classes").setCellRenderer(render);
        // NOPT NEEDED and strange class copy on click!!!??
        //jTable3.getColumn("Classes").setCellEditor(new ACE_ObjEditor(false));
    }

    private void cleardetails() {
        jTree3.setModel(null);
        jTable8.setModel(emptymodel);
        jTable6.setModel(emptymodel);
        jTable1.setModel(emptymodel);
    }

    private void showclassDetails() {

        if (Obj instanceof Class<?> == false) {
            return;
        }
        Class<?> classe = (Class<?>) Obj;
        javax.swing.JTextPane j;
        jTable6.setModel(new javax.swing.table.DefaultTableModel(
                new Object[][]{{classe, classe.getSimpleName(), java.lang.reflect.Modifier.toString(classe.getModifiers())}},
                new String[]{"Class", "SimpleName", "Modifiers"}));
        jTable6.getColumn("Class").setCellRenderer(render);
        jTable6.getColumn("Class").setCellEditor(editor62);
        jButton6.setEnabled(false);
        jTree3.setModel(new javax.swing.tree.DefaultTreeModel(new DefaultMutableTreeNode(classe)));
        Array2tree(getmethods(classe, java.lang.reflect.Constructor.class, false), "Constructors");
        Array2tree(getmethods(classe, java.lang.reflect.Constructor.class, true), "Public-Static");
        //statics field/functions... java.utils.array.copyarray... ...
        Array2tree(getmethods(classe, java.lang.reflect.Field.class, false), "Fields");
        Array2tree(getmethods(classe, java.lang.reflect.Field.class, true), "Public-Static");
        Array2tree(getmethods(classe, java.lang.reflect.Method.class, false), "Methods");
        Array2tree(getmethods(classe, java.lang.reflect.Method.class, true), "Public-Static");
        Array2tree(classe.getClasses(), "Classes");
        Array2tree(classe.getDeclaredClasses(), "Decl-Class");
        Array2tree(classe.getInterfaces(), "Interfaces");
        Array2tree(classe.getAnnotations(), "Annotations");
        Array2tree(classe.getDeclaredAnnotations(), "Decl-Annot.");
        Array2tree(classe.getEnumConstants(), "EnumConstant");
        Array2tree(classe.getSigners(), "Signers");
        DefaultMutableTreeNode obj = (DefaultMutableTreeNode) jTree3.getModel().getRoot();
        obj = addSuperClass(classe, obj);
        jTree3.setModel(new javax.swing.tree.DefaultTreeModel(obj));
        Array2tree(java.lang.Package.getPackages(), "Package");
        jTree3.repaint();
        this.setMethRes(true);
    }

    private boolean setSelectedClass() {
        if (jTable3.getSelectedRow() == -1) {
            return false;
        }
        Object ob = jTable3.getValueAt(jTable3.getSelectedRow(), 0);
        if (ob instanceof Class<?>) {
            Obj = ((Class<?>) ob);
            return true;
        } else if (ob instanceof com.jdcm.common.C_textClass) {
            Obj = ((com.jdcm.common.C_textClass) ob).getThisClasse();
            return true;
        } else if (ob instanceof String) {
            Obj = ob.toString();
            return false;
        }
        return false;
    }

    private void seeclass() {
        if (Obj instanceof Class<?> == false) {
            return;
        }
        cleardetails();
        showclassDetails();
        for (int i = 0; i < 3; i++) {
            jTabbedPane1.setEnabledAt(i, true);
        }

    }

    private void MajSerial(Object Ob) {
        C_Packet p = new C_Packet(Ob, null);//-99!!!
        byte[] Obser = p.getSerial();
        if (Obser != null) {
            try {
                int colidx = jTable6.getColumn("Serial").getModelIndex();
                jTable6.setValueAt(Obser, 0, colidx);
                jButton6.setEnabled(jButton1.isEnabled());
            } catch (IllegalArgumentException ex) {
                TDeb.wri("column 'Serial' not found =>" + ex.getMessage());
            }
        } else {
            jButton6.setEnabled(false);
        }
    }
    /*
     *
     *Create an Object from the text
     *   this object will be modified in the Table
     *
     */

    private void EditNewObj() {
        cleardetails();
        Object NewObj = null;
        //setSelectedClass();

        if (Obj instanceof Class<?> == false) {
            return;
        }

//jList1.setModel(new javax.swing.DefaultListModel());
        if (isautocreate()) {
            NewObj = TUtils.createObj((Class<?>) Obj);
        } else {
            try {
                NewObj = ((Class) Obj).newInstance();
            } catch (java.lang.InstantiationException | java.lang.IllegalAccessException ex) {
            }
        }

        if (NewObj == null) {
            seeclass();
            return;

        }
        Obj = NewObj;
        SeeNewObj(Obj);
        this.repaint();
    }

    private void SeeNewObj(Object o) {
        if (o != null) {
            Obj = o;
            showObj();
        } else {
            Obj = jTable6.getValueAt(0, 1);
            MajSerial(Obj);
        }
    }
// should be replaced by ShowDialog
  /*  private void SendObj() {
     //for arrays ...=> if (jTable6.getSelectedRow()==-1){return;}
     if (Obj != null && Parent != null) {
     Parent.read_in(new C_Packet(Obj, Parent.getIndex()));
     TDeb.wri("Object sended :" + Obj.toString());
     }
     }
     */

    /**
     * FilenameFilter filter = new FilenameFilter(){ public boolean accept(File
     * arg0, String arg1) { return arg1.endsWith(".class"); } };
     */
    private void getclassestree() {
        jTree2.setModel(null);
        if (issourceloader()) {
            jTree2.setModel(new DefaultTreeModel(TUtils.loader2tree(getURLLoader())));
        } else {
            jTree2.setModel(new DefaultTreeModel(Package2tree()));
        }
        jTree2.setCellRenderer(render);
        jTree2.repaint();
    }

    public DefaultMutableTreeNode Package2tree() {
        // add a new package ref (java.awt....) for packagelist? in the tree?
        // if not loaded before : ext are not includes !!
        // getJars()=> file.jar array=> see all javax.com....
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("[Packages]");
        Package[] p = java.lang.Package.getPackages();
        if (p == null || p.length == 0) {
            return null;
        }
        for (Package p1 : p) {
            String name = p1.getName();
            String[] str = name.split("\\.");
            DefaultMutableTreeNode act = root;
            for (String str1 : str) {
                boolean searching = true;
                for (int j = 0; searching && j < act.getChildCount(); j++) {
                    if (act.getChildAt(j).toString().compareTo(str1) == 0) {
                        act = (DefaultMutableTreeNode) act.getChildAt(j);
                        searching = false;
                    }
                }
                if (searching) {
                    // create a new node and insert it
                    DefaultMutableTreeNode node1 = new DefaultMutableTreeNode(new com.jdcm.common.C_textPackage(str1.toString()));
                    if (act.getChildCount() == 0) {
                        act.add(node1);
                    } else {
                        int point = 0;
                        while (act.getChildAt(point).toString().compareTo(node1.toString()) < 0 && point != act.getChildCount() - 1) {
                            point++;
                        }

                        if (point == act.getChildCount() - 1) {
                            act.add(node1);
                        } else {
                            act.insert(node1, point);
                        }
                    }
                    act = node1;
                }
            }
        }
        return root;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jPopupMenu3 = new javax.swing.JPopupMenu();
        jMenuItem3 = new javax.swing.JMenuItem();
        jToolBar1 = new javax.swing.JToolBar();
        jToggleButton1 = new javax.swing.JToggleButton();
        jButton1 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jButton18 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jCheckBox11 = new javax.swing.JCheckBox();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        jSpinner1 = new javax.swing.JSpinner();
        jButton17 = new javax.swing.JButton();
        jButton19 = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        jButton21 = new javax.swing.JButton();
        jToggleButton2 = new javax.swing.JToggleButton();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel9 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel10 = new javax.swing.JPanel();
        jSplitPane2 = new javax.swing.JSplitPane();
        jScrollPane8 = new javax.swing.JScrollPane();
        jTable3 = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTree2 = new javax.swing.JTree();
        jPanel11 = new javax.swing.JPanel();
        jScrollPane9 = new javax.swing.JScrollPane();
        jTable6 = new javax.swing.JTable();
        jPanel7 = new javax.swing.JPanel();
        jSplitPane3 = new javax.swing.JSplitPane();
        jScrollPane14 = new javax.swing.JScrollPane();
        jTable8 = new javax.swing.JTable();
        jSplitPane4 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTree3 = new javax.swing.JTree();
        jPanel5 = new javax.swing.JPanel();
        jButton20 = new javax.swing.JButton();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jButton10 = new javax.swing.JButton();
        jButton16 = new javax.swing.JButton();
        jButton13 = new javax.swing.JButton();
        jButton15 = new javax.swing.JButton();
        jButton14 = new javax.swing.JButton();
        jComboBox1 = new javax.swing.JComboBox<>();
        jPanel1 = new javax.swing.JPanel();
        jButton2 = new javax.swing.JButton();
        jButton11 = new javax.swing.JButton();
        jCheckBox10 = new javax.swing.JCheckBox();
        jButton9 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();

        jMenuItem1.setText("View Result");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem1);

        jMenuItem2.setText("set result");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem2);

        jMenuItem3.setText("Array element");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jPopupMenu3.add(jMenuItem3);

        setTitle("Object Browser");
        setMinimumSize(new java.awt.Dimension(321, 124));
        setPreferredSize(new java.awt.Dimension(550, 250));
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });

        jToolBar1.setRollover(true);

        jToggleButton1.setToolTipText("Compile");
        jToggleButton1.setBorderPainted(false);
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton1);

        jButton1.setToolTipText("Send Obj");
        jButton1.setBorderPainted(false);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jButton6.setToolTipText("Send Ser.");
        jButton6.setBorderPainted(false);
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton6);

        jButton18.setToolTipText("Refresh");
        jButton18.setBorderPainted(false);
        jButton18.setFocusable(false);
        jButton18.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton18.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton18.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton18ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton18);

        jButton7.setToolTipText("Ser2Obj");
        jButton7.setBorderPainted(false);
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton7);

        jButton3.setToolTipText("Create");
        jButton3.setBorderPainted(false);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jCheckBox11.setSelected(true);
        jCheckBox11.setText("Auto");
        jCheckBox11.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox11.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jToolBar1.add(jCheckBox11);

        jSeparator2.setOpaque(true);
        jToolBar1.add(jSeparator2);

        jSpinner1.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(0), Integer.valueOf(0), null, Integer.valueOf(1)));
        jSpinner1.setToolTipText("array size");
        jSpinner1.setMaximumSize(new java.awt.Dimension(32767, 20));
        jSpinner1.setMinimumSize(new java.awt.Dimension(31, 10));
        jToolBar1.add(jSpinner1);

        jButton17.setToolTipText("build Array");
        jButton17.setBorderPainted(false);
        jButton17.setFocusable(false);
        jButton17.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton17.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton17.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton17ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton17);

        jButton19.setToolTipText("see Array elt");
        jButton19.setBorderPainted(false);
        jButton19.setFocusable(false);
        jButton19.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton19.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton19.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton19ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton19);

        jSeparator1.setOpaque(true);
        jToolBar1.add(jSeparator1);

        jButton21.setToolTipText("pack");
        jButton21.setBorderPainted(false);
        jButton21.setFocusable(false);
        jButton21.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton21.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton21ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton21);

        jToggleButton2.setToolTipText("Loader");
        jToggleButton2.setBorderPainted(false);
        jToggleButton2.setFocusable(false);
        jToggleButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton2);

        jCB_ObjectEditor1.setEditable(true);
        jCB_ObjectEditor1.setEditing(false);
        jCB_ObjectEditor1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCB_ObjectEditor1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jCB_ObjectEditor1);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.NORTH);

        jPanel9.setLayout(new java.awt.BorderLayout());

        jSplitPane1.setDividerLocation(120);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setResizeWeight(1.0);

        jPanel10.setLayout(new java.awt.BorderLayout());

        jSplitPane2.setDividerLocation(150);

        jTable3.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_NEXT_COLUMN);
        jTable3.setAutoscrolls(false);
        jTable3.setShowHorizontalLines(false);
        jTable3.setShowVerticalLines(false);
        jTable3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable3MouseReleased(evt);
            }
        });
        jScrollPane8.setViewportView(jTable3);

        jSplitPane2.setRightComponent(jScrollPane8);

        jTree2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTree2MouseReleased(evt);
            }
        });
        jScrollPane2.setViewportView(jTree2);

        jSplitPane2.setLeftComponent(jScrollPane2);

        jPanel10.add(jSplitPane2, java.awt.BorderLayout.CENTER);

        jSplitPane1.setTopComponent(jPanel10);

        jPanel11.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jPanel11ComponentResized(evt);
            }
        });
        jPanel11.setLayout(new java.awt.BorderLayout());

        jScrollPane9.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jScrollPane9ComponentResized(evt);
            }
        });

        jTable6.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null}
            },
            new String [] {
                "Class", "Object", "Serial"
            }
        ));
        jTable6.setComponentPopupMenu(jPopupMenu3);
        jTable6.setDragEnabled(true);
        jScrollPane9.setViewportView(jTable6);

        jPanel11.add(jScrollPane9, java.awt.BorderLayout.CENTER);

        jSplitPane1.setRightComponent(jPanel11);

        jPanel9.add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Create", jPanel9);

        jPanel7.setLayout(new java.awt.BorderLayout());

        jSplitPane3.setDividerLocation(120);
        jSplitPane3.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jScrollPane14.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                jScrollPane14ComponentResized(evt);
            }
        });

        jTable8.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null}
            },
            new String [] {
                "Empty"
            }
        ));
        jTable8.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_NEXT_COLUMN);
        jTable8.setComponentPopupMenu(jPopupMenu1);
        jScrollPane14.setViewportView(jTable8);

        jSplitPane3.setBottomComponent(jScrollPane14);

        jSplitPane4.setDividerLocation(250);
        jSplitPane4.setRightComponent(jScrollPane1);

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("Class details");
        jTree3.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jTree3.setEditable(true);
        jTree3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTree3MouseReleased(evt);
            }
        });
        jScrollPane3.setViewportView(jTree3);

        jSplitPane4.setLeftComponent(jScrollPane3);

        jPanel5.setLayout(new java.awt.BorderLayout());

        jButton20.setText("Execute");
        jButton20.setToolTipText("invoke methode with params");
        jButton20.setEnabled(false);
        jButton20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton20ActionPerformed(evt);
            }
        });
        jPanel5.add(jButton20, java.awt.BorderLayout.SOUTH);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null}
            },
            new String [] {
                "Title 1"
            }
        ));
        jScrollPane5.setViewportView(jTable1);

        jPanel5.add(jScrollPane5, java.awt.BorderLayout.CENTER);

        jSplitPane4.setRightComponent(jPanel5);

        jSplitPane3.setLeftComponent(jSplitPane4);

        jPanel7.add(jSplitPane3, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Details", jPanel7);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("System"));
        jPanel3.setLayout(new java.awt.GridLayout(4, 0));

        jButton10.setText("Properties");
        jButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10ActionPerformed(evt);
            }
        });
        jPanel3.add(jButton10);

        jButton16.setText("Chanel");
        jButton16.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton16ActionPerformed(evt);
            }
        });
        jPanel3.add(jButton16);

        jButton13.setText("env");
        jButton13.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton13ActionPerformed(evt);
            }
        });
        jPanel3.add(jButton13);

        jButton15.setText("security manager");
        jButton15.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton15ActionPerformed(evt);
            }
        });
        jPanel3.add(jButton15);

        jButton14.setText("Console");
        jButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton14ActionPerformed(evt);
            }
        });
        jPanel3.add(jButton14);

        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });
        jPanel3.add(jComboBox1);

        jPanel2.add(jPanel3, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton2);

        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton11);

        jCheckBox10.setSelected(true);
        jCheckBox10.setText("see results");
        jCheckBox10.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox10.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox10ActionPerformed(evt);
            }
        });
        jPanel1.add(jCheckBox10);

        jButton9.setText("Paste");
        jButton9.setToolTipText("to clipboard??");
        jButton9.setEnabled(false);
        jPanel1.add(jButton9);

        jButton8.setText("Copy");
        jButton8.setToolTipText("to clipboard??");
        jButton8.setEnabled(false);
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton8);

        jButton5.setText("CLOSE");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton5);

        jPanel2.add(jPanel1, java.awt.BorderLayout.NORTH);

        jTabbedPane1.addTab("System", jPanel2);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        if (jTable8.getValueAt(0, 1) != null) {
            if (Parent == null) {
                F_Object a = new F_Object(jTable8.getValueAt(0, 1));
            } else {
                F_Object a = new F_Object(Parent, jTable8.getValueAt(0, 1));
            }

        }
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        resize();
    }//GEN-LAST:event_formComponentResized

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        //  if (Ojb instanceof java.lang.)
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
}//GEN-LAST:event_jButton8ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        if (this.getDefaultCloseOperation() == javax.swing.JFrame.EXIT_ON_CLOSE) {
            System.exit(0);
        } else {
            this.setVisible(false);
        }
}//GEN-LAST:event_jButton5ActionPerformed

    private void jCheckBox10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox10ActionPerformed
        setMethRes(isMethRes());
}//GEN-LAST:event_jCheckBox10ActionPerformed

    private void jButton14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton14ActionPerformed
        this.setObject(java.lang.System.console());
}//GEN-LAST:event_jButton14ActionPerformed

    private void jButton15ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton15ActionPerformed
        this.setObject(java.lang.System.getSecurityManager());
}//GEN-LAST:event_jButton15ActionPerformed

    private void jButton13ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton13ActionPerformed
        this.setObject(java.lang.System.getenv());
}//GEN-LAST:event_jButton13ActionPerformed

    private void jButton16ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton16ActionPerformed
        try {
            this.setObject(java.lang.System.inheritedChannel());
        } catch (IOException ex) {
            TDeb.wri("Pb set Object=>"+ex.getMessage());
        }
}//GEN-LAST:event_jButton16ActionPerformed

    private void jButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10ActionPerformed
        this.setObject(java.lang.System.getProperties());
}//GEN-LAST:event_jButton10ActionPerformed

    private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton11ActionPerformed
        javax.swing.JFileChooser ch = new javax.swing.JFileChooser();
        ch.setMultiSelectionEnabled(true);
        ch.setDialogTitle("Select file Object");
        ch.setDialogType(javax.swing.JFileChooser.OPEN_DIALOG);
        ch.setFileSelectionMode(javax.swing.JFileChooser.FILES_AND_DIRECTORIES);
        if (ch.showDialog(this, "Open") == javax.swing.JFileChooser.APPROVE_OPTION) {
            if (ch.getSelectedFiles().length == 1) {
                this.setObject(ch.getSelectedFile());
            } else {
                this.setObject(ch.getSelectedFiles());
            }

        }
}//GEN-LAST:event_jButton11ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        F_USB f = new F_USB(this);
}//GEN-LAST:event_jButton2ActionPerformed

    private void jButton20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton20ActionPerformed
        Exec_Detail();
}//GEN-LAST:event_jButton20ActionPerformed

    private void jTree3MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree3MouseReleased
        java.awt.Cursor cursor_curent = this.getCursor();
        this.setCursor(new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR));
        selectDetail(jTree3.getLeadSelectionPath());
        this.setCursor(cursor_curent);
}//GEN-LAST:event_jTree3MouseReleased

    private void jScrollPane14ComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jScrollPane14ComponentResized
        adjustrowheight();
}//GEN-LAST:event_jScrollPane14ComponentResized

    private void jCB_ObjectEditor1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCB_ObjectEditor1ActionPerformed
        getclassestree();
        jTable3.setModel(new javax.swing.table.DefaultTableModel());
}//GEN-LAST:event_jCB_ObjectEditor1ActionPerformed

    private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
        setSourceLoader(issourceloader());
}//GEN-LAST:event_jToggleButton2ActionPerformed

    private void jButton19ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton19ActionPerformed
        if (Obj.getClass().isArray()) {
            try {
                F_Object f = new F_Object(java.lang.reflect.Array.get(Obj, getArraysize()));
                f.setVisible(true);
            } catch (IllegalArgumentException | ArrayIndexOutOfBoundsException ex) {
            }
        }
    }//GEN-LAST:event_jButton19ActionPerformed

    private void jButton17ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton17ActionPerformed
        if (Obj == null) {
            return;
        }

        int idx = (Integer) jSpinner1.getValue();
        try {
            Object newObj = java.lang.reflect.Array.newInstance(Obj.getClass(), idx);
            for (int i = 0; i
                    < idx; i++) {
                java.lang.reflect.Array.set(newObj, i, Obj);
            }

            this.setObject(newObj);
        } catch (NegativeArraySizeException | IllegalArgumentException | ArrayIndexOutOfBoundsException ex) {
        }
}//GEN-LAST:event_jButton17ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        EditNewObj();
}//GEN-LAST:event_jButton3ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        if (Obj instanceof byte[]) {
            C_Packet p = new C_Packet((byte[]) Obj, null);//-99!!!
            Object buff = p.getSer2Obj();
            if (buff != null) {
                Obj = buff;
                showObj();

            }
        }
}//GEN-LAST:event_jButton7ActionPerformed

    private void jButton18ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton18ActionPerformed
        showObj();
}//GEN-LAST:event_jButton18ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        if (jToggleButton1.isSelected()) {
            String txt = "package com;"
                    + "\r\npublic class toto {\r\n  public toto(){"
                    + "\r\n    System.out.println(\"start toto\");\r  }"
                    + "\r\n  public String latete(){\r\n    return \"= 0 + 0 \";}"
                    + "\r\n  public String histoire(){"
                    + "\r\n    return \"la maitresse en maillot de bain\";}\r\n}";
            compiler = new F_Compile<>(txt);
            compiler.setVisible(true);
            compiler.setParent(this);
            compiler.setClassLoader((ClassLoader) jCB_ObjectEditor1.getValue());
        } else if (compiler != null) {
            Obj = compiler.getResult();
            compiler.setVisible(false);
            compiler = null;
            this.showObj();
        }
}//GEN-LAST:event_jToggleButton1ActionPerformed

    private void jPanel11ComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel11ComponentResized
}//GEN-LAST:event_jPanel11ComponentResized

    private void jScrollPane9ComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jScrollPane9ComponentResized
        adjustrowheight();
}//GEN-LAST:event_jScrollPane9ComponentResized

    private void jTable3MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable3MouseReleased
        if (setSelectedClass()) {
            seeclass();
        }
}//GEN-LAST:event_jTable3MouseReleased

    private void jButton21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton21ActionPerformed
        java.awt.Cursor cursor_curent = this.getCursor();
        this.setCursor(new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR));

        if (jButton21.getToolTipText() == null || jButton21.getToolTipText().compareTo("pack") == 0) {
            Object2tree();
            jButton21.setToolTipText("obj");
            jButton21.setIcon(TUtils.getIcon("Interfaces.gif"));
        } else if (jButton21.getToolTipText().compareTo("obj") == 0) {
            Interfaces2tree();
            jButton21.setIcon(TUtils.getIcon("Package.gif"));
            jButton21.setToolTipText("int");
        } else {
            setSourceLoader(issourceloader());
            jButton21.setToolTipText("pack");
            jButton21.setIcon(TUtils.getIcon("Object.gif"));
        }
        jToggleButton2.setEnabled(jButton21.getToolTipText().compareTo("pack") == 0);
        searchClasses();
        this.setCursor(cursor_curent);
    }//GEN-LAST:event_jButton21ActionPerformed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        setObject(jComboBox1.getSelectedItem());
    }//GEN-LAST:event_jComboBox1ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (Parent instanceof I_ObjectReceiver) {
            Parent.receiveObj(Obj);
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        if (Parent instanceof I_ObjectReceiver) {
            Parent.receiveObj(this.getSerial());
        }
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        if (jTable8.getValueAt(0, 1) != null) {
            this.setObject(jTable8.getValueAt(0, 1));
        }
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jTree2MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree2MouseReleased
        java.awt.Cursor cursor_curent = this.getCursor();
        this.setCursor(new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR));
        searchClasses();
        this.setCursor(cursor_curent);
    }//GEN-LAST:event_jTree2MouseReleased

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new F_Object().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton11;
    private javax.swing.JButton jButton13;
    private javax.swing.JButton jButton14;
    private javax.swing.JButton jButton15;
    private javax.swing.JButton jButton16;
    private javax.swing.JButton jButton17;
    private javax.swing.JButton jButton18;
    private javax.swing.JButton jButton19;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton20;
    private javax.swing.JButton jButton21;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JButton jButton9;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private javax.swing.JCheckBox jCheckBox10;
    private javax.swing.JCheckBox jCheckBox11;
    private javax.swing.JComboBox<Object> jComboBox1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JPopupMenu jPopupMenu3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane14;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JSpinner jSpinner1;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JSplitPane jSplitPane3;
    private javax.swing.JSplitPane jSplitPane4;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable3;
    private javax.swing.JTable jTable6;
    private javax.swing.JTable jTable8;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTree jTree2;
    private javax.swing.JTree jTree3;
    // End of variables declaration//GEN-END:variables
}

class ObjectTracker implements java.awt.event.ActionListener, java.io.Serializable {

    private static final long serialVersionUID = 1L;
    private F_Object chooser = null;
    private Object obj = null;
    private JDialog dialog = null;

    public ObjectTracker(F_Object o, JDialog d) {
        chooser = o;
        dialog = d;
        obj = chooser.getObject();
    }

    public ObjectTracker(F_Object o) {
        chooser = o;
        obj = chooser.getObject();
        chooser.setVisible(false);
    }

    @Override
    public void actionPerformed(java.awt.event.ActionEvent e) {
        if (e.getActionCommand().startsWith("Dialog_objOK")) {
            obj = chooser.getObject();
        }
        if (e.getActionCommand().startsWith("Dialog_serOK")) {
            obj = chooser.getSerial();
        }
        if (dialog != null) {
            dialog.setVisible(false);
        }
    }

    public Object getObject() {
        return obj;
    }
}

/*class MyAppletLoader extends sun.applet.AppletClassLoader {

 public MyAppletLoader(java.net.URL u) {
 super(u);
 }
 }*/
