package com.jdcm.editors;

//import usb.core.*;
import javax.swing.tree.*;
import com.jdcm.eltrx.D_Debug;
import com.jdcm.common.D_Utils;

/**
 *F_USB.java  Created on 10 juin 2008, 14:07
 * 
 * Form designed for USB test and debug
 * 
 * @author  Marc GIBOIN
 */
public class F_USB extends javax.swing.JFrame {
        // for serializable interface
    private static final long serialVersionUID = 1L;
    private D_Debug TDeb;
    private D_Utils TUtils = new D_Utils();
    private javax.swing.tree.DefaultTreeModel usbtm;
    private Object Parent = null;
  //  private ControllerUSBListener ctrl = null;
    /** Creates new form F_USB */
    public F_USB() {
        initComponents();
        init();
    }
/**
 * create the form for applet/sub form<br>
 * if isapplet then close do not exit system <br>
 * @param isapplet
 */
    public F_USB(boolean isaplet) {
        initComponents();
        setVisible(isaplet == false);
        init();
    }

    public F_USB(Object p) {
        Parent = p;
        initComponents();
        init();
        setVisible(true);
    }
    private void tolog(String message){
        System.out.println(message);
    }
    private void init() {
        if (javax.swing.JFrame.getOwnerlessWindows().length == 1) {
            this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
        }
        TDeb = new D_Debug("F-USB");
        this.setIconImage(TUtils.getImage("usb.gif"));
        jButton2.setIcon(TUtils.getIcon("refresh.gif"));
        jButton3.setIcon(TUtils.getIcon("Save.gif"));
        jButton1.setIcon(TUtils.getIcon("Close.gif"));
        jButton1.setVisible(Parent != null);
        jCB_ObjectEditor1.setVisible(Parent != null);
        jLabel1.setVisible(Parent != null);
        jButton1.setEnabled(Parent != null);

    }

    public void USBevent() {
        usbtm.reload();
        jTree1.repaint();
    }

    private void close() {
        try {
          //  host.removeUSBListener(ctrl);
        } catch (Exception ex) {
            tolog("Could not remove USB Control listner");
        }

        this.setVisible(false);
    }


    public javax.swing.tree.DefaultTreeModel getUSBtree() {
        return usbtm;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jToolBar1 = new javax.swing.JToolBar();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jButton1 = new javax.swing.JButton();

        setTitle("F_USB");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jToolBar1.setRollover(true);

        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.NORTH);

        jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTree1MouseReleased(evt);
            }
        });
        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jLabel1.setText("Selected : ");
        jPanel1.add(jLabel1);
        jPanel1.add(jCB_ObjectEditor1);

        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void jTree1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MouseReleased

    }//GEN-LAST:event_jTree1MouseReleased

    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged
        if (jTree1.getSelectionPath() == null) {
            return;
        }
        DefaultMutableTreeNode selobj = (DefaultMutableTreeNode) jTree1.getSelectionPath().getLastPathComponent();
        jCB_ObjectEditor1.setValue(selobj.getUserObject());
        jCB_ObjectEditor1.setEditable(true);
    }//GEN-LAST:event_jTree1ValueChanged

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (Parent instanceof com.jdcm.eltrx.C_Port) {
           // ((com.jdcm.eltrx.C_Port)Parent).setUSBInterface(jCB_ObjectEditor1.getValue());
            close();
        }
        if (Parent instanceof com.jdcm.editors.F_Object) {
            ((com.jdcm.editors.F_Object)Parent).setObject(jCB_ObjectEditor1.getValue());
            close();
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        init();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        if (Parent instanceof com.jdcm.eltrx.C_Port) {
        //    ((com.jdcm.eltrx.C_Port)Parent).setUSBInterface(jCB_ObjectEditor1.getValue());
        }
        close();
      
    }//GEN-LAST:event_formWindowClosing

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        //save as text
        java.io.FileOutputStream out;
        javax.swing.JFileChooser ch = new javax.swing.JFileChooser();
        if (ch.showDialog(this, "Save") == javax.swing.JFileChooser.APPROVE_OPTION) {
            try {
                out = new java.io.FileOutputStream(ch.getSelectedFile().toString());
            } catch (java.io.FileNotFoundException exe) {
                return;
            }
        } else {
            return;
        }
        try {
            DefaultMutableTreeNode top = (DefaultMutableTreeNode) jTree1.getModel().getRoot();
            out.write(top.toString().getBytes());
            for (int i = 0; i < top.getChildCount(); i++) {
                DefaultMutableTreeNode bs = (DefaultMutableTreeNode) top.getChildAt(i);
                com.jdcm.editors.P_USBEditor a = new com.jdcm.editors.P_USBEditor();
                a.setValue(bs.getUserObject());
                out.write(a.getdetails().getBytes());
                for (int j = 0; j < bs.getChildCount(); j++) {
                    DefaultMutableTreeNode dev = (DefaultMutableTreeNode) bs.getChildAt(i);
                    com.jdcm.editors.P_USBEditor b = new com.jdcm.editors.P_USBEditor();
                    b.setValue(dev.getUserObject());
                    out.write(b.getdetails().getBytes());
                    for (int k = 0; k < dev.getChildCount(); k++) {
                        DefaultMutableTreeNode intf = (DefaultMutableTreeNode) dev.getChildAt(i);
                        com.jdcm.editors.P_USBEditor c = new com.jdcm.editors.P_USBEditor();
                        c.setValue(intf.getUserObject());
                        out.write(c.getdetails().getBytes());
                    }

                }
            }
            out.close();
        } catch (Exception ex) {
        }

    }//GEN-LAST:event_jButton3ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                new F_USB().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables
   
}