package com.jdcm.editors;

/**
 *Edit/display Arrays
 * 
 * @author Marc GIBOIN
 */
class P_ArrayHeader{
    private Object arr=null;
    public P_ArrayHeader(Object o){
        if (o!=null && o.getClass().isArray()){
            arr=o;
        }
    }
            /**
     * Provide an Icon if needed (asked by frames)
     * @return an Icon of this Panel
     */
    public java.awt.Image getIcon() {
        try {
             return (new com.jdcm.common.D_Utils()).getImage("JList.gif");
        }catch(Exception ex){
            return null;
        }
    }
    @Override
    public String toString(){
        if (arr==null){
            return "null";
        }
        int lg = java.lang.reflect.Array.getLength(arr);
                String name = arr.getClass().getSimpleName();
                name = name.substring(0, name.length() - 2) + "[" + lg + "]";
                return name;
    }
    
}