package com.jdcm.eltrx;

import com.jdcm.common.Options_Model;

/**
 * Interface used for all object managed  
 * @author  Marc GIBOIN
 */
public interface I_Command {

 // return a description of the commanded object
 public String getCMDdesc();
//return the commanded object named chiled, if null return all childs
 public java.util.List<I_Command> getCMDChilds(String child);
 // return the commanded parent of this Object (root return root)
 public I_Command getCMDParent();
 // return the lablel of this object as commanded object
 public String getCMDName();
  // detail of the commanded element (show)
 public String getCMDdetails();
 public Options_Model getCMDOptions();
    public javax.swing.ImageIcon getCMDIcon();
}
