package com.jdcm.eltrx;
import com.jdcm.common.C_Packet;
import com.jdcm.common.Options_Model;
/**
 *Integace of all element accpted as a port (C_Port/C_Machine/...)
 * 
 * @author Marc GIBOIN
 */
public interface I_Port {
// get the name of the port (default is "Port_1")
    public String getPortName();
    public void setPortName(String txt);
    // public void setcxstatus(String status);
    public void setColor(java.awt.Color c);
    public java.awt.Color getColor();
    public void setSkin(java.awt.Component o);
     public java.awt.Component getSkin();
     public void setstop2end(boolean bool);
     public boolean getstop2end();
     // index of port in port list
    public int getIndex();
    public I_Console getConsole();
    public void setPort_Stat(boolean bool);
    public boolean isPort_Stat();
   // index port port in sub list (TCP)
    public int getSIndex();
    // true if system port (Shell/capture reading/...)
    public boolean isSystem();
    // get the status (open/started/closed/stopped/...
    public String getcxstatus();
    // get the name of the port cab (default is "IP")
    public String getModeName();
    public void setModeName(String txt);
    public int getOsiLevel();
    // get/set the array of options of the port
    public Options_Model getCMDOptions();
    
    public void setCMDOptions(Options_Model r);
    // get/set the matrix String Value for the group routing
    public String getPar_mxgrp() ;
    public void setPar_mxgrp(String txtval) ;
    
    public String[] getcxStatusList();

    public void init_Port();

    public boolean isEcho();

    public void CXArcv(I_Port src,String message,String type);

    public void CXnew();
    public boolean CXcreate(String methode, String value);
    // ask to start the port => startting...)
    public void CXstart();
    // ask to delete (removed) the port
    public void CXend();
    // ask to stop  the port => ...stopped
    public void CXstop();
/**
 * Receiving packet from Main
 * @param pack 
 */
    public void read_out(C_Packet pack);

    public void setslreading(boolean bool);

}
