package com.jdcm.eltrx;

import com.jdcm.common.C_Packet;
import java.io.*;

/**
 *  I_Terminal.java Created on 9 nov. 2007, 22:16:59
 * 
 * interface for terminal
 * nb : actually only one is created (TALC is not imlmented)
 * @author Marc GIBOIN
 */
public interface I_Terminal extends I_Slave {

    public InputStream getInputStream() throws java.io.IOException;

    public OutputStream getOutputStream() throws java.io.IOException;

    public void setextTitle(String exttitle);

    public void setVisible(boolean bool);

    /**
     * get the size of the input buffer<br>
     * @return the size of the buffer in byte
     */
    public int StreambuffSize();

    public int readStreambuff();
    /*
     * Manage as a slave (TO DO)
     * @param packet to print
     */

    @Override
    public int sl_start();

    @Override
    public int sl_open();

    @Override
    public int sl_close();

    /**
     * Return the size of the entry buffer (in texte box)<br>
     * @return the size in byte of the buffer
     */
    public int getinsize();

    public int write(C_Packet pack);
}
