/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jdcm.eltrx;

import com.jdcm.common.C_Packet;

/**
 *
 * @author Marc GIBOIN
 */
public class T_SYS extends Thread implements I_Slave {

    private final C_Port Parent;
    private final com.jdcm.common.D_Utils TUtils = new com.jdcm.common.D_Utils();
        private final java.util.List<String> cmdbuff = new java.util.ArrayList<>();
        
    private final D_Debug TDeb;
    private String dggruningcmd = "";
    private Process proc = null;
    private Runtime rt = null;
    private long started_time = 0;

    public T_SYS(C_Port P) {
        Parent = P;
        TDeb = new D_Debug("T-SYS [" + Parent.getIndex() + "] : ");
        TDeb.setconsole(Parent.getConsole());
        setName(this.getClass().getSimpleName() + ":" + getName());
    }

    @Override
    public int write(C_Packet p) {
        byte[] res;
        String cmde = null;
        if (p.isbuffer()) {
            res = p.getBytes();
        } else if (p.getObj() instanceof String) {
            res = p.getObj().toString().getBytes();
        } else if (p.getObj() != null) {
            TDeb.wri("Couldn't write " + p.getObj().toString() + " to process in stream");
            return 0;
        } else {
            TDeb.wri("Couldn't write NULL to process in stream");
            return 0;
        }

        if (Parent.isSYS_stdinout()) {
            try {
                if (Parent.getout() != null) {
                    Parent.getout().write(res);
                } else {
                    cmdbuff.add(cmde);
                }
            } catch (Exception ex) {
                return -1;
            }
            return 0;
        }
        try {
            cmde = new String(res);
            res = (byte[]) p.getObj();
            if (Parent.getout() == null && proc == null && this.isAlive() == false) {
                //?? why?? lanch without résult?? added :&&this.isAlive()==false?
                lauch_command(cmde);
            } else {
                cmdbuff.add(cmde);
                //!! setAcc_position bar is used by Readstream() buffer
                //   Parent.setAcc_position(cmdbuff.size());
            }
            if (res == null || Parent.getout() == null) {
                return 0;
            }
            return res.length;
        } catch (Exception ex) {
            return -1;
        }
    }

    @Override
    public int sl_start() {
        rt = Runtime.getRuntime();
        if (rt == null) {
            return -1;
        }
        Parent.setSYS_nbmup(rt.availableProcessors());
        return 0;
    }

    @Override
    public int sl_open() {

        if (Parent.isSYS_stdinout()) {
            Parent.setout(System.out);
            Parent.setin(System.in);
        }
        return 0;
    }

    @Override
    public int sl_close() {
        if (proc != null) {
            proc.destroy();
        }
        Parent.setSYS_status("");
        proc = null;
        rt = null;
        return 0;
    }

    private int lauch_command(String cmde) {
        if (Parent.isSYS_CheckSM()) {
            try {
                new SecurityManager().checkExec(cmde);
            } catch (Exception ex) {
                TDeb.wri("lauching command: " + cmde + " not permited : " + ex.getMessage());
                return -1;
            }
        }
        if (rt == null) {
            TDeb.wri("No more Runtine");
            return -1;
        }
        try {
            if (Parent.getSYS_lib() != null && Parent.getSYS_lib().length() > 0) {
                rt.load(Parent.getSYS_lib());
            }
            TDeb.wri("lauching command (lib & SM OK): " + cmde + " =>" + this.hashCode());
            started_time = System.currentTimeMillis();
            boolean isok = false;
            //100 ms should be parameter or return -1...  java.io.IOException
            while (isok == false && System.currentTimeMillis() < started_time + 10000) {
                try {
                    proc = rt.exec(cmde);
                    isok = true;
                } catch (Exception ex) {
                }
            }
            if (proc == null) {
                TDeb.wri("--Proc NOT properly launched");
                return -1;
            }
            Parent.setout(proc.getOutputStream());
            // Parent.setin(proc.getErrorStream());
            Parent.setin(proc.getInputStream());
            Parent.setSYS_status(cmde);
            return 0;
        } catch (SecurityException ex) {
            TDeb.wri("see java.lang.SecurityManager().CheckExec(String cmde) Exception : " + ex.getMessage());
            return -1;
            // } catch (java.io.IOException ex) {
            //     TDeb.wri("IO Exception : " + ex.getMessage());
            //     return -1;
        } catch (IllegalArgumentException ex) {
            TDeb.wri("commade string should be empty " + ex.getMessage());
            return -1;
        }
    }

    private byte[] readedtxt(java.io.InputStream in) {
        try {
            int size = in.available();
            if (in == null || size <= 0) {
                return null;
            }
            byte[] a = new byte[size];
            int readed = in.read(a);
            return java.util.Arrays.copyOf(a, readed);
            // return new String(b);
        } catch (Exception ex) {
            return null;
        }
    }

    public void wait_State(String state) {
        while (Parent.getcxstatus().compareTo(state) != 0) {
            try {
                sleep(10);
            } catch (InterruptedException ex) {
                //ex.printStackTrace();
            }
        }
    }

    /**
     * Run the SYS Slave
     *
     * no listner on in strean
     *
     */
    @Override
    public void run() {
        wait_State("started");
        if (Parent.isCX_autoopen() && Parent.isCX_openbyslave()) {
            Parent.CXopen();
        }
        // wait_State("opening");
        TDeb.wri("---Start of SYS thread file---");
        while (Parent.isslrunning()) {
            try {
                sleep(5);
            } catch (InterruptedException ex) {
                TDeb.wri("SYS slave running/ Pb during waiting [" + ex.getMessage() + "]");
            }
            // int size = 0;
            while (Parent.isslrunning() && (Boolean) Parent.getCMDOptions().getValuefor("Par_PadtStr")) {
                //Create an event "Data avalable" FOR PAD
                if (Parent.available() > 0) {//>size
                    //    size = Parent.available();
                    Parent.ReadStream(-1);
                }
                /*  if (Parent.available() == 0) {
                 size = 0;
                 }*/
                try {
                    sleep(1);
                } catch (InterruptedException ex) {
                    TDeb.wri("Pb during sleep =>" + ex.getMessage());
                }
            }
            while (Parent.isslreading()) {
                if (Parent.isSYS_stdinout()) {
                    while (Parent.isslreading()) {
                        try {
                            sleep(5);
                        } catch (InterruptedException ex) {
                            TDeb.wri("sys slave reading/ Pb during waiting [" + ex.getMessage() + "]");
                        }
                        Parent.ReadStream(-1);
                    }
                } else {
                    /// --- CATH THE PROCCESS --------
                    while (Parent.isslreading() && proc == null && rt != null) {
                        try {
                            sleep(5);
                        } catch (InterruptedException ex) {
                            TDeb.wri("sys slave reading/ Pb during waiting [" + ex.getMessage() + "]");
                        }
                        // TDeb.wri("waiting... "+cmdbuff.toString());
                        if (cmdbuff.size() > 0 && proc == null) {
                            String newcmde = cmdbuff.remove(0);
                            if (lauch_command(newcmde) < 0) {
                                TDeb.wri("Pb launching command: " + newcmde + "");
                            }
                            dggruningcmd = newcmde;
                            //see upper    Parent.setAcc_position(cmdbuff.size());
                        }
                    }
                    //--------------------PING AS PROCESS (adress.isrechable=>icmp... OR...  TCP#6...
                    boolean tryagain = Parent.available() >= 0;
                    TDeb.wri("tryagain:" + tryagain);
                    /// --- CATH THE DATAS --------
                    while (rt != null && tryagain && Parent.isslreading()) {
                        // a = new byte[Parent.available()];
                        try {
                            if (Parent.isSYS_sendOut()) {
                                Parent.ReadStream(-1);
                            }
                            try {
                                //if send true or send out=> read the end
                                proc.exitValue();
                                tryagain = Parent.available() > 0;
                                TDeb.wri("process ended for : " + dggruningcmd + " =>" + this.hashCode());
                            } catch (IllegalThreadStateException ex) {
                                //    tryagain = true; normal way
                            } catch (java.lang.NullPointerException nex) {
                                TDeb.wri("the process is null (killed) for : " + dggruningcmd);
                            } catch (Throwable ex) {
                                tryagain = false;
                                TDeb.wri("the process should have been killed =>" + ex.getMessage());
                            }
                            //txt = txt + new String(a).substring(0, readed);
                            sleep(1);
                            if (Parent.available() < 0) {
                                tryagain = false;
                                TDeb.wri("end because avalable is <0 of : " + dggruningcmd);
                            }
                        } catch (Exception ex) {
                            if (Parent.isSYS_DCXatend()) {
                                Parent.CXerror("error while reading: " + ex.getMessage());
                                return;
                            }
                        }

                    }

                    // ---SEND DATAS --------
                    int exval = 255;
                    if (proc != null) {
                        proc.destroy();
                        try {
                            exval = proc.exitValue();
                            Parent.setSYS_status(Parent.getSYS_status() + " : " + exval);
                        } catch (IllegalThreadStateException ex) {
                            //sl-close() has been made
                            TDeb.wri("process killed");
                            if (Parent.getSYS_status().length() > 0) {
                                Parent.setSYS_status(Parent.getSYS_status() + " : killed");
                            }
                        }
                        proc = null;
                    } else {
                        TDeb.wri("no process at end for :" + dggruningcmd + " =>" + this.hashCode());
                    }
                    if (Parent.isSYS_sendExit() && Parent.isslreading()) {
                        TDeb.wri("process send result = " + exval);
                        if (Parent.isSYS_exitasbyte()) {
                            Parent.read_in(new C_Packet(TUtils.prend("DEC", exval), Parent));
                        } else {
                            Parent.read_in(new C_Packet(exval, Parent));
                        }
                    }
                    if (Parent.isSYS_DCXatend()) {
                        Parent.CXdisconnect();
                    }
                }
            }
        }
        //sl_close();
        //Parent.CXdisconnect();
        TDeb.wri("---End of SYS thread---");
    }
}
