package com.jdcm.modifiers.matrix;


/**
 * The Matrix plugin Interface 
 * 
 * @author Marc GIBOIN
 */
public interface I_mat_elt extends java.lang.Cloneable {

    public void mx_init();

    public int getRowCount(boolean[][] boolArray);

    public void update(boolean[][] oldBools,boolean[][] newBools);

    public Object getValueAt(int aRow, int aColumn);

    public boolean isCellEditable(int row, int column);

    public void setValueAt(Object value, int aRow, int aColumn);
}
