package com.jdcm.modifiers.matrix;

import com.jdcm.eltrx.T_Matrice;

/**
 * This FULL matrix route all packets to ALL ports
 * 
 * @author  M.Marc GIBOIN
 */
public class mat_FULL extends mat_base {

    public boolean iscx = true;

    public mat_FULL(T_Matrice p) {
        Parent = p;
    }

    public static String getComment() {
        return "Full matrix";
    }
    public static javax.swing.Icon getIcon(){
       return (new com.jdcm.common.D_Utils()).getIcon("mat_full.gif");
    }
    @Override
    public void mx_init() {
        for (int i = 0; i < Parent.getmodel().getRowCount(); i++) {
            for (int j = 0; j < Parent.getmodel().getRowCount(); j++) {
                if (i == j) {
                    Parent.getmodel().setValueAt(Parent.isMat_Echo() && iscx, i, j + 1);
                } else {
                    Parent.getmodel().setValueAt( iscx, i, j + 1);
                }
            }
        }
    }

    @Override
    public void setConnection(int src, int dest, boolean bool) {
        // no connexion to set, matrix is  full
    }


    @Override
    public int getRowCount(boolean[][] boolArray) {
        return boolArray.length;
    }

    @Override
    public void update(boolean[][] oldBools,boolean[][] newBools) {
        if (newBools!=null){
            Parent.setmodelbools(newBools);
        }
        mx_init();
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        return null;
    }

    @Override
    public void setValueAt(Object value, int aRow, int aColumn) {
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        return false;
    }
}
