package com.jdcm.modifiers;


/**
 * Code / Uncode Quoted-printable from a buffer(used in Mails)
 * 
 * @author Marc GIBOIN
 */
public class modif_QP implements com.jdcm.modifiers.I_modifiers{
    private byte[] buffer;

    public modif_QP(){
    }
    public modif_QP(byte[] b){
        buffer=b;
    }
    @Override
    public void setBuffer(byte[] b){buffer=b;}
    @Override
    public byte[] getBuffer(){return buffer;}
    @Override
    public void ToClear() throws NumberFormatException {

        byte[] res=buffer;
        for (int i=0;i<res.length-2;i++){
            if (res[i]==0x3d ){
                byte[] a={res[i+1],res[i+2]};
                String b=new String(a);
                int nb=Integer.parseInt(b, 16);
                if (nb<=0x7E && nb!=0x3D){
                    //error
                    throw new NumberFormatException ("modifQP.ToClear() : not possible caractere : "+b+" at pos:"+i );
                }
                if (nb>0x7E){
                    res[i]=(byte)(nb-256);
                }else{
                    //for '='
                    res[i]=(byte)nb;
                }
                byte[] buf=new byte[res.length-2];
                int pos=0;
                for (int j=0;j<res.length;j++){
                   if (j<=i || j>i+2){
                       buf[pos]=res[j];
                       pos++;
                   }
                }
                res=buf;
            }
        }
        buffer=res;
    }
    @Override
    public void ToCode(){

        for (int i=0;i<buffer.length;i++){
            if (buffer[i]<0|| buffer[i]==0x3d){
                int nb=buffer[i];
                if (nb<0){
                    nb=nb+256;
                }
                String c="="+Integer.toHexString(nb).toUpperCase();
                int pos=0;
                byte[] buf=new byte[buffer.length+2];
                for (int j=0;j<buffer.length;j++){
                   if (j!=i){
                       buf[pos]=buffer[j];
                       pos++;
                   }else{
                       buf[pos]=c.getBytes()[0];
                       buf[pos+1]=c.getBytes()[1];
                       buf[pos+2]=c.getBytes()[2];
                       pos=pos+3;
                   }
                }
                buffer=buf;
            }
        }
    }

}