package com.jdcm.modifiers;

import java.io.IOException;

/**
 * The modif caode/uncode basic implementation
 * @author M.Marc GIBOIN
 */
public abstract class modif_base {

    private static String code = null;

    public static String getComment() {
        return "base code implementation";
    }

    public void setCode(String codetxt) {
        code = codetxt;
    }

    public static String getCode(String ClassName,Class<?> cl) {
        // cl is needed because in TUtils, I don't know how to get the loader for WEB applets
        if (code != null) {
            return code;
        } else {
            String codetxt = "";
            try {
                java.io.InputStream is = com.jdcm.common.D_Utils.getFileStream(ClassName + ".java", "com/jdcm/modifiers/matrix",cl.getClassLoader());
                if (is == null) {
                    is = com.jdcm.common.D_Utils.getFileStream(ClassName + ".java", "com/jdcm/modifiers/stacks/",cl.getClassLoader());
                }
                while (is != null && is.available() > 0) {
                    byte[] b = new byte[is.available()];
                    int i = is.read(b);
                    b = java.util.Arrays.copyOf(b, i);
                    codetxt += new String(b);
                }
            } catch (IOException ex) {
                return null;
            }
            return codetxt;
        }
    }
}
