package com.jdcm.modifiers;

import java.util.zip.DataFormatException;
import java.util.zip.Deflater;
import java.util.zip.Inflater;

/**
 *Code/Uncode as Zip
 * 
 * @author Marc GIBOIN
 */
public class modif_deflater implements I_modifiers {

    private byte[] buffer;

    public modif_deflater() {
    }

    @Override
    public void setBuffer(byte[] b) {
        buffer = b;
    }

    @Override
    public byte[] getBuffer() {
        return buffer;
    }

    @Override
    public void ToClear() {
        // Decompress the bytes care !! less than 20? => missing 2 last bytes
        Inflater decompresser = new Inflater();
        decompresser.setInput(buffer, 0, buffer.length);
        byte[] result = new byte[buffer.length * 100];
        try {
            int resultLength = decompresser.inflate(result);
            decompresser.end();
            buffer = java.util.Arrays.copyOfRange(result, 0, resultLength);
        } catch (DataFormatException ex) {
        }
        // Decode the bytes into a String
    }

    @Override
    public void ToCode() {
        // Compress the bytes
        byte[] output = new byte[buffer.length];
        Deflater compresser = new Deflater();
        compresser.setInput(buffer);
        compresser.finish();
        int compressedDataLength = compresser.deflate(output);
        buffer = java.util.Arrays.copyOfRange(output, 0, compressedDataLength);
    }
}
