package com.jdcm.modifiers.stacks;
import com.jdcm.common.C_Packet;
import com.jdcm.eltrx.I_Port;
/**
 *STACK ELEMENT INTERFACE used to manage a buffer within the port.
 *  - matchprotocal is an automatic format detection by packet analyse
 * 
 * @author Marc GIBOIN
 */
public interface I_stack_elt extends java.lang.Cloneable{
    // implement the module manager
  public void setParents(I_Port portidx,com.jdcm.eltrx.C_Stack modmangt);
  // return decapsuled byte array => data
  public java.util.List<C_Packet> receive(C_Packet packet) throws Exception ;
  // return ecapsuled data=> packet
  public java.util.List<C_Packet> transmit(C_Packet data) throws Exception ;
  //return protocol assigned values
  public  com.jdcm.common.Options_Model getOptions();
    //return description of the module
 // public String getcomment();
      //return the OSI level of the module
 // public  double getosi();
//return if media is the source of created byte
    public boolean isfrommedia() ;
    public void setfrommedia(boolean bool) ;
        public void setName(String txt) ;
    //return if debug is actiated for this module
    public boolean isdebug() ;
    public void setdebug(boolean bool) ;
        //return the real 'osi' level of the module
  public void  setlevel(double level);
    public  double getlevel();
    //return the column in the table (!!=>portidx+1)
    public  I_Port getport();
    // teach state modification of the port
    public void StkArcv(String message, String type);
   // return disply protocol name
    @Override
    public String toString();
    //to manage TO => NOT IMPLEMENTED (no need??)
    public void onClock();
    // check if a list of frame match with the protocol (protocol detection)
     public abstract double matchProtocol(C_Packet pack);
     //configure Stack to copy received information in model and disable checks (transparentfor analyse)
      public void setCopyMode(boolean bool);
      public double getOsi();
}
