package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;

/**
 * Dumy is an fool proptocol that do nothing (for tests)
 *
 * @author Marc Giboin
 */
public class Stack_Dumy extends Stack_base {

    public Stack_Dumy() {
        super();
    }

    public static String getComment() {
        return "Empty template";
    }

    public static double getosi() {
        return 0.0;
    }

    /**
     * decapsule packet, check header and provide payload
     *
     * @param  packet
     * @return the payload
     */
    @Override
    public java.util.List<C_Packet> receive(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        liste.add(packet);
        return liste;
    }

    /**
     * encapsule payload in header to form packet
     *
     * @param packet the payload
     * @return the packets
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> transmit(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        liste.add(packet);
        return liste;
    }
}
