package com.jdcm.modifiers.stacks;

import com.jdcm.common.C_Packet;
import java.util.ArrayList;
import java.util.List;

/**
 * TODO : get a simple HTTP protocol today only for autodetect
 *
 * @author Marc GIBOIN
 *
 */
public class Stack_MIDI extends Stack_base {

    public Stack_MIDI() {
        super();
    }

    public static String getComment() {
        return "empty MIDI Stack for matching";
    }

    public static double getosi() {
        return 8.0;
    }

    @Override
    public List<C_Packet> receive(C_Packet packet) throws Exception {
        //List<C_Packet> res = new ArrayList<>();
        if (packet.isbuffer() == false || packet.getBytes().length == 0) {
            return null;
        }
      //  res.add(packet);
        return null;
    }

    @Override
    public List<C_Packet> transmit(C_Packet packet) throws Exception {
        // no need of upper Protocols
      //  List<C_Packet> res = new ArrayList<>();

     //   res.add(packet);
        return null;

    }

    @Override
    public double matchProtocol(C_Packet pack) {
        //http://www.omega-art.com/midi/mfiles.html
        double res = 0.0;
        if (pack.isbuffer()&&pack.getBytes().length>0 ) {
            byte[] buff = pack.getBytes();
            if ( buff[0] == 0x4d
                    && buff[1] == 0x54
                    && buff[2] == 0x68
                    && buff[3] == 0x64) {// strts with MThd
                res = 0.999999;
            }
        }
        return res;
    }
}
