/*
 * 
 */
package com.jdcm.tests;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.InvocationTargetException;
import java.net.Socket;
import java.security.KeyManagementException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.UnrecoverableKeyException;
import java.security.cert.CertificateException;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManagerFactory;

/**
 *  * THIS CLASS IS BE INDEPENDANT (RUNABLE, NO other lib,...)
 *
 * checks the Warantie and consultation of French Cheques FNCI avalable : FNCI :
 * BFXZE658R5 TRANSAX :40174263 C/S : 00040410736 IMC 11899: 9994236437 IMCCTM :
 * 9994213122
 *
 * @author M.Marc GIBOIN
 */
public class verifChq extends java.lang.Thread {

    boolean isssl;
    String certf;
    String certp;
    String adrpass = null;
    long starttime;
    int portp;
    int timeout;
    String snumb = null;
    String fab = null;
    String adresseX25;
    String adresseX25sec;
    String cud;
    String abonne;
    String rang = null;
    String bank;
    String bqlibelle;
    String bqcontact;
    String bqstatus;
    String fonction;
    boolean verbose;
    boolean stop;
    Object Parent = null;
    String query;
    java.lang.reflect.Method writemeth = null;
    static String[][] tableDoms = new String[][]{
        // "acqId","address","addrSec","Locked","libelle","network","cud","contact","lastVerif","x25cud"},
        // BP : 19628340506
        // CM : 1963597087778
        // CTM : 1963782131050: 9994213122
        // CA : 196282910340, 1962889410033
 {"18406","196376745810","","0","Crca de la Brie","X25","143520180351","","26/04/13",""},
{"18206","196282910840","","0","Crca Ile de France","X25","143520180351","0825 83 83 00","11/09/13",""},
{"18306","196282910840","","0","Crca Normandie Seine","X25","143520180351","(08) 11 65 12 06","02/09/13",""},
{"18025","1963400688831","","0","Caisse d epargne de Picardie","X25","143520180351","(08) 25 82 78 27","10/09/13",""},
{"18189","196370076","","0","Compagnie generale de credit aux particuliers - Credipar Sofib","X25","143520180351","","16/08/13",""},
{"18106","196376745810","","0","Crca Savoie","X25","143520180351","(08) 26 10 23 75","10/09/13",""},
{"17907","1963400688801","","0","Banque Populaire Val de France","X25","143520180351","","26/04/13",""},
{"17865","1963400688831","1963751703202","0","Caisse d epargne d Ile de France Ouest","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"17959","196358779","196353495","0","Banque Michel Inchauspe Bami","X25","143520180351","","27/06/13",""},
{"17906","196376746830","","0","Crca Anjou","X25","143520180351","","09/09/13",""},
{"17807","1963400688801","","0","Banque populaire Occitane","X25","143520180351","","11/09/13",""},
{"17695","1963400688831","","0","Caisse d epargne de haute Normandie","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"17806","196376746830","","0","Crca mutuel Centre-Est","X25","143520180351","(08) 25 08 08 25","11/09/13",""},
{"17607","1963400688801","","0","Banque populaire d Alsace","X25","143520180351","M. ATT Pikjula/Broda : (03) 89 31 65 35","19/08/13",""},
{"17649","196358779","","0","Banque Revillon","X25","143520180351","","Pbx",""},
{"17206","196282910840","","0","Crca mutuel Alsace Vosges","X25","143520180351","","14/05/13",""},
{"17219","1963400688804","","0","Credit Maritime Atlantique","X25","143520180351","","23/08/13",""},
{"17515","1963400688831","","0","Caisse d epargne Ile de France Paris","X25","143520180351","(08) 25 82 78 27","12/09/13",""},
{"17179","1963400688801","","0","Caisse regionale de credit maritime mutuel de la Mediterranee","X25","143520180351","","10/09/13",""},
{"17169","1963400688804","","0","Caisse regionale de credit maritime mutuel du littoral du sud ouest","X25","143520180351","","02/07/13",""},
{"17149","1963400688804","","0","Caisse regionale de credit maritime mutuel de Bretagne-Normandie","X25","143520180351","(08) 20 30 30 03","25/07/13",""},
{"17106","196376706820","","0","Crca Sud-Mediterranee (Ariege et Pyr. Orientales)","X25","143520180351","","22/08/13",""},
{"16945","1963400688831","","0","Caisse d epargne Rhone Alpes Lyon","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"16906","196282910840","","0","Crca Pyrennee-Gascogne","X25","143520180351","","27/08/13",""},
{"16807","1963400688801","","0","Banque Populaire Alpes","X25","143520180351","(08) 20 82 04 47","09/09/13",""},
{"16806","196376745810","","0","Crca Centre France","X25","143530742511","","04/09/13",""},
{"16707","1963400688801","","0","Banque Populaire de l Ouest","X25","143520180351","","28/08/13",""},
{"16706","196376745810","","0","Crca Nord De France","X25","143520180351","","12/09/13",""},
{"10057","196358779","196353495","0","Societe Bordelaise de C. Indus. Comm.","X25","143520180351","","30/08/13",""},
{"10071","196370076","","0","Tresor Public","X25","143520180351","811107040","05/09/13",""},
{"10096","196358779","196353495","0","Societe Lyonnaise - CIC","X25","143520180351","(08) 25 00 38 16","13/09/13",""},
{"10107","196374700","","0","Bred (laPoste sur 20041)","X25","143520180351","","11/09/13",""},
{"10178","1963400688801","","0","Banque Chaix","X25","143520180351","","26/08/13",""},
{"10206","196282910840","","0","Crca Nord Est","X25","143520180351","(08) 25 31 31 00","25/04/13",""},
{"10207","1963400688801","","0","Banque Populaire Sud Paris","X25","143520180351","","13/09/13",""},
{"10228","1963782411711","196359739","1","Banque Laybernier  [CDN]","X25","143520180351","0820 82 20 20","04/04/13",""},
{"10268","1963782411711","196359739","1","Banque Courtois [CDN]","X25","143530742511","0820822020","26/03/13",""},
{"10278","196353495","196353498","0","Credit Mutuel de L Est","X25","143520180351","(08) 25 00 38 16","13/09/13",""},
{"10307","1963400688801","","0","Banque Populaire du Nord Paris","X25","143520180351","","18/03/13",""},
{"10468","1963782411711","1963400688808","1","Banque Rhône Alpes [CDN]","X25","143520180351","0820 82 20 20","26/03/13",""},
{"10548","1963400688801","","0","Banque de Savoie","X25","143520180351","","05/09/13",""},
{"10558","1963782411711","1963400688831","1","Banque Tarneaud [CDN]","X25","143520180351","0820 82 20 20","26/03/13",""},
{"10607","1963400688801","","0","Banque Populaire Anjou Vendee","X25","143520180351","","Pbx",""},
{"10638","1963400688804","","0","Credit Commercial du Sud Ouest","X25","143520180351","","29/08/13",""},
{"10807","1963400688801","","0","Banque Populaire","X25","143520180351","820888383","27/08/13",""},
{"10907","1963400688801","196376706820","0","Banque Populaire d Acquitaine (alias du sud ouest)","X25","143520180351","","13/09/13",""},
{"11006","196376745810","","0","Crca de Champagne Bourgogne","X25","143520180351","","13/09/13",""},
{"11206","196376706820","","0","Crca Albi - Aveyron Rodez","X25","143520180351","","19/08/13",""},
{"11306","196376706820","","0","Crca Alpes Provence","X25","143520180351","Roseline RIEUX 04 42 19 26 30","11/09/13",""},
{"11315","1963400688831","","0","Caisse d epargne Provence Alpes corse","X25","143520180351","(08) 25 82 78 27","13/09/13",""},
{"11378","196359739","","0","Banco Portugues de Negocios S.A.","X25","143520180351","","00/01/00",""},
{"11425","1963400688831","","0","Caisse d epargne de Basse Normandie","X25","143520180351","(08) 25 82 78 27","15/07/13",""},
{"11449","196370076","","0","Banque Themis","X25","143520180351","(08) 11 10 70 40","16/09/13",""},
{"11706","196376746830","","0","Crca Charente-Maritime Deux-Sevres","X25","143520180351","","03/09/13",""},
{"11899","196353495","196353498","0","Credit Mutuel (BECM-Arkea)","X25","143520180351","08 10 00 46 48","05/09/13",""},
{"11907","1963400688801","","0","Banque Populaire du Massif central","X25","143520180351","810808001","10/09/13",""},
{"11989","1963400688808","","0","Banque Pouyanne","X25","143520180351","","05/06/13",""},
{"12006","196376706820","","0","Crca Corse","X25","143520180351","","30/07/13",""},
{"12135","1963400688831","","0","Caisse d epargne de Bourgogne","X25","143520180351","(08) 25 82 78 27","29/07/13",""},
{"12206","196376745810","","0","Crca des Cotes-d Armor","X25","143520180351","","05/09/13",""},
{"12225","1963400688831","","0","Caisse d epargne de Bretagne","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"12319","196358779","","0","Athenais CIC","X25","143520180351","(08) 25 00 38 16","00/01/00",""},
{"12406","196376746830","","0","Crca Charente-Perigord","X25","143520180351","","24/04/13",""},
{"12506","196376745810","","0","Crca de Franche-Comte","X25","143520180351","(08) 10 20 23 12","16/08/13",""},
{"12515","1963400688831","","0","Caisse d epargne de Franche comte","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"12579","1963400688831","","0","Banque Bcp","X25","143520180351","","09/09/13",""},
{"12589","196359739","","0","Banco BPI","X25","143520180351","","28/05/13",""},
{"12619","1963782134071","1963782124071","0","Banque Caixa","X25","143530742511","","29/08/13",""},
{"12869","19637824130160","","0","Banque ACCORD","X25","143520180351","(03) 28 38 58 88","00/01/00",""},
{"12879","1963782124071","1963782134071","0","Banque Delubac et Cie","X25","143530742511","","09/09/13",""},
{"12906","196376745810","","0","Crca du Finistere","X25","143520180351","","30/05/13",""},
{"12939","196359739","","0","Banque Dupuy de Parseval","X25","143520180351","","17/07/13",""},
{"13106","196376706820","","0","Crca Toulouse 31","X25","143520180351","","16/07/13",""},
{"13135","1963400688831","","0","Caisse d epargne de Midi Pyrenees","X25","143520180351","(08) 25 82 78 27","03/09/13",""},
{"13149","196353495","196353498","0","Edel (Leclerc)","X25","143520180351","(08) 25 00 38 16","16/05/13",""},
{"13259","1963782411711","1963400688808","1","Banque Kolb [CDN]","X25","143520180351","0820 82 20 20","25/04/13",""},
{"13298","196353495","196353498","0","Banque Cooperative & mutuelle nord","X25","143520180351","","25/04/13",""},
{"13306","196376746830","19635616472","0","Crca d Aquitaine","X25","143530742511","","12/09/13",""},
{"13335","1963400688831","","0","Caisse d epargne Aquitaine Nord","X25","143520180351","(08) 25 82 78 27","29/08/13",""},
{"13369","196358779","196353495","0","Banque Martin - Maurel","X25","143520180351","","28/05/13",""},
{"13379","1963400688804","","0","Banque Marze","X25","143520180351","825301212","26/08/13",""},
{"13485","1963400688831","","0","Caisse d epargne du Languedoc Roussillon","X25","143520180351","(08) 25 82 78 27","22/08/13",""},
{"13489","1963782411711","196359739","1","Banque Nuger [CDN]","X25","143520180351","0820 82 20 20","02/04/13",""},
{"13506","196376706820","","0","Crca Languedoc","X25","143520180351","","10/09/13",""},
{"13507","1963400688804","","0","Banque Populaire du Nord","X25","143520180351","","24/07/13",""},
{"13529","1963400688804","","0","Banque Pelletier","X25","143520180351","(08) 20 82 06 04","25/04/13",""},
{"13606","196376746830","","0","Crca Ile et Villaine","X25","143520180351","","31/05/13",""},
{"13607","1963400688801","","0","Banque populaire Centre Atlantique (2eme du nom)","X25","143520180351","","21/03/13",""},
{"13705","1963400688831","","0","Caisse d epargne Centre Val de Loire","X25","143520180351","(08) 25 82 78 27","Pbx",""},
{"13807","1963400688801","","0","Banque Populaire Atlantique","X25","143520180351","","27/08/13",""},
{"13825","1963400688831","","0","Caisse d epargne des Alpes","X25","143520180351","(08) 25 82 78 27","05/09/13",""},
{"13906","196376745810","","0","Crca Sud Rhone-Alpes","X25","143520180351","","05/08/13",""},
{"13907","1963400688801","196376745810","0","Banque populaire Loire et Lyonnais","X25","143520180351","","16/09/13",""},
{"14006","19628503684","","0","Crca de la Guadeloupe","X25","143520180351","","Pbx",""},
{"14265","1963400688831","","0","Caisse d epargne Loire Drome Ardeche","X25","143520180351","(08) 25 82 78 27","05/09/13",""},
{"14406","196282910840","","0","Crca Val de France","X25","143520180351","0977 400 516","22/08/13",""},
{"14445","1963400688831","","0","Caisse d epargne des Pays de la Loire","X25","143520180351","(08) 25 82 78 27","13/08/13",""},
{"14505","1963400688831","","0","Caisse d epargne Val de France orleanais","X25","143520180351","(08) 25 82 78 27","13/09/13",""},
{"14506","196376745810","","0","Crca Haute Loire","X25","143520180351","(09) 69 32 04 42","29/04/13",""},
{"14607","1963400688801","","0","Banque Populaire(PACA) et Corse","X25","143520180351","","05/09/13",""},
{"14706","1963400688809","","0","Crca Atlantique Vendee","X25","143520180351","","16/04/13",""},
{"14707","1963400688806","","0","Banque Populaire Lorraine","X25","143520180351","","10/09/13",""},
{"14806","196376706820","","0","Crca Centre Loire","X25","143520180351","","10/07/13",""},
{"14978","196358779","","0","NSM (Absente BDF)","X25","143520180351","","00/01/00",""},
{"15128","196370076","","0","Volkswagen Bank","X25","143520180351","","28/05/13",""},
{"15135","1963400688831","","0","Caisse d epargne de Champagne Ardenne","X25","143520180351","(08) 25 82 78 27","03/09/13",""},
{"15455","1963400688831","","0","Caisse d epargne des Pays lorrains","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"15459","196358779","196353495","0","Credit Mutuel Centre","X25","143520180351","","Pbx",""},
{"15489","196353495","196353498","0","Caisse federale du credit mutuel de Maine-Anjou et Basse-Normandie","X25","143520180351","","21/06/13",""},
{"15519","196353495","196353498","0","Caisse Feder Cit Mut Ocean","X25","143520180351","","16/07/13",""},
{"15589","1963725012","","0","Credit Mutuel de Bretagne","X25","143520180351","","12/09/13",""},
{"15607","1963400688801","","0","Banque Populaire de Nice - du Var","X25","143520180351","489811016","29/08/13",""},
{"15629","196353495","196353498","0","Caisse Feder Cit Mut Nord de la France","X25","143520180351","","17/05/13",""},
{"15707","1963400688805","","0","Banque Populaire du Midi","X25","143520180351","","25/04/13",""},
{"15749","196353495","196358779","0","Credit Mutuel Centre Ouest","X25","143520180351","","Pbx",""},
{"15755","1963400688831","","0","Caisse d epargne de Lorraine Nord","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"15829","196353495","","0","Caisse federale du credit mutuel d Anjou","X25","143520180351","","01/01/13",""},
{"15899","196353495","196358779","0","Caisse interfederale du credit mutuel sud Europe Mediterranee","X25","143520180351","","Pbx",""},
{"15905","1963400688831","","0","Caisse d epargne des Pays du Hainaut","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"15959","19628344484","1963725012","0","Credit Mutuel Normandie","X25","143520180351","","Pbx",""},
{"15965","1963400688831","","0","Caisse d epargne de Flandre","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"15999","196353495","","0","Credit Mutuel du Nord (Absent BDF?)","X25","143520180351","","Pbx",""},
{"16006","196376745810","","0","Crca du Morbihan","X25","143520180351","","04/09/13",""},
{"16106","196282910840","196376745810","0","Crca Lorraine","X25","143520180351","","02/09/13",""},
{"16275","1963400688831","","0","Caisse d epargne du Pas de Calais","X25","143520180351","(08) 25 82 78 27","30/07/13",""},
{"16325","1963400688831","","0","Caisse d epargne d Auvergne","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"16485","1963400688831","","0","Caisse d epargne des Pays de l Adour","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"16606","196376746830","","0","Crca de Normandie","X25","143520180351","","09/09/13",""},
{"16607","1963400688805","","0","Banque Populaire Sud","X25","143520180351","","09/09/13",""},
{"16705","1963400688831","","0","Caisse d epargne d Alsace","X25","143520180351","(08) 25 82 78 27","09/07/13",""},
{"30041","19635874672","","0","La Poste (Province)","X25","143520180351","","Pbx",""},
{"30047","196358779","196353495","0","HSBC UBP","X25","143520180351","","09/09/13",""},
{"30027","196358779","196353495","0","Banque Scalbert Dupont","X25","143520180351","","13/09/13",""},
{"30007","1963400688801","","0","Natexis Banque","X25","143520180351","","25/04/13",""},
{"30004","19635775363","19635775263","0","Bnpp","X25","143530102511","(08) 25 07 27 47","14/09/13",""},
{"30003A","1911149921899","","0","Societe Generale homologation","X25","143520180351","","00/01/00",""},
{"30003","1963782411811","","0","Societe Generale","X25","143520180351","","14/09/13",""},
{"30002","1963782124071","196370076","1","Credit Lyonnais","X25","143520180351","(04) 42 25 15 65","25/03/13",""},
{"30001","196370076","196370076","0","Tresor Public","X25","143520180351","","16/08/13",""},
{"20041","19637824100121","","0","La Banque Postale","X25","143530742511","","13/09/13",""},
{"19806","19628503684","","0","Crca de la Martinique et de la Guyane","X25","143520180351","","Pbx",""},
{"19906","196376706820","","0","Crca de la Reunion","X25","143520180351","","Pbx",""},
{"19725","1963400688831","","0","Caisse d epargne de la Guadeloupe","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"19525","1963400688831","196354070810","0","Caisse d epargne Ile de France Nord","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"19506","196376746830","","0","Crca du Centre Ouest","X25","143520180351","(08) 11 65 08 24","19/08/13",""},
{"19229","1963400688801","","0","Banco de Sabadell","X25","143520180351","","26/04/13",""},
{"19406","196376745810","","0","Crca Touraine Poitou","X25","143520180351","","05/09/13",""},
{"18906","19637714553884","","0","Crca Sud Alliance","X25","143520180351","","Pbx",""},
{"19106","196376746830","","0","Crca Provence Alpes Cote d Azur","X25","143520180351","","10/09/13",""},
{"18315","1963400688831","","0","Caisse d epargne Cote d Azur l arenas","X25","143520180351","(08) 25 82 78 27","26/08/13",""},
{"18829","1963725012","","0","Bcme-arkea","X25","143520180351","(08) 10 00 46 68","20/08/13",""},
{"18715","1963400688831","","0","Caisse d epargne du Limousin","X25","143520180351","(08) 25 82 78 27","21/05/13",""},
{"18707","1963400688804","","0","Banque Populaire Val de France","X25","143520180351","","12/09/13",""},
{"18706","1963782411811","","0","Crca Brie Picardie","X25","143520180351","","23/05/13",""},
{"18645","1963751693202","1963400688831","0","Caisse d epargne de Poitou Charentes","X25","143520180351","(08) 25 82 78 27","00/01/00",""},
{"30056","1963400688809","1963400688801","0","HSBC","X25","143520180351","820820605","12/09/13",""},
{"30066","196358779","196353495","0","CIC","X25","143520180351","(08) 25 00 38 16","13/09/13",""},
{"30076","1963782411711","1963400688808","1","Credit du Nord  [CDN]","X25","143520180351","0820 82 20 20","04/04/13",""},
{"30077","1963782411711","1963400688808","1","Societe Marseillaise de Credit [CDN]","X25","143520180351","0820 82 2020","04/04/13",""},
{"30087","196358779","196353495","0","Societe Nanceienne Varin-Bernier (CIC Est)","X25","143520180351","","10/09/13",""},
{"30118","1963400688809","","0","HSBC de Baecque Beau","X25","143520180351","","21/05/13",""},
{"30368","1963400688809","","0","HSBC Hervet","X25","143520180351","","20/06/13",""},
{"30488","196358779","","0","Fortis Banque France","X25","143520180351","","Pbx",""},
{"30778","19635346191","","0","Morgan Guarranty Trust Compagnie of NewYork","X25","143520180351","","00/01/00",""},
{"30788","196358779","196353495","0","Banque Neuflize Schlumberger Mallet Dema","X25","143520180351","","14/08/13",""},
{"30938A","19635346191","","0","HSBC UBP","X25","143520180351","","00/01/00",""},
{"30938","1963400688809","","0","HSBC UBP","X25","143520180351","","25/04/13",""},
{"40168","19635874870","","0","Banque de Bretagne","X25","143520180351","","Pbx",""},
{"40618","196358779","","0","Caixa Banque (Boursorama)","X25","143520180351","(04) 42 25 15 61","00/01/00",""},
{"40868","196348772","","0","Via Banque","X25","143520180351","","00/01/00",""},
{"40978","1963400688801","","0","banque Palatine","X25","143520180351","","04/09/13",""},
{"41189","196359739","","0","Bbva","X25","143520180351","","11/06/13",""},
{"41199","196353498","","0","CIC Iberbanco","X25","143520180351","08 11 90 10 33","Pbx",""},
{"41439","196359739","","0","Banque Chaabi du Maroc","X25","143520180351","","Pbx",""},
{"41919","196359739","","0","BNP Paribas Reunion","X25","143520180351","","26/04/13",""},
{"42559","1963400688801","","0","BFCC - Credit Cooperatif","X25","143520180351","","12/09/13",""},
{"43659","196359739","","0","Banque Espirito Santo et de la Venetie","X25","143520180351","","03/09/13",""},
{"43849","1963400688801","","0","Tunisian foreign bank (ex UTB)","X25","143520180351","825301212","19/08/13",""},
{"10278","145.226.35.25:9010","196353498","0","Credit Mutuel de L Est","TCP","143520180351","","12/09/13",""},
{"20041","194.50.38.15:5446","194.50.38.143:5446","0","La Banque Postale","TCP","143530742511","","17/07/13",""},
{"18029","19637518000077","","0","BNPP Personal Finance (CETELEM)","X25","143520180351","01.46.39.11.88 M. Clement ou CETELEM","00/01/00",""},
{"30066","145.226.99.25:9012","196353495","0","CIC","TCP","143520180351","","13/09/13",""},
{"14818","1963400688801","","0","Banca regionale Europea S.p.A.","X25","143520180351","","18/06/13",""},
{"30478","196358779","196353495","0","Monte Paschi banque S.A.","X25","143520180351","","30/07/13",""},
{"FNCI","196282995","","0","Vérifiance/Resist/Mantis...","X25","","(01) 44 76 90 82","OK 08_2013","V4C1"},
{"TRANSAX","19637824100110","","0","Transax/Certegy/FIS/..","X25","","(01) 70 73 40 00","OK 08-2013","0"},
{"C/S","196285097","","0","Cheque Service / ATOS","X25","","(01) 40 08 65 33","OK 08-2013","MGCH"},
{"IMCCTM","1963782131050","","0","IMC by CTM [MONEXT]","X25","","(08) 25 32 30 13","OK 08-2013","DCCHEQUE\r"},
{"IMC10268","196356133","","0","IMC Banque Courtois","X25","","","not tested","DCCHEQUE\r"},
{"IMC11006","19635005931","","0","IMC CA Champagne","X25","","","OK 08-2013","DCCHEQUE\r"},
{"IMC11899","1963597087778","","0","IMC BECM","X25","","ATTCM 0825003816","tested OK 08_2013","DCCHEQUE\r"},
{"IMC13259","19637824100170","","0","IMC Banque KOLB","X25","","","tested 08-2013","DCCHEQUE\r"},
{"IMC14506","19635005931","","0","IMC CA Haute Loire","X25","","","KO?","DCCHEQUE\r"},
{"IMC14806"," 19637714553300","","0","IMC CA Centre Loire","X25","","","OK 08-2013","DCCHEQUE\r"},
{"IMC16807","19628340506","","0","IMC Banque Populaire Alpes","X25","","","non testee","DCCHEQUE\r"},
{"IMC17607","19628340502","","0","IMC BP Alsace","X25","","03 89 31 63 50 |03 89 31 65 46","OK 08_2013","DCCHEQUE\r"},
{"IMC17206","196282910340","1962889410033","0","IMC CA Alsace Vosges","X25","","","0K 08 2013","DCCHEQUE\r"},
{"IMC17806","196282910340","1962889410033","0","IMC CA Centre Est","X25","","","serveur KO?","DCCHEQUE\r"},
{"IMC18206","196282910340","1962889410033","0","IMC CA Ile de France","X25","","","OK 08-2013","DCCHEQUE\r"},
{"IMC18306","19628894134","","0"," IMC CA Normandie","X25","","","not tested","DCCHEQUE\r"},
{"IMC20041","196378271","","0","IMC La Banque Postale","X25","","","not tested","DCCHEQUE\r"},
{"IMC30002","1963725150011","","0","IMC Le Crédit Lyonnais","X25","","","OK 08-2013","DCCHEQUE\r"},
{"IMC30003","196374932","","0","IMC Société Générale","X25","","","OK 08-2013","DCCHEQUE\r"},
{"IMC30004"," 1963725150011","","0","IMC BNPP","X25","","","OK 08-2013","DCCHEQUE\r"},
{"IMC30087","1963597087778","","0","IMC Societe Nanceienne Varin-Bernier (CIC Est)","X25","","","not tested","DCCHEQUE\r"}		
    };

    public static javax.swing.table.DefaultTableModel getBankList() {
        return new javax.swing.table.DefaultTableModel(tableDoms, new String[]{"acqId", "address", "addrSec", "Locked", "libelle", "network", "itpCBemv", "contact", "lastVerif","x25cud"});
    }

    public static Object[] getArguments(String[] arstring) {
        boolean ssl = false;
        String adrx25 = null;// "196281234";
        String adrx25_sec = null;// "196281234";
        String cudx25 = null;
        boolean v = false;
        String banque = "FNCI";
        int to = 10000;
        int port = 5496;
        String adip = "193.56.46.150";
        String sn = "FT11111111";
        String f = "SAGEM";
        String domiciliation = null;
        String rg = "001";
        String cf = "otikfr.jks";
        String cp = "123456";
        String q = null;
        String bqlbl = null;
        String bqctc = null;
        String bqstat = null;
        if (arstring == null || arstring.length == 0) {
            arstring = new String[]{"-?"};
        }
        for (String opt : arstring) {
            if (opt.startsWith("-f")) {
                f = opt.substring(2).trim();
            } else if (opt.startsWith("-v")) {
                v = true;
            } else if (opt.startsWith("-r")) {
                rg = opt.substring(2).trim();
            } else if (opt.startsWith("-hp")) {
                adrx25 = opt.substring(3).trim();
                adrx25_sec = null;
            } else if (opt.startsWith("-hs")) {
                adrx25_sec = opt.substring(3).trim();
            } else if (opt.startsWith("-q")) {
                q = opt.substring(2).trim();
            } else if (opt.startsWith("-i")) {
                domiciliation = opt.substring(2).trim();
            } else if (opt.startsWith("-D")) {
                cudx25 = opt.substring(2);
            } else if (opt.startsWith("-a")) {
                try {
                    banque = opt.substring(2).trim();
                    if (adrx25 == null) {
                        String[] txts = getCTM(banque);
                        if (txts != null) {
                            adrx25 = txts[1];
                            adrx25_sec = txts[2];
                            bqlbl = txts[4];
                            bqctc = txts[7];
                            bqstat = txts[8];
                            if (cudx25 == null) {
                                cudx25 = txts[9];
                            }
                        } else {
                            System.err.println("address needed for bank : " + opt.substring(2).trim());
                        }
                    }
                } catch (Exception ex) {
                    System.err.println("!! Pb acquirer (bank) not set : " + ex.getMessage());
                }
            } else if (opt.startsWith("-b")) {
                adip = opt.substring(2).trim();
            } else if (opt.startsWith("-p")) {
                try {
                    port = new Integer(opt.substring(2).trim());
                } catch (Exception ex) {
                    System.err.println("!! Pb -p not set");
                }
            } else if (opt.startsWith("-cf")) {
                cf = opt.substring(3).trim();
            } else if (opt.startsWith("-cp")) {
                cp = opt.substring(3).trim();
            } else if (opt.startsWith("-ssl")) {
                ssl = true;
            } else if (opt.startsWith("-V")) {
                domiciliation = "ABCDE00A99";
                bqlbl = "Verifiance DEMO";
                adrx25 = "196376752";
                banque = "FNCI";
                cudx25 = "V7DE";
                /*   adip="localhost";
                 port=148;
                 ssl=false;*/
            } else if (opt.startsWith("-T")) {
                ssl = false;
                domiciliation = "0040241200";
                bqlbl = "Transax";
                adrx25 = "19628503834";
                banque = "TRANSAX";
                cudx25 = "0000000";
            } else if (opt.startsWith("-?")) {
                System.out.println("----------BUGS--------------------------");
                System.out.println(" Vérifier la GARANTIE avec le cheque de test utilisé ");
                System.out.println(" ");
                System.out.println("----------------------------------------");
                System.out.println("-v : verbose");
                System.out.println("-b : IP/URL adress for IP/X25 bridge [193.56.46.150]");
                System.out.println("-p : tcp port for IP/X25 bridging service [5496]");
                System.out.println("-h : X25 host adress <16");
                System.out.println("-t : timeout [10s]");
                System.out.println("-q : if spécified, return libelle as result");
                System.out.println("-f : equiment maker <10 [SAGEM]");
                System.out.println("-n : equipment Serial Number <20 [FT11111111]");
                System.out.println("-ssl : use SSL with certificat otikfr.jks");
                System.out.println("-i : abonnee");
                System.out.println("-D : X25 donnees complementaires");
                System.out.println("-r : terminal identifier (/3)");
                System.out.println("-a : acquaring bank (/5)");
                System.out.println("-B : check X25 test via ATOS by EFT SMART (le WARF)");
                System.out.println("-V : Verifiance consultation ");
                System.out.println("-T : TRANSAX consultation");
                System.out.println("-SSL : check ATOS SSL TCP connexion");
                return new Object[]{};
            } else {
                System.out.println("invalid option : " + opt);
                return null;
            }
        }
        if (domiciliation.length() > 14 && banque.compareTo("FNCI") == 0) {
            System.err.println("termid : wrong identifier size (" + domiciliation.length() + ") for " + domiciliation);
            return null;
        }
        if (cudx25.length() > 15) {
            System.err.println("termid : wrong identifier size (" + cudx25.length() + ") for " + cudx25);
            return null;
        }

        return new Object[]{v, f, adrx25, adrx25_sec, cudx25, sn, to, adip, port, ssl, domiciliation, rg, cf, cp, q, banque, bqlbl, bqctc, bqstat};
    }

    static private String[] getCTM(String banqueId) {

        for (String[] dom : tableDoms) {
            if (dom[0].compareTo(banqueId) == 0 || dom[0].compareTo("IMC" + banqueId) == 0) {
                String[] res = new String[]{dom[0], dom[1], dom[2], dom[3], dom[4], dom[5], dom[6], dom[7], dom[8],dom[9]};
                return res;
            }
        }
        return null;
    }

    public verifChq(boolean v, String f, String a, String a2, String cudx25, String s, int t, String adrp, int pp,
            boolean ssl, String abo, String rng, String cf, String cp, String q,
            String banq, String bqlbl, String bqctc, String bqst) {
        stop = false;
        adresseX25 = a;
        adresseX25sec = a2;
        timeout = t;
        fab = f;
        cud = cudx25;
        query = q;
        bank = banq;
        snumb = s;
        portp = pp;
        adrpass = adrp;
        isssl = ssl;
        abonne = abo;
        rang = rng;
        verbose = v;
        certf = cf;
        certp = cp;
        bqlibelle = bqlbl;
        bqcontact = bqctc;
        bqstatus = bqst;
    }

    public void askStop() {
        stop = true;
    }

    private SSLContext getSSLcontext() {
        SSLContext cotx;
        KeyStore ks;
        KeyStore ts;
        KeyManagerFactory kmf;
        TrustManagerFactory tmf;
        try {
            try {
                cotx = SSLContext.getInstance("TLS");
                kmf = KeyManagerFactory.getInstance("SunX509");
                tmf = TrustManagerFactory.getInstance("SunX509");
            } catch (java.security.NoSuchAlgorithmException e) {

                writeResult("SSL : Invalid Algorithm or protocol [" + e.getMessage() + "]");
                return null;
            }
            try {
                ks = KeyStore.getInstance("JKS");
                ts = KeyStore.getInstance("JKS");
            } catch (java.security.KeyStoreException e) {
                writeResult("SSL : Invalid Keystor Type [" + e.getMessage() + "]");
                return null;
            }
            ks.load(ClassLoader.getSystemResourceAsStream(certf), certp.toCharArray());
            ts.load(ClassLoader.getSystemResourceAsStream(certf), certp.toCharArray());
            kmf.init(ks, certp.toCharArray());
            tmf.init(ts);
            cotx.init(kmf.getKeyManagers(), tmf.getTrustManagers(), null);
            // see if possible to customize tmf to allow/refuse cert (ex : as microsoft)
            //Interface ManagerFactoryParameters
            //CertPathParameters
        } catch (IOException | NoSuchAlgorithmException | CertificateException | KeyStoreException | UnrecoverableKeyException | KeyManagementException e) {
            writeResult("Pb creating SSL context [" + e.getMessage() + "]");
            return null;
        }
        return cotx;
    }

    private void writeResult(String txt) {
        if (query != null && query.length() > 0) {
            if (txt.contains(query) == false) {
                return;
            }
        }
        if (writemeth != null && Parent != null) {
            try {
                writemeth.invoke(Parent, new Object[]{txt});
            } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
                System.out.println("Pb affichage :'" + txt + "' =>" + ex);
            }
        } else {
            System.out.println(txt);
        }
        if (query != null && query.length() > 0) {
            if (txt.contains(query)) {
                exit(0);
            }
        }

    }

    public void setWMethod(Object parent, java.lang.reflect.Method m) {
        writemeth = m;
        Parent = parent;
    }

    private void exit(int nb) {
        if (writemeth == null && Parent == null) {
            System.exit(nb);
        } else {
            writeResult("--END--");
            writemeth = null;
        }
    }

    private Integer scanContract() {

        byte[] res;
        SSLContext ctx;
        java.net.Socket sslsocket;
        OutputStream out = null;
        InputStream in = null;
        String SSLcomment = "";
        if (verbose) {
            writeResult("Creating socket ");
        }
        int result = 0;
        try {
            SSLSocketFactory sslsocketfactory = null;
            ctx = getSSLcontext();
            if (ctx == null) {
                writeResult("SSL contaxt is null, pb reading certificats?");
                return -1;
            } else {
                sslsocketfactory = ctx.getSocketFactory();
            }
            sslsocket = null;
            starttime = System.currentTimeMillis();
            if (isssl && sslsocketfactory != null) {
                SSLcomment = "+SSL";
                sslsocket = (SSLSocket) sslsocketfactory.createSocket(adrpass, portp);
                ((SSLSocket) sslsocket).setUseClientMode(true);
                ((SSLSocket) sslsocket).startHandshake();
            } else if (!isssl) {
                sslsocket = new Socket(adrpass, portp);
            } else {
                writeResult("sslSocket shuld be null");
            }

        } catch (Exception e) {
            if (verbose) {
                writeResult("exception " + e.getMessage());
            }
            writeResult("Could not get TCP/IP socket : " + adrpass + "#" + portp + SSLcomment + " (" + (System.currentTimeMillis() - starttime) + "ms)");
            return -2;
        }
        if (verbose) {
            writeResult("Socket to " + adrpass + "#" + portp + " ..OK");
            writeResult("Start streams in/out");
        }
        if (sslsocket != null) {
            try {
                sslsocket.setSoTimeout(10);
                out = sslsocket.getOutputStream();
                in = sslsocket.getInputStream();
            } catch (Exception e) {
                if (verbose) {
                    writeResult("exception =>" + e.getMessage());
                }
                writeResult("could not open streams: " + adrpass + "#" + portp + SSLcomment);
                return -2;
            }
        }
        if (in == null || out == null) {
            return -2;
        }
        if (verbose) {
            writeResult("=> in : " + in + " out : " + out);
            writeResult("Streams OK");
        }
        try {
            if (adresseX25 == null) {
                if (in != null) {
                    // simply test TCP socket
                    writeResult(adrpass + " TCP : " + portp + SSLcomment + " (" + (System.currentTimeMillis() - starttime) + "ms)");
                    if (abonne != null && bank != null) {
                        writeResult(adrpass + " DOMICILIATION  : " + abonne + " banque : " + bank + "");
                        return -2;
                    } else {
                        return 0;
                    }
                } else {
                    writeResult(adrpass + " TCP : " + portp + SSLcomment + " (" + (System.currentTimeMillis() - starttime) + "ms) ");
                    return -1;
                }
            } else {
                if (adresseX25.compareTo("0") == 0) {
                    if (verbose) {
                        writeResult("Direct Cbcom, no RFC");
                    }
                    //res=rfc1086Data(cbcom0); NO FULL IP  send 0xC1...on tcp
                    res = null;
                } else {
                    if (verbose) {
                        writeResult("buid RFC init");
                    }
                    byte[] init_rfc1 = {0x04, 0x01};
                    //====================FABRICANT=====================
                    byte[] fabr = fab.getBytes();
                    int fabrl = fabr.length;
                    fabr = java.util.Arrays.copyOf(fabr, 11);
                    if (fabrl < 128) {
                        fabr[10] = (byte) fabrl;
                    } else {
                        writeResult("Maker adresse abnormaly long (>10)");
                        return -2;
                    }
                    byte[] init_rfc1bis = {0x39, 0x30, 0x30, 0x30, 0x30, 0x34, 0x39, 0x38, 0x00, 0x00, 0x08};
                    //
                    //====================Serial Number===============
                    //byte[] addrx25 = {0x31,0x39,0x36,0x32,0x38,0x31,0x032,0x33,0x34,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09};//arstring[0].getBytes();
                    byte[] sn = snumb.getBytes();
                    int snl = sn.length;
                    sn = java.util.Arrays.copyOf(sn, 21);
                    if (snl < 20) {
                        sn[20] = (byte) snl;
                    } else {
                        writeResult("Serial number adresse abnormaly long (>20)");
                        return -2;
                    }
                    //======================MAC===================
                    byte[] mac = "001556ADE07B".getBytes();
                    int macl = mac.length;
                    mac = java.util.Arrays.copyOf(mac, 21);
                    if (macl < 20) {
                        mac[20] = (byte) macl;
                    } else {
                        writeResult("MAC adresse abnormaly long (>20)");
                        return -2;
                    }
                    byte[] init_rfc2 = {0x00, 0x01, 0x01, 0x00, 0x03};
                    // RFC de test
                    //0x04 0x01 0x53 0x41 0x47 0x45 0x4d 0x00 0x00 0x00 0x00 0x00 0x05 0x39 0x30 0x30 0x30 0x30 0x34 0x39 0x38 0x00 0x00 0x08 0x46 0x54 0x31 0x30 0x34 0x31 0x34 0x33 0x37 0x33 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x0a 0x30 0x30 0x31 0x35 0x35 0x36 0x41 0x44 0x45 0x30 0x37 0x42 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x0c 0x00 0x01 0x01 0x00 0x03 0x31 0x39 0x36 0x32 0x38 0x31 0x32 0x33 0x34 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x09 0x00 0x00 0x00 0x00 0x00 0x01 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x04 0x00 0x00 0x00 0x00 0x00 0x00 0x00 0x03 0x00 0x00 0x0f 0xc2 0x09 0x05 0x04 0x12 0x01 0x11 0x30 0x08 0x01 0x01
                    //============adresse x25===============
                    //byte[] addrx25 = {0x31,0x39,0x36,0x32,0x38,0x31,0x032,0x33,0x34,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x09};//arstring[0].getBytes();
                    byte[] addrx25 = adresseX25.getBytes();
                    int addrl = addrx25.length;
                    addrx25 = java.util.Arrays.copyOf(addrx25, 17);
                    if (addrl < 16) {
                        addrx25[16] = (byte) addrl;
                    } else {
                        writeResult("X25 adresse abnormaly long (>20)");
                        return -2;
                    }
                    //============CUD===============
                    byte[] cudbuff = cud.getBytes();
                    cudbuff = addtab(new byte[]{0x01, 0x00, 0x00, 0x00}, cudbuff);
                    int cudl = cudbuff.length;
                    cudbuff = java.util.Arrays.copyOf(cudbuff, 17);
                    if (addrl < 16) {
                        cudbuff[16] = (byte) cudl;
                    } else {
                        writeResult("CUD abnormaly long (>15); care 01:00:00:00 with CUD");
                        return -2;
                    }
                    //==========rest of frame===============
                    byte[] rfc_proto = {0x00, 0x00, 0x00, 0x00, 0x00};
                    byte[] end_rfc = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
                    res = addtab(init_rfc1, fabr);
                    res = addtab(res, init_rfc1bis);
                    res = addtab(res, sn);
                    res = addtab(res, mac);
                    res = addtab(res, init_rfc2);
                    res = addtab(res, addrx25);
                    res = addtab(res, rfc_proto);
                    res = addtab(res, cudbuff);
                    res = addtab(res, end_rfc);
                    //    res = addtab(res, rfc1086Data(cbcom0)); chq send directly C1...
                    if (verbose) {
                        writeResult("Send RFC init");
                    }
                }
                if (bank.compareTo("FNCI") == 0 || bank.compareTo("TRANSAX") == 0 || bank.compareTo("C/S") == 0) {
                    //CBCOM for CONSULTATION & GARANTIE
                    //TEST X25 is reachable not possible because no answer without a complet message
                    byte[] chcom = {-63, 0x07, 0x05, 0x02, 0x05, 0x54, 0x06, 0x01, 0x21};
                    byte[] chpnv0 = {-109, 0x00, 0x10, 0x00, 0x04, 0x00, 0x28, 0x40, -128, 0x00};
                    //démo vérifiance 30€ = vert, 20 => Orange, 10 => blanc, 15 => Rouge
                    byte[] amount = {0x00, 0x00, 0x00, 0x00, 0x15, 0x00};
                    byte[] chpn1 = {0x00, 0x42};
                    byte[] cmc7 = {0x23, 0x0d, 0x00, -107, 0x36, 0x5d, -128, 0x00, 0x00, 0x00, 0x09, 0x09, -16, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0b};
                    byte[] centre = {-63, -62, -61, -60, -59, -16, -16, -63, -7, -7, 0x40, 0x40};
                    byte[] abo = {-15, -63, -62, -61, -60, -59, -16, -16, -63, -7, -7, 0x40, 0x40, 0x40, 0x40};
                    if (abonne != null && abonne.length() > 7) {
                        while (abonne.length() < 14) {
                            abonne += " ";
                        }
                        abo = addtab(new byte[]{-15}, abonne.getBytes("IBM1047"));
                    }
                    byte[] monaie = {0x09, 0x78};
                    // donnees garantie
                    byte[] garDatas = {-16, -16, -16, -16, -16, -16, -16, -16, -16,
                        0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40,
                        0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40,
                        0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40};
                    if (bank.compareTo("FNCI") != 0) {
                        chpnv0[0] = -111;
                        chpnv0[7] = 0x60; // need field 43 in BitMap
                    }
                    byte[] chpn = addtab(chcom, chpnv0);
                    chpn = addtab(chpn, amount);
                    chpn = addtab(chpn, chpn1);
                    chpn = addtab(chpn, cmc7);
                    chpn = addtab(chpn, centre);
                    chpn = addtab(chpn, abo);
                    if (bank.compareTo("FNCI") != 0) {
                        chpn = addtab(chpn, garDatas);
                    }
                    chpn = addtab(chpn, monaie);
                    res = addtab(res, addRfc1086Data(chpn));
                    out.write(res);
                    byte[] rcvdres = receive(in);
                    // rcvdres inclue rfc...
                    //   System.out.println(new String(rcvdres));
                    if (rcvdres == null) {
                        result = -1;
                    } else if (rcvdres.length >= 92 && rcvdres[12] == -109 && rcvdres[13] == 0x10) {//FNCI (9310)
                        String rep = getEBCDIC(new byte[]{rcvdres[52], rcvdres[53]});
                        writeResult("CHQ code reponse : " + rep);
                        String typeAbo = "unknown";
                        if (rcvdres[54] == -14) {
                            typeAbo = "SIRET";
                        } else if (rcvdres[54] == -15) {
                            typeAbo = "Abonne";
                        }
                        byte[] buff = new byte[14];
                        System.arraycopy(rcvdres, 55, buff, 0, buff.length);
                        writeResult("CHQ Identifiant : " + typeAbo + "=" + getEBCDIC(buff));
                        buff = new byte[21];
                        System.arraycopy(rcvdres, 70, buff, 0, buff.length);
                        writeResult("CHQ message : " + getEBCDIC(buff));
                        buff = new byte[4];
                        System.arraycopy(rcvdres, 86, buff, 0, buff.length);
                        writeResult("CHQ signature: " + getEBCDIC(buff));
                        if (rep.compareTo("04") == 0) {
                            writeResult("CHQ NUMERO D'ABONNE INCORRECTE");
                            result = -3;
                        }
                    } else if (rcvdres.length >= 141 && rcvdres[12] == -111 && rcvdres[13] == 0x10) {
                        //GARANTIE (9110)
                        String rep = getEBCDIC(new byte[]{rcvdres[60], rcvdres[61], rcvdres[62]});
                        writeResult("CHQ code réponse : " + rep);
                        String typeAbo = "unknown";
                        if (rcvdres[63] == -14) {
                            typeAbo = "SIRET";
                        } else if (rcvdres[63] == -15) {
                            typeAbo = "Abonne";
                        }
                        byte[] buff = new byte[14];
                        System.arraycopy(rcvdres, 64, buff, 0, buff.length);
                        writeResult("CHQ Identifiant : " + typeAbo + "=" + getEBCDIC(buff));
                        buff = new byte[40];
                        System.arraycopy(rcvdres, 78, buff, 0, buff.length);
                        String message = getEBCDIC(buff);
                        writeResult("CHQ message : " + message);
                        if (rep.compareTo("003") == 0
                                || message.startsWith("ERREUR ABONNE")
                                || message.startsWith("APPELER TRANSAX")) {
                            writeResult("CHQ NUMERO D'ABONNE INCORRECTE");
                            result = -3;
                        }
                    } else if (rcvdres.length > 4 && rcvdres[4] == -59) {
                        writeResult("CHQ server closed ");
                        result = -1;
                    } else {
                        result = -1;
                    }
                } else {
                    //IMAGE CHEQUE 
                    out.write(res);
                    int to = timeout;
                    timeout = 5000; //seems enought, found on from EFT : 15sec
                    byte[] rcvdres = receive(in);
                    if (rcvdres != null || rcvdres == null) { // the serveur message is Optional
                        timeout = to;
                        out.write(addRfc1086Data("CHEQUE;CH1\r".getBytes()));
                        rcvdres = receive(in);
                        if (rcvdres != null) {
                            String acqStr = get7BIT(removeRfc1086Data(rcvdres)).trim();
                            if (acqStr == null || acqStr.length() == 0) {
                                acqStr = "NO BANNER";
                            }
                            writeResult("CHQ Acquereur : " + acqStr);
                            while (abonne.length() < 10) {
                                abonne = " " + abonne;
                            }
                            res = set7BIT(new String(addtab(new byte[]{0x01}, abonne.getBytes())) + rang.substring(1) + "21CA06058422");
                            res = addtab(res, new byte[]{03});
                            res = addtab(res, new byte[]{lrc_chq(res)});
                            out.write(addRfc1086Data(res));
                            rcvdres = receive(in);
                            if (rcvdres == null) {
                                writeResult("CHQ ABONNE KO");
                                result = -1;
                            } else if (rcvdres.length > 150) {
                                byte[] buffchpr = removeRfc1086Data(rcvdres);
                                if (buffchpr[0] == 0x02) {
                                    writeResult("CHQ Parite non respectee");
                                    result = -1;
                                } else if (buffchpr[0] != -126) {
                                    writeResult("CHQ STX attentu et non recu");
                                    result = -1;
                                } else {
                                    String reponse = get7BIT(buffchpr);
                                    writeResult("CHQ Identifiant : " + reponse.substring(1, 11) + "/" + reponse.substring(11, 13));
                                    reponse = reponse.substring(13);
                                    //   writeResult("CHQ reste : "+reponse); // CReer une MAP des CA et des valeurs
                                    java.util.Map<String, String> map = getTLVFields(reponse);
                                    writeResult("CHQ Appels : " + map.get("CD") + " /" + map.get("CE") + "* - " + map.get("CF") + "min.");
                                    writeResult("CHQ X25 princ.: " + map.get("CB") + "; sec.: " + map.get("CC"));
                                    if (map.containsKey("CP") && map.get("CP").length() > 0) {
                                        writeResult("CHQ Compt Comm.: " + map.get("CP"));
                                    }
                                    writeResult("- Lieu :" + map.get("CV"));
                                    writeResult("- Enseigne :" + map.get("CR"));
                                    if (map.containsKey("CY") && map.get("CY").trim().length() > 0) {
                                        writeResult("-- [IMPRESSION : " + map.get("CY") + "]");
                                    }
                                    res = new byte[]{0x04};
                                    res = addtab(res, new byte[]{lrc_chq(res)});
                                    out.write(addRfc1086Data(res));
                                    result = 0;
                                }
                            } else if (rcvdres[4] == -107 && rcvdres.length == 7) {
                                writeResult("CHQ ABONNE REFUSE");
                                result = -3;
                            } else {
                                writeResult("CHQ ABONNE KO");
                                result = -1;
                            }

                        } else {
                            result = -1;
                        }
                    } else {
                        result = -1;
                    }
                }
            }
            if (in != null) {
                in.close();
            }
            if (out != null) {
                out.close();
            }
            if (sslsocket != null) {
                sslsocket.close();
            }

        } catch (IOException | NumberFormatException exception) {
            //    exception.printStackTrace();
            if (verbose) {
                writeResult("exception " + exception.getMessage());
            }
            writeResult("ipBridge:" + adrpass + "#" + portp + "reached Pb with" + adresseX25 + " ");
            return -2;
        }
        return result;
    }

    @Override
    public void run() {
        if (verbose) {
            writeResult("----------Start Verif CHEQUE----------------");
            writeResult(" NO Image Cheque today,... ");
            writeResult("----------------------------------------");
        }

        writeResult("Abonne: " + abonne + " / " + rang + "  for  service : " + bank);
        writeResult("  Name: " + bqlibelle + " @ " + adresseX25 + "; CUD: " + cud.trim());
        writeResult("  Contact: " + bqcontact + "; Status : " + bqstatus);
        int res = scanContract();
        if (res < 0) {
            if (adresseX25sec != null && adresseX25sec.length() > 0) {
                writeResult("---------TEST SECONDARY : " + adresseX25sec);
                adresseX25 = adresseX25sec;
                res = scanContract();
                if (res == -1) {
                    writeResult(" -------- [UNKNOWN ACQUIER] -----------");
                }else if (res == -3) {
                    writeResult(" -------- [REFUS CONTRACT] ----------- ");
                } else if (res < 0) {
                    writeResult(" -------- [ABNORMAL END] ----------- ");
                } else {
                    writeResult(" => OK");
                    writeResult("- [System Actif] -");
                }
            } else if (res == -1) {
                writeResult(" -------- [UNKNOWN ACQUIER] -----------");
            } else if (res == -3) {
                   writeResult(" -------- [REFUS CONTRACT] ----------- ");
                } else {
                writeResult(" -------- [ABNORMAL END] ----------- ");
            }
        } else {
            writeResult(" => OK");
            writeResult("- [System Actif] -");
        }
        exit(res);
    }

    public static void main(String[] arstring) {
        // verifCtra a = new verifCtra(v, f, adrx25,adrx25sec, sn, to, adip, port, ssl, domiciliation, rg, tasa, itp, banque,cf,cp,appid,query);
        if (arstring == null || arstring.length == 0) {
            arstring = new String[]{"-V", "-blocalhost", "-p148"};
        }
        Object[] objs = getArguments(arstring);
        try {
            Class<verifChq> cl = verifChq.class;
            for (java.lang.reflect.Constructor<?> c : cl.getConstructors()) {
                if (c.getParameterTypes().length == objs.length) {
                    verifChq a = (verifChq) c.newInstance(objs);
                    a.start();
                }
            }
        } catch (Exception ex) {//SecurityException | InstantiationException | IllegalAccessException | IllegalArgumentException | InvocationTargetException ex) {
            System.out.println("==>" + ex.getMessage());
        }

    }

    /**
     * retrieve a TLV with tag lenght=2 and size length=2
     *
     * @param buffer
     * @return
     */
    private java.util.Map<String, String> getTLVFields(String txt) {
        java.util.Map<String, String> res = new java.util.HashMap<>();
        String stxt = txt;
        try {
            while (stxt != null && stxt.length() > 4) {
                int size = Integer.parseInt(stxt.substring(2, 4));
                if (size > stxt.length() - 4) {
                    return null;
                }

                String field = stxt.substring(4, 4 + size);
                String tag = stxt.substring(0, 2);
                if (res.containsKey(tag)) {
                    field = res.get(tag) + "|" + field;
                    res.put(tag, field);
                } else {
                    res.put(tag, field);
                }
                stxt = stxt.substring(size + 4);
            }
        } catch (Exception ex) {
            return null;
        }
        if (res.isEmpty()) {
            return res;
        }
        return res;
    }

    private String getEBCDIC(byte[] buff) {
        try {
            return new String(buff, "IBM1047");
        } catch (Exception ex) {
            return buff.toString();
        }
    }

    private String get7BIT(byte[] buff) {
        for (int b = 0; b < buff.length; b++) {
            if (buff[b] < 0) {
                buff[b] += 0x80;
            }
        }
        return new String(buff);
    }

    private byte[] set7BIT(String txt) {
        byte[] buffer = txt.getBytes();
        boolean parity = false; //EVEN
        for (int pos = 0; pos < buffer.length; pos++) {
            //  String txt=Integer.toBinaryString(buffer[pos]); => simple heavy way
            byte mask = 0x01;
            byte i = 0;
            byte nbBit = 0;
            while (i < 7) { //On compte le nombre de 1 
                if ((buffer[pos] & (mask << i)) != 0) {
                    nbBit++;
                }
                i++;
            }
            if (nbBit % 2 == 0 == parity) {
                int nb = (buffer[pos] ^ 0x80) - 256;
                if (nb < 128 && nb > -128) {
                    buffer[pos] = (byte) nb;
                }
            }
        }
        return buffer;
    }

    private byte[] removeRfc1086Data(byte[] rcvframe) {
        byte[] buff = new byte[rcvframe.length - 4];
        System.arraycopy(rcvframe, 4, buff, 0, buff.length);
        return buff;
    }

    private byte[] addRfc1086Data(byte[] rcvframe) {

        if (adresseX25.compareTo("0") == 0) {
            int rest = rcvframe.length;
            byte by1 = getByte((int) Math.floor(rest / (256 * 256 * 256)));
            rest = rest - (by1 * 256 * 256 * 256);
            byte by2 = getByte((int) Math.floor(rest / (256 * 256)));
            rest = rest - (by2 * (256 * 256));
            byte by3 = getByte((int) Math.floor(rest / 256));
            rest = rest - (by2 * (256));
            byte by4 = getByte(rest);
            byte[] hdrSz = {by1, by2, by3, by4};
            return addtab(hdrSz, rcvframe);
        } else {
            int rest = rcvframe.length + 4;
            byte by1 = getByte((int) Math.floor(rest / (256 * 256)));
            rest = rest - (by1 * 256 * 256);
            byte by2 = getByte((int) Math.floor(rest / 256));
            rest = rest - (by2 * 256);
            byte by3 = getByte(rest);
            byte[] rfc = {3, by1, by2, by3};
            //System.out.println("==>"+(rcvframe.length+4)+"=> "+by1+":"+by2+":"+by3+".");
            return addtab(rfc, rcvframe);
        }
    }

    private byte[] receive(InputStream in) {
        Long initTOtime = System.currentTimeMillis();
        if (in == null) {
            if (verbose) {
                writeResult("in InputStream is NULL");
            }
            return null;
        }
        if (verbose) {
            writeResult("waiting receive for " + timeout + " ms");
        }
        byte[] msg = new byte[0];
        int msgSize = -1;
        while (System.currentTimeMillis() < initTOtime + timeout
                && (msg.length < 4 || msgSize < 0 || msg.length < msgSize)) {

            int size = -2;
            byte[] head = new byte[4];
            byte[] Imputdat = null;
            try {
                try {
                    if (msgSize == -1) { //in.available() disable withSSL
                        size = in.read(head);
                        if (size == 4) {
                            if (adresseX25.compareTo("0") == 0) {
                                msgSize = getInt(head[3]) + 256 * getInt(head[2]) + 256 * 256 * getInt(head[1]) + 256 * 256 * 256 * getInt(head[0]);
                                msgSize += 4;
                            } else {
                                msgSize = getInt(head[3]) + 256 * getInt(head[2]) + 256 * 256 * getInt(head[1]);
                            }
                            //writeResult("header=>"+head[3]+":"+head[2]+":"+head[1]+":"+head[3]+"=>"+msgSize);
                            Imputdat = new byte[msgSize];
                            System.arraycopy(head, 0, Imputdat, 0, head.length);
                        }
                    } else if (msgSize > -1) {
                        Imputdat = new byte[msgSize - msg.length];
                        size = in.read(Imputdat);//?slreading?
                    }
                } catch (IOException ex) {
                    // no data received => So timeout
                    if (verbose) {
                        writeResult("TCP reading : {" + ex.getMessage() + "}");
                    }
                }
            } catch (NullPointerException e) {
                if (verbose) {
                    writeResult("exception " + e.getMessage());
                }
                exit(1);
            }
            if (size == -1) {
                if (verbose) {
                    writeResult("readedd size = -1; so socket should have been close by the server");
                    exit(1);
                }
                //manage RFC1086
            } else if (size >= 4) {
                byte[] donnees = new byte[msg.length + size];
                System.arraycopy(msg, 0, donnees, 0, msg.length);
                System.arraycopy(Imputdat, 0, donnees, msg.length, size);
                msg = donnees;
                if (verbose) {
                    writeResult("received : " + msg.length + " byte");
                }
            }
        }
        if (msg.length != 0) {
            return msg;
        }
        if (verbose && System.currentTimeMillis() >= initTOtime + timeout) {
            writeResult("Timeout : " + timeout + " reached");
        }
        return null;
    }

    private byte[] addtab(byte[] a, byte[] b) {
        // copy of TUtils need for stand alone solution
        if (a == null || a.length == 0) {
            return b;
        }
        if (b == null || b.length == 0) {
            return a;
        }
        byte[] c = new byte[a.length + b.length];
        System.arraycopy(a, 0, c, 0, a.length);
        System.arraycopy(b, 0, c, a.length, b.length);
        return c;
    }

    private int getInt(byte a) {
        if (a < 0) {
            return a + 256;
        }
        return (int) a;
    }

    private byte getByte(int a) {
        if (a > 127) {
            return (byte) (a - 256);
        }
        return (byte) a;
    }

    private byte lrc_chq(byte[] buff) {
        if (buff == null) {
            return -1;
        } else {
            byte lrc = 127;
            for (byte oct : buff) {
                lrc ^= oct;
            }
            if (lrc > 0) {
                //       lrc=(byte)lrc-0x80;
            } else {
            }
            return lrc;
        }
    }
}
