/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jdcm.analyse;

import com.jdcm.common.C_Packet;
import com.jdcm.common.D_Utils;
import com.jdcm.common.Options_Model;
import com.jdcm.common.XML2tree;
import com.jdcm.common.XMLres;
import com.jdcm.editors.P_HexaEditor;
import com.jdcm.eltrx.D_Debug;
import com.jdcm.eltrx.I_Console;
import com.jdcm.eltrx.I_Main;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.Point;
import javax.swing.table.DefaultTableCellRenderer;
import java.io.File;
import static java.lang.Thread.sleep;
import java.sql.SQLException;
import java.util.List;
import java.util.TimerTask;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.table.TableColumn;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;

/**
 *
 * @author user
 */
public class P_CodeEditor extends javax.swing.JPanel {

    private static final long serialVersionUID = 1L;
    private final D_Utils TUtils = new D_Utils();
    private final String CR = "\n";
    private final com.jdcm.editors.ACE_ObjRenderer<Object> render = new com.jdcm.editors.ACE_ObjRenderer<>();
    private final com.jdcm.editors.ACE_ObjEditor<Object> editor = new com.jdcm.editors.ACE_ObjEditor<>(false);
    private final java.awt.event.ActionListener al = new java.awt.event.ActionListener() {
        @Override
        public void actionPerformed(java.awt.event.ActionEvent evt) {
            refresh(new C_Packet(model.getBuffer()));
        }
    };
    
    private com.jdcm.eltrx.F_Terminal Parent;
    private D_Debug TDeb;
    //  the displayed and analysed Packet Code Model
    private Code_Model model;
    //   liste des Conversations actives
    private Conversation conv = null;
    // P_XML xmlpanel = null;

    private P_HexaEditor.selectionEventListner HexaEvt = null;
    private java.util.Timer timerFinish = null;

    public P_CodeEditor() {
        TDeb = new D_Debug("CModel");
        model = new com.jdcm.analyse.Code_Model();
        model.settosend(false);
        model.setencode(false);
        init_table();
        jButton2.setEnabled(true);
        finishTable();
        init_encode(false);
        setVisible(true);
    }

    /**
     * create the form for applet/sub form<br> if isapplet then close do not
     * exit system <br>
     *
     * @param isaplet
     */
    public P_CodeEditor(boolean isaplet) {
        TDeb = new D_Debug("CModel");
        setVisible(isaplet == false);
        model = new com.jdcm.analyse.Code_Model();
        model.settosend(false);
        model.setencode(false);
        init_table();
        jButton2.setVisible(isaplet == false);
        // finishTable(); no need no byte
        init_encode(false);
    }

    public P_CodeEditor(com.jdcm.eltrx.F_Terminal p) {
        Parent = p;
        TDeb = new D_Debug("CModel");
        if (Parent.getport() != null && Parent.getport().getMain() instanceof com.jdcm.eltrx.I_Console) {
            TDeb.setconsole((com.jdcm.eltrx.I_Console) Parent.getport().getMain());
        }
        model = new com.jdcm.analyse.Code_Model();
        model.settosend(false);
        model.setencode(false);
        init_table();
        init_encode(false);
        jButton2.setVisible(false);
    }

    /**
     * Creates new form F_Dec_out visible or not to decode stream
     *
     * @param isaplet set for a "light UI"
     * @param m model to Edit
     *
     */
    public P_CodeEditor(boolean isaplet, Code_Model m) {
        //just to see the stored result : Code_Model Ex: Terminal
        if (m != null) {
            TDeb = new D_Debug("CModel");
            model = m;
            init_table();
            finishTable();
            setVisible(isaplet == false);
            //jToolBar1.setVisible(isaplet == false);
            jButton2.setEnabled(isaplet == false);
            init_encode(model.isencode());
        }
    }

    public java.awt.Image getIcon() {
        return TUtils.getImage("Dec_out.gif");
    }

    public final void init_table() {
        initComponents();
        jComboBox20.addActionListener(al);
        jCB_InitHexaEditor1.setValue(model.getInitBuffer());
        setModel(model);
        setDescription(model.toString());
        TUtils.addTabedPane2Frame(jTabbedPane3);
    }

    public boolean isConvOn() {
        return jToggleButton3.isSelected();
    }

    public int getSmalestField(int pos) {
        int ressz = -1;
        int foundrow = -1;
        for (int row = 0; row < getModel().getRowCount(); row++) {
            int fieldstart = getModel().getValueAt(row, "First", 0);
            int fieldsz = getModel().getValueAt(row, "Size", 1);
            if (pos >= fieldstart && pos < fieldstart + fieldsz && (ressz == -1 || ressz > fieldsz)) {
                ressz = fieldsz;
                foundrow = row;
            }
        }
        return foundrow;
    }

    private void init_encode(boolean bool) {
        HexaEvt = new P_HexaEditor.selectionEventListner() {
            @Override
            public void selectedPerformed(java.awt.event.MouseEvent evt) {
                if (evt != null && evt.paramString().startsWith("MOUSE_RELEASE")) {
                    int[] poss = p_HexaEditor1.getSelectingPos();
                    // 1 pos => find the smalle field matching that include position
                    int foundrow = getSmalestField(poss[0]);
                    if (foundrow >= 0) {
                        if (getSelectedTableLine() != foundrow || (poss[1] - poss[0] != getModel().getValueAt(foundrow, "Size", 1))) {
                            setSelectTableLine(foundrow);
                        }
                    }
                } else {
                    // nothing to do four Drag/...SetSeection,...
                }
            }
        };
        p_HexaEditor1.addSelectionEventListner(HexaEvt);
        jToggleButton2.setIcon(TUtils.getIcon("Encode.gif"));
        jToggleButton3.setIcon(TUtils.getIcon("Bt_on_play.gif"));
        jToggleButton3.setSelectedIcon(TUtils.getIcon("Bt_on_pause.gif"));
        jButton5.setIcon(TUtils.getIcon("Send_obj.gif"));
        jButton6.setIcon(TUtils.getIcon("Send_ser.gif"));
        jButton1.setIcon(TUtils.getIcon("DB_shema.gif"));
        jToggleButton4.setIcon(TUtils.getIcon("X_Add_child.gif"));
        jButton8.setIcon(TUtils.getIcon("Open.gif"));
        jButton7.setIcon(TUtils.getIcon("refresh.gif"));
        jToggleButton1.setSelectedIcon(TUtils.getIcon("Bt_on_CX.gif"));
        jToggleButton1.setIcon(TUtils.getIcon("Bt_off_CX.gif"));
        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(TUtils.getFiles("Descriptors", null).toArray(new File[]{})));
        jComboBox1.setRenderer(render);
        jToggleButton1.setEnabled(model.isencode());
        java.io.File fi = getDecfile();
        jComboBox20.setModel(new javax.swing.DefaultComboBoxModel<>(TUtils.getFiles("Descriptors", null).toArray(new File[]{})));
        jComboBox20.setRenderer(render);
        if (fi != null) {
            setDecfile(fi);
        }
        if (getModel() != null && getModel().getDESC_Protofirst() != null) {
            boolean subproto = getModel().getDESC_Protolast() == null;
            jToggleButton4.setSelected(subproto);
            jComboBox20.setSelectedItem(getModel().getDESC_Protofirst());
            jComboBox20.setToolTipText("auto : " + getModel().getDESC_Protofirst().getName());
        }
        if (bool) {
            jToggleButton2.setSelected(true);
            setENC_Protocol(model.getDESC_Protofirst());
        }

        jPanel1.setVisible(bool);
        jTree1.setEditable(model.isencode());
        getResultTable();
        setViewProtos(false);
    }

    public Component getPanel() {
        return this.getRootPane().getContentPane();
    }

    public void setModel(Code_Model cm) {
        jTable1.editingCanceled(null);
        model = cm;
        jTable1.setModel(model);
        if (model.getDESC_Protofirst() != null && model.getDESC_Protofirst().length() > 0) {
            setDecfile(model.getDESC_Protofirst());
        }
    }

    /**
     * Display a packet Analyse, If conv isfinished then display a conv analyse
     * else a simple packet analyse only for terminal!!
     *
     * @param packet
     * @param default_proto
     * @param isClick if packet is clicked or simply added
     */
    public void setPacket(C_Packet packet, String default_proto, boolean isClick) {
        //  model = null;
        if (packet == null || packet.isbuffer() == false) {
            return;
        }
        C_Packet analysedPack = packet;
        if (packet.getProtocols() == null || packet.getProtocols().isEmpty()) {
            if (Parent != null && Parent.getport() != null && Parent.getport().getMain() instanceof com.jdcm.eltrx.C_Main) {
                ((com.jdcm.eltrx.C_Main) Parent.getport().getMain()).findPacketStacks(packet);
            }
        }
        if (packet.isbuffer() && packet.getBytes().length > 0) {
            if (conv != null && conv.isAlive() == false) {
                analysedPack = conv.getConvPacket(packet);
                if (analysedPack == null) {
                    analysedPack = packet;
                }
            }
            if (analysedPack.getProtocols() == null || analysedPack.getProtocols().isEmpty()) {
                default_proto = "auto";
            } else {
                default_proto = analysedPack.getProtocols().get(0).getClass().getSimpleName();
                if (default_proto.startsWith("Stack_")) {
                    default_proto = default_proto.substring("Stack_".length());
                }
            }
            TDeb.wri("Ask displayPacket :" + analysedPack.toString() + " [" + analysedPack.getBytes().length + "]");
            final C_Packet packetModel = analysedPack;
            // codeModel for terminal managing HTTP (fragmentation over TCP)
            model = new Code_Model(Parent.getport(), analysedPack, default_proto) {
                private static final long serialVersionUID = 1L;

                @Override
                public boolean askReceive(int waitedBytes) {
                    if (conv != null) {
                        return super.askReceive(waitedBytes);
                    } else {
                        int initSize = getBuffer().length;
                        int idx = Parent.getModelPackets().indexOf(packetModel);
                        for (int i = idx + 1; i < Parent.getModelPackets().size(); i++) {
                            final C_Packet packetSec = Parent.getModelPackets().get(i);
                            boolean isOk = true;
                            if (packetSec.getProtocols() != null) {
                                for (int protoidx = 0; protoidx < packetSec.getProtocols().size(); protoidx++) {
                                    com.jdcm.modifiers.stacks.I_stack_elt base = packetModel.getProtocols().get(protoidx);
                                    com.jdcm.modifiers.stacks.I_stack_elt compl = packetSec.getProtocols().get(protoidx);
                                    if (base.getClass() != compl.getClass()) {
                                        //need also to check adresses/port/...=> stack signature
                                        isOk = false;
                                    }
                                    if (isOk && base instanceof com.jdcm.modifiers.stacks.Stack_TCP) {
                                        com.jdcm.modifiers.stacks.Stack_TCP tcp1 = (com.jdcm.modifiers.stacks.Stack_TCP) base;
                                        com.jdcm.modifiers.stacks.Stack_TCP tcp2 = (com.jdcm.modifiers.stacks.Stack_TCP) compl;
                                        // could be done with UDP/IP??...
                                        if (tcp1.getOptions().getValuefor("tcp_dest").toString().compareTo(tcp2.getOptions().getValuefor("tcp_dest").toString()) != 0) {
                                            isOk = false;
                                        }
                                        // not working?? with int??
                                        if (tcp1.getOptions().getValuefor("tcp_src").toString().compareTo(tcp2.getOptions().getValuefor("tcp_src").toString()) != 0) {
                                            isOk = false;
                                        }
                                    }
                                    if (isOk && base instanceof com.jdcm.modifiers.stacks.Stack_IP) {
                                        com.jdcm.modifiers.stacks.Stack_IP ip1 = (com.jdcm.modifiers.stacks.Stack_IP) base;
                                        com.jdcm.modifiers.stacks.Stack_IP ip2 = (com.jdcm.modifiers.stacks.Stack_IP) compl;
                                        if (ip1.getOptions().getValuefor("ip_dest").toString().compareTo(ip2.getOptions().getValuefor("ip_dest").toString()) != 0) {
                                            isOk = false;
                                        }
                                        // not working?

                                        if (ip1.getOptions().getValuefor("ip_src").toString().compareTo(ip2.getOptions().getValuefor("ip_src").toString()) != 0) {
                                            isOk = false;
                                        }
                                    }
                                }

                                com.jdcm.modifiers.stacks.I_stack_elt st = packetSec.getProtocols().get(packetSec.getProtocols().size() - 1);

                                byte[] buff = null;
                                if (st.getOptions().isPresent(st.toString().toLowerCase() + "_data")) {
                                    buff = st.getOptions().getValuefor(st.toString().toLowerCase() + "_data", new byte[]{});
                                }
                                if (isOk && buff != null) {
                                    setbuffer(TUtils.addtab(getBuffer(), buff));
                                    model.setbuffer(getBuffer());
                                    Parent.setSelectedPackets(new C_Packet[]{packetModel, packetSec});
                                    if (getBuffer().length - initSize >= waitedBytes) {
                                        model.setinitbuffer();
                                        jCB_InitHexaEditor1.setValue(model.getInitBuffer());
                                        return true;
                                    }
                                }
                            }
                        }
                    }
                    return false;
                }

                @Override
                public boolean isDESC_PadTO() {
                    // return false;
                    return true;
                }
            };
            if (isClick && conv == null) {
                refresh(model);
            }
            if (model.waitCodeEnds(1000) < 0) {//10000
                TDeb.wri("Decode Problem TO with packet : " + analysedPack);
                return;
            }
            if (conv != null && conv.active) {
                model = conv.getCodeModel(packet, model); // the model has been store with packet as reference
                analysedPack = conv.getConvPacket(packet);
            }
            if (model != null && analysedPack != null && isClick) {
                jComboBox20.removeActionListener(al);
                //System.err.println("=>"+model.getDESC_Protofirst());
                if (model.getDESC_Protofirst() != null
                        && (model.getDESC_Protofirst().length() > 0
                        || model.getDESC_Protofirst().toString().indexOf(".jar") > 0)) {
                    setDecfile(model.getDESC_Protofirst());
                }
                refresh(analysedPack);
                jComboBox20.addActionListener(al);
            }
        } else if (packet.getObj().getClass().getName().startsWith("jpcap.packet")) {
            C_Packet pack = (C_Packet) packet.clone();
            jpcap.packet.Packet packeth;
            try {
                packeth = (jpcap.packet.Packet) packet.getObj();
            } catch (Throwable ex) {
                TDeb.wri(" could not displayPacket, jpcap library should have been loaded");
                return;

            }
            pack.setObj(TUtils.addtab(packeth.header, packeth.data));
            if (pack.getBytes() != null && pack.getBytes().length > 14) {
                if ((new com.jdcm.modifiers.stacks.Stack_ETHI()).matchProtocol(pack) > 0.5) {
                    setPacket(pack, "ETHI", isClick);
                } else {
                    setPacket(pack, "ETHII", isClick);
                }
            } else {
                setPacket(pack, "0NULL", isClick);
            }
        }
    }

    public final void finishTable() {
        if (model == null) {
            return;
        }
        if (model != null && model.getendtime() == null) {//&& timerFinish == null
            timerFinish = new java.util.Timer();
            timerFinish.schedule(new TimerTask() {
                @Override
                public void run() {
                    finishTable();
                }
            }, 100);
        } else {
            p_HexaEditor1.setValue(model.getBuffer());
            //getInitBuffer() => conversation..
            //model.getBuffer() =>PPP
            p_HexaEditor1.setEditbutton(false);
            p_HexaEditor1.setmode("Hexa");
            p_HexaEditor1.clearColorRange();
            timerFinish = null;
            jTable1.setModel(model);
            setDescription(model.toString());
            setResultTree();
            getResultTable();
            jTable1.setAutoCreateRowSorter(true);
            findFieldColor();
        }
    }

    private void findFieldColor() {
        java.awt.Color col;
        int start = 0;

        if (model.getRowCount() > 0) {
            String proto = model.getValueAt(0, "Proto", "");
            col = model.getProtoColor(proto);
            // setAlpha or Brighter()?...
            java.awt.Color colveryLow = new java.awt.Color(col.getRed(), col.getGreen(), col.getBlue(), 50);
            java.awt.Color colLow = new java.awt.Color(col.getRed(), col.getGreen(), col.getBlue(), 75);
            java.awt.Color colHi = new java.awt.Color(col.getRed(), col.getGreen(), col.getBlue(), 100);
            for (int fld = 0; fld < model.getRowCount(); fld++) {
                String nxproto = model.getValueAt(fld, "Proto", "");
                if (nxproto != null && nxproto.length() > 0) { // could/should be removed??
                    int nxstart = model.getValueAt(fld, "First", 0);
                    boolean nxvis = model.getValueAt(fld, "Visible", true);
                    String nxname = model.getValueAt(fld, "Description", "");
                    int nxoft = model.getValueAt(fld, "Ofset", 0);
                    if (nxname.endsWith("data")
                            && (fld == model.getRowCount() - 1
                            || model.getValueAt(fld, "Level", 0) > model.getValueAt(fld + 1, "Level", 0))) {
                        //NOT WORKING
                        int fin = nxstart + model.getValueAt(fld, "Size", 0) - 1;
                        p_HexaEditor1.addColorRange(nxstart, fin, colveryLow);
                    }
                    if (nxoft > 0) {
                        p_HexaEditor1.addColorRange(nxstart, nxstart + nxoft - 1, colLow);
                    }
                    if (!nxvis) {
                        // if a row is not visible, then check inside if same proto & visible and set blur
                        int sec = fld + 1;
                        String secProto = model.getValueAt(sec, "Proto", "");
                        int deb = nxstart;
                        int fin = nxstart + model.getValueAt(fld, "Size", 0) - 1;
                        if (secProto != null && secProto.compareTo(nxproto) == 0) {
                            while (sec < model.getRowCount()
                                    && model.getValueAt(sec, "First", 1) < fin
                                    && model.getValueAt(sec, "Proto", "").compareTo(nxproto) == 0) {
                                int secsz = model.getValueAt(sec, "Size", 1);
                                if (model.getValueAt(sec, "First", 1) == deb + nxoft && model.getValueAt(sec, "Visible", true)) {
                                    //remove start from blur range
                                    deb = deb + secsz;
                                }
                                if (model.getValueAt(sec, "First", 1) + secsz == fin && model.getValueAt(sec, "Visible", true)) {
                                    //remove end from blur range
                                    fin = fin - secsz;
                                }
                                sec++;
                            }
                            p_HexaEditor1.addColorRange(deb, fin, colLow);
                        }
                    }
                    // set the whole protocol color
                    if (nxproto.compareTo(proto) != 0 || fld == model.getRowCount() - 1) {
                        if (fld == model.getRowCount() - 1 && nxproto.compareTo(proto) == 0) {
                            nxstart = nxstart + model.getValueAt(fld, "Size", 0);
                        }
                        p_HexaEditor1.addColorRange(start, nxstart - 1, colHi);
                        start = nxstart;
                        col = model.getProtoColor(nxproto);
                        colveryLow = new java.awt.Color(col.getRed(), col.getGreen(), col.getBlue(), 50);
                        colLow = new java.awt.Color(col.getRed(), col.getGreen(), col.getBlue(), 75);
                        colHi = new java.awt.Color(col.getRed(), col.getGreen(), col.getBlue(), 100);
                        proto = nxproto;
                        if (fld == model.getRowCount() - 1 && nxproto.compareTo(proto) == 0) {
                            nxstart = nxstart + model.getValueAt(fld, "Size", 0);
                            p_HexaEditor1.addColorRange(start, nxstart - 1, colHi);

                        }
                    }

                }
                /*  int st = model.getValueAt(fld, "First", 0);
                 int sz = model.getValueAt(fld, "Size", 0);
                 */
            }
            p_HexaEditor1.repaint();
        }
    }

    public Code_Model getModel() {
        return model;

    }

    public boolean isSubProtocol() {
        return jToggleButton4.isSelected();
    }

    private void setDescription(String txt) {
        jLabel2.setText(txt);
    }

    public java.io.File getDecfile() {
        if (jComboBox20.getSelectedItem() instanceof File == false) {
            return null;
        }
        return (File) jComboBox20.getSelectedItem();
    }

    public void setDecfile(java.io.File proto) {
        if (proto instanceof java.io.File) {
            jComboBox20.setSelectedItem(proto);
        }
    }

    public void setDecfile(String name) {
        for (int i = 0; i < jComboBox20.getItemCount(); i++) {
            if (jComboBox20.getItemAt(i).getName().compareTo(name) == 0
                    || jComboBox20.getItemAt(i).getName().compareTo(name + ".xml") == 0) {
                TDeb.wri("Set descriptor file by name:" + name);
                setDecfile(jComboBox20.getItemAt(i));
                return;
            }
        }
        TDeb.wri("F_CodeEditor.setDecFile(name=" + name + ") NOT FOUND");
    }
    // not used because no DB today 

    private Object getDBinfo(String target, String DBtable, String DBattr) {
        String driver = "org.gjt.mm.mysql.Driver";
        String url = "jdbc:mysql://localhost:3306/divers";
        try {
            java.sql.Driver dr = (java.sql.Driver) Class.forName(driver).newInstance();
            if (dr.acceptsURL(url) == false) {
                return null;
            }
            java.sql.DriverManager.registerDriver(dr);
            java.sql.Connection cxDB = java.sql.DriverManager.getConnection(url, "root", "admin");
            java.sql.Statement request = cxDB.createStatement();
            if (request.execute("SELECT * FROM " + DBtable + " WHERE " + DBattr + " = " + target) == false) {
                return null;
            } else {
                return request.getResultSet();
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | SQLException t) {
            return null;
        }
    }
    // not used because no XML base today 

    private Object getXMLinfo(String target, String initXMLfile, String XMLattr) {
        String XMLfile = initXMLfile;
        if (XMLfile.endsWith(".xml") == false) {
            XMLfile += ".xml";
        }
        XML2tree a = new XML2tree();
        DefaultTreeModel proto_tree = a.XMLBase(D_Utils.getFileStream(XMLfile, "http://sgiboin.free.fr/lib/xml/", getClass().getClassLoader()));
        if (proto_tree == null) {
            TDeb.wri("could not load tree from file :" + XMLfile);
        } else {
            TreePath DBpath = new TreePath(proto_tree.getRoot());
            DefaultMutableTreeNode pdmlnode = null;
            DefaultMutableTreeNode valnode;
            while ((DBpath.getLastPathComponent()).toString().compareTo("pdml") != 0) {
                pdmlnode = (DefaultMutableTreeNode) ((DefaultMutableTreeNode) DBpath.getLastPathComponent()).getFirstChild();
                DBpath = new TreePath(pdmlnode);
            }
            if (pdmlnode == null) {
                return null;
            }
            for (int n = 0; n < pdmlnode.getChildCount(); n++) {
                valnode = (DefaultMutableTreeNode) pdmlnode.getChildAt(n);
                XMLres valelt = (XMLres) valnode.getUserObject();
                if (valelt == null) {
                    return null;
                }
                if (valelt.getAttrVal(XMLattr).toString().compareTo(target) == 0) {
                    return valelt;
                }
            }
        }
        return null;
    }
    //Serch more info button on DB or XML (for big informations choices) => not used

    private void searchInfo() {
        if (model == null) {
            return;
        }
        for (int i = 0; i < model.getRowCount(); i++) {
            Object objdetail = model.getValueAt(i, "Detail");
            if (objdetail != null && objdetail.toString() != null && objdetail.toString().startsWith("[")) {
                String DBstr = objdetail.toString().substring(1);
                if (DBstr.indexOf("]") == -1) {
                    TDeb.wri("Missing ] in [" + DBstr + " line :" + i);
                    return;
                }
                if (DBstr.indexOf(":") == -1) {
                    TDeb.wri("Missing : in [" + DBstr + " line :" + i);
                    return;
                }
                DBstr = DBstr.substring(0, DBstr.indexOf("]"));
                if (model.getValueAt(i, "Value", "") == null) {
                    return;
                }
                String target = model.getValueAt(i, "Value", "");
                String DBtable = DBstr.substring(0, DBstr.indexOf(":"));
                String DBatt = DBstr.substring(DBstr.indexOf(":") + 1);
                //  model.setValueAt(getXMLinfo(target,DBtable,DBatt), i, "Value");
                model.setValueAt(getDBinfo(target, DBtable, DBatt), i, "Value");
                model.fireTableDataChanged();
            }
        }
    }

    public void setResultTree() {
        if (model != null) {
            DefaultTreeModel treeModel = model.getTree();
            jTree1.setModel(treeModel);
            jTree1.setEditable(model.isencode());
            jTree1.setCellRenderer(render);
            jTree1.setCellEditor(editor);
            if (jTree1.getRowCount() > 0) {
                // jTree1.expandRow(1);
            }
            jTree1.repaint();
        }
    }

    public void getResultTable() {
        // Show colors by rendering them in their own color.
        if (model == null) {
            jTable1.setModel(new javax.swing.table.DefaultTableModel());
        } else {
            Color couleur[] = {Color.DARK_GRAY, Color.BLUE, Color.RED, new Color(130, 50, 0),
                new Color(51, 102, 0), Color.GRAY, Color.MAGENTA, Color.GREEN.darker(), Color.green, Color.orange};
            for (int column = 0; column < model.getColumnCount(); column++) {
                Color col;
                if (column < couleur.length) {
                    col = couleur[column];
                } else {
                    col = Color.black;
                }
               // 

                TableColumn theColumn = jTable1.getColumnModel().getColumn(column);
                String colName = "" + theColumn.getHeaderValue();
                if (colName.compareTo("Value") == 0
                        || colName.compareTo("Description") == 0
                        || colName.compareTo("VDesc") == 0) {
                    if (theColumn.getPreferredWidth() < 200) {
                        theColumn.setPreferredWidth(150);
                    }
                } else if (colName.compareTo("Nb") == 0) {
                    theColumn.setPreferredWidth(20);
                }
                if (colName.compareTo("Value") == 0
                        || colName.compareTo("Choice") == 0
                        || colName.compareTo("Buffer") == 0) {
                    theColumn.setCellRenderer(render);
                    theColumn.setCellEditor(editor);
                } else {
                    theColumn.setCellRenderer(new TxtRenderer(col));
                }
                //if (i>0 &&i<4){column.setPreferredWidth(100);}else{column.setPreferredWidth(30);}
            }
        }
        jTable1.repaint();
    }

    private int getPathIdx(DefaultMutableTreeNode node, TreePath p, int oldidx) {
        int idx = oldidx;
        if (idx < 0) {
            if (node.isLeaf()) {
                idx -= 1;
            }
            TreePath p2 = new TreePath(node.getPath());
            if (p.equals(p2)) {
                return -idx - 2;
            }
            for (int i = 0; i < node.getChildCount(); i++) {
                idx = getPathIdx((DefaultMutableTreeNode) node.getChildAt(i), p, idx);
            }
        }
        return idx;
    }

    private void setSelectTreeNode(TreePath P) {
        if (P == null || jTree1.getModel() == null) {
            return;
        }
        int idx = getPathIdx((DefaultMutableTreeNode) jTree1.getModel().getRoot(), P, -1);
        if (idx >= 0 && getSelectedTableLine() != idx) {
            setSelectTableLine(idx);
        }
    }

    private int getSelectedTableLine() {
        if (jTable1.getSelectedRowCount() > 1 || jTable1.getSelectedRowCount() == 0) {
            return -1;
        }
        return jTable1.getRowSorter().convertRowIndexToView(jTable1.getSelectedRow());
    }

    private void setSelectTableLine(int row) {
        //  p_HexaEditor1.removeSelectionEventListner(HexaEvt);
        if (row == -1) {
            return;
        }
        int begin = model.getValueAt(row, "First", 0);
        int end = model.getValueAt(row, "Size", 0) + begin - 1;
        begin = begin + model.getValueAt(row, "Ofset", 0);
        if (end - begin < 0 && begin > 0) {
            // => ex : size=0(memout...)=> previous byte!!!!
            //could look for the real byte (ex : memout=>memin...)
            begin = begin - 1;
            end = begin;
        }
        int[] pos = p_HexaEditor1.getSelectingPos();
        if (pos == null || pos[0] != begin || pos[1] != end) {
            p_HexaEditor1.setSelectedPos(begin, end);
            p_HexaEditor1.viewSelected();
        }
        if (jTree1.getModel() != null) {
            DefaultMutableTreeNode rt = (DefaultMutableTreeNode) jTree1.getModel().getRoot();
            DefaultMutableTreeNode n1 = rt.getFirstLeaf();
            for (int i = 0; i < row && n1 != null; i++) {
                n1 = n1.getNextLeaf();
            }
            if (n1 != null) {
                jTree1.setSelectionPath(new TreePath(n1.getPath()));
            }
        }

        if (jTree1.getSelectionRows() != null && jTree1.getSelectionRows().length > 0) {
            javax.swing.JViewport viewport1 = jScrollPane1.getViewport();
            java.awt.Rectangle rect1 = jTree1.getRowBounds(jTree1.getSelectionRows()[0]);
            java.awt.Point pos1 = new Point(0, rect1.getLocation().y);
            if (viewport1.getViewRect().contains(pos1) == false) {
                viewport1.setViewPosition(pos1);
            }
        }
        int viewrow = jTable1.getRowSorter().convertRowIndexToView(row);
        jTable1.setRowSelectionInterval(viewrow, viewrow);
        javax.swing.JViewport viewport2 = this.jScrollPane2.getViewport();
        java.awt.Rectangle rect2 = jTable1.getCellRect(viewrow, 0, true);
        java.awt.Point pos2 = rect2.getLocation();
        if (viewport2.getViewRect().contains(pos2) == false) {
            viewport2.setViewPosition(pos2);
        }
        repaint();
        //  p_HexaEditor1.addSelectionEventListner(HexaEvt);
    }

    private void setStartEncode(boolean bool) {
        if (bool != isStartEncode()) {
            jToggleButton1.setSelected(bool);
        }
        jComboBox1.setEnabled(bool == false);
        jButton3.setEnabled(bool);
        jButton4.setEnabled(bool);
        if (bool) {
            if (model != null) {
                model.setDESC_Protofirst(getENC_Protocol());
                model.createDec();
                jCB_InitHexaEditor1.setValue(model.getInitBuffer());
            }
        } else {
            if (model != null) {
                model.EndModel();
                jCB_InitHexaEditor1.setValue(model.getInitBuffer());
            }
        }
    }

    public void setENC_Protocol(java.io.File initproto) {
        if (initproto == null) {
            initproto = jComboBox1.getItemAt(0);
        }
        if (initproto == getENC_Protocol()) {
            jComboBox1.setSelectedItem(initproto);
            model.setDESC_Protofirst(getENC_Protocol());
        }
    }

    public File getENC_Protocol() {
        return (File) jComboBox1.getSelectedItem();
    }

    private boolean isStartEncode() {
        return jToggleButton1.isSelected();
    }

    public void initConversation() {
        if (Parent==null){
             javax.swing.JOptionPane.showMessageDialog(this, "no port for a packet stream conversation analyse", "Conversation", javax.swing.JOptionPane.ERROR_MESSAGE);
             jToggleButton3.setSelected(false);
             return;
        }
        if (conv == null) {
            conv = new Conversation();
            conversationEventListner evt = new conversationEventListner() {
                @Override
                public void afterInitEvent() {
                    if (Parent.getselectedpackets() != null && Parent.getselectedpackets().length == 1) {
                        //  setPacket(Parent.getselectedpackets()[0], null,false);
                    }
                }
            };
            conv.addConversationEvent(evt);
        }
        if (Parent != null && conv != null && conv.isAlive() == false) {
            conv.start();
        }
    }

    public boolean isActive() {
        if (conv != null) {
            return conv.active;
        }
        return false;
    }

    public void askStop() {
        conv.active = false;
    }

    public void refresh(Code_Model codem) {
        jTable1.setAutoCreateRowSorter(false);
        jTable1.editingCanceled(null);
        model = codem;
        finishTable();
    }

    public void refresh(C_Packet pack) {
        if (pack == null || pack.isbuffer() == false || pack.getBytes().length == 0) {
            return;
        }
        jTable1.setAutoCreateRowSorter(false);
        jTable1.editingCanceled(null);
        // model.removeAllproto();=> then could not modifi & reload
        model.removeAllproto(false);
        model.clear();
        jTree1.setModel(null);
        jCB_InitHexaEditor1.setValue(pack.getBytes());
        model.setbuffer(pack.getBytes());
        model.setinitbuffer();
        if (getDecfile() != null) {
            model.setDESC_Protofirst(getDecfile());
            if (isSubProtocol()) {
                model.setDESC_Protolast(new java.io.File("none"));
            } else {
                model.setDESC_Protolast(null);
            }
        }
        model.createDec();
        /*     if (model.waitCodeEnds(10) < 0) {//10000
         TDeb.wri("TO reached while : refresh(C_Packet)");
         }*/
        finishTable();
    }

    private void setViewProtos(boolean bool) {
        if (bool) {
            if (model != null) {
                if (model.getprotocols() != null) {
                    for (String protoLabel : model.getprotocols().keySet()) {
                        com.jdcm.editors.P_XML xmlpanel = new com.jdcm.editors.P_XML();
                        xmlpanel.setTxtMode(true);
                        xmlpanel.displayTree(model.getprotocols().get(protoLabel));
                        xmlpanel.setEditable(true);
                        jTabbedPane1.addTab(protoLabel, xmlpanel);
                    }
                    TUtils.addTabedPane2Frame(jTabbedPane1);
                }
            }
        } else {
            jTabbedPane1.removeAll();
        }

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jToolBar1 = new javax.swing.JToolBar();
        jCB_InitHexaEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jComboBox20 = new javax.swing.JComboBox<>();
        jButton8 = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jButton7 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jToggleButton4 = new javax.swing.JToggleButton();
        jButton6 = new javax.swing.JButton();
        jToggleButton2 = new javax.swing.JToggleButton();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jTabbedPane2 = new javax.swing.JTabbedPane();
        jSplitPane2 = new javax.swing.JSplitPane();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        p_HexaEditor1 = new com.jdcm.editors.P_HexaEditor();
        jPanel2 = new javax.swing.JPanel();
        jSplitPane3 = new javax.swing.JSplitPane();
        jTabbedPane3 = new javax.swing.JTabbedPane();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTree2 = new javax.swing.JTree();
        jPanel3 = new javax.swing.JPanel();
        jProgressBar1 = new javax.swing.JProgressBar();
        jToggleButton3 = new javax.swing.JToggleButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jToggleButton1 = new javax.swing.JToggleButton();
        jComboBox1 = new javax.swing.JComboBox<>();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        jMenuItem1.setText("export");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem1);

        setLayout(new java.awt.BorderLayout());

        jToolBar1.setRollover(true);
        jToolBar1.setMaximumSize(new java.awt.Dimension(2147483647, 17));

        jCB_InitHexaEditor1.setEditable(true);
        jCB_InitHexaEditor1.setMaximumSize(new java.awt.Dimension(20000, 20));
        jCB_InitHexaEditor1.setMinimumSize(new java.awt.Dimension(30, 15));
        jCB_InitHexaEditor1.setPreferredSize(new java.awt.Dimension(150, 15));
        jCB_InitHexaEditor1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCB_InitHexaEditor1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jCB_InitHexaEditor1);

        jComboBox20.setEditable(true);
        jComboBox20.setFont(new java.awt.Font("Tahoma", 0, 10)); // NOI18N
        jComboBox20.setToolTipText("Select Descriptor");
        jComboBox20.setMaximumSize(new java.awt.Dimension(20000, 20));
        jComboBox20.setMinimumSize(new java.awt.Dimension(30, 15));
        jComboBox20.setPreferredSize(new java.awt.Dimension(150, 15));
        jComboBox20.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox20ActionPerformed(evt);
            }
        });
        jToolBar1.add(jComboBox20);

        jButton8.setBorderPainted(false);
        jButton8.setFocusable(false);
        jButton8.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton8.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton8);

        jLabel2.setText("-result.toString()-");
        jToolBar1.add(jLabel2);

        jButton7.setToolTipText("Refresh");
        jButton7.setBorderPainted(false);
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton7);

        jButton5.setToolTipText("Send as Model");
        jButton5.setBorderPainted(false);
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton5);

        jToggleButton4.setSelected(true);
        jToggleButton4.setToolTipText("allows sub-protocols");
        jToggleButton4.setBorderPainted(false);
        jToggleButton4.setFocusable(false);
        jToggleButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton4ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton4);

        jButton6.setToolTipText("Send as buffer");
        jButton6.setBorderPainted(false);
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton6);

        jToggleButton2.setToolTipText("Encode");
        jToggleButton2.setBorderPainted(false);
        jToggleButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton2);

        jButton1.setToolTipText("Link with externel Databases");
        jButton1.setBorderPainted(false);
        jButton1.setEnabled(false);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jButton2.setText("close");
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setMinimumSize(new java.awt.Dimension(31, 15));
        jButton2.setPreferredSize(new java.awt.Dimension(31, 15));
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        add(jToolBar1, java.awt.BorderLayout.NORTH);

        jTabbedPane2.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jTabbedPane2StateChanged(evt);
            }
        });

        jSplitPane2.setDividerLocation(100);
        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jSplitPane1.setDividerLocation(100);

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("Protocols");
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jTree1.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        jTree1.setRootVisible(false);
        jTree1.setScrollsOnExpand(false);
        jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTree1MouseReleased(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        jSplitPane1.setLeftComponent(jScrollPane1);

        jTable1.setAutoCreateRowSorter(true);
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null, null, null, null, null, null}
            },
            new String [] {
                "", "", "", "", "", "", "", "", "", "", "", ""
            }
        ));
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable1MouseReleased(evt);
            }
        });
        jScrollPane2.setViewportView(jTable1);

        jSplitPane1.setRightComponent(jScrollPane2);

        jSplitPane2.setRightComponent(jSplitPane1);
        jSplitPane2.setTopComponent(p_HexaEditor1);

        jTabbedPane2.addTab("Decode", jSplitPane2);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jTabbedPane3.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jSplitPane3.setRightComponent(jTabbedPane3);

        treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("Conversations");
        jTree2.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jTree2.setToolTipText("Protocols");
        jTree2.setAutoscrolls(true);
        jTree2.setComponentPopupMenu(jPopupMenu1);
        jTree2.setShowsRootHandles(true);
        jTree2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTree2MouseClicked(evt);
            }
        });
        jScrollPane3.setViewportView(jTree2);

        jSplitPane3.setLeftComponent(jScrollPane3);

        jPanel2.add(jSplitPane3, java.awt.BorderLayout.CENTER);

        jPanel3.setLayout(new java.awt.BorderLayout());

        jProgressBar1.setToolTipText("scaned packets");
        jProgressBar1.setBorderPainted(false);
        jProgressBar1.setOpaque(true);
        jProgressBar1.setStringPainted(true);
        jProgressBar1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jProgressBar1MouseClicked(evt);
            }
        });
        jPanel3.add(jProgressBar1, java.awt.BorderLayout.CENTER);

        jToggleButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton3ActionPerformed(evt);
            }
        });
        jPanel3.add(jToggleButton3, java.awt.BorderLayout.WEST);

        jPanel2.add(jPanel3, java.awt.BorderLayout.SOUTH);

        jTabbedPane2.addTab("Conversations", jPanel2);
        jTabbedPane2.addTab("Protocols", jTabbedPane1);

        add(jTabbedPane2, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jToggleButton1);

        jPanel1.add(jComboBox1);

        jButton3.setText("Next");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton3);

        jButton4.setText("Return");
        jButton4.setEnabled(false);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton4);

        add(jPanel1, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents

    private void jCB_InitHexaEditor1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCB_InitHexaEditor1ActionPerformed
        byte[] buff = (byte[]) jCB_InitHexaEditor1.getValue();
        if (java.util.Arrays.equals(buff, model.getBuffer()) == false) {
            model.clear();
            model.setbuffer(buff);
            model.setinitbuffer();
            jTree1.setModel(null);
            p_HexaEditor1.setValue(model.getBuffer());
            this.repaint();
        }
    }//GEN-LAST:event_jCB_InitHexaEditor1ActionPerformed

    private void jComboBox20ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox20ActionPerformed
    }//GEN-LAST:event_jComboBox20ActionPerformed

    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        java.io.File f = TUtils.getUIreadFile(null, JFileChooser.FILES_ONLY, null, true);
        if (f != null && f.getName().endsWith(".xml")) {
            javax.swing.DefaultComboBoxModel<File> c = (javax.swing.DefaultComboBoxModel<File>) jComboBox20.getModel();
            c.addElement(f);
            model.addpCustomProto(f);
            this.setDecfile(f);

        }
    }//GEN-LAST:event_jButton8ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        refresh(new C_Packet(model.getInitBuffer()));
    }//GEN-LAST:event_jButton7ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        if (model != null) {
            model.send_model();
        }
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jToggleButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton4ActionPerformed
        if (jToggleButton4.isSelected() != (model.getDESC_Protolast() == null)) {
            refresh(new C_Packet(model.getInitBuffer()));
        }
    }//GEN-LAST:event_jToggleButton4ActionPerformed

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        if (model != null) {
            model.send_buffer();
        }
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jToggleButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton2ActionPerformed
        boolean bool = jToggleButton2.isSelected();
        jPanel1.setVisible(bool);
        jToggleButton1.setEnabled(bool);
        if (model != null) {
            model.setencode(bool);
            jComboBox1.setSelectedItem(model.getProtoNames());
        }
        setStartEncode(bool);
    }//GEN-LAST:event_jToggleButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        searchInfo();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jTree1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MouseReleased
        setSelectTreeNode(jTree1.getSelectionPath());
    }//GEN-LAST:event_jTree1MouseReleased

    private void jTable1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseReleased
        int viewrow = jTable1.getSelectedRow();
        int modelrow = jTable1.getRowSorter().convertRowIndexToModel(viewrow);
        setSelectTableLine(modelrow);
    }//GEN-LAST:event_jTable1MouseReleased

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        setStartEncode(isStartEncode());
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        if (model != null) {
            model.setwaitingnext(false);
            p_HexaEditor1.repaint();
            jCB_InitHexaEditor1.setValue(model.getInitBuffer());
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        //  setlast(true);
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jTabbedPane2StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jTabbedPane2StateChanged
        boolean isProtSelected = jTabbedPane2.getTitleAt(jTabbedPane2.getSelectedIndex()).compareTo("Protocols") == 0;
        if (!isProtSelected) {
            if (jTabbedPane1.getSelectedIndex() != -1) {
                java.util.Map<String, DefaultTreeModel> protoMap = model.getprotocols();
                String protoName = jTabbedPane1.getTitleAt(jTabbedPane1.getSelectedIndex());
                protoMap.remove(protoName);
                com.jdcm.editors.P_XML xmlEd = (com.jdcm.editors.P_XML) jTabbedPane1.getSelectedComponent();
                DefaultMutableTreeNode analyseNode = (DefaultMutableTreeNode) xmlEd.getTreeModel().getRoot();
                analyseNode = (DefaultMutableTreeNode) analyseNode.getChildAt(0);
                protoMap.put(protoName, new DefaultTreeModel(analyseNode));
            }
        }
        setViewProtos(isProtSelected);
    }//GEN-LAST:event_jTabbedPane2StateChanged

    private void jProgressBar1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jProgressBar1MouseClicked
        if (evt.isControlDown()) {
            askStop();
        }
    }//GEN-LAST:event_jProgressBar1MouseClicked

    private void jTree2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree2MouseClicked
        if (jTree2.getSelectionPath() != null) {
            Object ob = jTree2.getSelectionPath().getLastPathComponent();
            if (ob instanceof javax.swing.tree.DefaultMutableTreeNode) {
                if (((javax.swing.tree.DefaultMutableTreeNode) ob).getUserObject() instanceof ProtoEventMatrix) {
                    ProtoEventMatrix mx = (ProtoEventMatrix) ((javax.swing.tree.DefaultMutableTreeNode) ob).getUserObject();
                    if (mx.getStatuslist().isEmpty() == false) {
                        boolean found = false;
                        for (int i = 0; i < jTabbedPane3.getTabCount(); i++) {
                            if (jTabbedPane3.getTitleAt(i).compareTo(mx.getSignature()) == 0) {
                                jTabbedPane3.setSelectedIndex(i);
                                found = true;
                            }
                        }
                        if (found == false) {
                            jTabbedPane3.addTab(mx.getSignature(), new com.jdcm.diagram.P_Diagram(mx));
                        }
                    }
                    Parent.setSelectedPackets(null);
                    Parent.setSelectedPackets(mx.packetList.toArray(new C_Packet[]{}));
                }

            }
        }

    }//GEN-LAST:event_jTree2MouseClicked

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        //   if (this.getDefaultCloseOperation() == javax.swing.JFrame.EXIT_ON_CLOSE) {
        System.exit(0);
        /*  } else {
         this.setVisible(false);
         }*/
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        if (jTree2.getSelectionPath() != null && jTree2.getSelectionPath().getPathCount() > 1) {
            Object ProtoMx = jTree2.getSelectionPath().getLastPathComponent();
            Object subProtoMx = jTree2.getSelectionPath().getParentPath().getLastPathComponent();
            if (subProtoMx instanceof javax.swing.tree.DefaultMutableTreeNode && ProtoMx instanceof javax.swing.tree.DefaultMutableTreeNode) {
                if (((javax.swing.tree.DefaultMutableTreeNode) subProtoMx).getUserObject() instanceof ProtoEventMatrix
                        && ((javax.swing.tree.DefaultMutableTreeNode) ProtoMx).getUserObject() instanceof ProtoEventMatrix) {
                    ProtoEventMatrix mxp = (ProtoEventMatrix) ((javax.swing.tree.DefaultMutableTreeNode) subProtoMx).getUserObject();
                    ProtoEventMatrix mx = (ProtoEventMatrix) ((javax.swing.tree.DefaultMutableTreeNode) ProtoMx).getUserObject();
                    conv.displayProtocol(mxp, mx, jTree2.getSelectionPath().getParentPath());
                }
            }
        }
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jToggleButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton3ActionPerformed
        initConversation();
    }//GEN-LAST:event_jToggleButton3ActionPerformed
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                //  java.io.InputStream is=TUtils.getFileStream(TUtils.getFile("telecol chq9994236127.cap", "traces"));
                // P_CodeEditor ce =new P_CodeEditor(false, new com.jdcm.analyse.Code_Model(null, buff, "Dump"));
                P_CodeEditor ce = new P_CodeEditor(false, new com.jdcm.analyse.Code_Model(null, "this is an exemple\r\nof a csv file".getBytes(), "CSV"));
                javax.swing.JFrame fr = new javax.swing.JFrame("Decoder");
                fr.add(ce);
                fr.setSize(ce.getPreferredSize());
                fr.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
                fr.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private com.jdcm.editors.JCB_ObjectEditor jCB_InitHexaEditor1;
    private javax.swing.JComboBox<File> jComboBox1;
    private javax.swing.JComboBox<File> jComboBox20;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JSplitPane jSplitPane3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTabbedPane jTabbedPane2;
    private javax.swing.JTabbedPane jTabbedPane3;
    private javax.swing.JTable jTable1;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    private javax.swing.JToggleButton jToggleButton3;
    private javax.swing.JToggleButton jToggleButton4;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTree jTree1;
    private javax.swing.JTree jTree2;
    private com.jdcm.editors.P_HexaEditor p_HexaEditor1;
    // End of variables declaration//GEN-END:variables

    class TxtRenderer extends DefaultTableCellRenderer {
// need to be outside of the class else pb with first decode of CodeModel
        // for serializable interface

        private static final long serialVersionUID = 1L;
        private final Color cool;

        public TxtRenderer(Color c) {
            cool = c;
        }

        @Override
        public Component getTableCellRendererComponent(
                javax.swing.JTable table, Object initvalue, boolean isSelected, boolean hasFocus, int row, int col) {
            Object value = initvalue;
            if (value == null) {
                value = "";
            }
            setText(value.toString());
            this.setVerticalAlignment(DefaultTableCellRenderer.NORTH);
            setFont(new Font("Courier New", Font.PLAIN, 12));
            setForeground(cool);
            if (isSelected) {
                setBackground(table.getSelectionBackground());
            } else {
                setBackground(table.getBackground());
            }
            return this;
        }
    }

    private class Conversation extends java.lang.Thread implements I_Code_Parent {
        private final java.util.List<conversationEventListner> conversationEventListners = new java.util.ArrayList<>();
        private final int initTO = 1000;
        
        int trow = 0;
        private D_Utils.simpleListNode<ProtoEventMatrix> convMatrices = null;
        private boolean active = false;
        Code_Model convCm = null; // convCm (for dynamic conv protocol)ex : ELC proto

        public Conversation() {
            convMatrices = new D_Utils.simpleListNode<>();
            convMatrices.getRootNode().setUserObject("Conversations");
            jTree2.setModel(new javax.swing.tree.DefaultTreeModel(convMatrices.getRootNode()));
            //not usefull
            //    jTree2.setCellEditor(new com.jdcm.editors.ACE_ObjEditor());
            //    jTree2.setEditable(true);
            setName("CMconv:" + getName());
        }

        public boolean isEmpty() {
            return convMatrices.isEmpty();
        }

        public boolean contens(String ProtoName) {
            for (ProtoEventMatrix pm : convMatrices) {
                if (pm.getTitle().compareTo(ProtoName) == 0) {
                    return true;
                }
            }
            return false;
        }

        private boolean waitActive() {
            while (active == false) {
                try {
                    long start = System.currentTimeMillis();
                    if (System.currentTimeMillis() > start + 10 * initTO) {
                        TDeb.wri("Pb : TO reachaed while init after " + 10 * initTO + "ms");
                        return false;
                    }
                    sleep(10);
                } catch (InterruptedException ex) {
                     System.out.println("Conversation : waitActive()=>" + ex);
                }
            }
            return true;
        }

        public void displayProtocol(ProtoEventMatrix mxp, ProtoEventMatrix mx, javax.swing.tree.TreePath parentPath) {
            com.jdcm.eltrx.F_Terminal f = new com.jdcm.eltrx.F_Terminal();
            f.setVisible(true);
            f.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
            for (C_Packet p : mxp.packetList) {
                Code_Model cm = doCodeModel(p);
                for (int row = 0; row < cm.getRowCount(); row++) {
                    Object val = cm.getValueAt(row, "Value");
                    if (val instanceof byte[]
                            && cm.getValueAt(row, "Proto", "").compareTo(mxp.getTitle()) == 0
                            && cm.getValueAt(row, "Name", "").endsWith("data")
                            && ((byte[]) val).length > 0) {
                        // what's about IP fragmentation???
                        //no need of path analyse because packet are selected from parent

                        if (compareSignature(cm.getConvSignature(mxp.getTitle(), row), mxp.getSignature())
                                && (cm.getConvSignature(mx.getTitle(), row) == null
                                || compareSignature(cm.getConvSignature(mx.getTitle(), row), mx.getSignature())) /*getPathAsString(parentPath).compareTo(cm.getConvSignatures())==0*/) {
                            C_Packet pack = (C_Packet) p.clone();
                            if (pack.getProtocols() != null) {
                                // root is not a protocol
                                for (int i = 1; i < parentPath.getPathCount() && pack.getProtocols().isEmpty() == false; i++) {
                                    pack.getProtocols().remove(0);
                                }
                            }
                            pack.setObj(((byte[]) val));
                            f.write(pack);
                        }
                    }
                }
            }
        }

        public C_Packet getConvPacket(C_Packet p) {
            if (p == null || p.isbuffer() == false || Parent.getModelPackets().contains(p) == false) {
                return null;
            } else {
                C_Packet pack = p;
                for (ProtoEventMatrix mx : convMatrices) {
                    pack = mx.getGlobalPacket(pack);
                }
                if (pack != null) {
                    return pack;
                } else {
                    return p;
                }
            }
        }

        public Code_Model getCodeModel(C_Packet p, Code_Model cm) {
            if (p == null || p.isbuffer() == false
                    || Parent.getModelPackets().contains(p) == false) { //
                return cm;
            }
            if (!waitActive()) {
                return cm;
            }
            if (!convMatrices.isEmpty() && (p.getProtocols() == null
                    || p.getProtocols().isEmpty()) || p.getProtocols().get(0).getClass().getSimpleName().contains("0NULL")) {// else fragmentation Concert=>Null
                //foireux... set Cm protocol as conversation 'valided?' proptocol (s?)
                cm.setDESC_Protofirst(TUtils.getFile(convMatrices.get(0).protoFileName + ".xml", "Descriptors"));
            }
            for (ProtoEventMatrix mx : convMatrices) {
                if (mx.isFirstPacket(p)) {
                    // first Packet => to study if /how cm Change ??
                    // mx.changeProto(p, cm);
                    mx.displayActivState(p, Parent);
                } else {
                    mx.changeProto(mx.getPrevious(p), cm);
                    mx.displayActivState(p, Parent);
                }
            }
            return cm;
        }

        public void addConversationEvent(conversationEventListner evt) {
            conversationEventListners.add(evt);
        }

        public void removeConversationEvent(conversationEventListner evt) {
            conversationEventListners.remove(evt);
        }

        /*   public void setParent(I_Code_Parent Parent) {
         this.Parent = Parent;
         }*/
        public List<ProtoEventMatrix> getConversations() {
            return convMatrices;
        }
        //Compare but 20,400 and 400,80=> true

        public boolean compareSignature(String sgn1, String sgn2) {
            if (sgn2 == null || sgn1 == null) {
                return false;
            }
            java.util.List<String> txts2 = java.util.Arrays.asList(sgn2.split(","));
            for (String txt1 : sgn1.split(",")) {
                if (txts2.contains(txt1) == false) {
                    return false;
                }
            }
            return true;
        }

        private ProtoEventMatrix findProtoMatrix(java.util.List<ProtoEventMatrix> list, String signature, String protoName, String protoFileName) {
            Object[] mats = convMatrices.toArray(list);
            for (Object m : mats) {
                if (m instanceof ProtoEventMatrix) {
                    ProtoEventMatrix mat = (ProtoEventMatrix) m;
                    if (signature == null) {
                        if (protoName.endsWith(mat.getTitle())) {
                            return mat;
                        }
                    } else if (compareSignature(signature, mat.getSignature())) {
                        return mat;
                    }
                }
            }
            ProtoEventMatrix mx = ProtoEventMatrix.getProtoEventMatrix(protoFileName);
            TDeb.wri("Will try to Load : " + protoFileName);
            java.io.InputStream io = com.jdcm.common.D_Utils.getFileStream(protoFileName + ".xml", "Descriptors", null);
            if (io == null) {
                TDeb.wri("Pb Loading : " + protoFileName + " with stream : " + io);
            } else {
                mx = new ProtoEventMatrix(io);
                TDeb.wri("Conversation init : Loaded protocol : " + protoFileName);
                mx.setProtoFileName(protoFileName);
                mx.setSignature(signature);
                if (mx.getTitle().length() == 0) {
                    mx.setTitle(protoName);
                }
                if (list.isEmpty()) {
                    convMatrices.add(mx);
                } else {
                    convMatrices.addChild(list, mx);
                }
            }
            return mx;
        }

        private Code_Model doCodeModel(C_Packet pack) {
            if (pack == null || pack.isbuffer() == false) {
                return null;
            }
            if (convCm == null) {
                convCm = new Code_Model(this, pack, "auto") {
                    private static final long serialVersionUID = 1L;

                    // if data wait whiel decode then look for next packet to deliver data asked by protocol. 
                    @Override
                    public boolean askReceive(int waitedBytes) {
                        int initSize = getBuffer().length;
                        java.util.List<C_Packet> packs = Parent.getModelPackets();
                        while (trow < packs.size() - 1 && packs.get(trow + 1).isbuffer()
                                && (packs.get(trow + 1).getsourceidx() == packs.get(trow).getsourceidx())) {
                            //  && getBuffer().length - initSize < waitedBytes) {
                            setbuffer(TUtils.addtab(getBuffer(), packs.get(trow + 1).getBytes()));
                            trow++;
                            if (getBuffer().length - initSize >= waitedBytes) {
                                return true;
                            }
                        }
                        return false;
                    }

                    @Override
                    public boolean isDESC_PadTO() {
                        // return false;
                        return true;
                    }

                    @Override
                    public boolean addProtoTree(String fprotoname) {
                        for (ProtoEventMatrix mx : convMatrices) {
                            if (mx.getProtoFileName().compareTo(fprotoname + ".xml") == 0) {
                                getprotocols().put(fprotoname, mx.getProtoTree());
                            }
                        }
                        super.addProtoTree(fprotoname);
                        return true;
                    }
                };
            } else {
                // only if convCm is a global (
                convCm.clear();
                convCm.removeAllproto(true);
                if (model != null) {
                    model.removeAllproto(false);
                }

                convCm.setDESC_Protofirst(null);
                convCm.setDESC_Protolast(new java.io.File("none"));
                convCm.setbuffer(pack.getBytes());
                convCm.setinitbuffer();
                convCm.createDec();
            }
            // premiere étape => créer un codeModel avec le Packet
            long start = System.currentTimeMillis();
            while (convCm != null && convCm.getendtime() == null) {
                if (System.currentTimeMillis() > start + 10 * initTO) {
                    TDeb.wri("Pb : TO reachaed while init after " + initTO + "ms");
                    return null;
                }
                try {
                    sleep(100);
                } catch (InterruptedException ex) {
                    System.out.println("Conversation : doCodeModel()=>" + ex);
                }
            }
            return convCm;
        }

        /**
         * Follow a live conversation if unique and with starting
         */
        public void doConversation() {
            boolean treatedAsFrgment;
            if (Parent == null || trow < 0 || trow >= Parent.getModelPackets().size()) {
                return;
            }
            while (trow < Parent.getModelPackets().size() && isConvOn()) {
                C_Packet pack = Parent.getModelPackets().get(trow);
                if (Parent.getModelPackets().size() - trow > 0) {
                    jProgressBar1.setVisible(true);
                    jProgressBar1.setMaximum(Parent.getModelPackets().size());
                    jProgressBar1.setValue(trow);
                    jProgressBar1.setString(jProgressBar1.getValue() + "/" + jProgressBar1.getMaximum());
                }
                if (pack.isbuffer()) {
                    Code_Model convCm1 = doCodeModel(pack);
                    // STEP 1 => check if a conversation is loaded, if not, load it
                    // un conversation est un protocol ... avec une signature propre > qu'est ce qu'un signature (adresses/ports/...??)
                    if (convCm1 == null || convCm1.getProtoNames() == null && convCm1.getRowCount() == 0) {
                        TDeb.wri("Pb Code Model on frame : " + trow);
                        System.err.println("Pb Code Model on frame : " + trow);
                    } else {
                        //prevMxs is the local memory of previous protocols needed to finfd the good Mx (Ex IP>TCP>IP)
                        java.util.List<ProtoEventMatrix> prevMxs = new java.util.ArrayList<>();
                        ProtoEventMatrix mx = null;
                        //       for (String protoName : convCm1.getProtoNames()) { 
                        //step 2 => teach protoEventMatrix with CM for this matrix
                        for (int row = 0; row < convCm1.getRowCount() && isConvOn(); row++) {// get fieldName as "..:.." & proto & 
                            treatedAsFrgment = false;
                            String protoName = convCm1.getValueAt(row, "Proto", "");
                            boolean isnewProto = row == 0 || convCm1.getValueAt(row - 1, "Proto", "").compareTo(protoName) != 0;
                            boolean isDown = (row > 0
                                    && convCm1.getValueAt(row, "Level", 0) < convCm1.getValueAt(row - 1, "Level", 0));
                            // CARE PPP flag end/PPP flag start
                            boolean isFloor = row == 0 || (convCm1.getValueAt(row, "Level", 0) == 0 && convCm1.getValueAt(row - 1, "Level", 0) > 0);
                            if (isFloor) {
                                //levelisnewProto ==0 Ex :[PPP/IP/TCP][PPP/IP...]
                                prevMxs = new java.util.ArrayList<>();
                            }
                            if (isDown && isnewProto) {
                                // manage PPP/ETX/... Stop flags
                                while (prevMxs.isEmpty() == false
                                        && prevMxs.get(prevMxs.size() - 1).toString().startsWith("[" + protoName + "]") == false) {
                                    prevMxs.remove(prevMxs.size() - 1);
                                }
                            }
                            if ((isDown == false && isnewProto) || isFloor) {
                                // a new proto => Add it
                                mx = findProtoMatrix(prevMxs, convCm1.getConvSignature(protoName, row), protoName, convCm1.getFileProtoName(protoName));
                                prevMxs.add(mx);
                            }

                            //-------------- 
                            //MANAGMT OF FRAGMENTS on 0NULL 
                            //else isDESC_PadTO() BUT (TODO!!) not over protocols (ex: http frag over TCP ) 
                            //-------------------------
                            try {
                                if (convCm1.getProtoNames() != null && convCm1.getProtoNames().size() > 0 && mx != null
                                        && convCm1.getProtoNames().get(convCm1.getProtoNames().size() - 1).compareTo(convCm1.getValueAt(row, "Proto", "")) == 0
                                        && convCm1.getValueAt(row, "Name", "").endsWith("data")
                                        && convCm1.getValueAt(row, "Value") instanceof byte[]
                                        && protoName.compareTo(mx.getTitle()) == 0) {
                                    byte[] buff = convCm1.getValueAt(row, "Value", new byte[]{});

                                    mx.addFragment(pack, buff);
                                    // case 02.. and other pack .. 03 LRC
                                    Code_Model convCm2 = doCodeModel(mx.getDefragPacket());
                                    if (convCm2 != null
                                            && convCm2.getProtoNames().get(0).compareTo("0NULL") != 0) {
                                        // if sum of 0NULL provide a Protocol packet (serial fragmentation)
                                        //   System.out.print("found fragmentation for size : " + mx.getDefragPacket().getBytes().length
                                        //    + " with: " + convCm2.getProtoName());
                                        java.util.List<ProtoEventMatrix> prevMxs2 = new java.util.ArrayList<>();
                                        for (String protoName2 : convCm2.getProtoNames()) {
                                            ProtoEventMatrix mx2 = findProtoMatrix(prevMxs2, convCm2.getConvSignature(protoName2, row),
                                                    protoName2, convCm2.getFileProtoName(protoName2));
                                            prevMxs2.add(mx2);
                                            for (int row2 = 0; row2 < convCm2.getRowCount(); row2++) {
                                                mx2.addActions(convCm2, row2, mx.getFragPackets(), mx.getDefragPacket().getBytes());
                                            }
                                        }
                                        mx.removePacket(mx.getFragPackets());
                                        mx.clearFragments();
                                        treatedAsFrgment = true;
                                    }
                                }
                            } catch (Exception ex) {
                                TDeb.wri("Pb with " + convCm1 + "=>" + ex.getMessage());
                            }

                            if (treatedAsFrgment == false) {
                                // case of end of proto on follow frames with checked
                                // could be done one time before row CodeModel parsing
                                C_Packet[] packets = null;
                                byte[] frag = null;
                                int idx = Parent.getModelPackets().indexOf(pack);
                                while (idx <= trow) {
                                    C_Packet pa = Parent.getModelPackets().get(idx);
                                    if (pa.isbuffer()) {
                                        packets = TUtils.addtab(packets, new C_Packet[]{pa});
                                        frag = TUtils.addtab(frag, pa.getBytes());
                                    }
                                    idx++;
                                }
                                if (mx != null) {
                                    // mx should never be null met in multi-PPP on a frame
                                    mx.addActions(convCm1, row, packets, frag);
                                }
                            }
                        }

                    }
                }
                trow++;
            }
            for (conversationEventListner evt : conversationEventListners) {
                evt.afterInitEvent();
            }
            ((javax.swing.tree.DefaultTreeModel) jTree2.getModel()).reload();
        }

        @Override
        public void run() {
            boolean isstarting = true;
            while (isstarting || active) {

                if (Parent.getModelPackets().size() > trow) {
                    jProgressBar1.setMinimum(0);
                    // java.util.ConcurrentModificationException if click uring conversation.init()
                    doConversation();
                    TDeb.wri("Conversation init : is Active for " + convMatrices.size() + " protocols");
                    if (isstarting) {
                        active = true;
                        isstarting = false;
                    }
                    jProgressBar1.setVisible(false);
                }
                try {
                    sleep(10);
                } catch (InterruptedException ex) {
                     System.out.println("Conversation : run()=>" + ex);
                }
            }
        }

        @Override
        public Options_Model getCMDOptions() {
            return null;
        }

        @Override
        public void setinitDESCPack(C_Packet p) {
        }

        @Override
        public void CXstop() {
        }

        @Override
        public void read_in(C_Packet packet) {
        }

        @Override
        public void read_out(C_Packet packet) {
        }

        @Override
        public void write_out(C_Packet pack) {
        }

        @Override
        public I_Console getConsole() {
            if (Parent != null && Parent.getport() != null
                    && Parent.getport().getMain() instanceof com.jdcm.eltrx.I_Console) {
                return (com.jdcm.eltrx.I_Console) Parent.getport().getMain();
            }
            return null;
        }

        @Override
        public I_Main getMain() {
            if (Parent != null && Parent.getport() != null) {
                return Parent.getport().getMain();
            }
            return null;
        }

        @Override
        public void setAcc_position(int pos) {
        }

        @Override
        public void setAcc_initsize(int pos) {
        }

        @Override
        public void setDESC_slid(int pos) {
        }

        @Override
        public int getAcc_initsize() {
            return -1;
        }

        @Override
        public boolean isDESC_EOFstop() {
            return false;
        }
    }

    public static class conversationEventListner {

        public conversationEventListner() {
        }

        public void afterInitEvent() {
        }
    }
}
