package com.jdcm.common;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * TODO : The Jar file 'as File' with isDirectory, getLenght(), ... try to get a
 * File Class for Jar (&....) a jar is a directory
 *
 * @author Marc GIBOIN
 */
public class C_httpFile extends java.io.File {

    private static final long serialVersionUID = 1L;
    boolean Directory;
    private java.net.URL url = null;
    private String httpsize = "?";
    private String httpdate = "?";
   
    
    public C_httpFile(String pathname) {
        super(pathname);
        try {
            url = new java.net.URL(pathname);
        } catch (MalformedURLException ex) {
            System.out.println("C_httpFile()"+ex.getMessage());
        }
    }

    public C_httpFile(String pathname, boolean dir) {
        super(pathname);
        Directory = dir;
        try {
            url = new java.net.URL(pathname);
        } catch (MalformedURLException ex) {
            System.out.println("C_httpFile()"+ex.getMessage());
        }
    }

    @Override
    public boolean canExecute() {
        return false;
    }
    /**
     * Why doest f.string()=>"http:/sgiboin.free.fr/..."?
     * @return 
     */
    @Override
    public String toString() {
        String txt=super.toString();
        if (txt.startsWith("http:\\\\")==false && txt.startsWith("http:\\")){
            txt="http:\\\\"+txt.substring("http:\\".length());
        }
        return txt;
    }
    @Override
    public boolean isDirectory() {
        return Directory;
    }

    public String gethttpSize() {
        return httpsize;
    }

    public String gethttpDate() {
        return httpdate;
    }

    @Override
    public boolean canWrite() {
        return false;
    }

    @Override
    public boolean canRead() {
        // because is in the listing if not then not visible by tomcat...
        return true;
    }

    /**
     * unused : convert WEB listing file size this size is NOT the real file
     * size
     *
     * @param txt the size as text (1k)
     * @return the provide WEB file size
     */
    private int gettxtSize(String txt) {
        int sz;
        int coef = 1;
        if (txt.endsWith("k")) {
            txt = txt.substring(0, txt.length() - 1);
            coef = 1000;
        } else if (txt.endsWith("m")) {
            txt = txt.substring(0, txt.length() - 1);
            coef = 1000000;
        }
        try {
            sz = Integer.parseInt(txt);
        } catch (NumberFormatException ex) {
            sz = 0;
        }
        return sz * coef;
    }

    public URL getURL() {
        return url;
    }

    @Override
    public File[] listFiles() {
        //try to get : 'helloWorld.class</A>        26-Jul-2013 08:42     1k'
        // tested only with apache...and free...
        String source = "";
        if (url.toString().endsWith(".jar")) {
            return (new D_Utils()).getJarFiles("jar:" + url.toString() + "!/").toArray(new java.io.File[]{});
        } else if (url.toString().contains(".jar!/")) {
            return (new D_Utils()).getJarFiles(url.toString()).toArray(new java.io.File[]{});
        }
        // Jar are not managed 
        //     java.net.JarURLConnection jcx = (java.net.JarURLConnection) url.openConnection();
        java.util.List<File> res = new java.util.ArrayList<>();

        try {
            // Pb with HTML (not XML?? <meta,....)
            //XML2tree xmlLib=new XML2tree();
            // javax.swing.tree.DefaultTreeModel tree=xmlLib.XMLBase(yc.getInputStream());
            java.net.URLConnection yc = url.openConnection();
            try (BufferedReader in = new BufferedReader(new InputStreamReader(yc.getInputStream()))) {
                String inputLine;
                while ((inputLine = in.readLine()) != null) {
                    source += inputLine;
                }
            }
            if (source.toLowerCase().contains("<title>index of") && source.toLowerCase().contains("parent directory")) {
                Directory = true;
                source = source.substring(source.toLowerCase().indexOf("parent directory") + "parent directory".length(), source.lastIndexOf("<HR>"));
                while (source.contains("</A>")) {
                    if (source.trim().startsWith("</A>")) {
                        source = source.trim().substring("</A>".length());
                    }
                    String fileName = source.substring(0, source.indexOf("</A>"));
                    fileName = fileName.substring(fileName.lastIndexOf(">") + 1).trim();
                    source = source.substring(source.indexOf("</A>") + "</A>".length());
                    String ds = source.substring(0, source.indexOf("<")).trim();
                    httpdate = ds.substring(0, 18).trim();
                    httpsize = ds.substring(19).trim();
                    // could get dir??..
                    try {
                        C_httpFile f = new C_httpFile(url + "/" + fileName, fileName.endsWith("/"));
                        res.add(f);
                    } catch (Exception ex) {
                        System.err.println("Pb with File Name: " + fileName);
                    }
                }
                return res.toArray(new java.io.File[0]);
            } else {
                System.err.println("no avalable liste found for : " + url);
            }
        } catch (IOException ex) {
            //  System.err.println(" C_httpFile : listFiles() " + ex.getMessage());
        }
         return res.toArray(new C_httpFile[]{});
    }
}
