package com.jdcm.common;

/**
 *
 * @author M.Marc GIBOIN
 *  * NO USE => NEED TO REVEW  XML2TREE
 */
public class XMLhdr extends XMLres {
        // for serializable interface
    private static final long serialVersionUID = 1L;
    public XMLhdr(String version, String code) {
        super("HEADER");
        if (version != null) {
            this.addAttribut("version", version);
        }
        if (code != null) {
            this.addAttribut("encoding", code);
        }
    }

    public String getEncoding() {
        return this.getAttrVal("encoding").toString();
    }

    public void setEncoding(String txt) {
        this.setAttrVal("encoding", txt);
    }

    public String getVersion() {
        return this.getAttrVal("version").toString();
    }

    public void setVersion(String txt) {
        this.setAttrVal("version", txt);
    }

    @Override
    public String toString() {
        String res = "<?xml";
        if (getVersion() != null && getVersion().length() != 0) {
            res = res +" version=\""+ getVersion() + "\" ";
        }
        if (getEncoding() != null && getEncoding().length() != 0) {
            res = res +" encoding=\""+ getEncoding() + "\" ";

        }
        res = res + " ?>";
        return res;
    }
}
