package com.jdcm.common;

/**
 * a value for table edition with status, memory (initial value), color,...
 * 
 * 
 * @author Marc GIBOIN
 */
public class cellDataModel {

    public Object newValue = null;
    public Object oldValue = null;
    public boolean isEditable = true;
    static public int NONE = 0;
    static public int ADDED = 1;
    static public int REMOVED = 2;
    static public int CHANGED = 3;
    public int Status = 0;

    public cellDataModel(Object ob) {
        newValue = ob;
    }

    public void setNewValue(Object ob) {
        if (Status != REMOVED) {
            if (ob !=null && ob.equals(newValue) == false) {
                oldValue = newValue;
                newValue = ob;
                Status = CHANGED;
            }else if (ob==null && newValue!=null){
                 oldValue = newValue;
                newValue = ob;
                Status = CHANGED;
            }
        }
    }

    public void remove() {
       if (Status != REMOVED) {
        Status = REMOVED;
        isEditable=false;
       }else{
           Status =NONE;
           isEditable=true;
       }
    }

    public void add() {
        Status = ADDED;
    }

    public java.awt.Color getStatusColor() {
        if (Status == ADDED) {
            return java.awt.Color.getHSBColor(57, 28, 70); // yellow
        } else if (Status == CHANGED) {
            return java.awt.Color.CYAN;
        } else if (Status == REMOVED) {
            return java.awt.Color.getHSBColor(50, 100, 70);
            //return java.awt.Color.LIGHT_GRAY;
        } else {
            return null;
        }


    }
}
