package com.jdcm.editors;

import com.jdcm.eltrx.C_Main;
import com.jdcm.eltrx.C_Port;
import com.jdcm.eltrx.I_Port;
import java.awt.event.ActionEvent;
import com.jdcm.modifiers.stacks.Stack_baseStart;
import java.awt.Color;
import java.awt.Toolkit;
import java.net.UnknownHostException;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.SpinnerNumberModel;

/**
 * created on 02/2013 This form use zConcert protocol & code, C0C1
 *
 * @author M.Marc Giboin
 */
public class B_EFT_LC extends javax.swing.JPanel implements I_ObjectReceiver {
     private static final long serialVersionUID = 1L;
    private C_Port Parent = null;
    private C_Main main = null;
    private com.jdcm.eltrx.C_Stack stack = null;
    private Stack_baseStart concECR = null;
    private Stack_baseStart concEFT = null;
    private javax.swing.table.TableModel defaultModel = null;
    private final com.jdcm.common.D_Utils T_Util = new com.jdcm.common.D_Utils();
  //  private java.text.Format monaieFormat = new java.text.DecimalFormat("#,##0.##");

    /**
     * Creates new form B_EFT_LC
     */
    public B_EFT_LC() {
        initComponents();
        Toolkit.getDefaultToolkit().setDynamicLayout(true);
        JDialog.setDefaultLookAndFeelDecorated(true);
        JFrame.setDefaultLookAndFeelDecorated(true);
        defaultModel = new javax.swing.table.DefaultTableModel();
        T_Util.addTabedPane2Frame(jTabbedPane1);
        setName("EFT ECR Simulator");
        jTabbedPane1.setIconAt(0, T_Util.getIcon("system.gif"));
        jTabbedPane1.setIconAt(1, T_Util.getIcon("eft.gif"));
        jButton2.setIcon(T_Util.getIcon("Add.gif"));
        jButton3.setIcon(T_Util.getIcon("Remove.gif"));
        jTable3.setRowSelectionInterval(0, 0);
        jComboBox9.setRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        jComboBox10.setRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        initEFT();
    }

    public java.awt.Image getIcon() {
        return T_Util.getImage("system.gif");
    }

    private void initEFT() {
        jComboBox3.setEnabled(false);
        jComboBox4.setEnabled(false);
        jLabel3.setText("-");
        jLabel1.setText("0,00");
        jLabel1.setEnabled(false);
        jPanel5.removeAll();
    }

    private void EnableEFT(boolean bool) {
        jComboBox3.setEnabled(bool);
        jComboBox4.setEnabled(bool);
        jLabel3.setEnabled(bool);
        jLabel1.setEnabled(bool);
        jButton1.setEnabled(bool);
        jPanel5.removeAll();
        jPanel5.repaint();
    }

    private void initECR(boolean activ) {
        jTextField1.setEnabled(activ);
        jTextField2.setEnabled(activ);
        jComboBox9.setEnabled(activ);
        jButton2.setEnabled(activ);
        jButton3.setEnabled(activ);
        if (activ) {
            for (int i = 0; i < jTable3.getRowCount(); i++) {
                jTable3.setValueAt(0, i, 3);
            }
            jFormattedTextField1.setValue(0.0);
            concECR.getOptions().getValuefor("trs_amount", new com.jdcm.common.O_Amount()).setAmount(0.0);
            jToggleButton1.setEnabled(false); // amount is 0.00
            jToggleButton1.setSelected(false);
        } else {
            jLabel4.setBackground(Color.gray);
            jLabel5.setText("-");
            jLabel4.setText("WAIT");
        }

    }

    private void setComms() {
        boolean bool = jComboBox5.getSelectedItem().toString().compareTo("IPL4") == 0;
        jTextField1.setVisible(bool);
        jTextField2.setVisible(bool);
        jComboBox9.setVisible(!bool);
         bool = jComboBox6.getSelectedItem().toString().compareTo("IPL4") == 0;
        jTextField3.setVisible(bool);
        jComboBox10.setVisible(!bool);
        doLayout();
        repaint();
    }

    public java.util.List<javax.swing.JMenuItem> getMenus() {
        java.util.List<javax.swing.JMenuItem> items = new java.util.ArrayList<>();
        final javax.swing.JMenuItem item0 = new javax.swing.JMenuItem("Objectif");
        item0.setActionCommand("?");
        item0.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String txt = "Cet outils a pour objectif de facilité l'intergation des liaison entre caisses et EFT\r\n"
                        + "il integre à ce jour uniquement le protocol concert\r\n"
                        + "chaque partie EFT ou ECR fonctionne \r\n"
                        + " - soit de façon autonome avec un équipement réel\r\n"
                        + " - soit de ensemble, par IP sur localhost\r\n"
                        + "Aucune doc de référence n'est réalisée à ce jour";
                javax.swing.JOptionPane.showMessageDialog(null, txt, "Objectif", javax.swing.JOptionPane.INFORMATION_MESSAGE);
            }
        });
        javax.swing.JMenuItem item1 = new javax.swing.JMenuItem("Traces");
        item1.setActionCommand("Wire");
        item1.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (concECR != null && concECR.getport() != null && Parent != null) {
                        ((Stack_baseStart) stack.getTarget("ECR", "LogECR")).setStack_Start(true);
                }
            }
        });
        final javax.swing.JCheckBoxMenuItem item4 = new javax.swing.JCheckBoxMenuItem("Look");
        item4.setActionCommand("Look");
        item4.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (item4.isSelected()) {
                    com.jdcm.common.D_Utils.addOpacytyListner((javax.swing.JFrame) Parent.getSlave());
                } else {
                    com.jdcm.common.D_Utils.removeOpacytyListner((javax.swing.JFrame) Parent.getSlave());
                }
            }
        });
        items.add(item0);
        items.add(item1);
        //items.add(item4);
        return items;
    }

    private void implementAmount(boolean bool) {
        if (jTable3.getSelectedRow() >= 0) {
            double total = 0;
            int incr = 1;
            if (!bool) {
                incr = -1;
            }
            for (int row : jTable3.getSelectedRows()) {
                int qt = ((int) jTable3.getValueAt(row, 3)) + incr;
                if (qt >= 0) {
                    jTable3.setValueAt(qt, row, 3);
                }
            }
            for (int row = 0; row < jTable3.getRowCount(); row++) {
                total += (double) jTable3.getValueAt(row, 1) * (int) jTable3.getValueAt(row, 3);
            }
            jFormattedTextField1.setValue(total);
            jToggleButton1.setEnabled(total > 0);
            // should tigger an Action lisnter
            com.jdcm.common.O_Amount mnt = concECR.getOptions().getValuefor("trs_amount", new com.jdcm.common.O_Amount());
            mnt.setAmount(total);
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane2 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel3 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTable3 = new javax.swing.JTable();
        jPanel7 = new javax.swing.JPanel();
        jButton3 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        jSpinner1 = new javax.swing.JSpinner();
        jPanel9 = new javax.swing.JPanel();
        jComboBox5 = new javax.swing.JComboBox<>();
        jComboBox9 =  new javax.swing.JComboBox<>();
        jTextField1 = new javax.swing.JTextField();
        jTextField2 = new javax.swing.JTextField();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jPanel11 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jFormattedTextField1 = new javax.swing.JFormattedTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jPanel10 = new javax.swing.JPanel();
        jComboBox2 = new javax.swing.JComboBox<>();
        jComboBox1 = new javax.swing.JComboBox<>();
        jButton4 = new javax.swing.JButton();
        jToggleButton1 = new javax.swing.JToggleButton();
        jLabel7 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel12 = new javax.swing.JPanel();
        jComboBox6 = new javax.swing.JComboBox<>();
        jComboBox10 =  new javax.swing.JComboBox<>();
        jTextField3 = new javax.swing.JTextField();
        jCB_ObjectEditor2 = new com.jdcm.editors.JCB_ObjectEditor();
        jPanel15 = new javax.swing.JPanel();
        jPanel13 = new javax.swing.JPanel();
        jComboBox4 = new javax.swing.JComboBox<>();
        jComboBox3 = new javax.swing.JComboBox<>();
        jPanel5 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jPanel14 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jComboBox8 = new javax.swing.JComboBox<>();
        jComboBox7 = new javax.swing.JComboBox<>();

        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane2.setViewportView(jTable2);

        setMinimumSize(new java.awt.Dimension(450, 250));
        setPreferredSize(new java.awt.Dimension(400, 219));
        setLayout(new java.awt.BorderLayout());

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new java.awt.BorderLayout());

        jTable3.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"PQ",  new Double(1.02), "Papier toilette",  new Integer(0)},
                {"PC",  new Double(1233.21), "Personal computer",  new Integer(0)},
                {"IR",  new Double(50.01), "briquet de lumiere",  new Integer(0)},
                {"API",  new Double(10.23), "La pomme",  new Integer(0)},
                {"SEC",  new Double(20.56), "Le saucisson",  new Integer(0)}
            },
            new String [] {
                "Ref", "P.U.", "Designation", "Qt"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Double.class, java.lang.String.class, java.lang.Integer.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, true, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable3MouseReleased(evt);
            }
        });
        jScrollPane3.setViewportView(jTable3);

        jPanel1.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        jPanel7.setLayout(new javax.swing.BoxLayout(jPanel7, javax.swing.BoxLayout.Y_AXIS));

        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jPanel7.add(jButton3);

        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel7.add(jButton2);

        jPanel1.add(jPanel7, java.awt.BorderLayout.WEST);

        jPanel6.setLayout(new javax.swing.BoxLayout(jPanel6, javax.swing.BoxLayout.Y_AXIS));

        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel8.setText("Caisse : ");
        jLabel8.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
        jPanel6.add(jLabel8);

        jSpinner1.setMaximumSize(new java.awt.Dimension(32767, 30));
        jPanel6.add(jSpinner1);

        jPanel1.add(jPanel6, java.awt.BorderLayout.EAST);

        jPanel3.add(jPanel1, java.awt.BorderLayout.CENTER);

        jPanel9.setLayout(new javax.swing.BoxLayout(jPanel9, javax.swing.BoxLayout.LINE_AXIS));

        jComboBox5.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1" }));
        jComboBox5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox5ActionPerformed(evt);
            }
        });
        jPanel9.add(jComboBox5);

        jComboBox9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox9ActionPerformed(evt);
            }
        });
        jPanel9.add(jComboBox9);

        jTextField1.setText("localhost");
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jPanel9.add(jTextField1);

        jTextField2.setText("9599");
        jTextField2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField2ActionPerformed(evt);
            }
        });
        jPanel9.add(jTextField2);

        jCB_ObjectEditor1.setAsButton(true);
        jPanel9.add(jCB_ObjectEditor1);

        jPanel3.add(jPanel9, java.awt.BorderLayout.PAGE_START);

        jPanel11.setLayout(new javax.swing.BoxLayout(jPanel11, javax.swing.BoxLayout.Y_AXIS));

        jPanel8.setLayout(new java.awt.BorderLayout());

        jFormattedTextField1.setEditable(false);
        jFormattedTextField1.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.NumberFormatter(java.text.NumberFormat.getCurrencyInstance())));
        jFormattedTextField1.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jFormattedTextField1.setValue(0.0);
        jPanel8.add(jFormattedTextField1, java.awt.BorderLayout.WEST);

        jLabel4.setBackground(new java.awt.Color(255, 255, 255));
        jLabel4.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setText("SAISIE");
        jLabel4.setOpaque(true);
        jPanel8.add(jLabel4, java.awt.BorderLayout.CENTER);

        jLabel5.setText("-");
        jPanel8.add(jLabel5, java.awt.BorderLayout.EAST);

        jPanel11.add(jPanel8);

        jPanel10.setLayout(new javax.swing.BoxLayout(jPanel10, javax.swing.BoxLayout.LINE_AXIS));

        jComboBox2.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1" }));
        jPanel10.add(jComboBox2);

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1" }));
        jPanel10.add(jComboBox1);

        jButton4.setText("RAS");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jPanel10.add(jButton4);

        jToggleButton1.setText("Paiement");
        jToggleButton1.setEnabled(false);
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jPanel10.add(jToggleButton1);

        jLabel7.setText("Total :");
        jPanel10.add(jLabel7);

        jLabel6.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        jLabel6.setText("0.00");
        jPanel10.add(jLabel6);

        jPanel11.add(jPanel10);

        jPanel3.add(jPanel11, java.awt.BorderLayout.PAGE_END);

        jTabbedPane1.addTab("ECR", jPanel3);

        jPanel4.setLayout(new java.awt.BorderLayout());

        jLabel1.setBackground(new java.awt.Color(204, 255, 204));
        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel1.setText("0,00€");
        jLabel1.setToolTipText("Amount Screen");
        jLabel1.setOpaque(true);
        jPanel4.add(jLabel1, java.awt.BorderLayout.CENTER);

        jPanel12.setLayout(new java.awt.GridLayout(1, 0));

        jComboBox6.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1" }));
        jComboBox6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox6ActionPerformed(evt);
            }
        });
        jPanel12.add(jComboBox6);

        jComboBox10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox10ActionPerformed(evt);
            }
        });
        jPanel12.add(jComboBox10);

        jTextField3.setText("9599");
        jTextField3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField3ActionPerformed(evt);
            }
        });
        jPanel12.add(jTextField3);

        jCB_ObjectEditor2.setAsButton(true);
        jPanel12.add(jCB_ObjectEditor2);

        jPanel4.add(jPanel12, java.awt.BorderLayout.PAGE_START);

        jPanel15.setLayout(new javax.swing.BoxLayout(jPanel15, javax.swing.BoxLayout.Y_AXIS));

        jPanel13.setLayout(new javax.swing.BoxLayout(jPanel13, javax.swing.BoxLayout.LINE_AXIS));

        jPanel13.add(jComboBox4);

        jPanel13.add(jComboBox3);

        jPanel5.setLayout(new java.awt.BorderLayout());
        jPanel13.add(jPanel5);

        jButton1.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        jButton1.setForeground(new java.awt.Color(255, 0, 0));
        jButton1.setText("ABN");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel13.add(jButton1);

        jPanel15.add(jPanel13);

        jPanel14.setLayout(new javax.swing.BoxLayout(jPanel14, javax.swing.BoxLayout.LINE_AXIS));

        jLabel2.setText("ECR : ");
        jPanel14.add(jLabel2);

        jLabel3.setText("- -");
        jPanel14.add(jLabel3);

        jComboBox8.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1" }));
        jComboBox8.setEnabled(false);
        jPanel14.add(jComboBox8);

        jComboBox7.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1" }));
        jComboBox7.setEnabled(false);
        jPanel14.add(jComboBox7);

        jPanel15.add(jPanel14);

        jPanel4.add(jPanel15, java.awt.BorderLayout.PAGE_END);

        jTabbedPane1.addTab("EFT", jPanel4);

        add(jTabbedPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        jComboBox3.setSelectedItem("7:NonAboutie");
        // error in IP : concEFT.setStack_Start(true);
        boolean isListner = false;
        if (concEFT.getport().getModeName().compareTo("IPL4") == 0) {
            if (((C_Port) concEFT.getport()).getTCP_Mode().compareTo("TCP_L") == 0) {
                isListner = true;
                for (com.jdcm.eltrx.I_Port p : main.getPorts()) {
                    if (stack != null && p instanceof C_Port && ((C_Port) p).getListener() == concEFT.getport()) {
                        com.jdcm.modifiers.stacks.I_stack_elt st = stack.getTarget(p, "zconcert");
                        if (st != null && st instanceof com.jdcm.modifiers.stacks.Stack_baseStart) {
                            ((com.jdcm.modifiers.stacks.Stack_baseStart) st).setStack_Start(true);
                        }
                    }
                }
            }
        }
        if (isListner == false) {
            concEFT.setStack_Start(true);
        }
        if (jPanel5.getComponentCount() > 0 && jPanel5.getComponent(0) instanceof javax.swing.JToggleButton) {
            javax.swing.JToggleButton b = (javax.swing.JToggleButton) jPanel5.getComponent(0);

            initEFT();
        }

    }//GEN-LAST:event_jButton1ActionPerformed

    private void jComboBox6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox6ActionPerformed
        setComms();
        concEFT.getOptions().setValuefor("trs_phy", jComboBox6.getSelectedItem());
    }//GEN-LAST:event_jComboBox6ActionPerformed

    private void jComboBox5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox5ActionPerformed
        setComms();
        concECR.getOptions().setValuefor("trs_phy", jComboBox5.getSelectedItem());
    }//GEN-LAST:event_jComboBox5ActionPerformed

    private void jTable3MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable3MouseReleased
    }//GEN-LAST:event_jTable3MouseReleased

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        implementAmount(true);
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        implementAmount(false);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jTextField2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField2ActionPerformed
    }//GEN-LAST:event_jTextField2ActionPerformed

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        if (concECR != null) {
            if (jComboBox5.getSelectedItem().toString().compareTo("IPL4") == 0) {
                java.net.InetAddress inet = null;
                try {
                    inet = java.net.InetAddress.getByName(jTextField1.getText());
                } catch (UnknownHostException ex) {
                }
                if (inet != null) {
                    concECR.getOptions().setValuefor("trs_IPaddr", inet);
                } else {
                    try {
                        jTextField1.setText(concECR.getOptions().getValuefor("trs_IPaddr", java.net.InetAddress.getByName("1.1.1.1")).getHostAddress());
                    } catch (UnknownHostException ex) {
                        jTextField1.setText("localhost");
                    }
                }
                try {
                    int port = new Integer(jTextField2.getText());
                    concECR.getOptions().setValuefor("trs_TCPport", port);
                } catch (NumberFormatException ex) {
                    jTextField2.setText("" + concECR.getOptions().getValuefor("trs_TCPport", 8080));
                }
            } else {
                ((C_Port) concECR.getport()).setRS_Port(jComboBox9.getSelectedObjects());
            }
            concECR.getOptions().setValuefor("trs_phy", jComboBox5.getSelectedItem());
            concECR.setStack_Start(jToggleButton1.isSelected());
            if (concECR.isStack_isStart()) {
                initECR(false);

            }
        }
        if (concEFT != null){
            if (jComboBox6.getSelectedItem().toString().compareTo("IPL4") == 0) {
                try {
                    int port = new Integer(jTextField3.getText());
                    concEFT.getOptions().setValuefor("trs_TCPport", port);
                } catch (NumberFormatException ex) {
                    jTextField3.setText("" + concEFT.getOptions().getValuefor("trs_TCPport", 8080));
                }
            }
        }
    }//GEN-LAST:event_jToggleButton1ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        concECR.getport().CXstop();
        jLabel4.setBackground(Color.WHITE);
        jLabel5.setText("-");
        jLabel4.setText("RAS");
        initECR(true);

    }//GEN-LAST:event_jButton4ActionPerformed

    private void jComboBox9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox9ActionPerformed
        Parent.setRS_Port(jComboBox9.getSelectedItem());
         concECR.getOptions().setValuefor("trs_RSport", jComboBox9.getModel());
    }//GEN-LAST:event_jComboBox9ActionPerformed

    private void jComboBox10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox10ActionPerformed
        Parent.setRS_Port(jComboBox10.getSelectedItem());
         concEFT.getOptions().setValuefor("trs_RSport", jComboBox10.getModel());
    }//GEN-LAST:event_jComboBox10ActionPerformed

    private void jTextField3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField3ActionPerformed
                    try {
                    int port = new Integer(jTextField3.getText());
                    concEFT.getOptions().setValuefor("trs_TCPport", port);
                } catch (NumberFormatException ex) {
                    jTextField3.setText("" + concEFT.getOptions().getValuefor("trs_TCPport", 8080));
                }
    }//GEN-LAST:event_jTextField3ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor2;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JComboBox<Object> jComboBox10;
    private javax.swing.JComboBox<String> jComboBox2;
    private javax.swing.JComboBox<String> jComboBox3;
    private javax.swing.JComboBox<String> jComboBox4;
    private javax.swing.JComboBox<String> jComboBox5;
    private javax.swing.JComboBox<String> jComboBox6;
    private javax.swing.JComboBox<String> jComboBox7;
    private javax.swing.JComboBox<String> jComboBox8;
    private javax.swing.JComboBox<Object> jComboBox9;
    private javax.swing.JFormattedTextField jFormattedTextField1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSpinner jSpinner1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable2;
    private javax.swing.JTable jTable3;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JToggleButton jToggleButton1;
    // End of variables declaration//GEN-END:variables

    @Override
    public void receiveObj(Object obj) {
        if (obj instanceof String && obj.toString().compareTo("/CLOSE TALC/")==0) {
            for (I_Port p:main.getPorts()){
                if (p.getPortName().compareTo("ECR")==0
                        ||p.getPortName().compareTo("EFT")==0){
                    p.CXend();
                    main.CXremove(p);
                }
            }
            stack.setStack_Enabled(false);
        }else if (obj instanceof C_Port) {
            Parent = (C_Port) obj;
             main = (C_Main) Parent.getMain();
            C_Port portECR = (C_Port) main.addCX("Port", "ECR", "Serial");
            C_Port portEFT = (C_Port) main.addCX("Port", "EFT", "Serial");

            //         portEFT.getCMDOptions().setValuefor("CX_openbyslave", false);
            if (portECR == null) {
                //port already exist
                java.util.List<com.jdcm.eltrx.I_Command> list = main.getCMDChilds("ECR");
                if (list != null && list.isEmpty() == false && list.get(0) instanceof com.jdcm.eltrx.C_Port) {
                    portECR = (C_Port) list.get(0);
                } else {
                    return;
                }
            }

            if (portEFT == null) {
                //port already exist
                java.util.List<com.jdcm.eltrx.I_Command> list = main.getCMDChilds("EFT");
                if (list != null && list.isEmpty() == false && list.get(0) instanceof com.jdcm.eltrx.C_Port) {
                    portEFT = (C_Port) list.get(0);
                } else {
                    return;
                }
            }
            if (portEFT == null || portECR == null) {
                return;
            }
            portECR.getCMDOptions().setValuefor("CX_openbyslave", false);
            portECR.setRS_Rate(1200);
            portEFT.setRS_Rate(1200);
           // portEFT.setTCP_Listner(true);
            java.util.List<com.jdcm.eltrx.I_Command> list = main.getCMDChilds("Stacks");
            if (list != null && list.isEmpty() == false && list.get(0) instanceof com.jdcm.eltrx.C_Stack) {
                stack = (com.jdcm.eltrx.C_Stack) list.get(0);
                try {
                    stack.addStack("ECR", "zconcert", "ConcECR", 8.0);
                    stack.addStack("ECR", "C0C1", "C0C1", 5.0);
                    stack.addStack("ECR", "Log", "LogECR", 4.5);
                    stack.addStack("EFT", "zconcert", "ConcEFT", 8.0);
                    stack.addStack("EFT", "C0C1", "C0C1", 5.0);
                } catch (Exception ex) {
                }
                stack.setStack_Enabled(true);

                concECR = (Stack_baseStart) stack.getTarget("ECR", "ConcECR");
                concEFT = (Stack_baseStart) stack.getTarget("EFT", "ConcEFT");
                concECR.getOptions().setValuefor("trs_isOutput", "CodeModel");
                concEFT.getOptions().setValuefor("trs_isOutput", "CodeModel");
                concEFT.getOptions().setValuefor("trs_isECR", false);
                concECR.getOptions().setValuefor("trs_phy", "IPL4");
                concEFT.getOptions().setValuefor("trs_phy", "IPL4");      
                portEFT.CXstart();
                concECR.getOptions().getValuefor("trs_amount", new com.jdcm.common.O_Amount()).setAmount(0.0);
                jSpinner1.setModel(concECR.getOptions().getValuefor("trs_ecrNb", new SpinnerNumberModel()));
                // jTextField1.setText("" + concECR.getOptions().getValuefor("trs_amount", new com.jdcm.common.O_Amount()).AMOUNT);
                jComboBox1.setModel(concECR.getOptions().getValuefor("trs_ecrMode", new javax.swing.DefaultComboBoxModel<String>()));
                jComboBox2.setModel(concECR.getOptions().getValuefor("trs_ecrTrsType", new javax.swing.DefaultComboBoxModel<String>()));
                jComboBox5.setModel(concECR.getOptions().getValuefor("trs_phy", new javax.swing.DefaultComboBoxModel<String>()));
                jComboBox6.setModel(concEFT.getOptions().getValuefor("trs_phy", new javax.swing.DefaultComboBoxModel<String>()));
                jCB_ObjectEditor1.setValue(defaultModel);
                jCB_ObjectEditor1.setEnabled(false);
                try {
                    jTextField1.setText(concECR.getOptions().getValuefor("trs_IPaddr", java.net.InetAddress.getByName("1.1.1.1")).getHostAddress());
                } catch (UnknownHostException ex) {
                    jTextField1.setText("localhost");
                }
                jTextField2.setText("" + concECR.getOptions().getValuefor("trs_TCPport", 8080));
                jTextField3.setText("" + concEFT.getOptions().getValuefor("trs_TCPport", 8080));
                jComboBox9.setModel(((C_Port) concEFT.getport()).getCMDOptions().getValuefor("RS_interfaces", new javax.swing.DefaultComboBoxModel<>()));
                jComboBox9.setSelectedItem(((C_Port) concEFT.getport()).getRS_Port());
                 jComboBox10.setModel(((C_Port) concECR.getport()).getCMDOptions().getValuefor("RS_interfaces", new javax.swing.DefaultComboBoxModel<>()));
                jComboBox10.setSelectedItem(((C_Port) concECR.getport()).getRS_Port());
                setComms();
            }
        } else if (obj instanceof com.jdcm.common.C_Packet) {
            if (((com.jdcm.common.C_Packet) obj).getsource() == concECR.getport()) {
                EnableEFT(false);
                if (((com.jdcm.common.C_Packet) obj).getObj() instanceof com.jdcm.analyse.Code_Model) {
                    com.jdcm.analyse.Code_Model model = ((com.jdcm.analyse.Code_Model) ((com.jdcm.common.C_Packet) obj).getObj());
                    jCB_ObjectEditor1.setValue(model);
                    jCB_ObjectEditor1.setEnabled(true);
                    DefaultComboBoxModel<String> cmb = concECR.getOptions().getValuefor("trs_eftResult", new DefaultComboBoxModel<String>());
                    DefaultComboBoxModel<String> cmb2 = concECR.getOptions().getValuefor("trs_eftIssuer", new DefaultComboBoxModel<String>());
                    if (cmb.getSelectedItem().toString().startsWith("0")) {
                        jLabel4.setText("OK");
                        jLabel4.setBackground(Color.GREEN);
                    } else if (cmb.getSelectedItem().toString().startsWith("7")
                            || cmb.getSelectedItem().toString().startsWith("8")) {
                        jLabel4.setText("KO");
                        jLabel4.setBackground(Color.RED);
                    } else if (cmb.getSelectedItem().toString().startsWith("9")) {
                        jLabel4.setText("ACK");
                        jLabel4.setBackground(Color.YELLOW);
                    }
                    double amount = concECR.getOptions().getValuefor("trs_amount", new com.jdcm.common.O_Amount()).AMOUNT;
                    if (cmb.getSelectedItem().toString().startsWith("0")) {
                        // String monaiestr = monaieFormat.format();
                        jLabel6.setText("" + (Double.parseDouble(jLabel6.getText()) + amount));
                    }
                    String issuer = cmb2.getSelectedItem().toString();
                    jLabel5.setText(issuer.substring(issuer.indexOf(":") + 1));
                    initECR(true);
                    // Thread needed because else on serial port a Serail event will ask to close serial Port => blocekd in stopping
                    java.lang.Thread t = new java.lang.Thread(new java.lang.Runnable() {
                        @Override
                        public void run() {
                            concECR.setStack_Start(false);
                        }
                    });
                    t.start();
                }
            } else if (((C_Port) ((com.jdcm.common.C_Packet) obj).getsource()).getListener() == concEFT.getport()
                    || ((C_Port) ((com.jdcm.common.C_Packet) obj).getsource()) == concEFT.getport()) {
                EnableEFT(true);
                if (((com.jdcm.common.C_Packet) obj).getObj() instanceof com.jdcm.analyse.Code_Model) {
                    com.jdcm.analyse.Code_Model model = ((com.jdcm.analyse.Code_Model) ((com.jdcm.common.C_Packet) obj).getObj());
                    jCB_ObjectEditor2.setValue(model);
                    jCB_ObjectEditor2.setEnabled(true);
                    if (stack != null) {
                        jPanel5.removeAll();
                        com.jdcm.modifiers.stacks.Stack_zconcert concStack =
                                (com.jdcm.modifiers.stacks.Stack_zconcert) stack.getTarget(
                                ((com.jdcm.common.C_Packet) obj).getsource().getPortName(), "zconcert");
                        com.jdcm.common.Options_Model opt = concStack.getOptions();
                        javax.swing.JToggleButton btn = opt.getValuefor("stack_start", new javax.swing.JToggleButton());
                        btn.setForeground(Color.green);
                        btn.setText("VALID");
                        btn.setFont(new java.awt.Font(btn.getFont().getName(), btn.getFont().getStyle(), 18));
                        jPanel5.add(btn, java.awt.BorderLayout.CENTER);
                        com.jdcm.common.O_Amount mnt = opt.getValuefor("trs_amount", new com.jdcm.common.O_Amount());
                        jLabel1.setText("" + mnt.AMOUNT + " " + mnt.getSymbol());
                        jComboBox3.setModel(opt.getValuefor("trs_eftResult", new javax.swing.DefaultComboBoxModel<String>()));
                        jComboBox4.setModel(opt.getValuefor("trs_eftIssuer", new javax.swing.DefaultComboBoxModel<String>()));
                        jComboBox7.setModel(opt.getValuefor("trs_ecrTrsType", new javax.swing.DefaultComboBoxModel<String>()));
                        jComboBox8.setModel(opt.getValuefor("trs_ecrMode", new javax.swing.DefaultComboBoxModel<String>()));
                        if (jComboBox8.getSelectedItem().toString().startsWith("C:CHEQUE")) {
                            jComboBox4.setSelectedItem("C:Cheque");
                        }
                        jLabel3.setText(opt.getValuefor("trs_ecrNb", new SpinnerNumberModel()).getValue().toString());
                        jComboBox3.setEnabled(true);
                        jComboBox4.setEnabled(true);
                        jLabel1.setEnabled(true);
                    }
                }
            }
        }
    }
}
