/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.jdcm.editors;

import com.jdcm.eltrx.C_Main;
import com.jdcm.eltrx.C_Port;
import java.awt.event.ActionEvent;
import java.net.UnknownHostException;

/**
 *
 * @author MGiboin
 */
public class B_SIMsCan extends javax.swing.JPanel implements I_ObjectReceiver {

    private static final long serialVersionUID = 1L;
    private final javax.swing.JCheckBoxMenuItem menuLog = new javax.swing.JCheckBoxMenuItem("Log");
    private final sender snd = new sender();
    
    private C_Port Parent = null;
    private String ipTarget = "194.5.120.199";
    private String tcpTarget = "148";
    private C_Main main = null;
    private C_Port MODEM_GPRS = null;

    /**
     * Creates new form B_SIMScan
     */
    public B_SIMsCan() {
        initComponents();
        try {
            jCB_ObjectEditor1.setValue(java.net.InetAddress.getByName("192.168.110.205"));
        } catch (UnknownHostException ex) {
            System.out.println("B_SIMsCan : B_SIMsCan()=>" + ex);
        }
        this.setName("SIM SCANNER");
        String[] apnstxt = new String[]{"m2m.orange.spec", "m2m.orange.fr", "orange.fr", "internet-entreprise"};
        javax.swing.DefaultComboBoxModel<String> apns = new javax.swing.DefaultComboBoxModel<>(apnstxt);
        int row = 1;
        for (int i = 0; i < jTable1.getRowCount(); i++) {
            if (jTable1.getValueAt(i, 0) != null && jTable1.getValueAt(i, 0).toString().compareTo("APNs") == 0) {
                row = i;
            }
        }
        if (row >= 0) {
            jTable1.setValueAt(apns, row, 2);
        }
        jTable1.getColumn("Cmdes").setCellRenderer(new com.jdcm.editors.ACE_ObjRenderer<>());
        jTable1.getColumn("Cmdes").setCellEditor(new com.jdcm.editors.ACE_ObjEditor<>());
    }

    public java.awt.Image getIcon() {
        return (new com.jdcm.common.D_Utils()).getImage("sim.gif");
    }

    public java.util.List<javax.swing.JMenuItem> getMenus() {
        java.util.List<javax.swing.JMenuItem> items = new java.util.ArrayList<>();
        final javax.swing.JMenuItem item0 = new javax.swing.JMenuItem("Objectif");
        item0.setActionCommand("?");
        item0.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String txt = "Cette application a pour objectif de fournir les informations d'une SIM\r\n"
                        + "elle est dévellopée dans le cadre des integrations monétique\r\n"
                        + "La SIM doit être placée dans un modem (CXR-TTGRPS)\r\n"
                        + "aprés connection (en telnet) au modem, l'envoie de commande AT \r\n"
                        + "Aucune doc de référence n'est réalisée à ce jour";
                javax.swing.JOptionPane.showMessageDialog(null, txt, "Objectif", javax.swing.JOptionPane.INFORMATION_MESSAGE);
            }
        });
        menuLog.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                setLogs(menuLog.isSelected());
            }
        });
        final javax.swing.JMenuItem item1 = new javax.swing.JMenuItem("IP Adresse");
        item1.setActionCommand("Target");
        item1.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Object res = javax.swing.JOptionPane.showInputDialog(null, "IP Adresse : ", "SIM Scan : Target", javax.swing.JOptionPane.INFORMATION_MESSAGE, null, null, ipTarget);
                if (res != null && res instanceof String) {
                    ipTarget = res.toString();
                }
            }
        });
        final javax.swing.JMenuItem item2 = new javax.swing.JMenuItem("TCP Port");
        item2.setActionCommand("Target");
        item2.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Object res = javax.swing.JOptionPane.showInputDialog(null, "TCP Adresse : ", "SIM Scan : Target", javax.swing.JOptionPane.INFORMATION_MESSAGE, null, null, tcpTarget);
                if (res != null && res instanceof String) {
                    ipTarget = res.toString();
                }
            }
        });
        items.add(item0);
        items.add(menuLog);
        items.add(item1);
        items.add(item2);
        menuLog.setActionCommand("?");
        menuLog.setEnabled(true);
        return items;
    }

    class sender extends Thread {

        public boolean waitingState = false;
        String ATresult = "";
        public int ligne = -1;
        public String APN = null;

        public sender() {
        }

        public void addResult(String txt) {
            ATresult += txt;
        }

        public String sendModem(String txt, int l, String apn, long TOsec) {
            ligne = l;
            APN = apn;
            waitingState = true;
            ATresult = "";
            if (MODEM_GPRS != null && txt != null) {
                System.out.println("==>" + txt);
                byte[] query = (txt + "\r\n").getBytes();
                main.read(new com.jdcm.common.C_Packet(query, MODEM_GPRS));
            }
            long ti = System.currentTimeMillis();
            while (waitingState || ti + 500 > System.currentTimeMillis()) {
                try {
                    sleep(5);
                } catch (InterruptedException ex) {
                    System.out.println("B_SIMsCan : sendModem()=>" + ex);
                }
                if (System.currentTimeMillis() > ti + TOsec * 1000) {
                    System.out.println("==>[TO]");
                    return "[TO]:" + ATresult;
                }
            }
            return ATresult;
        }
    }

    private void setStart(boolean bool) {
        if (bool) {
            MODEM_GPRS = (C_Port) main.addCX("Port", "MODEM_GPRS", "IPL4");
            MODEM_GPRS.setTCP_Addr((java.net.InetAddress) jCB_ObjectEditor1.getValue());
            MODEM_GPRS.setTCP_Port(jTextField2.getText());
            MODEM_GPRS.CXstart();
            for (int i = 0; i < jTable1.getRowCount(); i++) {
                jTable1.setValueAt("", i, 1);
            }
            // wait for banner
            if (snd.sendModem(null, -1, null, 2).startsWith("[TO]")) {
                // setStart(false);
                return;
            }
            // snd.sendModem("+++", -1, null);
            snd.sendModem("ATZ", -1, null, 2);
            for (int activRow = 0; activRow < jTable1.getRowCount(); activRow++) {
                if (jTable1.getValueAt(activRow, 2) instanceof String) {
                    snd.sendModem("AT" + jTable1.getValueAt(activRow, 2), activRow, null, 5);
                } else if (jTable1.getValueAt(activRow, 2) instanceof javax.swing.DefaultComboBoxModel) {
                    javax.swing.DefaultComboBoxModel apns = (javax.swing.DefaultComboBoxModel) jTable1.getValueAt(activRow, 2);
                    snd.sendModem("AT#PROVIP32=\"" + ipTarget + "\"", -1, null, 2);
                    snd.sendModem("AT#SKTSET32=" + tcpTarget, -1, null, 2);
                    for (int j = 0; j < 0; j++) {//apns.getSize()
                        String apn = apns.getElementAt(j).toString();
                        snd.sendModem("AT#PROVID32=\"" + apn + "\"", -1, apn, 12);
                        long ti = System.currentTimeMillis();
                        while (snd.sendModem("AT&V10", -2, apn, 10).contains(",99,")
                                && ti + 100000 > System.currentTimeMillis()) {
                        }
                        if (ti + 100000 > System.currentTimeMillis()) {
                            snd.sendModem("ATZ", -1, null, 2);
                            //       snd.sendModem("AT$T1032", activRow, apn);
                        }

                    }
                    snd.sendModem("ATZ", -1, null, 2);
                }
            }
            jToggleButton1.setSelected(false);
        } else if (MODEM_GPRS != null) {
            snd.sendModem("+++", -1, null, 1);
            MODEM_GPRS.CXend();
            snd.waitingState = false;
            jToggleButton1.setSelected(false);
        }

    }

    private void setLogs(boolean bool) {
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTextField1 = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jCB_ObjectEditor1 = new com.jdcm.editors.JCB_ObjectEditor();
        jLabel2 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jToggleButton1 = new javax.swing.JToggleButton();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel2 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jToggleButton2 = new javax.swing.JToggleButton();

        jTextField1.setText("jTextField1");

        setPreferredSize(new java.awt.Dimension(452, 200));
        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.LINE_AXIS));

        jLabel1.setText("IP  Modem : ");
        jPanel1.add(jLabel1);

        jCB_ObjectEditor1.setEditable(true);
        jPanel1.add(jCB_ObjectEditor1);

        jLabel2.setText("Port TCP : ");
        jPanel1.add(jLabel2);

        jTextField2.setText("23");
        jPanel1.add(jTextField2);

        jToggleButton1.setText("Start");
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jToggleButton1);

        add(jPanel1, java.awt.BorderLayout.NORTH);

        jPanel3.setLayout(new javax.swing.BoxLayout(jPanel3, javax.swing.BoxLayout.LINE_AXIS));

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"APNs", null, ""},
                {"init", null, "O97"},
                {"IMEI", null, "+CGSN"},
                {"IMSI", null, "+IMSI"},
                {"Operator", null, "+COPS"},
                {"SIM Serial Numer", null, "+CCID"},
                {"GSM Level", null, "+CSQ"},
                {"ISMI", null, "+CNUM"},
                {"LOC", null, "#MONI"}
            },
            new String [] {
                "Descr", "Result", "Cmdes"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, true, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTable1);

        jPanel3.add(jScrollPane1);

        add(jPanel3, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.LINE_AXIS));

        jLabel3.setText("SMS destination : ");
        jPanel2.add(jLabel3);

        jTextField3.setText("+33676213871");
        jPanel2.add(jTextField3);

        jToggleButton2.setText("Start");
        jPanel2.add(jToggleButton2);

        add(jPanel2, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        setStart(jToggleButton1.isSelected());
    }//GEN-LAST:event_jToggleButton1ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private com.jdcm.editors.JCB_ObjectEditor jCB_ObjectEditor1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToggleButton jToggleButton2;
    // End of variables declaration//GEN-END:variables

    @Override
    public void receiveObj(Object obj) {
        if (obj instanceof C_Port) {
            Parent = (C_Port) obj;
            main = ((C_Main) Parent.getMain());
            snd.waitingState = true;
        } else if (obj instanceof String && obj.toString().compareTo("/CLOSE TALC/") == 0) {
        } else if (obj instanceof com.jdcm.common.C_Packet) {
            obj = ((com.jdcm.common.C_Packet) obj).getObj();
            if (obj instanceof byte[]) {
                String ATrep = (new String((byte[]) obj)).trim();
                System.out.println("==<" + ATrep);
                snd.addResult(ATrep);
                if (ATrep.contains("TSGPRS")) {
                    snd.waitingState = false;
                } else if (ATrep.contains("OK")) {
                    snd.waitingState = false;
                } else if (ATrep.contains("ERROR")) {
                    snd.waitingState = false;
                }
                if (snd.APN != null && snd.APN.length() > 0) {
                    if (ATrep.contains("OK") && snd.ligne >= 0) {
                        jTable1.setValueAt(jTable1.getValueAt(snd.ligne, 1).toString() + ";" + snd.APN, snd.ligne, 1);
                        if (jTable1.getValueAt(snd.ligne, 1).toString().startsWith(";")) {
                            jTable1.setValueAt(jTable1.getValueAt(snd.ligne, 1).toString().substring(1), snd.ligne, 1);
                        }
                    }
                } else {
                    if (snd.ligne > 0) {
                        if (ATrep.endsWith("OK")) {
                            ATrep = ATrep.substring(0, ATrep.length() - 2);
                        }
                        if (ATrep.endsWith("ERROR")) {
                            ATrep = ATrep.substring(0, ATrep.length() - 5);
                        }
                        if (ATrep.indexOf(": ") >= 0) {
                            ATrep = ATrep.substring(ATrep.indexOf(": ") + 2);
                        }
                        jTable1.setValueAt(jTable1.getValueAt(snd.ligne, 1).toString() + ATrep, snd.ligne, 1);
                    }
                }
            }
        }
        jTable1.repaint();
    }
}
