package com.jdcm.editors;

import com.jdcm.common.*;
import java.sql.*;
import com.jdcm.common.C_Packet;
import com.jdcm.eltrx.I_Port;
import com.jdcm.eltrx.C_Port;
import com.jdcm.eltrx.D_Debug;
import com.jdcm.eltrx.T_DB;
import javax.swing.text.BadLocationException;

/**
 * F_DBTable.java Created on 30 novembre 2006, 13:14
 *
 * @author Marc GIBOIN missing in the result set : - the original statement SQL
 *
 * string => refresh - the timeStamp of creation - the time of the Database
 * proceccing delai -
 */
public class P_SQLTable extends javax.swing.JPanel {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final java.awt.Color col_green = new java.awt.Color(150, 220, 150);
    private final java.awt.Color col_org = new java.awt.Color(250, 180, 130);
    private final runRequests runner = new runRequests() {
        @Override
        public void display(int init, int nb) {
            jToggleButton1.setToolTipText("rest : " + nb + "/" + init);
        }

        @Override
        public void end(int init) {
            jToggleButton1.setToolTipText("");
            jToggleButton1.setSelected(false);
        }
    };

    private D_Debug TDeb;
    private D_Utils TUtils = new D_Utils();
    private I_Port Parent;
    private C_Packet Pack;

    private D_DBUtils dbutils = null;

    /**
     * Creates new form F_DBTable
     */
    public P_SQLTable() {
        initComponents();
        dbutils = new D_DBUtils();
        p_Table1.setValue(P_TableEditor.defaultTable());
        p_Table1.sethdrcol(true);
        initialise();
    }

    public P_SQLTable(boolean isaplet) {
        initComponents();
        dbutils = new D_DBUtils();
        p_Table1.setValue(P_TableEditor.defaultTable());
        p_Table1.sethdrcol(true);
        initialise();
        setVisible(isaplet == false);
    }

    public P_SQLTable(I_Port p, C_Packet paquet) {
        TUtils = new D_Utils();
        dbutils = new D_DBUtils();
        initComponents();
        Pack = paquet;
        setParent(p);
        if (Pack != null && Pack.getObj() instanceof ResultSet) {
            p_Table1.setValue(paquet);
            p_Table1.setSQLRequest(Pack.getSQLReq());
        }
        initialise();
        //addTab(new P_PacketEditor(Pack),"first SQL Packet",null);
    }

    final public void setParent(I_Port p) {
        Parent = p;
        if (TDeb == null && p != null) {
            TDeb = new D_Debug("DB_Tab: [" + Parent.getIndex() + "]");
        } else if (TDeb != null && p != null) {
            TDeb.setsource("DB_Tab: [" + Parent.getIndex() + "]");
        } else if (TDeb != null && p == null) {
            TDeb.setsource("DB_Tab:");
        } else if (TDeb == null && p == null) {
            TDeb = new D_Debug("DB_Tab: ");
        }
        if (Parent instanceof C_Port) {
            dbutils.setPort(((C_Port) Parent));
            TDeb.setconsole(Parent.getConsole());
            p_Texte1.setDataBase(((C_Port) Parent).getDB_CX());
        }
    }

    private void initialise() {
        jButton2.setIcon(TUtils.getIcon("DB_where.gif"));
        jButton3.setIcon(TUtils.getIcon("DB_orderAsc.gif"));
        jToggleButton1.setIcon(TUtils.getIcon("Bt_on_play.gif"));
        jToggleButton1.setSelectedIcon(TUtils.getIcon("stop.gif"));
        jButton5.setIcon(TUtils.getIcon("DB_orderDsc.gif"));
        jButton1.setBackground(java.awt.Color.gray);
        jButton1.setText("-");
        p_Texte1.setType("SQL");
    }

    public void setDBcx(java.sql.Connection dbcx) {
        p_Texte1.setDataBase(dbcx);
    }

    public com.jdcm.editors.P_Texte getSQLTextPane() {
        return p_Texte1;
    }

    public void insertTable(String shema, String table) {
        insertText(dbutils.getstdTableName(shema, table));
    }

    public void insertText(String txt) {
        int pos = p_Texte1.getTextePane().getCaretPosition();
        if (pos >= 0) {
            try {
                p_Texte1.getTextePane().getDocument().insertString(pos, txt, null);
            } catch (BadLocationException ex) {
                TDeb.wri("P_ISQLTable : insertText() =>" + ex.getMessage());
            }
        }
        p_Texte1.colorCode();
    }

    public void performSelect(String shema, String table, int max) {
        performRequest("SELECT * FROM " + dbutils.getstdTableName(shema, table) + ";", max);
        jToggleButton1.setSelected(false);
    }

    public void performRequest(String req, int maxRows) {
        req = req.trim();
        if (req == null || req.length() == 0 || Parent instanceof C_Port == false) {
            return;
        }
        if (jToggleButton1.isSelected() == false) {
            jToggleButton1.setSelected(true);
            jToggleButton1.repaint();
        }
        String tempOutType = ((C_Port) Parent).getDB_resultType();
        ((C_Port) Parent).setDB_resultType("ResultSet");
        try {
            jButton1.setBackground(java.awt.Color.black);
            jButton1.setText("-");
            jButton1.setToolTipText("running");
            jButton1.repaint();
            p_Table1.setValue(null);
            if (p_Texte1.getText() == null
                    || p_Texte1.getText().trim().length() == 0
                    || p_Texte1.getText().contains(req) == false) {
                p_Texte1.setText(req);
            }
            C_Packet pack = new C_Packet(req, -1);
            C_Port part = (C_Port) Parent;
            if (part.getSlave() instanceof T_DB) {
                boolean err = part.isDB_Errors();
                part.setDB_Errors(true);
                if (maxRows > 0) {
                    int tmpmax = part.getDB_maxrows();
                    part.setDB_maxrows(maxRows);
                    pack = ((T_DB) part.getSlave()).Trt_out(pack);
                    part.setDB_maxrows(tmpmax);
                } else {
                    pack = ((T_DB) part.getSlave()).Trt_out(pack);
                    maxRows = part.getDB_maxrows();
                }
                part.setDB_Errors(err);
            }
            if (pack == null) {
                if (req.toUpperCase().startsWith("CREATE ")
                        || req.toUpperCase().startsWith("DROP ")
                        || req.toUpperCase().startsWith("ALTER ")) {
                    jButton1.setText("OK");
                }
                jButton1.setBackground(col_green);
            } else if (pack.getObj() instanceof Integer) {
                jButton1.setText("" + pack.getObj());
                jButton1.setBackground(col_green);
                jButton1.setText("Upd: " + pack.getObj());
                p_Table1.addLogs("Row(s) Updated : " + pack.getObj());
            } else if (pack.getObj() instanceof ResultSet) {
                ResultSet res = (ResultSet) pack.getObj();
                p_Table1.setValue(res);
                p_Table1.setSQLRequest(req);

                // req = "Select count(*) from " + table + ";";
                try {
                    ResultSet rescnt = null;
                    if (part.getSlave() instanceof T_DB) {
                        String subreq = req.substring(req.toUpperCase().indexOf(" FROM "));
                        if (subreq.toUpperCase().contains(" ORDER ")) {
                            subreq = subreq.substring(0, subreq.toUpperCase().indexOf(" ORDER "));
                        }
                        req = "SELECT COUNT(*) as Nb_Rows" + subreq;
                        rescnt = ((T_DB) part.getSlave()).Trt_out(req);
                    }
                    if (rescnt == null) {
                        p_Table1.addLogs("no valid Count..");
                        return;
                    }
                    // if ( !Parent.getDB_type().startsWith("ODBC_xls")) {
                    rescnt.next();
                    //  }
                    Object nbrowsObj = rescnt.getObject("Nb_Rows");
                    long nbrows;
                    if (nbrowsObj instanceof Integer) {
                        nbrows = 0L + ((Integer) nbrowsObj);
                    } else {
                        nbrows = (Long) nbrowsObj;
                    }
                    jButton1.setBackground(col_green);
                    jButton1.setText("" + nbrows);
                    p_Table1.addLogs("Readed : " + nbrows + " rows for : " + req);
                    if (maxRows == 0 || maxRows < nbrows) {
                        jButton1.setBackground(col_org);
                    }
                    rescnt.close();
                    jButton1.setToolTipText("req : " + req);
                } catch (SQLException ex) {
                    TDeb.wri("===>" + ex.getMessage());
                }
            } else {
                String log;
                jButton1.setBackground(java.awt.Color.red);
                if (pack.getObj() instanceof byte[]) {
                    log = "" + new String((byte[]) pack.getObj());
                } else {
                    log = "" + pack.getObj();
                }
                jButton1.setToolTipText(log);
                p_Table1.addLogs(log);
            }
        } catch (Exception ex) {
            TDeb.wri("==>" + ex.getMessage());
        }
        ((C_Port) Parent).setDB_resultType(tempOutType);

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane2 = new javax.swing.JSplitPane();
        p_Table1 = new com.jdcm.editors.P_TableEditor();
        jPanel1 = new javax.swing.JPanel();
        jToolBar1 = new javax.swing.JToolBar();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jToggleButton1 = new javax.swing.JToggleButton();
        jButton1 = new javax.swing.JButton();
        p_Texte1 = new com.jdcm.editors.P_Texte();

        setLayout(new java.awt.BorderLayout());

        jSplitPane2.setDividerLocation(100);
        jSplitPane2.setDividerSize(3);
        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        p_Table1.setMinimumSize(new java.awt.Dimension(10, 10));
        p_Table1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                p_Table1MouseClicked(evt);
            }
        });
        jSplitPane2.setRightComponent(p_Table1);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jToolBar1.setRollover(true);

        jButton2.setToolTipText("WHERE");
        jButton2.setBorderPainted(false);
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jButton3.setToolTipText("ASC");
        jButton3.setBorderPainted(false);
        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jButton5.setToolTipText("DESC");
        jButton5.setBorderPainted(false);
        jButton5.setFocusable(false);
        jButton5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton5.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButton5.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton5);

        jToggleButton1.setToolTipText("request");
        jToggleButton1.setFocusable(false);
        jToggleButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jToggleButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToggleButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jToggleButton1);

        jButton1.setToolTipText("Status");
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jPanel1.add(jToolBar1, java.awt.BorderLayout.NORTH);

        p_Texte1.setGlobalBar(false);
        p_Texte1.setLineBar(false);
        p_Texte1.setMinimumSize(new java.awt.Dimension(1, 10));
        p_Texte1.setPreferredSize(new java.awt.Dimension(30, 100));
        jPanel1.add(p_Texte1, java.awt.BorderLayout.CENTER);

        jSplitPane2.setLeftComponent(jPanel1);

        add(jSplitPane2, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new P_SQLTable().setVisible(true);
            }
        });
    }
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (jButton1.getText().length() > 0 && jButton1.getBackground() == col_org) {
            // complete a request (300 /default => more
            try {
                int max = Integer.parseInt(jButton1.getText());
                performRequest(p_Texte1.getText(), max);
                jToggleButton1.setSelected(false);
            } catch (NumberFormatException ex) {
                TDeb.wri("jButton1ActionPerformed()=>"+ex.getMessage());
            }
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        String colName = p_Table1.getDataSelectedColumnIntem();
        String valString = p_Table1.getDataSelectedValue();
        if (colName == null) {
            return;
        }
        String select = p_Texte1.getText();
        /* if (Parent instanceof C_Port) {
         if (((C_Port) Parent).getSlave() instanceof T_DB) {
         colName = ((T_DB) ((C_Port) Parent).getSlave()).getstdColumnName(colName);
         }
         }*/
        if (select != null) {
            if (select.endsWith(";")) {
                select = select.substring(0, select.length() - 1);
            }
            String part2 = colName + " LIKE '%'";
            if (valString != null && valString.length() > 0) {
                part2 = colName + " = '" + valString + "'";
            }
            if (select.toUpperCase().contains(" WHERE ")) {
                int posw = select.toUpperCase().indexOf(" WHERE ") + " WHERE ".length();
                select = select.substring(0, posw) + part2 + " AND " + select.substring(posw) + ";";
            } else if (select.toUpperCase().contains(" ORDER ")) {
                int posw = select.toUpperCase().indexOf(" ORDER ");
                select = select.substring(0, posw) + " WHERE " + part2 + select.substring(posw) + ";";
            } else {
                select = select + " WHERE " + part2 + ";";
            }
            p_Texte1.setText(select);
            performRequest(p_Texte1.getText(), 0);
        }
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        String colName = p_Table1.getDataSelectedColumnIntem();
        String select = p_Texte1.getText();
        if (colName == null) {
            return;
        }
        /*  if (Parent instanceof C_Port) {
         if (((C_Port) Parent).getSlave() instanceof T_DB) {
         colName = ((T_DB) ((C_Port) Parent).getSlave()).getstdColumnName(colName);
         }
         }*/
        if (select != null) {
            if (select.endsWith(";")) {
                select = select.substring(0, select.length() - 1);
            }
            if (select.toUpperCase().contains(" ORDER BY ") && select.toUpperCase().contains(" ASC")) {
                int poso = select.toUpperCase().toUpperCase().indexOf(" ORDER BY ") + " ORDER BY ".length();
                select = select.substring(0, poso) + colName + "," + select.substring(poso) + ";";
            } else {
                select = select + " ORDER BY " + colName + " ASC;";
            }
            p_Texte1.setText(select);
            performRequest(p_Texte1.getText(), 0);
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        String colName = p_Table1.getDataSelectedColumnIntem();
        String select = p_Texte1.getText();
        if (colName == null) {
            return;
        }
        /*  if (Parent instanceof C_Port) {
         if (((C_Port) Parent).getSlave() instanceof T_DB) {
         colName = ((T_DB) ((C_Port) Parent).getSlave()).getstdColumnName(colName);
         }
         }*/
        if (select != null) {
            if (select.endsWith(";")) {
                select = select.substring(0, select.length() - 1);
            }
            if (select.toUpperCase().contains(" ORDER BY ") && select.toUpperCase().contains(" DESC")) {
                int poso = select.toUpperCase().toUpperCase().indexOf(" ORDER BY ") + " ORDER BY ".length();
                select = select.substring(0, poso) + colName + "," + select.substring(poso) + ";";
            } else {
                select = select + " ORDER BY " + colName + " DESC;";
            }
            p_Texte1.setText(select);
            performRequest(p_Texte1.getText(), 0);
        }
    }//GEN-LAST:event_jButton5ActionPerformed

    private void p_Table1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_p_Table1MouseClicked
        boolean bool = p_Table1.getDataSelectedColumnIntem() != null;
        jButton2.setEnabled(bool);
        jButton3.setEnabled(bool);
        jButton5.setEnabled(bool);

    }//GEN-LAST:event_p_Table1MouseClicked

    private void jToggleButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButton1ActionPerformed
        if (jToggleButton1.isSelected()) {
            // need to split by ;... but care";";--... ;...
            if (p_Texte1.getText().trim().endsWith(";") == false) {
                p_Texte1.setText(p_Texte1.getText().trim() + ";");
            }
            p_Table1.addLogs("Request : " + p_Texte1.getText());
            String requests = p_Texte1.getText();
            requests = requests.trim();
            String[] reqs = requests.split(";\n");
            /*       String buffer = "";      
             for (String request : requests) {
             if (request != null && request.length() > 1 && request.trim().startsWith("--") == false) {
             buffer += request + "\r\n";
             if (request.endsWith(";")) {
             java.util.List<String> reqs = java.util.Arrays.asList(new String[]{buffer});
             }
             }
             }*/
            for (String txt : reqs) {
                runner.addReq(txt);
            }
            java.lang.Thread t = new java.lang.Thread(runner);
            t.start();
        } else {
            runner.clearReqs();
        }
    }//GEN-LAST:event_jToggleButton1ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JToggleButton jToggleButton1;
    private javax.swing.JToolBar jToolBar1;
    private com.jdcm.editors.P_TableEditor p_Table1;
    private com.jdcm.editors.P_Texte p_Texte1;
    // End of variables declaration//GEN-END:variables

    class runRequests implements java.lang.Runnable {

        java.util.List<String> reqs = new java.util.LinkedList<>();

        public void clearReqs() {
            reqs.clear();
        }

        public void addReq(String req) {
            this.reqs.add(req);
        }

        public void display(int init, int nb) {
            // just to display the number of requests to do (should be overwrited)
        }

        public void end(int nb) {
            // just to display the number of requests to do (should be overwrited)
        }

        @Override
        public void run() {
            int initSize = reqs.size();
            /*
             * Split an INSERT to get a 'viewable' INSERT for
             * Scripts if (buffer.startsWith("INSERT") &&
             * buffer.indexOf("VALUES")>0){ reqs=new
             * java.util.ArrayList<String>(); String
             * radical=buffer.substring(0,
             * buffer.indexOf("VALUES ")+"VALUES ".length());
             * buffer=buffer.substring(radical.length());
             * String[] bufs=buffer.split(",\r\n"); for (String
             * buf:bufs){ if (!buf.endsWith(";")){ buf=buf+";";
             * } reqs.add(radical+buf); }
             }
             */
            while (!reqs.isEmpty()) {
                String req = reqs.remove(0);
                performRequest(req, 0);
                display(initSize, reqs.size());
            }
            end(initSize);
        }
    }
}
