package com.jdcm.editors;

import com.jdcm.common.*;
import java.sql.*;
import com.jdcm.common.C_Packet;
import com.jdcm.eltrx.*;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 *
 * @author Marc GIBOIN missing in the result set : - the original statement SQL
 *
 * string => refresh - the timeStamp of creation - the time of the Database
 * proceccing delai -
 */
public class P_SQLTables extends javax.swing.JPanel {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final D_Utils TUtils = new D_Utils();
    private final javax.swing.JPanel EmptyPanel = null;

    private D_Debug TDeb;
    private C_Port Parent;
    private C_Main Main;
    private ResultSet rset = null;
    private C_Packet Pack;
    private java.sql.Connection activeCX = null;
    private java.util.Map<java.sql.Connection, I_Port> CXMap = null;

    /**
     * Creates new form F_DBTable
     */
    public P_SQLTables() {
        initComponents();
        initialise();
        // this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
    }

    public P_SQLTables(boolean isaplet) {
        initComponents();
        initialise();
        setVisible(isaplet == false);
    }

    public P_SQLTables(C_Port p, C_Packet paquet) {
        Pack = paquet;
        initComponents();
        if (Pack != null && Pack.getObj() instanceof ResultSet) {
            rset = (ResultSet) Pack.getObj();

        }
        setParent(p);
        initialise();
        //addTab(new P_PacketEditor(Pack),"first SQL Packet",null);
    }

    public P_SQLTables(C_Main m) {
        initComponents();
        TDeb = new D_Debug("DB_Tab: Main");
        Main = m;
        updateDB();
        initialise();
        //addTab(new P_PacketEditor(Pack),"first SQL Packet",null);
    }

    final public void setParent(C_Port p) {
        Parent = p;
        if (TDeb == null && p != null) {
            TDeb = new D_Debug("DB_Tab: [" + Parent.getIndex() + "]");
        } else if (TDeb != null && p != null) {
            TDeb.setsource("DB_Tab: [" + Parent.getIndex() + "]");
        } else if (TDeb != null && p == null) {
            TDeb.setsource("DB_Tab:");
        } else if (TDeb == null && p == null) {
            TDeb = new D_Debug("DB_Tab: ");
        }
        if (Parent instanceof C_Port) {
            TDeb.setconsole(Parent.getConsole());
        }
        if (p != null) {
            for (int i = 0; i < jTabbedPane1.getTabCount(); i++) {
                if (jTabbedPane1.getComponentAt(i) instanceof P_SQLTable) {
                    ((P_SQLTable) jTabbedPane1.getComponentAt(i)).setParent(p);
                }
            }
            updateDB();
        }
    }

    private void initialise() {
        TUtils.addTabedPane2Frame(jTabbedPane1);
        //  setIconImage(TUtils.getImage("DB_table.gif"));
        jButton1.setIcon(TUtils.getIcon("refresh.gif"));
        jButton2.setIcon(TUtils.getIcon("Add.gif"));
        jButton3.setIcon(TUtils.getIcon("Remove.gif"));
        jButton4.setIcon(TUtils.getIcon("DB_shema.gif"));
        jButton5.setIcon(TUtils.getIcon("Empty.gif"));
        jButton6.setIcon(TUtils.getIcon("Xbuild.gif"));
        jButton7.setIcon(TUtils.getIcon("Valide.gif"));
        jButton8.setIcon(TUtils.getIcon("View.gif"));
        G_ButtonTabComponent bpanel = new G_ButtonTabComponent(jTabbedPane1, true, null) {
            private static final long serialVersionUID = 1L;

            @Override
            public void addTab() {
                addSQLTab();
            }
        };
        jTabbedPane1.setTabComponentAt(jTabbedPane1.getTabCount() - 1, bpanel);
        bpanel.addTab();
        updateDB();
    }

    public void addSQLTab() {
        if (activeCX == null) {
            return;
        }
        P_SQLTable newPanel = new P_SQLTable(CXMap.get(activeCX), null);

        newPanel.setDBcx(activeCX);
        javax.swing.JTabbedPane pane = jTabbedPane1;
        pane.insertTab("Tab " + pane.getTabCount(), null, newPanel, null, pane.getTabCount() - 1);
        if (pane.getTabCount() > 1) {
            G_ButtonTabComponent tab = new G_ButtonTabComponent(pane, false, newPanel);
            pane.setTabComponentAt(pane.getTabCount() - 2, tab);
        }
        pane.setSelectedIndex(pane.getTabCount() - 2);
    }
    /*
     private void removeSQLTab(int idx) {
     if (idx < 0 || idx >= jTabbedPane1.getTabCount()) {
     return;
     }
     jTabbedPane1.remove(idx);
     }*/

    private P_SQLTable getSelectedSQLTab() {
        try {
            return (P_SQLTable) jTabbedPane1.getSelectedComponent();
        } catch (Exception ex) {
        }
        return null;
    }

    private void showcxDB() {
        if (Parent != null && Parent.getSlave() instanceof T_DB) {
            if (activeCX != null) {
                F_DBConnexion FDBcx = new F_DBConnexion(Parent, activeCX);
                FDBcx.setVisible(true);
            }
        }
    }

    public void addRequest(String req) {
        if (getSelectedSQLTab() == null || getSelectedSQLTab().getSQLTextPane().getText() != null) {
            addSQLTab();
        }
        getSelectedSQLTab().performRequest(req, 0);
    }

    public void clear() {
        while (jTabbedPane1.getTabCount() > 2) {
            jTabbedPane1.remove(1);
            //  removeSQLTab(1);
        }
    }

    private String getCurentCatalog() {
        //dbcx.getCatalog()=> mysql => get connexion 
        //catalog/shema see Metadata getCatalogTerm/shemaTerm == "database"?& Shema??
        String res = "";
        try {
            ResultSet rescnt = null;
            if (Parent.getSlave() instanceof T_DB) {
                rescnt = ((T_DB) Parent.getSlave()).Trt_out("SELECT DATABASE();");
            }
            if (rescnt == null) {
                return res;
            }
            // if ( !Parent.getDB_type().startsWith("ODBC_xls")) {
            rescnt.next();
            //  }
            res = rescnt.getObject(1).toString();
        } catch (SQLException ex) {
            TDeb.wri("getCurentCatalog()=>"+ex.getMessage());
        }
        return res;
    }

    private void updateDB() {
        DefaultMutableTreeNode top = new DefaultMutableTreeNode("Bases");
        DefaultMutableTreeNode jdbc = null;
        String tempOutType = "";
        if (Parent != null) {
            tempOutType = Parent.getDB_resultType();
            Parent.setDB_resultType("ResultSet");
        }
        try {
            CXMap = getCXs();
            java.sql.Connection[] dbcxs = CXMap.keySet().toArray(new java.sql.Connection[]{});
            for (java.sql.Connection dbcx : dbcxs) {
                if (dbcx != null && dbcx.getMetaData() != null) {
                    String cxname = dbcx.getMetaData().getDatabaseProductName() + "@" + CXMap.get(dbcx).getPortName();
                    if (dbcx == activeCX) {
                        cxname = ">" + cxname;
                    }
                    jdbc = new DefaultMutableTreeNode(cxname);
                    //  top.setUserObject(dbcx.);
                    try (ResultSet r = dbcx.getMetaData().getCatalogs()) {
                        while (r.next()) {
                            String catalog = r.getString(1);
                            //Shema/catalog, ? who think what ? SQLserver/oracle/Access/excel?????
                            DefaultMutableTreeNode schema = new DefaultMutableTreeNode(catalog);
                            if (catalog.compareTo(getCurentCatalog()) == 0) {
                                // seems not working if DB_resultType ="Tree"!!!
                                schema.setUserObject(">" + catalog);
                            }
                            java.util.List<String> typeslist;
                            if (dbcx.getMetaData().getDriverName().contains("ODBC")) {
                                typeslist = java.util.Arrays.asList(
                                        new String[]{"TABLE", "VIEW", "SYSTEM TABLE", "ALIAS",
                                            "global temp", "local temp", "SYNONYM"});
                            } else {
                                ResultSet rtt = dbcx.getMetaData().getTableTypes();
                                typeslist = new java.util.ArrayList<>();
                                while (rtt.next()) {
                                    typeslist.add(rtt.getString(1));
                                }
                            }
                            for (String type : typeslist) {
                                DefaultMutableTreeNode typenode = new DefaultMutableTreeNode(type);
                                if (dbcx.getMetaData().getDatabaseProductName().startsWith("EXCEL")) {
                                    catalog = null;
                                }
                                try (ResultSet r2 = dbcx.getMetaData().getTables(catalog, null, null, new String[]{type})) {
                                    while (r2.next()) {
                                        if (catalog == null || catalog.compareTo(r2.getString(1)) == 0) {
                                            String tablename = r2.getString(3);
                                            DefaultMutableTreeNode tableNode = null;
                                            if (tablename != null) {
                                                tableNode = new DefaultMutableTreeNode(tablename);
                                            }
                                            typenode.add(tableNode);
                                        }
                                    }
                                }
                                if (dbcx.getMetaData().getDriverName().contains("ODBC") == false || typenode.getChildCount() > 0) {
                                    schema.add(typenode);
                                }
                            }
                            jdbc.add(schema);
                        }
                    }
                    top.add(jdbc);
                }
            }
        } catch (SQLException exe) {
            //   dbcx = getCX();
            TDeb.wri("try to refresh, couldn't get Connexion");
        }
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(top));
        if (jdbc != null) {
            jTree1.expandPath(new javax.swing.tree.TreePath(jdbc.getPath()));
        }
        jTree1.setRootVisible(false);
        if (Parent != null && tempOutType != null && tempOutType.length() > 0) {
            Parent.setDB_resultType(tempOutType);
        }
    }

    public void setDBPanel(boolean bool) {
        if (bool) {
            jSplitPane1.setDividerSize(1);
            jSplitPane1.setDividerLocation(0);
        } else {
            jSplitPane1.setDividerSize(5);
            jSplitPane1.setDividerLocation(120);
        }
        jScrollPane5.setVisible(bool);
        jSplitPane1.setEnabled(bool);
    }

    private I_Port getPortSelected() {
        String portName = jTree1.getSelectionPath().getPathComponent(1).toString().split("@")[1];
        for (java.util.Map.Entry<java.sql.Connection, I_Port> en : CXMap.entrySet()) {
            if (en.getValue().getPortName().compareTo(portName) == 0) {
                return en.getValue();
            }
        }
        return null;
    }

    private String getSchemaSelected() {
        if (jTree1.getSelectionPath() != null && jTree1.getSelectionPath().getPathCount() > 2) {
            Object node = jTree1.getSelectionPath().getPathComponent(2);
            if (node instanceof DefaultMutableTreeNode) {
                DefaultMutableTreeNode schemanode = (DefaultMutableTreeNode) node;
                String schema = schemanode.getUserObject().toString();
                if (schema.startsWith(">")) {
                    schema = schema.substring(1);
                }
                return schema;
            }
        }
        return null;
    }

    private String getTableSelected() {
        String table;
        // BASES/DRIVER/CATALOG/TYPE/TABLE
        if (jTree1.getSelectionPath() != null && jTree1.getSelectionPath().getPathCount() == 5) {
            if (jTree1.getSelectionPath().getLastPathComponent() instanceof DefaultMutableTreeNode) {
                DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree1.getSelectionPath().getLastPathComponent();
                // do not use 'USE' to keep current (PARENT)shema else synchro...
                // ((T_DB) Parent.getSlave()).Trt_in("use "+shema+");....
                table = node.getUserObject().toString();
                C_Port port = ((C_Port) CXMap.get(activeCX));
                if (port == null) {
                    return null;
                }
                try {
                    if (table != null && table.length() > 0) {
                        String res = table;
                        /*
                         * if (port.getSlave() instanceof T_DB) { res = ((T_DB)
                         * port.getSlave()).getstdTableName(schema, table); }
                         */
                        return res;
                    }
                } catch (Exception ex) {
                    TDeb.wri("==>" + ex.getMessage());
                    return null;
                }
            }
        }
        return null;
    }

    private java.util.Map<java.sql.Connection, I_Port> getCXs() {
        java.util.Map<java.sql.Connection, I_Port> res = new java.util.HashMap<>();

        if (rset != null && Pack != null) {
            try {
                res.put(rset.getStatement().getConnection(), Pack.getsource());
            } catch (SQLException ex) {
            }
        } else if (Parent == null && Main != null) {
            for (I_Port p : Main.getPorts()) {
                if (p instanceof C_Port && ((C_Port) p).getDB_CX() != null) {
                    res.put(((C_Port) p).getDB_CX(), p);
                }
            }
        } else {
            I_Port p = null;
            if (Pack != null) {
                p = Pack.getsource();
            } else if (Parent != null) {
                p = Parent;
            }
            if (p != null && p instanceof C_Port) {
                res.put(((C_Port) p).getDB_CX(), p);
            }
        }
        if (activeCX == null && res.isEmpty() == false) {
            activeCX = res.keySet().toArray(new java.sql.Connection[]{})[0];
        }
        return res;
    }

    private void add() {
        if (jTree1.getSelectionPath() == null) {
            return;
        }
        if (jTree1.getSelectionPath().getPathCount() == 2) {
            String name = javax.swing.JOptionPane.showInputDialog(this, "newCat", "Add Catalog", javax.swing.JOptionPane.QUESTION_MESSAGE);
            if (name != null) {
                getSelectedSQLTab().performRequest("CREATE DATABASE " + name + ";", 0);//IF NOT EXISTS mysql
            }
        } else if (jTree1.getSelectionPath().getPathCount() == 4) {
            if (jTree1.getSelectionPath().getLastPathComponent() instanceof DefaultMutableTreeNode) {
                String type = ((DefaultMutableTreeNode) jTree1.getSelectionPath().getLastPathComponent()).getUserObject().toString();
                if (type.startsWith("TABLE")) {//&& (getCurentCatalog().length() > 0 ) 
                    //TODO : columns are mandatory but ...(keys/relations/...)
                    String name = javax.swing.JOptionPane.showInputDialog(this, "newTable", "Add Table", javax.swing.JOptionPane.QUESTION_MESSAGE);
                    getSelectedSQLTab().performRequest("CREATE TABLE " + name + " (id_" + name + " INT NOT NULL ,  PRIMARY KEY (id_" + name + ") );", 0);

                } else if (type.startsWith("VIEW") && getSelectedSQLTab().getSQLTextPane().getText().trim().startsWith("SELECT")) {
                    String req = getSelectedSQLTab().getSQLTextPane().getText().trim();
                    String name = javax.swing.JOptionPane.showInputDialog(this, "newView", "Add VIEW", javax.swing.JOptionPane.QUESTION_MESSAGE);
                    getSelectedSQLTab().performRequest("CREATE VIEW " + name + " AS " + req, 0);
                }
            }
        }
        updateDB();

    }

    private void remove() {

        if (jTree1.getSelectionPath() == null) {
            return;
        }
        if (jTree1.getSelectionPath().getPathCount() == 3) {
            String schema = this.getSchemaSelected();
            if (schema != null && schema.length() > 0) {
                int res = javax.swing.JOptionPane.showConfirmDialog(this, "Are you sure ?", "DROP DATABASE: " + schema, javax.swing.JOptionPane.WARNING_MESSAGE);
                if (res != javax.swing.JOptionPane.OK_OPTION) {
                    return;
                }
                getSelectedSQLTab().performRequest("DROP DATABASE " + schema + ";", 0); //IF EXISTS
            }
            updateDB();
        } else if (jTree1.getSelectionPath().getPathCount() == 5) {
            DefaultMutableTreeNode node = (DefaultMutableTreeNode) jTree1.getSelectionPath().getLastPathComponent();
            String table = node.getUserObject().toString();
            String type = ((DefaultMutableTreeNode) node.getParent()).getUserObject().toString();
            if (table != null && table.length() > 0) {
                int res = javax.swing.JOptionPane.showConfirmDialog(this, "Are you sure ?", "DROP " + type + ": " + table, javax.swing.JOptionPane.WARNING_MESSAGE);
                if (res != javax.swing.JOptionPane.OK_OPTION) {
                    return;
                }
                getSelectedSQLTab().performRequest("DROP " + type + " " + table + ";", 0); //IF EXISTS
            }
            updateDB();
        }
    }

    private void setdefaultShema() {
        if (jTree1.getSelectionPath() == null) {
            return;
        }
        if (jTree1.getSelectionPath().getPathCount() == 3) {
            String shemaName = jTree1.getSelectionPath().getLastPathComponent().toString();
            getSelectedSQLTab().performRequest("USE " + shemaName + ";", 0);//IF NOT EXISTS mysql 
        } else if (jTree1.getSelectionPath().getPathCount() == 2) {
            I_Port cport = getPortSelected();
            for (java.util.Map.Entry<java.sql.Connection, I_Port> en : CXMap.entrySet()) {
                if (en.getValue() == cport) {
                    activeCX = en.getKey();
                }
            }
        }
        updateDB();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        p_SQLTable1 = new com.jdcm.editors.P_SQLTable();
        jPopupMenu1 = new javax.swing.JPopupMenu();
        Add = new javax.swing.JMenuItem();
        Remove = new javax.swing.JMenuItem();
        Default = new javax.swing.JMenuItem();
        jToolBar1 = new javax.swing.JToolBar();
        jButton1 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();

        Add.setText("Add");
        Add.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddActionPerformed(evt);
            }
        });
        jPopupMenu1.add(Add);

        Remove.setText("Remove");
        Remove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RemoveActionPerformed(evt);
            }
        });
        jPopupMenu1.add(Remove);

        Default.setText("Default");
        Default.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DefaultActionPerformed(evt);
            }
        });
        jPopupMenu1.add(Default);

        setLayout(new java.awt.BorderLayout());

        jToolBar1.setRollover(true);

        jButton1.setToolTipText("Refresh");
        jButton1.setBorderPainted(false);
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        jButton7.setToolTipText("Valide");
        jButton7.setBorderPainted(false);
        jButton7.setFocusable(false);
        jButton7.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton7.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton7);

        jButton2.setToolTipText("add");
        jButton2.setBorderPainted(false);
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jButton3.setToolTipText("Remove");
        jButton3.setBorderPainted(false);
        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jButton4.setToolTipText("DB Cx details");
        jButton4.setBorderPainted(false);
        jButton4.setFocusable(false);
        jButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton4.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton4);

        jButton6.setToolTipText("2 XML");
        jButton6.setBorderPainted(false);
        jButton6.setFocusable(false);
        jButton6.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton6.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jButton6.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton6);

        jButton5.setToolTipText("Clear");
        jButton5.setBorderPainted(false);
        jButton5.setFocusable(false);
        jButton5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton5.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton5);

        jButton8.setFocusable(false);
        jButton8.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton8.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton8);

        add(jToolBar1, java.awt.BorderLayout.NORTH);

        jSplitPane1.setDividerLocation(120);

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("DB");
        javax.swing.tree.DefaultMutableTreeNode treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("tables");
        javax.swing.tree.DefaultMutableTreeNode treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("table1");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("view");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("view1");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        jTree1.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        jTree1.setAutoscrolls(true);
        jTree1.setComponentPopupMenu(jPopupMenu1);
        jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTree1MouseClicked(evt);
            }
        });
        jScrollPane5.setViewportView(jTree1);

        jSplitPane1.setLeftComponent(jScrollPane5);

        jTabbedPane1.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jTabbedPane1.setMinimumSize(new java.awt.Dimension(100, 100));
        jTabbedPane1.addContainerListener(new java.awt.event.ContainerAdapter() {
            public void componentAdded(java.awt.event.ContainerEvent evt) {
                jTabbedPane1ComponentAdded(evt);
            }
            public void componentRemoved(java.awt.event.ContainerEvent evt) {
                jTabbedPane1ComponentRemoved(evt);
            }
        });

        jPanel1.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                jPanel1ComponentShown(evt);
            }
        });
        jTabbedPane1.addTab("", jPanel1);

        jSplitPane1.setRightComponent(jTabbedPane1);

        add(jSplitPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new P_SQLTables().setVisible(true);
            }
        });
    }
private void jTree1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTree1MouseClicked
    if (evt.getButton() == 1) {
        if (jTree1.getSelectionPath() != null) {
            jButton7.setEnabled(false);
            jButton2.setEnabled(false);
            jButton3.setEnabled(false);
            Default.setEnabled(false);
            Add.setEnabled(false);
            Remove.setEnabled(false);
            int level = jTree1.getSelectionPath().getPathCount();
            if (level == 2 || level == 3) {
                jButton7.setEnabled(true);
                Default.setEnabled(true);
            }
            if (level == 2 || level == 4) {
                jButton2.setEnabled(true);
                Add.setEnabled(true);
            }
            if (level == 3 || level == 5) {
                jButton3.setEnabled(true);
                Remove.setEnabled(true);
            }
        }
        java.awt.Cursor cursor_curent = this.getCursor();
        this.setCursor(new java.awt.Cursor(java.awt.Cursor.WAIT_CURSOR));
        if (getTableSelected() != null) {
            try {
                if (getSelectedSQLTab().getSQLTextPane().getText() != null
                        && getSelectedSQLTab().getSQLTextPane().getText().trim().length() > 0
                        && getSelectedSQLTab().getSQLTextPane().getTextePane().getCaretPosition() > 0
                        && evt.isShiftDown()) {
                    getSelectedSQLTab().insertTable(getSchemaSelected(), getTableSelected());
                } else {
                    getSelectedSQLTab().setParent(getPortSelected());
                    getSelectedSQLTab().performSelect(getSchemaSelected(), getTableSelected(), 0);
                }
            } catch (Exception ex) {
            }
        }
        this.setCursor(cursor_curent);
    }

}//GEN-LAST:event_jTree1MouseClicked

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        updateDB();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        add();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        if (jTree1.isFocusOwner()) {
            remove();
        } else if (jTabbedPane1.getSelectedIndex() > 1) {
            jTabbedPane1.remove(jTabbedPane1.getSelectedIndex());
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        showcxDB();
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jTabbedPane1ComponentAdded(java.awt.event.ContainerEvent evt) {//GEN-FIRST:event_jTabbedPane1ComponentAdded
        if (evt.getChild() instanceof P_SQLTable) {
            int idx = jTabbedPane1.indexOfComponent(evt.getChild());
            if (idx > 0) {
                jTabbedPane1.setTabComponentAt(idx, new G_ButtonTabComponent(jTabbedPane1, false, evt.getChild()));
            }
        }
        if (EmptyPanel != null && jTabbedPane1.indexOfComponent(EmptyPanel) < jTabbedPane1.getTabCount() - 1) {
            jTabbedPane1.remove(jTabbedPane1.indexOfComponent(EmptyPanel));
            jTabbedPane1.add(" ", EmptyPanel);
            jTabbedPane1.setTabComponentAt(jTabbedPane1.getTabCount() - 1, new G_ButtonTabComponent(jTabbedPane1, true, EmptyPanel));
        }
    }//GEN-LAST:event_jTabbedPane1ComponentAdded

    private void jTabbedPane1ComponentRemoved(java.awt.event.ContainerEvent evt) {//GEN-FIRST:event_jTabbedPane1ComponentRemoved
        int idx = jTabbedPane1.getSelectedIndex();
        if (idx > 0 && jTabbedPane1.getTitleAt(idx).compareTo("+") == 0) {
            jTabbedPane1.setSelectedIndex(idx - 1);
        }
    }//GEN-LAST:event_jTabbedPane1ComponentRemoved

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        clear();
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jPanel1ComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel1ComponentShown
        if (evt.getComponent() == EmptyPanel && jTabbedPane1.getTabCount() >= 2) {
            jTabbedPane1.setSelectedIndex(jTabbedPane1.getTabCount() - 2);
        }
    }//GEN-LAST:event_jPanel1ComponentShown

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        (new F_DBMap(Parent)).setVisible(true);
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        setdefaultShema();
    }//GEN-LAST:event_jButton7ActionPerformed

    private void AddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AddActionPerformed
        add();
    }//GEN-LAST:event_AddActionPerformed

    private void RemoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoveActionPerformed
        remove();
    }//GEN-LAST:event_RemoveActionPerformed

    private void DefaultActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DefaultActionPerformed
        setdefaultShema();
    }//GEN-LAST:event_DefaultActionPerformed

    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        String txt = "Exemples : http://sqlzoo.net/ \r\n";
        txt += "CREATE TABLE Personnes (Nom CHAR(20));\r\n";
        txt += "CREATE TABLE Personnes (Nom CHAR(20) NOT NULL \r\n"
                + "   CONSTRAINT clé_primaire PRIMARY KEY(Nom));\r\n";
        txt += "DROP TABLE Personnes;\r\n";
        txt += "ALTER TABLE Personnes ADD Naissance DATE;\r\n";
        txt += "ALTER TABLE Personnes DROP Naissance;\r\n";
        txt += "INSERT INTO Personnes (Nom) VALUES('Machin');\r\n";
        txt += "UPDATE Personnes SET Prénom='Henri' WHERE Nom='Truc';\r\n";
        txt += "DELETE FROM Personnes;\r\n";
        txt += "DELETE FROM Personnes WHERE Nom='Truc';\r\n";
        txt += "SELECT p.Nom FROM Personnes AS p ORDER BY p.Nom DESC`\r\n";
        txt += "SELECT * FROM Personnes LEFT JOIN Communes \r\n"
                + "   ON Communes.code_commune = Personnes.Code_commune;\r\n";
        txt += "SELECT * FROM Personnes RIGHT JOIN Communes \r\n"
                + "   ON Communes.code_commune = Personnes.Code_commune;\r\n";
        txt += "SELECT * FROM Personnes INNER JOIN Communes \r\n"
                + "   ON Communes.code_commune = Personnes.Code_commune;\r\n";
        txt += "SELECT DISTINCT(Nom) FROM Personnes WHERE NOT(nom LIKE 'c%');\r\n";
        txt += "SELECT Date, SUM(CA) AS CA_total FROM Résultats \r\n"
                + "   GROUP BY Date HAVING Sum(CA)>2500;\r\n";
        txt += "[avg/max/min/count/sum] \r\n";
        txt += "SELECT nom AS Col1, prénom AS Col2 FROM Table1\r\n"
                + "   UNION SELECT nom AS Col1, prénom AS Col2 FROM Table2;\r\n";
        txt += "SELECT nom, prénom FROM Table1 WHERE Table1.nom IN (SELECT nom FROM Table2)\r\n";
        txt += "[iif/switch/first/last/choose/curdir/FileDateTime";
        txt += "[rnd/val/cos/sin/tan/atn/abs/round/fix/int/exp/log/isnumeric/isnull/sgn]\r\n";
        txt += "[replace/trim/len/format/ltrim/right/left/str/Ucase/lcase/space/mid]\r\n";
        txt += "[now/datevalue/date/dateadd/datediff/datepart/dateserial/isdate/time/timeval/timeserial]/r/n";
        txt += "[Second/minute/hour/day/weekday/weekdayname/month/monthname/Year]\r\n";
        javax.swing.JOptionPane.showConfirmDialog(this, txt, "SQL Exemples", javax.swing.JOptionPane.OK_OPTION, javax.swing.JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_jButton8ActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem Add;
    private javax.swing.JMenuItem Default;
    private javax.swing.JMenuItem Remove;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JTree jTree1;
    private com.jdcm.editors.P_SQLTable p_SQLTable1;
    // End of variables declaration//GEN-END:variables
}
