package com.jdcm.eltrx;

import com.jdcm.editors.P_SQLTable;
import java.sql.*;
import com.jdcm.common.*;

/**
 *  F_DBConnexion.java Created on 28 novembre 2006, 21:18
 * 
 *Display/edit Databas connexion<br>
 * ?? should be an editor??,
 * @author  Marc GIBOIN
 */
public class F_DBConnexion extends javax.swing.JFrame {
    // for serializable interface

    private static final long serialVersionUID = 1L;
    private final D_Debug TDeb;
    private final D_Utils TUtils;
    private final C_Port Parent;
  //  private int[] hold = {ResultSet.HOLD_CURSORS_OVER_COMMIT, ResultSet.CLOSE_CURSORS_AT_COMMIT};
    private final Connection CX;
    private DatabaseMetaData cxm;
   // DefaultMutableTreeNode map_act = null;

    /**
     * Creates new form F_DBConnexion
     * 
     * @param P the port used to get this DB
     * @param cx the connexion edited here
     */
    public F_DBConnexion(C_Port P, Connection cx) {
        CX = cx;
        Parent = P;
        TDeb = new D_Debug("DB-CX: [" + Parent.getIndex() + "]");
        TDeb.setconsole(Parent.getConsole());
        TUtils = new D_Utils();
        setIconImage(TUtils.getImage("DB_shema.gif"));
        initComponents();
        jMenuItem1.setIcon(TUtils.getIcon("DB_table.gif"));
        jMenuItem2.setIcon(TUtils.getIcon("Remove.gif"));
        jMenuItem3.setIcon(TUtils.getIcon("Add.gif"));
        this.setTitle("DB Connexion Port [" + Parent.getIndex() + "]");
        feelFrames();
    }

    public final void feelFrames() {
        boolean res;
        try {
            res = CX.getAutoCommit();
        } catch (SQLException ex) {
            res = false;
        }
        setautocommit(res);
        try {
            jTextField1.setText(CX.getCatalog());
        } catch (SQLException ex) {
            jTextField1.setEnabled(false);
        }
        try {
            jCheckBox2.setSelected(CX.isClosed());
        } catch (SQLException ex) {
            jCheckBox2.setEnabled(false);
        }
        try {
            jCheckBox3.setSelected(CX.isReadOnly());
        } catch (SQLException ex) {
            jCheckBox3.setEnabled(false);
        }
        try {
            try {
                if (CX.getHoldability() == ResultSet.HOLD_CURSORS_OVER_COMMIT) {
                    jTextField40.setText("HOLD_CURSORS_OVER_COMMIT");
                }
                if (CX.getHoldability() == ResultSet.CLOSE_CURSORS_AT_COMMIT) {
                    jTextField40.setText("CLOSE_CURSORS_AT_COMMIT");
                }
            } catch (UnsupportedOperationException ex) {
                jTextField40.setEnabled(false);
            }
        } catch (SQLException ex) {
            jTextField40.setEnabled(false);
        }
        try {
            try {
                if (CX.getTransactionIsolation() == Connection.TRANSACTION_NONE) {
                    jTextField41.setText("TRANSACTION_NONE");
                }
                if (CX.getTransactionIsolation() == Connection.TRANSACTION_READ_COMMITTED) {
                    jTextField41.setText("TRANSACTION_READ_COMMITTED");
                }
                if (CX.getTransactionIsolation() == Connection.TRANSACTION_READ_UNCOMMITTED) {
                    jTextField41.setText("TRANSACTION_READ_UNCOMMITTED");
                }
                if (CX.getTransactionIsolation() == Connection.TRANSACTION_REPEATABLE_READ) {
                    jTextField41.setText("TRANSACTION_REPEATABLE_READ");
                }
                if (CX.getTransactionIsolation() == Connection.TRANSACTION_SERIALIZABLE) {
                    jTextField41.setText("TRANSACTION_SERIALIZABLE");
                }
            } catch (UnsupportedOperationException ex) {
                jTextField41.setEnabled(false);
            }
        } catch (SQLException ex) {
            jTextField41.setEnabled(false);
        }
        // DatabaseMetaData cxm=null;
        try {
            cxm = CX.getMetaData();
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getCatalogs(), jTable1);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getSchemas(), jTable2);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getTableTypes(), jTable3);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getTypeInfo(), jTable4);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getClientInfoProperties(), jTable24);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        getTables();
        try {
            jTextField30.setText(cxm.getURL());
        } catch (SQLException ex) {
            jTextField30.setEnabled(false);
        }
        try {
            jTextField31.setText(cxm.getCatalogSeparator());
        } catch (SQLException ex) {
            jTextField31.setEnabled(false);
        }
        try {
            jTextField32.setText(cxm.getCatalogTerm());
        } catch (SQLException ex) {
            jTextField32.setEnabled(false);
        }
        try {
            jTextField33.setText(cxm.getExtraNameCharacters());
        } catch (SQLException ex) {
            jTextField33.setEnabled(false);
        }
        try {
            jTextField34.setText(cxm.getIdentifierQuoteString());
        } catch (SQLException ex) {
            jTextField34.setEnabled(false);
        }
        try {
            jTextField35.setText(cxm.getSchemaTerm());
        } catch (SQLException ex) {
            jTextField35.setEnabled(false);
        }
        try {
            jTextField36.setText(cxm.getSearchStringEscape());
        } catch (SQLException ex) {
            jTextField36.setEnabled(false);
        }
       try {
            jTextField39.setText(""+CX.getNetworkTimeout());
        } catch (SQLException ex) {
            jTextField39.setEnabled(false);
        }
        try {
            jTextField37.setText(cxm.getUserName());
        } catch (SQLException ex) {
            jTextField37.setEnabled(false);
        }
        try {
            jTextField38.setText(cxm.getProcedureTerm());
        } catch (SQLException ex) {
            jTextField38.setEnabled(false);
        }
        //TYPE DE TRAN=> FORRWARD ONLY :try{jTextField39.setText(cx.);}catch(Exception ex){jTextField39.setEnabled(false);}

        try {
            jTextField2.setText(cxm.getDatabaseProductName());
        } catch (SQLException ex) {
            jTextField1.setEnabled(false);
        }
        try {
            jTextField4.setText(cxm.getDatabaseProductVersion());
        } catch (SQLException ex) {
            jTextField4.setEnabled(false);
        }
        try {
            jTextField6.setText("" + cxm.getDatabaseMinorVersion());
        } catch (SQLException ex) {
            jTextField6.setEnabled(false);
        }
        try {
            jTextField7.setText("" + cxm.getDatabaseMajorVersion());
        } catch (SQLException ex) {
            jTextField7.setEnabled(false);
        }
        try {
            jTextField3.setText(cxm.getDriverName());
        } catch (SQLException ex) {
            jTextField3.setEnabled(false);
        }
        try {
            jTextField5.setText(cxm.getDriverVersion());
        } catch (SQLException ex) {
            jTextField5.setEnabled(false);
        }
        jTextField8.setText("" + cxm.getDriverMinorVersion());
        jTextField9.setText("" + cxm.getDriverMajorVersion());
        java.util.List<String[]> datas=new java.util.ArrayList<>();
        String sep=",";//javaProperties("separateur??");
        //for ..but if exception...
        try {
            datas.add(cxm.getNumericFunctions().split(sep));
        } catch (SQLException ex) {
            datas.add(new String[]{"=>"+ex.getMessage()});
        }
        try {
             datas.add(cxm.getSQLKeywords().split(sep));
        } catch (SQLException ex) {
             datas.add(new String[]{"=>"+ex.getMessage()});
        }
        try {
            datas.add(cxm.getStringFunctions().split(sep));
        } catch (SQLException ex) {
             datas.add(new String[]{"=>"+ex.getMessage()});
        }
        try {
            datas.add(cxm.getSystemFunctions().split(sep));
        } catch (SQLException ex) {
           datas.add(new String[]{"=>"+ex.getMessage()});
        }
        try {
             datas.add(cxm.getTimeDateFunctions().split(sep));
        } catch (SQLException ex) {
             datas.add(new String[]{"=>"+ex.getMessage()});
        }
        int max=0;
        for (String[]lit:datas){
            if (lit.length>max){
                max=lit.length;
            }
        }
       // String[][] d=datas.toArray(new String[][]{});
       String[][] pivodatas=new String[max][5];
       for (int i=0;i< 5;i++){
           for (int j=0;j<datas.get(i).length;j++){
               pivodatas[j][i]=datas.get(i)[j];
           }
       }
        jTable21.setModel(new javax.swing.table.DefaultTableModel(
                pivodatas, 
                new String[]{"Numeric","SQLKeywords","String","System","TimeDate"} ));
        try {
            jTextField10.setText("" + cxm.getMaxBinaryLiteralLength());
        } catch (SQLException ex) {
            jTextField10.setEnabled(false);
        }
        try {
            jTextField11.setText("" + cxm.getMaxCatalogNameLength());
        } catch (SQLException ex) {
            jTextField11.setEnabled(false);
        }
        try {
            jTextField12.setText("" + cxm.getMaxCharLiteralLength());
        } catch (SQLException ex) {
            jTextField12.setEnabled(false);
        }
        try {
            jTextField13.setText("" + cxm.getMaxColumnNameLength());
        } catch (SQLException ex) {
            jTextField13.setEnabled(false);
        }
        try {
            jTextField14.setText("" + cxm.getMaxColumnsInGroupBy());
        } catch (SQLException ex) {
            jTextField14.setEnabled(false);
        }
        try {
            jTextField15.setText("" + cxm.getMaxColumnsInIndex());
        } catch (SQLException ex) {
            jTextField15.setEnabled(false);
        }
        try {
            jTextField16.setText("" + cxm.getMaxColumnsInOrderBy());
        } catch (SQLException ex) {
            jTextField16.setEnabled(false);
        }
        try {
            jTextField17.setText("" + cxm.getMaxColumnsInSelect());
        } catch (SQLException ex) {
            jTextField17.setEnabled(false);
        }
        try {
            jTextField18.setText("" + cxm.getMaxColumnsInTable());
        } catch (SQLException ex) {
            jTextField18.setEnabled(false);
        }
        try {
            jTextField19.setText("" + cxm.getMaxConnections());
        } catch (SQLException ex) {
            jTextField19.setEnabled(false);
        }
        try {
            jTextField20.setText("" + cxm.getMaxCursorNameLength());
        } catch (SQLException ex) {
            jTextField20.setEnabled(false);
        }
        try {
            jTextField21.setText("" + cxm.getMaxIndexLength());
        } catch (SQLException ex) {
            jTextField21.setEnabled(false);
        }
        try {
            jTextField22.setText("" + cxm.getMaxProcedureNameLength());
        } catch (SQLException ex) {
            jTextField22.setEnabled(false);
        }
        try {
            jTextField23.setText("" + cxm.getMaxRowSize());
        } catch (SQLException ex) {
            jTextField23.setEnabled(false);
        }
        try {
            jTextField24.setText("" + cxm.getMaxSchemaNameLength());
        } catch (SQLException ex) {
            jTextField24.setEnabled(false);
        }
        try {
            jTextField25.setText("" + cxm.getMaxStatementLength());
        } catch (SQLException ex) {
            jTextField25.setEnabled(false);
        }
        try {
            jTextField26.setText("" + cxm.getMaxStatements());
        } catch (SQLException ex) {
            jTextField26.setEnabled(false);
        }
        try {
            jTextField27.setText("" + cxm.getMaxTableNameLength());
        } catch (SQLException ex) {
            jTextField27.setEnabled(false);
        }
        try {
            jTextField28.setText("" + cxm.getMaxTablesInSelect());
        } catch (SQLException ex) {
            jTextField28.setEnabled(false);
        }
        try {
            jTextField29.setText("" + cxm.getMaxUserNameLength());
        } catch (SQLException ex) {
            jTextField29.setEnabled(false);
        }

        try {
            jCheckBox4.setSelected(cxm.allProceduresAreCallable());
        } catch (SQLException ex) {
            jCheckBox4.setEnabled(false);
        }
        try {
            jCheckBox5.setSelected(cxm.allTablesAreSelectable());
        } catch (SQLException ex) {
            jCheckBox5.setEnabled(false);
        }
        try {
            jCheckBox6.setSelected(cxm.dataDefinitionCausesTransactionCommit());
        } catch (SQLException ex) {
            jCheckBox6.setEnabled(false);
        }
        try {
            jCheckBox7.setSelected(cxm.dataDefinitionIgnoredInTransactions());
        } catch (SQLException ex) {
            jCheckBox7.setEnabled(false);
        }
        try {
            jCheckBox8.setSelected(cxm.doesMaxRowSizeIncludeBlobs());
        } catch (SQLException ex) {
            jCheckBox8.setEnabled(false);
        }
        try {
            jCheckBox9.setSelected(cxm.isCatalogAtStart());
        } catch (SQLException ex) {
            jCheckBox9.setEnabled(false);
        }
        try {
            jCheckBox10.setSelected(cxm.isReadOnly());
        } catch (SQLException ex) {
            jCheckBox10.setEnabled(false);
        }
        //try{jCheckBox11.setSelected(cxm.locatorsUpdateCopy());}catch(Exception ex){jCheckBox11.setEnabled(false);}
        try {
            jCheckBox12.setSelected(cxm.nullPlusNonNullIsNull());
        } catch (SQLException ex) {
            jCheckBox12.setEnabled(false);
        }
        try {
            jCheckBox13.setSelected(cxm.nullsAreSortedAtEnd());
        } catch (SQLException ex) {
            jCheckBox13.setEnabled(false);
        }
        try {
            jCheckBox14.setSelected(cxm.nullsAreSortedAtStart());
        } catch (SQLException ex) {
            jCheckBox14.setEnabled(false);
        }
        try {
            jCheckBox15.setSelected(cxm.nullsAreSortedHigh());
        } catch (SQLException ex) {
            jCheckBox15.setEnabled(false);
        }
        try {
            jCheckBox16.setSelected(cxm.nullsAreSortedLow());
        } catch (SQLException ex) {
            jCheckBox16.setEnabled(false);
        }
        try {
            jCheckBox17.setSelected(cxm.storesLowerCaseIdentifiers());
        } catch (SQLException ex) {
            jCheckBox17.setEnabled(false);
        }
        try {
            jCheckBox18.setSelected(cxm.storesMixedCaseIdentifiers());
        } catch (SQLException ex) {
            jCheckBox18.setEnabled(false);
        }
        try {
            jCheckBox19.setSelected(cxm.storesLowerCaseQuotedIdentifiers());
        } catch (SQLException ex) {
            jCheckBox19.setEnabled(false);
        }
        try {
            jCheckBox20.setSelected(cxm.storesUpperCaseIdentifiers());
        } catch (SQLException ex) {
            jCheckBox20.setEnabled(false);
        }
        try {
            jCheckBox21.setSelected(cxm.storesUpperCaseQuotedIdentifiers());
        } catch (SQLException ex) {
            jCheckBox21.setEnabled(false);
        }
        try {
            jCheckBox22.setSelected(cxm.supportsANSI92EntryLevelSQL());
        } catch (SQLException ex) {
            jCheckBox22.setEnabled(false);
        }
        try {
            jCheckBox23.setSelected(cxm.supportsANSI92FullSQL());
        } catch (SQLException ex) {
            jCheckBox23.setEnabled(false);
        }
        try {
            jCheckBox24.setSelected(cxm.supportsANSI92IntermediateSQL());
        } catch (SQLException ex) {
            jCheckBox24.setEnabled(false);
        }
        try {
            jCheckBox25.setSelected(cxm.supportsAlterTableWithAddColumn());
        } catch (SQLException ex) {
            jCheckBox25.setEnabled(false);
        }
        try {
            jCheckBox26.setSelected(cxm.supportsAlterTableWithDropColumn());
        } catch (SQLException ex) {
            jCheckBox26.setEnabled(false);
        }
        try {
            jCheckBox27.setSelected(cxm.supportsBatchUpdates());
        } catch (SQLException ex) {
            jCheckBox27.setEnabled(false);
        }
        try {
            jCheckBox28.setSelected(cxm.supportsCatalogsInDataManipulation());
        } catch (SQLException ex) {
            jCheckBox28.setEnabled(false);
        }
        try {
            jCheckBox29.setSelected(cxm.supportsCatalogsInIndexDefinitions());
        } catch (SQLException ex) {
            jCheckBox29.setEnabled(false);
        }
        try {
            jCheckBox30.setSelected(cxm.supportsCatalogsInPrivilegeDefinitions());
        } catch (SQLException ex) {
            jCheckBox30.setEnabled(false);
        }
        try {
            jCheckBox31.setSelected(cxm.supportsCatalogsInProcedureCalls());
        } catch (SQLException ex) {
            jCheckBox31.setEnabled(false);
        }
        try {
            jCheckBox32.setSelected(cxm.supportsCatalogsInTableDefinitions());
        } catch (SQLException ex) {
            jCheckBox32.setEnabled(false);
        }
        try {
            jCheckBox33.setSelected(cxm.supportsColumnAliasing());
        } catch (SQLException ex) {
            jCheckBox33.setEnabled(false);
        }
        try {
            jCheckBox34.setSelected(cxm.supportsConvert());
        } catch (SQLException ex) {
            jCheckBox34.setEnabled(false);
        }
        try {
            jCheckBox35.setSelected(cxm.supportsCoreSQLGrammar());
        } catch (SQLException ex) {
            jCheckBox35.setEnabled(false);
        }
        try {
            jCheckBox36.setSelected(cxm.supportsCorrelatedSubqueries());
        } catch (SQLException ex) {
            jCheckBox36.setEnabled(false);
        }
        try {
            jCheckBox37.setSelected(cxm.supportsDataDefinitionAndDataManipulationTransactions());
        } catch (SQLException ex) {
            jCheckBox37.setEnabled(false);
        }
        try {
            jCheckBox38.setSelected(cxm.supportsDataManipulationTransactionsOnly());
        } catch (SQLException ex) {
            jCheckBox38.setEnabled(false);
        }
        try {
            jCheckBox39.setSelected(cxm.supportsDifferentTableCorrelationNames());
        } catch (SQLException ex) {
            jCheckBox39.setEnabled(false);
        }
        try {
            jCheckBox40.setSelected(cxm.supportsExpressionsInOrderBy());
        } catch (SQLException ex) {
            jCheckBox40.setEnabled(false);
        }
        try {
            jCheckBox41.setSelected(cxm.supportsExtendedSQLGrammar());
        } catch (SQLException ex) {
            jCheckBox41.setEnabled(false);
        }
        try {
            jCheckBox42.setSelected(cxm.supportsFullOuterJoins());
        } catch (SQLException ex) {
            jCheckBox42.setEnabled(false);
        }
        try {
            jCheckBox43.setSelected(cxm.supportsGetGeneratedKeys());
        } catch (SQLException ex) {
            jCheckBox43.setEnabled(false);
        }
        try {
            jCheckBox44.setSelected(cxm.supportsGroupBy());
        } catch (SQLException ex) {
            jCheckBox44.setEnabled(false);
        }
        try {
            jCheckBox45.setSelected(cxm.supportsGroupByBeyondSelect());
        } catch (SQLException ex) {
            jCheckBox45.setEnabled(false);
        }
        try {
            jCheckBox46.setSelected(cxm.supportsGroupByUnrelated());
        } catch (SQLException ex) {
            jCheckBox46.setEnabled(false);
        }
        try {
            jCheckBox47.setSelected(cxm.supportsIntegrityEnhancementFacility());
        } catch (SQLException ex) {
            jCheckBox47.setEnabled(false);
        }
        try {
            jCheckBox48.setSelected(cxm.supportsLikeEscapeClause());
        } catch (SQLException ex) {
            jCheckBox48.setEnabled(false);
        }
        try {
            jCheckBox49.setSelected(cxm.supportsLimitedOuterJoins());
        } catch (SQLException ex) {
            jCheckBox49.setEnabled(false);
        }
        try {
            jCheckBox50.setSelected(cxm.supportsMinimumSQLGrammar());
        } catch (SQLException ex) {
            jCheckBox50.setEnabled(false);
        }
        try {
            jCheckBox51.setSelected(cxm.supportsMixedCaseIdentifiers());
        } catch (SQLException ex) {
            jCheckBox51.setEnabled(false);
        }
        try {
            jCheckBox52.setSelected(cxm.supportsMultipleOpenResults());
        } catch (SQLException ex) {
            jCheckBox52.setEnabled(false);
        }
        try {
            jCheckBox53.setSelected(cxm.supportsMultipleResultSets());
        } catch (SQLException ex) {
            jCheckBox53.setEnabled(false);
        }
        try {
            jCheckBox54.setSelected(cxm.supportsMultipleTransactions());
        } catch (SQLException ex) {
            jCheckBox54.setEnabled(false);
        }
        try {
            jCheckBox55.setSelected(cxm.supportsNamedParameters());
        } catch (SQLException ex) {
            jCheckBox55.setEnabled(false);
        }
        try {
            jCheckBox56.setSelected(cxm.supportsNonNullableColumns());
        } catch (SQLException ex) {
            jCheckBox56.setEnabled(false);
        }
        try {
            jCheckBox57.setSelected(cxm.supportsOpenCursorsAcrossCommit());
        } catch (SQLException ex) {
            jCheckBox57.setEnabled(false);
        }
        try {
            jCheckBox58.setSelected(cxm.supportsOpenCursorsAcrossRollback());
        } catch (SQLException ex) {
            jCheckBox58.setEnabled(false);
        }
        try {
            jCheckBox59.setSelected(cxm.supportsOpenStatementsAcrossCommit());
        } catch (SQLException ex) {
            jCheckBox59.setEnabled(false);
        }
        try {
            jCheckBox60.setSelected(cxm.supportsOpenStatementsAcrossRollback());
        } catch (SQLException ex) {
            jCheckBox60.setEnabled(false);
        }
        try {
            jCheckBox61.setSelected(cxm.supportsOrderByUnrelated());
        } catch (SQLException ex) {
            jCheckBox61.setEnabled(false);
        }
        try {
            jCheckBox62.setSelected(cxm.supportsOuterJoins());
        } catch (SQLException ex) {
            jCheckBox62.setEnabled(false);
        }
        try {
            jCheckBox63.setSelected(cxm.supportsPositionedDelete());
        } catch (SQLException ex) {
            jCheckBox63.setEnabled(false);
        }
        try {
            jCheckBox64.setSelected(cxm.supportsPositionedUpdate());
        } catch (SQLException ex) {
            jCheckBox64.setEnabled(false);
        }
        try {
            jCheckBox65.setSelected(cxm.supportsSavepoints());
        } catch (SQLException ex) {
            jCheckBox65.setEnabled(false);
        }
        try {
            jCheckBox66.setSelected(cxm.supportsSchemasInDataManipulation());
        } catch (SQLException ex) {
            jCheckBox66.setEnabled(false);
        }
        try {
            jCheckBox67.setSelected(cxm.supportsSchemasInIndexDefinitions());
        } catch (SQLException ex) {
            jCheckBox67.setEnabled(false);
        }
        try {
            jCheckBox68.setSelected(cxm.supportsSchemasInPrivilegeDefinitions());
        } catch (SQLException ex) {
            jCheckBox68.setEnabled(false);
        }
        try {
            jCheckBox69.setSelected(cxm.supportsSchemasInProcedureCalls());
        } catch (SQLException ex) {
            jCheckBox69.setEnabled(false);
        }
        try {
            jCheckBox70.setSelected(cxm.supportsSchemasInTableDefinitions());
        } catch (SQLException ex) {
            jCheckBox70.setEnabled(false);
        }
        try {
            jCheckBox71.setSelected(cxm.supportsSelectForUpdate());
        } catch (SQLException ex) {
            jCheckBox71.setEnabled(false);
        }
        //try{jCheckBox72.setSelected(cxm.supportsStatementPooling());}catch(Exception ex){jCheckBox72.setEnabled(false);}
        try {
            jCheckBox73.setSelected(cxm.supportsStoredProcedures());
        } catch (SQLException ex) {
            jCheckBox73.setEnabled(false);
        }
        try {
            jCheckBox74.setSelected(cxm.supportsSubqueriesInComparisons());
        } catch (SQLException ex) {
            jCheckBox74.setEnabled(false);
        }
        try {
            jCheckBox75.setSelected(cxm.supportsSubqueriesInExists());
        } catch (SQLException ex) {
            jCheckBox75.setEnabled(false);
        }
        try {
            jCheckBox76.setSelected(cxm.supportsSubqueriesInIns());
        } catch (SQLException ex) {
            jCheckBox76.setEnabled(false);
        }
        try {
            jCheckBox77.setSelected(cxm.supportsSubqueriesInQuantifieds());
        } catch (SQLException ex) {
            jCheckBox77.setEnabled(false);
        }
        try {
            jCheckBox78.setSelected(cxm.supportsTableCorrelationNames());
        } catch (SQLException ex) {
            jCheckBox78.setEnabled(false);
        }
        try {
            jCheckBox79.setSelected(cxm.supportsTransactions());
        } catch (SQLException ex) {
            jCheckBox79.setEnabled(false);
        }
        try {
            jCheckBox80.setSelected(cxm.supportsUnion());
        } catch (SQLException ex) {
            jCheckBox80.setEnabled(false);
        }
        try {
            jCheckBox81.setSelected(cxm.supportsUnionAll());
        } catch (SQLException ex) {
            jCheckBox81.setEnabled(false);
        }
        try {
            jCheckBox82.setSelected(cxm.usesLocalFilePerTable());
        } catch (SQLException ex) {
            jCheckBox82.setEnabled(false);
        }
        try {
            jCheckBox83.setSelected(cxm.usesLocalFiles());
        } catch (SQLException ex) {
            jCheckBox83.setEnabled(false);
        }
        try {
            jCheckBox82.setSelected(cxm.usesLocalFilePerTable());
        } catch (SQLException ex) {
            jCheckBox82.setEnabled(false);
        }
        updateWarnings();

    }

    private boolean isautocommit() {
        return jCheckBox1.isSelected();
    }

    private void setautocommit(boolean askautocommit) {
        boolean bool=askautocommit;
        try {
            if (CX.getAutoCommit() != bool) {
                try {
                    CX.setAutoCommit(isautocommit());
                } catch (SQLException ex) {
                    TDeb.wri("Pb setting autocommit [" + ex.getMessage() + "]");
                    bool = !bool ;
                }
            }
        } catch (SQLException ex) {
            TDeb.wri("Pb getting autocommit [" + ex.getMessage() + "]");
        }
        if (bool != isautocommit()) {
            jCheckBox1.setSelected(bool);
        }
        jButton2.setEnabled(bool == false);
        jButton3.setEnabled(bool == false);

    }
    private void updateWarnings() {
        SQLWarning w = null;
        String res = "";
        String sep = "\r\n";
        try {
            w = CX.getWarnings();
        } catch (SQLException ex) {
        }
        if (w != null) {
            res = res + w.getMessage() + sep;
            while (w.getNextWarning() != null) {
                w = w.getNextWarning();
                res = res + w.getMessage() + sep;
            }
            jTextArea1.setText(res);
        } else {
            jTextArea1.setText("");
        }
    }

    private void getTables() {
        try {
            TUtils.resultset2Table(cxm.getTables(getcat(), getschema(), null, getTType()), jTable5);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        // select the first row
        if (jTable5.getModel().getRowCount() > 0) {
            setTableSelection(jTable5.getValueAt(0, 2).toString());
        }
        try {
            TUtils.resultset2Table(cxm.getTablePrivileges(getcat(), getschema(), null), jTable6);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getSuperTables(getcat(), getschema(), null), jTable7);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getSuperTypes(getcat(), getschema(), null), jTable22);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getProcedures(getcat(), getschema(), null), jTable8);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getProcedureColumns(getcat(), getschema(), null, null), jTable9);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getUDTs(getcat(), getschema(), null, null), jTable10);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getFunctions(getcat(), getschema(), null), jTable16);
        } catch (SQLException ex) {//Throwable
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getFunctionColumns(getcat(), getschema(), null, null), jTable17);
        } catch (SQLException ex) {//Throwable
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getAttributes(getcat(), getschema(), null, null), jTable23);
        } catch (SQLException ex) {//Throwable
            TDeb.wri("[" + ex.getMessage() + "]");
        }
    }

    private String getcat() {
        String res = null;
        if (jTable1.getSelectedRow() != -1) {
            res = jTable1.getValueAt(jTable1.getSelectedRow(), jTable1.getSelectedColumn()).toString();
            if (res.length() == 0) {
                res = null;
            }
        }
        return res;
    }

    private String getschema() {
        String res = null;
        if (jTable2.getSelectedRow() != -1) {
            res = jTable2.getValueAt(jTable2.getSelectedRow(), jTable2.getSelectedColumn()).toString();
            if (res.length() == 0) {
                res = null;
            }
        }
        return res;
    }

    private String[] getTType() {
        String[] res = null;
        if (jTable3.getSelectedRow() != -1) {
            res = new String[1];
            res[0] = jTable3.getValueAt(jTable3.getSelectedRow(), jTable3.getSelectedColumn()).toString();
        }
        return res;
    }

    private String getTablename() {
        String tab = "";
        String cat = "";
        String sch = "";
        String sep = "";
        try {
            sep = cxm.getIdentifierQuoteString();
        } catch (SQLException ex) {
        }
        if (sep.length() > 1) {
            sep = sep.substring(0, 1);
        }
        if (sep.length() == 0) {
            sep = " ";
        }
        int col_Table_name = 2;
        int col_Sch_name = 1;
        int col_Cat_name = 0;
        if (jTable5.getSelectedRow() != -1) {
            /// see how cat make Pbs (ODBC?/SQLserver/...
            cat = jTable5.getValueAt(jTable5.getSelectedRow(), col_Cat_name).toString();
            sch = jTable5.getValueAt(jTable5.getSelectedRow(), col_Sch_name).toString();
            tab = jTable5.getValueAt(jTable5.getSelectedRow(), col_Table_name).toString();
        }
        if (cat.length() > 0) {
            cat = sep + cat + sep + ".";
        }
        if (sch.length() > 0) {
            sch = sep + sch + sep + ".";
        }
        if (tab.length() > 0) {
            tab = sep + tab + sep;
        } else {
            return null;
        }
        return cat + sch + tab;
    }

    private void commit() {
        try {
            CX.commit();
        } catch (SQLException ex) {
            TDeb.wri("Pb during DB comit : " + ex.getMessage());
        }
    }

    private void rollback() {
        try {
            if (CX.getAutoCommit()) {
                TDeb.wri("Rollback not proceed beacause autocomit is on!");
            }
            CX.rollback();
        } catch (SQLException ex) {
            TDeb.wri("Pb with DB Rollback : " + ex.getMessage());
        }
    }

    private void showTable() {
        ResultSet res;
        String end = "";
        //if (jTextField2.getText().compareTo("Oracle")==0){end="";}
        if (getTablename() == null) {
            return;
        }
        String req = "SELECT * FROM " + getTablename() + end; ///change to cat.shem.table
        C_Packet pack = new C_Packet("SQL request", Parent);
        try {
            Statement request = CX.createStatement();
            request.setMaxRows(Parent.getDB_maxrows());
            long start = System.currentTimeMillis();
            res = request.executeQuery(req);
            long stop = System.currentTimeMillis();
            pack.setSQL(req, new java.util.Date(start), new java.util.Date(stop));
            pack.setObj(res);
        } catch (SQLException e) {
            javax.swing.JOptionPane.showMessageDialog(this, req + "\r\n provided : [" + e.getMessage() + "]", "View error", javax.swing.JOptionPane.ERROR_MESSAGE);
            TDeb.wri("Pb with getting Table : " + getTablename());
            return;
        }
        javax.swing.JFrame f=new javax.swing.JFrame();
        f.add(new P_SQLTable(Parent, pack));
        f.setVisible(true);
    }

    private void dropTable() {
        int res;
        String end = "";
        if (jTextField2.getText().compareTo("Oracle") == 0) {
            end = "";
        }
        String req = "DROP TABLE " + getTablename() + end;
        try {
            Statement request = CX.createStatement();
            res = request.executeUpdate(req);
        } catch (SQLException e) {
            javax.swing.JOptionPane.showMessageDialog(this, req + "\r\n provided : [" + e.getMessage() + "]", "View error", javax.swing.JOptionPane.ERROR_MESSAGE);
            TDeb.wri("Pb with getting Table : " + getTablename());
            return;
        }
        getTables();
    }

    private void setTableSelection(String tablename) {
        if (jTable5.getSelectedRow() == -1 || jTable5.getValueAt(jTable5.getSelectedRow(), 2).toString().compareTo(tablename) != 0) {
            int i = 0;
            while (jTable5.getValueAt(i, 2).toString().compareTo(tablename) != 0) {
                i++;
            }
            jTable5.setRowSelectionInterval(i, i);
        }
        try {
            TUtils.resultset2Table(cxm.getColumns(getcat(), getschema(), tablename, null), jTable11);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getColumnPrivileges(getcat(), getschema(), tablename, null), jTable12);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }

        try {
            TUtils.resultset2Table(cxm.getExportedKeys(getcat(), getschema(), tablename), jTable13);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getImportedKeys(getcat(), getschema(), tablename), jTable14);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getTablePrivileges(getcat(), getschema(), tablename), jTable6);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getPrimaryKeys(getcat(), getschema(), tablename), jTable15);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getIndexInfo(getcat(), getschema(), tablename, false, false), jTable18);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
        try {
            TUtils.resultset2Table(cxm.getBestRowIdentifier(getcat(), getschema(), tablename, DatabaseMetaData.bestRowSession, true), jTable19);
        } catch (SQLException ex) {
            TDeb.wri("[" + ex.getMessage() + "]");
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("serial")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        jToolBar1 = new javax.swing.JToolBar();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jPanel24 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jCheckBox2 = new javax.swing.JCheckBox();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox3 = new javax.swing.JCheckBox();
        jPanel22 = new javax.swing.JPanel();
        jLabel56 = new javax.swing.JLabel();
        jTextField41 = new javax.swing.JTextField();
        jLabel43 = new javax.swing.JLabel();
        jTextField30 = new javax.swing.JTextField();
        jPanel23 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jTextField40 = new javax.swing.JTextField();
        jLabel50 = new javax.swing.JLabel();
        jTextField37 = new javax.swing.JTextField();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel4 = new javax.swing.JPanel();
        jPanel49 = new javax.swing.JPanel();
        jPanel26 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jTextField4 = new javax.swing.JTextField();
        jPanel44 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        jTextField7 = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextField6 = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jPanel45 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jTextField9 = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jTextField8 = new javax.swing.JTextField();
        jPanel46 = new javax.swing.JPanel();
        jLabel44 = new javax.swing.JLabel();
        jTextField31 = new javax.swing.JTextField();
        jLabel46 = new javax.swing.JLabel();
        jTextField33 = new javax.swing.JTextField();
        jPanel47 = new javax.swing.JPanel();
        jLabel45 = new javax.swing.JLabel();
        jTextField32 = new javax.swing.JTextField();
        jLabel47 = new javax.swing.JLabel();
        jTextField34 = new javax.swing.JTextField();
        jPanel9 = new javax.swing.JPanel();
        jLabel51 = new javax.swing.JLabel();
        jTextField38 = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jTextField39 = new javax.swing.JTextField();
        jPanel48 = new javax.swing.JPanel();
        jLabel48 = new javax.swing.JLabel();
        jTextField35 = new javax.swing.JTextField();
        jLabel49 = new javax.swing.JLabel();
        jTextField36 = new javax.swing.JTextField();
        jScrollPane29 = new javax.swing.JScrollPane();
        jTable21 = new javax.swing.JTable();
        jPanel5 = new javax.swing.JPanel();
        jSplitPane1 = new javax.swing.JSplitPane();
        jPanel11 = new javax.swing.JPanel();
        jScrollPane7 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jSplitPane2 = new javax.swing.JSplitPane();
        jPanel12 = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jSplitPane3 = new javax.swing.JSplitPane();
        jPanel14 = new javax.swing.JPanel();
        jScrollPane10 = new javax.swing.JScrollPane();
        jTable4 = new javax.swing.JTable();
        jPanel13 = new javax.swing.JPanel();
        jScrollPane9 = new javax.swing.JScrollPane();
        jTable3 = new javax.swing.JTable();
        jPanel7 = new javax.swing.JPanel();
        jSplitPane4 = new javax.swing.JSplitPane();
        jPanel15 = new javax.swing.JPanel();
        jScrollPane11 = new javax.swing.JScrollPane();
        jTable5 = new javax.swing.JTable();
        jSplitPane5 = new javax.swing.JSplitPane();
        jPanel16 = new javax.swing.JPanel();
        jScrollPane23 = new javax.swing.JScrollPane();
        jTable15 = new javax.swing.JTable();
        jSplitPane6 = new javax.swing.JSplitPane();
        jPanel37 = new javax.swing.JPanel();
        jScrollPane26 = new javax.swing.JScrollPane();
        jTable18 = new javax.swing.JTable();
        jPanel38 = new javax.swing.JPanel();
        jScrollPane27 = new javax.swing.JScrollPane();
        jTable19 = new javax.swing.JTable();
        jPanel39 = new javax.swing.JPanel();
        jScrollPane28 = new javax.swing.JScrollPane();
        jTable20 = new javax.swing.JTable();
        jPanel8 = new javax.swing.JPanel();
        jSplitPane7 = new javax.swing.JSplitPane();
        jPanel21 = new javax.swing.JPanel();
        jScrollPane14 = new javax.swing.JScrollPane();
        jTable8 = new javax.swing.JTable();
        jSplitPane8 = new javax.swing.JSplitPane();
        jPanel19 = new javax.swing.JPanel();
        jScrollPane15 = new javax.swing.JScrollPane();
        jTable9 = new javax.swing.JTable();
        jPanel20 = new javax.swing.JPanel();
        jScrollPane16 = new javax.swing.JScrollPane();
        jTable10 = new javax.swing.JTable();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel1 = new javax.swing.JPanel();
        jCheckBox22 = new javax.swing.JCheckBox();
        jCheckBox23 = new javax.swing.JCheckBox();
        jCheckBox24 = new javax.swing.JCheckBox();
        jCheckBox25 = new javax.swing.JCheckBox();
        jCheckBox26 = new javax.swing.JCheckBox();
        jCheckBox27 = new javax.swing.JCheckBox();
        jCheckBox28 = new javax.swing.JCheckBox();
        jCheckBox29 = new javax.swing.JCheckBox();
        jCheckBox30 = new javax.swing.JCheckBox();
        jCheckBox31 = new javax.swing.JCheckBox();
        jCheckBox32 = new javax.swing.JCheckBox();
        jCheckBox33 = new javax.swing.JCheckBox();
        jCheckBox34 = new javax.swing.JCheckBox();
        jCheckBox35 = new javax.swing.JCheckBox();
        jCheckBox36 = new javax.swing.JCheckBox();
        jCheckBox37 = new javax.swing.JCheckBox();
        jCheckBox38 = new javax.swing.JCheckBox();
        jCheckBox39 = new javax.swing.JCheckBox();
        jCheckBox40 = new javax.swing.JCheckBox();
        jCheckBox41 = new javax.swing.JCheckBox();
        jCheckBox42 = new javax.swing.JCheckBox();
        jCheckBox43 = new javax.swing.JCheckBox();
        jCheckBox44 = new javax.swing.JCheckBox();
        jCheckBox45 = new javax.swing.JCheckBox();
        jCheckBox46 = new javax.swing.JCheckBox();
        jCheckBox47 = new javax.swing.JCheckBox();
        jCheckBox48 = new javax.swing.JCheckBox();
        jCheckBox49 = new javax.swing.JCheckBox();
        jCheckBox50 = new javax.swing.JCheckBox();
        jCheckBox51 = new javax.swing.JCheckBox();
        jCheckBox52 = new javax.swing.JCheckBox();
        jCheckBox53 = new javax.swing.JCheckBox();
        jCheckBox54 = new javax.swing.JCheckBox();
        jCheckBox55 = new javax.swing.JCheckBox();
        jCheckBox56 = new javax.swing.JCheckBox();
        jCheckBox57 = new javax.swing.JCheckBox();
        jCheckBox58 = new javax.swing.JCheckBox();
        jCheckBox59 = new javax.swing.JCheckBox();
        jCheckBox60 = new javax.swing.JCheckBox();
        jCheckBox61 = new javax.swing.JCheckBox();
        jCheckBox62 = new javax.swing.JCheckBox();
        jCheckBox63 = new javax.swing.JCheckBox();
        jCheckBox64 = new javax.swing.JCheckBox();
        jCheckBox65 = new javax.swing.JCheckBox();
        jCheckBox66 = new javax.swing.JCheckBox();
        jCheckBox67 = new javax.swing.JCheckBox();
        jCheckBox68 = new javax.swing.JCheckBox();
        jCheckBox69 = new javax.swing.JCheckBox();
        jCheckBox70 = new javax.swing.JCheckBox();
        jCheckBox71 = new javax.swing.JCheckBox();
        jCheckBox72 = new javax.swing.JCheckBox();
        jCheckBox73 = new javax.swing.JCheckBox();
        jCheckBox74 = new javax.swing.JCheckBox();
        jCheckBox75 = new javax.swing.JCheckBox();
        jCheckBox76 = new javax.swing.JCheckBox();
        jCheckBox77 = new javax.swing.JCheckBox();
        jCheckBox78 = new javax.swing.JCheckBox();
        jCheckBox79 = new javax.swing.JCheckBox();
        jCheckBox80 = new javax.swing.JCheckBox();
        jCheckBox81 = new javax.swing.JCheckBox();
        jCheckBox82 = new javax.swing.JCheckBox();
        jCheckBox83 = new javax.swing.JCheckBox();
        jPanel10 = new javax.swing.JPanel();
        jScrollPane17 = new javax.swing.JScrollPane();
        jPanel2 = new javax.swing.JPanel();
        jPanel50 = new javax.swing.JPanel();
        jCheckBox5 = new javax.swing.JCheckBox();
        jCheckBox9 = new javax.swing.JCheckBox();
        jCheckBox6 = new javax.swing.JCheckBox();
        jCheckBox8 = new javax.swing.JCheckBox();
        jCheckBox10 = new javax.swing.JCheckBox();
        jCheckBox11 = new javax.swing.JCheckBox();
        jCheckBox7 = new javax.swing.JCheckBox();
        jCheckBox4 = new javax.swing.JCheckBox();
        jCheckBox14 = new javax.swing.JCheckBox();
        jCheckBox15 = new javax.swing.JCheckBox();
        jCheckBox16 = new javax.swing.JCheckBox();
        jCheckBox17 = new javax.swing.JCheckBox();
        jCheckBox12 = new javax.swing.JCheckBox();
        jCheckBox13 = new javax.swing.JCheckBox();
        jCheckBox18 = new javax.swing.JCheckBox();
        jCheckBox19 = new javax.swing.JCheckBox();
        jCheckBox20 = new javax.swing.JCheckBox();
        jCheckBox21 = new javax.swing.JCheckBox();
        jPanel51 = new javax.swing.JPanel();
        jLabel31 = new javax.swing.JLabel();
        jTextField25 = new javax.swing.JTextField();
        jLabel33 = new javax.swing.JLabel();
        jTextField27 = new javax.swing.JTextField();
        jLabel32 = new javax.swing.JLabel();
        jTextField26 = new javax.swing.JTextField();
        jLabel26 = new javax.swing.JLabel();
        jTextField24 = new javax.swing.JTextField();
        jLabel27 = new javax.swing.JLabel();
        jTextField20 = new javax.swing.JTextField();
        jLabel28 = new javax.swing.JLabel();
        jTextField21 = new javax.swing.JTextField();
        jLabel29 = new javax.swing.JLabel();
        jTextField22 = new javax.swing.JTextField();
        jLabel30 = new javax.swing.JLabel();
        jTextField23 = new javax.swing.JTextField();
        jLabel17 = new javax.swing.JLabel();
        jTextField10 = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        jTextField12 = new javax.swing.JTextField();
        jLabel19 = new javax.swing.JLabel();
        jTextField11 = new javax.swing.JTextField();
        jLabel18 = new javax.swing.JLabel();
        jTextField14 = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        jTextField13 = new javax.swing.JTextField();
        jLabel21 = new javax.swing.JLabel();
        jTextField15 = new javax.swing.JTextField();
        jLabel22 = new javax.swing.JLabel();
        jTextField16 = new javax.swing.JTextField();
        jLabel23 = new javax.swing.JLabel();
        jTextField17 = new javax.swing.JTextField();
        jLabel24 = new javax.swing.JLabel();
        jTextField18 = new javax.swing.JTextField();
        jLabel25 = new javax.swing.JLabel();
        jTextField19 = new javax.swing.JTextField();
        jLabel34 = new javax.swing.JLabel();
        jTextField28 = new javax.swing.JTextField();
        jLabel35 = new javax.swing.JLabel();
        jTextField29 = new javax.swing.JTextField();
        jPanel28 = new javax.swing.JPanel();
        jSplitPane13 = new javax.swing.JSplitPane();
        jPanel29 = new javax.swing.JPanel();
        jScrollPane18 = new javax.swing.JScrollPane();
        jTable11 = new javax.swing.JTable();
        jSplitPane14 = new javax.swing.JSplitPane();
        jPanel30 = new javax.swing.JPanel();
        jScrollPane20 = new javax.swing.JScrollPane();
        jTable12 = new javax.swing.JTable();
        jSplitPane15 = new javax.swing.JSplitPane();
        jPanel31 = new javax.swing.JPanel();
        jScrollPane21 = new javax.swing.JScrollPane();
        jTable13 = new javax.swing.JTable();
        jPanel32 = new javax.swing.JPanel();
        jScrollPane22 = new javax.swing.JScrollPane();
        jTable14 = new javax.swing.JTable();
        jPanel33 = new javax.swing.JPanel();
        jSplitPane16 = new javax.swing.JSplitPane();
        jPanel34 = new javax.swing.JPanel();
        jScrollPane24 = new javax.swing.JScrollPane();
        jTable16 = new javax.swing.JTable();
        jSplitPane17 = new javax.swing.JSplitPane();
        jPanel35 = new javax.swing.JPanel();
        jScrollPane25 = new javax.swing.JScrollPane();
        jTable17 = new javax.swing.JTable();
        jSplitPane18 = new javax.swing.JSplitPane();
        jPanel18 = new javax.swing.JPanel();
        jScrollPane13 = new javax.swing.JScrollPane();
        jTable7 = new javax.swing.JTable();
        jPanel41 = new javax.swing.JPanel();
        jScrollPane30 = new javax.swing.JScrollPane();
        jTable22 = new javax.swing.JTable();
        jPanel36 = new javax.swing.JPanel();
        jSplitPane19 = new javax.swing.JSplitPane();
        jPanel17 = new javax.swing.JPanel();
        jScrollPane12 = new javax.swing.JScrollPane();
        jTable6 = new javax.swing.JTable();
        jSplitPane20 = new javax.swing.JSplitPane();
        jPanel43 = new javax.swing.JPanel();
        jScrollPane32 = new javax.swing.JScrollPane();
        jTable24 = new javax.swing.JTable();
        jPanel42 = new javax.swing.JPanel();
        jScrollPane31 = new javax.swing.JScrollPane();
        jTable23 = new javax.swing.JTable();
        jPanel27 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jPanel25 = new javax.swing.JPanel();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();

        jMenuItem1.setText("Show table");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem1);

        jMenuItem2.setText("Drop Table");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem2);

        jMenuItem3.setText("Add Table");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jPopupMenu1.add(jMenuItem3);

        setTitle("DB Connexion");

        jToolBar1.setRollover(true);

        jButton2.setText("Comit");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton2);

        jButton3.setText("rollback");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton3);

        jButton1.setText("Close");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jToolBar1.add(jButton1);

        getContentPane().add(jToolBar1, java.awt.BorderLayout.NORTH);

        jPanel24.setLayout(new javax.swing.BoxLayout(jPanel24, javax.swing.BoxLayout.Y_AXIS));

        jPanel6.setLayout(new javax.swing.BoxLayout(jPanel6, javax.swing.BoxLayout.LINE_AXIS));

        jLabel1.setText("Catalog : ");
        jPanel6.add(jLabel1);

        jTextField1.setText("catalog");
        jTextField1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField1ActionPerformed(evt);
            }
        });
        jPanel6.add(jTextField1);

        jCheckBox2.setText("isclosed");
        jCheckBox2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox2.setEnabled(false);
        jCheckBox2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel6.add(jCheckBox2);

        jCheckBox1.setText("Autocommit");
        jCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });
        jPanel6.add(jCheckBox1);

        jCheckBox3.setText("isreadonly");
        jCheckBox3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox3ActionPerformed(evt);
            }
        });
        jPanel6.add(jCheckBox3);

        jPanel24.add(jPanel6);

        jPanel22.setLayout(new javax.swing.BoxLayout(jPanel22, javax.swing.BoxLayout.LINE_AXIS));

        jLabel56.setText("TransIsolation :");
        jPanel22.add(jLabel56);

        jTextField41.setText("- getTransactionIsolation-");
        jPanel22.add(jTextField41);

        jLabel43.setText("URL  :");
        jPanel22.add(jLabel43);

        jTextField30.setText("-URL");
        jPanel22.add(jTextField30);

        jPanel24.add(jPanel22);

        jPanel23.setLayout(new javax.swing.BoxLayout(jPanel23, javax.swing.BoxLayout.LINE_AXIS));

        jLabel2.setText("holdability : ");
        jPanel23.add(jLabel2);

        jTextField40.setText("-getHoldability -");
        jPanel23.add(jTextField40);

        jLabel50.setText("UserName :");
        jPanel23.add(jLabel50);

        jTextField37.setText("-user-");
        jPanel23.add(jTextField37);

        jPanel24.add(jPanel23);

        getContentPane().add(jPanel24, java.awt.BorderLayout.SOUTH);

        jPanel4.setLayout(new java.awt.BorderLayout());

        jPanel49.setLayout(new javax.swing.BoxLayout(jPanel49, javax.swing.BoxLayout.Y_AXIS));

        jPanel26.setLayout(new javax.swing.BoxLayout(jPanel26, javax.swing.BoxLayout.LINE_AXIS));

        jLabel3.setText("name : ");
        jPanel26.add(jLabel3);

        jTextField2.setText("-name-");
        jPanel26.add(jTextField2);

        jLabel8.setText(" vers :");
        jPanel26.add(jLabel8);

        jTextField4.setText("-DB vers-");
        jPanel26.add(jTextField4);

        jPanel49.add(jPanel26);

        jPanel44.setLayout(new javax.swing.BoxLayout(jPanel44, javax.swing.BoxLayout.LINE_AXIS));

        jLabel7.setText("Major :");
        jPanel44.add(jLabel7);

        jTextField7.setText("-maj vers-");
        jPanel44.add(jTextField7);

        jLabel5.setText("Minor :");
        jPanel44.add(jLabel5);

        jTextField6.setText("-Min vers -");
        jPanel44.add(jTextField6);

        jLabel6.setText("vers :");
        jPanel44.add(jLabel6);

        jTextField5.setText("-drv vers -");
        jPanel44.add(jTextField5);

        jPanel49.add(jPanel44);

        jPanel45.setLayout(new javax.swing.BoxLayout(jPanel45, javax.swing.BoxLayout.LINE_AXIS));

        jLabel4.setText("Driver :");
        jPanel45.add(jLabel4);

        jTextField3.setText("-drv name -");
        jPanel45.add(jTextField3);

        jLabel9.setText("Major :");
        jPanel45.add(jLabel9);

        jTextField9.setText("-maj vers-");
        jPanel45.add(jTextField9);

        jLabel10.setText("Minor");
        jPanel45.add(jLabel10);

        jTextField8.setText("-min vers -");
        jPanel45.add(jTextField8);

        jPanel49.add(jPanel45);

        jPanel46.setLayout(new javax.swing.BoxLayout(jPanel46, javax.swing.BoxLayout.LINE_AXIS));

        jLabel44.setText("Catalog sep :");
        jPanel46.add(jLabel44);

        jTextField31.setText("-cat sep-");
        jPanel46.add(jTextField31);

        jLabel46.setText("ExtraNameCharacters");
        jPanel46.add(jLabel46);

        jTextField33.setText("- Xtra name char -");
        jPanel46.add(jTextField33);

        jPanel49.add(jPanel46);

        jPanel47.setLayout(new javax.swing.BoxLayout(jPanel47, javax.swing.BoxLayout.LINE_AXIS));

        jLabel45.setText("Catalog term :");
        jPanel47.add(jLabel45);

        jTextField32.setText("-cat term");
        jPanel47.add(jTextField32);

        jLabel47.setText("IdentifierQuoteString");
        jPanel47.add(jLabel47);

        jTextField34.setText("-ident quote-string-");
        jPanel47.add(jTextField34);

        jPanel49.add(jPanel47);

        jPanel9.setLayout(new javax.swing.BoxLayout(jPanel9, javax.swing.BoxLayout.LINE_AXIS));

        jLabel51.setText("Procedure term :");
        jPanel9.add(jLabel51);

        jTextField38.setText("-proc term-");
        jPanel9.add(jTextField38);

        jLabel11.setText("getNetworkTimeout :");
        jPanel9.add(jLabel11);

        jTextField39.setText("-getNetworkTimeout-");
        jPanel9.add(jTextField39);

        jPanel49.add(jPanel9);

        jPanel48.setLayout(new javax.swing.BoxLayout(jPanel48, javax.swing.BoxLayout.LINE_AXIS));

        jLabel48.setText("SchemaTerm : ");
        jPanel48.add(jLabel48);

        jTextField35.setText("-schema term-");
        jPanel48.add(jTextField35);

        jLabel49.setText("SearchStringEscape");
        jPanel48.add(jLabel49);

        jTextField36.setText("-search string-");
        jPanel48.add(jTextField36);

        jPanel49.add(jPanel48);

        jPanel4.add(jPanel49, java.awt.BorderLayout.NORTH);

        jTable21.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null},
                {null, null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4", "SQL Keywords"
            }
        ));
        jScrollPane29.setViewportView(jTable21);

        jPanel4.add(jScrollPane29, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Description", jPanel4);

        jPanel5.setLayout(new java.awt.BorderLayout());

        jSplitPane1.setDividerLocation(100);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel11.setBorder(javax.swing.BorderFactory.createTitledBorder("Catalog"));
        jPanel11.setLayout(new java.awt.BorderLayout());

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable1MouseReleased(evt);
            }
        });
        jScrollPane7.setViewportView(jTable1);

        jPanel11.add(jScrollPane7, java.awt.BorderLayout.CENTER);

        jSplitPane1.setTopComponent(jPanel11);

        jSplitPane2.setDividerLocation(100);
        jSplitPane2.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel12.setBorder(javax.swing.BorderFactory.createTitledBorder("Schema"));
        jPanel12.setLayout(new java.awt.BorderLayout());

        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable2.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable2MouseReleased(evt);
            }
        });
        jScrollPane8.setViewportView(jTable2);

        jPanel12.add(jScrollPane8, java.awt.BorderLayout.CENTER);

        jSplitPane2.setTopComponent(jPanel12);

        jSplitPane3.setDividerLocation(100);
        jSplitPane3.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel14.setBorder(javax.swing.BorderFactory.createTitledBorder("Tables Info"));
        jPanel14.setLayout(new java.awt.BorderLayout());

        jTable4.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable4.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane10.setViewportView(jTable4);

        jPanel14.add(jScrollPane10, java.awt.BorderLayout.CENTER);

        jSplitPane3.setRightComponent(jPanel14);

        jPanel13.setBorder(javax.swing.BorderFactory.createTitledBorder("Tables Type"));
        jPanel13.setLayout(new java.awt.BorderLayout());

        jTable3.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable3.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        jTable3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable3MouseReleased(evt);
            }
        });
        jScrollPane9.setViewportView(jTable3);

        jPanel13.add(jScrollPane9, java.awt.BorderLayout.CENTER);

        jSplitPane3.setLeftComponent(jPanel13);

        jSplitPane2.setRightComponent(jSplitPane3);

        jSplitPane1.setRightComponent(jSplitPane2);

        jPanel5.add(jSplitPane1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Definition", jPanel5);

        jPanel7.setLayout(new java.awt.BorderLayout());

        jSplitPane4.setDividerLocation(100);
        jSplitPane4.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel15.setBorder(javax.swing.BorderFactory.createTitledBorder("Tables"));
        jPanel15.setLayout(new java.awt.BorderLayout());

        jScrollPane11.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jScrollPane11MouseClicked(evt);
            }
        });

        jTable5.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable5.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable5.setComponentPopupMenu(jPopupMenu1);
        jTable5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTable5MouseReleased(evt);
            }
        });
        jScrollPane11.setViewportView(jTable5);

        jPanel15.add(jScrollPane11, java.awt.BorderLayout.CENTER);

        jSplitPane4.setTopComponent(jPanel15);

        jSplitPane5.setDividerLocation(100);
        jSplitPane5.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel16.setBorder(javax.swing.BorderFactory.createTitledBorder("getPrimaryKeys"));
        jPanel16.setLayout(new java.awt.BorderLayout());

        jTable15.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable15.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable15.setComponentPopupMenu(jPopupMenu1);
        jScrollPane23.setViewportView(jTable15);

        jPanel16.add(jScrollPane23, java.awt.BorderLayout.CENTER);

        jSplitPane5.setTopComponent(jPanel16);

        jSplitPane6.setDividerLocation(100);
        jSplitPane6.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel37.setBorder(javax.swing.BorderFactory.createTitledBorder("IndexInfo"));
        jPanel37.setLayout(new java.awt.BorderLayout());

        jTable18.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable18.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable18.setComponentPopupMenu(jPopupMenu1);
        jScrollPane26.setViewportView(jTable18);

        jPanel37.add(jScrollPane26, java.awt.BorderLayout.CENTER);

        jSplitPane6.setTopComponent(jPanel37);

        jPanel38.setBorder(javax.swing.BorderFactory.createTitledBorder("IndexInfo"));
        jPanel38.setLayout(new java.awt.BorderLayout());

        jTable19.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable19.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable19.setComponentPopupMenu(jPopupMenu1);
        jScrollPane27.setViewportView(jTable19);

        jPanel38.add(jScrollPane27, java.awt.BorderLayout.CENTER);

        jSplitPane6.setTopComponent(jPanel38);

        jPanel39.setBorder(javax.swing.BorderFactory.createTitledBorder("BestRowIdentifier"));
        jPanel39.setLayout(new java.awt.BorderLayout());

        jTable20.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable20.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable20.setComponentPopupMenu(jPopupMenu1);
        jScrollPane28.setViewportView(jTable20);

        jPanel39.add(jScrollPane28, java.awt.BorderLayout.CENTER);

        jSplitPane6.setRightComponent(jPanel39);

        jSplitPane5.setRightComponent(jSplitPane6);

        jSplitPane4.setRightComponent(jSplitPane5);

        jPanel7.add(jSplitPane4, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Tables", jPanel7);

        jPanel8.setLayout(new java.awt.BorderLayout());

        jSplitPane7.setDividerLocation(200);
        jSplitPane7.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel21.setBorder(javax.swing.BorderFactory.createTitledBorder("Procedures"));
        jPanel21.setLayout(new java.awt.BorderLayout());

        jTable8.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable8.setToolTipText("(MSAccess requests)");
        jTable8.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane14.setViewportView(jTable8);

        jPanel21.add(jScrollPane14, java.awt.BorderLayout.CENTER);

        jSplitPane7.setLeftComponent(jPanel21);

        jSplitPane8.setDividerLocation(100);
        jSplitPane8.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel19.setBorder(javax.swing.BorderFactory.createTitledBorder("Procedure columns"));
        jPanel19.setLayout(new java.awt.BorderLayout());

        jTable9.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Title 1"
            }
        ));
        jTable9.setToolTipText("MS access request result?");
        jTable9.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane15.setViewportView(jTable9);

        jPanel19.add(jScrollPane15, java.awt.BorderLayout.CENTER);

        jSplitPane8.setTopComponent(jPanel19);

        jPanel20.setBorder(javax.swing.BorderFactory.createTitledBorder("User Defined Type"));
        jPanel20.setLayout(new java.awt.BorderLayout());

        jTable10.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Title 1"
            }
        ));
        jTable10.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane16.setViewportView(jTable10);

        jPanel20.add(jScrollPane16, java.awt.BorderLayout.CENTER);

        jSplitPane8.setRightComponent(jPanel20);

        jSplitPane7.setBottomComponent(jSplitPane8);

        jPanel8.add(jSplitPane7, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Procedures", jPanel8);

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new javax.swing.BoxLayout(jPanel1, javax.swing.BoxLayout.Y_AXIS));

        jCheckBox22.setText("supportsANSI92EntryLevelSQL");
        jCheckBox22.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox22.setEnabled(false);
        jCheckBox22.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox22);

        jCheckBox23.setText("supportsANSI92FullSQL");
        jCheckBox23.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox23.setEnabled(false);
        jCheckBox23.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox23);

        jCheckBox24.setText("supportsANSI92IntermediateSQL");
        jCheckBox24.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox24.setEnabled(false);
        jCheckBox24.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox24);

        jCheckBox25.setText("supportsAlterTableWithAddColumn");
        jCheckBox25.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox25.setEnabled(false);
        jCheckBox25.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox25);

        jCheckBox26.setText("supportsAlterTableWithDropColumn");
        jCheckBox26.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox26.setEnabled(false);
        jCheckBox26.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox26);

        jCheckBox27.setText("supportsBatchUpdates");
        jCheckBox27.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox27.setEnabled(false);
        jCheckBox27.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox27);

        jCheckBox28.setText("supportsCatalogsInDataManipulation");
        jCheckBox28.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox28.setEnabled(false);
        jCheckBox28.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox28);

        jCheckBox29.setText("supportsCatalogsInIndexDefinitions");
        jCheckBox29.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox29.setEnabled(false);
        jCheckBox29.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox29);

        jCheckBox30.setText("supportsCatalogsInPrivilegeDefinitions");
        jCheckBox30.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox30.setEnabled(false);
        jCheckBox30.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox30);

        jCheckBox31.setText("supportsCatalogsInProcedureCalls");
        jCheckBox31.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox31.setEnabled(false);
        jCheckBox31.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox31);

        jCheckBox32.setText("supportsCatalogsInTableDefinitions");
        jCheckBox32.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox32.setEnabled(false);
        jCheckBox32.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox32);

        jCheckBox33.setText("supportsColumnAliasing");
        jCheckBox33.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox33.setEnabled(false);
        jCheckBox33.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox33);

        jCheckBox34.setText("supportsConvert");
        jCheckBox34.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox34.setEnabled(false);
        jCheckBox34.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox34);

        jCheckBox35.setText("supportsCoreSQLGrammar");
        jCheckBox35.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox35.setEnabled(false);
        jCheckBox35.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox35);

        jCheckBox36.setText("supportsCorrelatedSubqueries");
        jCheckBox36.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox36.setEnabled(false);
        jCheckBox36.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox36);

        jCheckBox37.setText("supportsDataDefinitionAndDataManipulationTransactions");
        jCheckBox37.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox37.setEnabled(false);
        jCheckBox37.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox37);

        jCheckBox38.setText("supportsDataManipulationTransactionsOnly");
        jCheckBox38.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox38.setEnabled(false);
        jCheckBox38.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox38);

        jCheckBox39.setText("supportsDifferentTableCorrelationNames");
        jCheckBox39.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox39.setEnabled(false);
        jCheckBox39.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox39);

        jCheckBox40.setText("supportsExpressionsInOrderBy");
        jCheckBox40.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox40.setEnabled(false);
        jCheckBox40.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox40);

        jCheckBox41.setText("supportsExtendedSQLGrammar");
        jCheckBox41.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox41.setEnabled(false);
        jCheckBox41.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox41);

        jCheckBox42.setText("supportsFullOuterJoins");
        jCheckBox42.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox42.setEnabled(false);
        jCheckBox42.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox42);

        jCheckBox43.setText("supportsGetGeneratedKeys");
        jCheckBox43.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox43.setEnabled(false);
        jCheckBox43.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox43);

        jCheckBox44.setText("supportsGroupBy");
        jCheckBox44.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox44.setEnabled(false);
        jCheckBox44.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox44);

        jCheckBox45.setText("supportsGroupByBeyondSelect");
        jCheckBox45.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox45.setEnabled(false);
        jCheckBox45.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox45);

        jCheckBox46.setText("supportsGroupByUnrelated");
        jCheckBox46.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox46.setEnabled(false);
        jCheckBox46.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox46);

        jCheckBox47.setText("supportsIntegrityEnhancementFacility");
        jCheckBox47.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox47.setEnabled(false);
        jCheckBox47.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox47);

        jCheckBox48.setText("supportsLikeEscapeClause");
        jCheckBox48.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox48.setEnabled(false);
        jCheckBox48.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox48);

        jCheckBox49.setText("supportsLimitedOuterJoins");
        jCheckBox49.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox49.setEnabled(false);
        jCheckBox49.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox49);

        jCheckBox50.setText("supportsMinimumSQLGrammar");
        jCheckBox50.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox50.setEnabled(false);
        jCheckBox50.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox50);

        jCheckBox51.setText("supportsMixedCaseIdentifiers");
        jCheckBox51.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox51.setEnabled(false);
        jCheckBox51.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox51);

        jCheckBox52.setText("supportsMultipleOpenResults");
        jCheckBox52.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox52.setEnabled(false);
        jCheckBox52.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox52);

        jCheckBox53.setText("supportsMultipleResultSets");
        jCheckBox53.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox53.setEnabled(false);
        jCheckBox53.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox53);

        jCheckBox54.setText("supportsMultipleTransactions");
        jCheckBox54.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox54.setEnabled(false);
        jCheckBox54.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox54);

        jCheckBox55.setText("supportsNamedParameters");
        jCheckBox55.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox55.setEnabled(false);
        jCheckBox55.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox55);

        jCheckBox56.setText("supportsNonNullableColumns");
        jCheckBox56.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox56.setEnabled(false);
        jCheckBox56.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox56);

        jCheckBox57.setText("supportsOpenCursorsAcrossCommit");
        jCheckBox57.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox57.setEnabled(false);
        jCheckBox57.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox57);

        jCheckBox58.setText("supportsOpenCursorsAcrossRollback");
        jCheckBox58.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox58.setEnabled(false);
        jCheckBox58.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox58);

        jCheckBox59.setText("supportsOpenStatementsAcrossCommit");
        jCheckBox59.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox59.setEnabled(false);
        jCheckBox59.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox59);

        jCheckBox60.setText("supportsOpenStatementsAcrossRollback");
        jCheckBox60.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox60.setEnabled(false);
        jCheckBox60.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox60);

        jCheckBox61.setText("supportsOrderByUnrelated");
        jCheckBox61.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox61.setEnabled(false);
        jCheckBox61.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox61);

        jCheckBox62.setText("supportsOuterJoins");
        jCheckBox62.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox62.setEnabled(false);
        jCheckBox62.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox62);

        jCheckBox63.setText("supportsPositionedDelete");
        jCheckBox63.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox63.setEnabled(false);
        jCheckBox63.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox63);

        jCheckBox64.setText("supportsPositionedUpdate");
        jCheckBox64.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox64.setEnabled(false);
        jCheckBox64.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox64);

        jCheckBox65.setText("supportsSavepoints");
        jCheckBox65.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox65.setEnabled(false);
        jCheckBox65.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox65);

        jCheckBox66.setText("supportsSchemasInDataManipulation");
        jCheckBox66.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox66.setEnabled(false);
        jCheckBox66.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox66);

        jCheckBox67.setText("supportsSchemasInIndexDefinitions");
        jCheckBox67.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox67.setEnabled(false);
        jCheckBox67.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox67);

        jCheckBox68.setText("supportsSchemasInPrivilegeDefinitions");
        jCheckBox68.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox68.setEnabled(false);
        jCheckBox68.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox68);

        jCheckBox69.setText("supportsSchemasInProcedureCalls");
        jCheckBox69.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox69.setEnabled(false);
        jCheckBox69.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox69);

        jCheckBox70.setText("supportsSchemasInTableDefinitions");
        jCheckBox70.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox70.setEnabled(false);
        jCheckBox70.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox70);

        jCheckBox71.setText("supportsSelectForUpdate");
        jCheckBox71.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox71.setEnabled(false);
        jCheckBox71.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox71);

        jCheckBox72.setText("supportsStatementPooling");
        jCheckBox72.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox72.setEnabled(false);
        jCheckBox72.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox72.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox72ActionPerformed(evt);
            }
        });
        jPanel1.add(jCheckBox72);

        jCheckBox73.setText("supportsStoredProcedures");
        jCheckBox73.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox73.setEnabled(false);
        jCheckBox73.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox73);

        jCheckBox74.setText("supportsSubqueriesInComparisons");
        jCheckBox74.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox74.setEnabled(false);
        jCheckBox74.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox74);

        jCheckBox75.setText("supportsSubqueriesInExists");
        jCheckBox75.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox75.setEnabled(false);
        jCheckBox75.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox75);

        jCheckBox76.setText("supportsSubqueriesInIns");
        jCheckBox76.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox76.setEnabled(false);
        jCheckBox76.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox76);

        jCheckBox77.setText("supportsSubqueriesInQuantifieds");
        jCheckBox77.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox77.setEnabled(false);
        jCheckBox77.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox77);

        jCheckBox78.setText("supportsTableCorrelationNames");
        jCheckBox78.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox78.setEnabled(false);
        jCheckBox78.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox78);

        jCheckBox79.setText("supportsTransactions");
        jCheckBox79.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox79.setEnabled(false);
        jCheckBox79.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox79);

        jCheckBox80.setText("supportsUnion");
        jCheckBox80.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox80.setEnabled(false);
        jCheckBox80.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox80);

        jCheckBox81.setText("supportsUnionAll");
        jCheckBox81.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox81.setEnabled(false);
        jCheckBox81.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox81);

        jCheckBox82.setText("usesLocalFilePerTable");
        jCheckBox82.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox82.setEnabled(false);
        jCheckBox82.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox82);

        jCheckBox83.setText("usesLocalFiles");
        jCheckBox83.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox83.setEnabled(false);
        jCheckBox83.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel1.add(jCheckBox83);

        jScrollPane1.setViewportView(jPanel1);

        jPanel3.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Support", jPanel3);

        jPanel10.setLayout(new java.awt.BorderLayout());

        jPanel2.setLayout(new javax.swing.BoxLayout(jPanel2, javax.swing.BoxLayout.LINE_AXIS));

        jPanel50.setLayout(new javax.swing.BoxLayout(jPanel50, javax.swing.BoxLayout.Y_AXIS));

        jCheckBox5.setText("allTablesAreSelectable");
        jCheckBox5.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox5.setEnabled(false);
        jCheckBox5.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox5);

        jCheckBox9.setText("isCatalogAtStart");
        jCheckBox9.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox9.setEnabled(false);
        jCheckBox9.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox9);

        jCheckBox6.setText("dataDefinitionCausesTransactionCommit");
        jCheckBox6.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox6.setEnabled(false);
        jCheckBox6.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox6);

        jCheckBox8.setText("doesMaxRowSizeIncludeBlobs");
        jCheckBox8.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox8.setEnabled(false);
        jCheckBox8.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox8);

        jCheckBox10.setText("isReadOnly");
        jCheckBox10.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox10.setEnabled(false);
        jCheckBox10.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox10);

        jCheckBox11.setText("locatorsUpdateCopy");
        jCheckBox11.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox11.setEnabled(false);
        jCheckBox11.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox11);

        jCheckBox7.setText("dataDefinitionIgnoredInTransactions");
        jCheckBox7.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox7.setEnabled(false);
        jCheckBox7.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox7);

        jCheckBox4.setText("allProceduresAreCallable");
        jCheckBox4.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox4.setEnabled(false);
        jCheckBox4.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox4);

        jCheckBox14.setText("nullsAreSortedAtStart");
        jCheckBox14.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox14.setEnabled(false);
        jCheckBox14.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox14);

        jCheckBox15.setText("nullsAreSortedHigh");
        jCheckBox15.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox15.setEnabled(false);
        jCheckBox15.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox15);

        jCheckBox16.setText("nullsAreSortedLow");
        jCheckBox16.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox16.setEnabled(false);
        jCheckBox16.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox16);

        jCheckBox17.setText("storesLowerCaseIdentifiers");
        jCheckBox17.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox17.setEnabled(false);
        jCheckBox17.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox17);

        jCheckBox12.setText("nullPlusNonNullIsNull");
        jCheckBox12.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox12.setEnabled(false);
        jCheckBox12.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox12);

        jCheckBox13.setText("nullsAreSortedAtEnd");
        jCheckBox13.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox13.setEnabled(false);
        jCheckBox13.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox13);

        jCheckBox18.setText("storesMixedCaseIdentifiers");
        jCheckBox18.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox18.setEnabled(false);
        jCheckBox18.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox18);

        jCheckBox19.setText("storesLowerCaseQuotedIdentifiers");
        jCheckBox19.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox19.setEnabled(false);
        jCheckBox19.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox19);

        jCheckBox20.setText("storesUpperCaseIdentifiers");
        jCheckBox20.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox20.setEnabled(false);
        jCheckBox20.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox20);

        jCheckBox21.setText("storesUpperCaseQuotedIdentifiers");
        jCheckBox21.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox21.setEnabled(false);
        jCheckBox21.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jPanel50.add(jCheckBox21);

        jPanel2.add(jPanel50);

        jPanel51.setLayout(new java.awt.GridLayout(20, 2));

        jLabel31.setText("getMaxStatementLength");
        jPanel51.add(jLabel31);

        jTextField25.setText("0");
        jTextField25.setEnabled(false);
        jPanel51.add(jTextField25);

        jLabel33.setText("getMaxTableNameLength");
        jPanel51.add(jLabel33);

        jTextField27.setText("0");
        jTextField27.setEnabled(false);
        jPanel51.add(jTextField27);

        jLabel32.setText("getMaxStatements");
        jPanel51.add(jLabel32);

        jTextField26.setText("0");
        jTextField26.setEnabled(false);
        jPanel51.add(jTextField26);

        jLabel26.setText("getMaxCursorNameLength");
        jPanel51.add(jLabel26);

        jTextField24.setText("0");
        jTextField24.setEnabled(false);
        jPanel51.add(jTextField24);

        jLabel27.setText("getMaxIndexLength");
        jPanel51.add(jLabel27);

        jTextField20.setText("0");
        jTextField20.setEnabled(false);
        jPanel51.add(jTextField20);

        jLabel28.setText("getMaxProcedureNameLength");
        jPanel51.add(jLabel28);

        jTextField21.setText("0");
        jTextField21.setEnabled(false);
        jPanel51.add(jTextField21);

        jLabel29.setText("getMaxRowSize");
        jPanel51.add(jLabel29);

        jTextField22.setText("0");
        jTextField22.setEnabled(false);
        jPanel51.add(jTextField22);

        jLabel30.setText("getMaxSchemaNameLength");
        jPanel51.add(jLabel30);

        jTextField23.setText("0");
        jTextField23.setEnabled(false);
        jPanel51.add(jTextField23);

        jLabel17.setText("getMaxCatalogNameLength");
        jPanel51.add(jLabel17);

        jTextField10.setText("0");
        jTextField10.setEnabled(false);
        jPanel51.add(jTextField10);

        jLabel16.setText("getMaxBinaryLiteralLength");
        jPanel51.add(jLabel16);

        jTextField12.setText("0");
        jTextField12.setEnabled(false);
        jPanel51.add(jTextField12);

        jLabel19.setText("getMaxColumnNameLength");
        jPanel51.add(jLabel19);

        jTextField11.setText("0");
        jTextField11.setEnabled(false);
        jPanel51.add(jTextField11);

        jLabel18.setText("getMaxCharLiteralLength");
        jPanel51.add(jLabel18);

        jTextField14.setText("0");
        jTextField14.setEnabled(false);
        jPanel51.add(jTextField14);

        jLabel20.setText("getMaxColumnsInGroupBy");
        jPanel51.add(jLabel20);

        jTextField13.setText("0");
        jTextField13.setEnabled(false);
        jPanel51.add(jTextField13);

        jLabel21.setText("getMaxColumnsInIndex");
        jPanel51.add(jLabel21);

        jTextField15.setText("0");
        jTextField15.setEnabled(false);
        jPanel51.add(jTextField15);

        jLabel22.setText("getMaxColumnsInOrderBy");
        jPanel51.add(jLabel22);

        jTextField16.setText("0");
        jTextField16.setEnabled(false);
        jPanel51.add(jTextField16);

        jLabel23.setText("getMaxColumnsInSelect");
        jPanel51.add(jLabel23);

        jTextField17.setText("0");
        jTextField17.setEnabled(false);
        jPanel51.add(jTextField17);

        jLabel24.setText("getMaxColumnsInTable");
        jPanel51.add(jLabel24);

        jTextField18.setText("0");
        jTextField18.setEnabled(false);
        jPanel51.add(jTextField18);

        jLabel25.setText("getMaxConnections");
        jPanel51.add(jLabel25);

        jTextField19.setText("0");
        jTextField19.setEnabled(false);
        jPanel51.add(jTextField19);

        jLabel34.setText("getMaxTablesInSelect");
        jPanel51.add(jLabel34);

        jTextField28.setText("0");
        jTextField28.setEnabled(false);
        jPanel51.add(jTextField28);

        jLabel35.setText("getMaxUserNameLength");
        jPanel51.add(jLabel35);

        jTextField29.setText("0");
        jTextField29.setEnabled(false);
        jPanel51.add(jTextField29);

        jPanel2.add(jPanel51);

        jScrollPane17.setViewportView(jPanel2);

        jPanel10.add(jScrollPane17, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Arguments", jPanel10);

        jPanel28.setLayout(new java.awt.BorderLayout());

        jSplitPane13.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel29.setBorder(javax.swing.BorderFactory.createTitledBorder("Colums"));
        jPanel29.setLayout(new java.awt.BorderLayout());

        jTable11.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable11.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane18.setViewportView(jTable11);

        jPanel29.add(jScrollPane18, java.awt.BorderLayout.CENTER);

        jSplitPane13.setTopComponent(jPanel29);

        jSplitPane14.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel30.setBorder(javax.swing.BorderFactory.createTitledBorder("Colums Privileges"));
        jPanel30.setLayout(new java.awt.BorderLayout());

        jTable12.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable12.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane20.setViewportView(jTable12);

        jPanel30.add(jScrollPane20, java.awt.BorderLayout.CENTER);

        jSplitPane14.setTopComponent(jPanel30);

        jSplitPane15.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel31.setBorder(javax.swing.BorderFactory.createTitledBorder("ExportedKeys"));
        jPanel31.setLayout(new java.awt.BorderLayout());

        jTable13.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable13.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane21.setViewportView(jTable13);

        jPanel31.add(jScrollPane21, java.awt.BorderLayout.CENTER);

        jSplitPane15.setTopComponent(jPanel31);

        jPanel32.setBorder(javax.swing.BorderFactory.createTitledBorder("ImportedKeys"));
        jPanel32.setLayout(new java.awt.BorderLayout());

        jTable14.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable14.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane22.setViewportView(jTable14);

        jPanel32.add(jScrollPane22, java.awt.BorderLayout.CENTER);

        jSplitPane15.setRightComponent(jPanel32);

        jSplitPane14.setRightComponent(jSplitPane15);

        jSplitPane13.setRightComponent(jSplitPane14);

        jPanel28.add(jSplitPane13, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Colums", jPanel28);

        jPanel33.setLayout(new java.awt.BorderLayout());

        jSplitPane16.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel34.setBorder(javax.swing.BorderFactory.createTitledBorder("Functions"));
        jPanel34.setLayout(new java.awt.BorderLayout());

        jTable16.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable16.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane24.setViewportView(jTable16);

        jPanel34.add(jScrollPane24, java.awt.BorderLayout.CENTER);

        jSplitPane16.setTopComponent(jPanel34);

        jSplitPane17.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel35.setBorder(javax.swing.BorderFactory.createTitledBorder("FunctionColumns"));
        jPanel35.setLayout(new java.awt.BorderLayout());

        jTable17.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable17.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane25.setViewportView(jTable17);

        jPanel35.add(jScrollPane25, java.awt.BorderLayout.CENTER);

        jSplitPane17.setTopComponent(jPanel35);

        jSplitPane18.setDividerLocation(101);
        jSplitPane18.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel18.setBorder(javax.swing.BorderFactory.createTitledBorder("Super Table"));
        jPanel18.setLayout(new java.awt.BorderLayout());

        jTable7.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable7.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_NEXT_COLUMN);
        jScrollPane13.setViewportView(jTable7);

        jPanel18.add(jScrollPane13, java.awt.BorderLayout.CENTER);

        jSplitPane18.setRightComponent(jPanel18);

        jPanel41.setBorder(javax.swing.BorderFactory.createTitledBorder("Super Type"));
        jPanel41.setLayout(new java.awt.BorderLayout());

        jTable22.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable22.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_NEXT_COLUMN);
        jScrollPane30.setViewportView(jTable22);

        jPanel41.add(jScrollPane30, java.awt.BorderLayout.CENTER);

        jSplitPane18.setLeftComponent(jPanel41);

        jSplitPane17.setRightComponent(jSplitPane18);

        jSplitPane16.setRightComponent(jSplitPane17);

        jPanel33.add(jSplitPane16, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Function", jPanel33);

        jPanel36.setLayout(new java.awt.BorderLayout());

        jSplitPane19.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel17.setBorder(javax.swing.BorderFactory.createTitledBorder("Tables privileges"));
        jPanel17.setLayout(new java.awt.BorderLayout());

        jTable6.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable6.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane12.setViewportView(jTable6);

        jPanel17.add(jScrollPane12, java.awt.BorderLayout.CENTER);

        jSplitPane19.setTopComponent(jPanel17);

        jSplitPane20.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);

        jPanel43.setBorder(javax.swing.BorderFactory.createTitledBorder("ClientInfoProperties()"));
        jPanel43.setLayout(new java.awt.BorderLayout());

        jTable24.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable24.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane32.setViewportView(jTable24);

        jPanel43.add(jScrollPane32, java.awt.BorderLayout.CENTER);

        jSplitPane20.setLeftComponent(jPanel43);

        jPanel42.setBorder(javax.swing.BorderFactory.createTitledBorder("Attributs"));
        jPanel42.setLayout(new java.awt.BorderLayout());

        jTable23.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "N/A"
            }
        ));
        jTable23.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jScrollPane31.setViewportView(jTable23);

        jPanel42.add(jScrollPane31, java.awt.BorderLayout.CENTER);

        jSplitPane20.setRightComponent(jPanel42);

        jSplitPane19.setRightComponent(jSplitPane20);

        jPanel36.add(jSplitPane19, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Definition II", jPanel36);

        jPanel27.setLayout(new java.awt.BorderLayout());

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane2.setViewportView(jTextArea1);

        jPanel27.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jPanel25.setLayout(new javax.swing.BoxLayout(jPanel25, javax.swing.BoxLayout.LINE_AXIS));

        jButton4.setText("clearWarning");
        jButton4.setFocusable(false);
        jButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton4.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jPanel25.add(jButton4);

        jButton5.setText("update Warning");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jPanel25.add(jButton5);

        jPanel27.add(jPanel25, java.awt.BorderLayout.NORTH);

        jTabbedPane1.addTab("Logs", jPanel27);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        if (CX == null) {
            return;
        }
        F_DBEditTable a = new F_DBEditTable(this, CX);
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void jScrollPane11MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jScrollPane11MouseClicked
    }//GEN-LAST:event_jScrollPane11MouseClicked

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        dropTable();
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jTable5MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable5MouseReleased
        if (evt.getClickCount() == 2) {
            showTable();
            return;
        }

        int idx = jTable5.getSelectedRow();
        if (idx != -1) {
            setTableSelection(jTable5.getValueAt(idx, 2).toString());
        }
    }//GEN-LAST:event_jTable5MouseReleased

    private void jTable3MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable3MouseReleased
        this.getTables();
    }//GEN-LAST:event_jTable3MouseReleased

    private void jTable1MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable1MouseReleased
        this.getTables();
    }//GEN-LAST:event_jTable1MouseReleased

    private void jCheckBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox3ActionPerformed
        try {
            CX.setReadOnly(jCheckBox1.isSelected());
        } catch (SQLException ex) {
            TDeb.wri("Pb setting read only [" + ex.getMessage() + "]");
        }
    }//GEN-LAST:event_jCheckBox3ActionPerformed

    private void jCheckBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
        setautocommit(isautocommit());

    }//GEN-LAST:event_jCheckBox1ActionPerformed

    private void jTextField1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField1ActionPerformed
    }//GEN-LAST:event_jTextField1ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        rollback();
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        commit();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed

        showTable();

    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jTable2MouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable2MouseReleased
        getTables();
    }//GEN-LAST:event_jTable2MouseReleased

    private void jCheckBox72ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox72ActionPerformed
    }//GEN-LAST:event_jCheckBox72ActionPerformed

private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
    try {
        CX.clearWarnings();
    } catch (SQLException ex) {
    }
}//GEN-LAST:event_jButton4ActionPerformed

private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
    updateWarnings();
}//GEN-LAST:event_jButton5ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox10;
    private javax.swing.JCheckBox jCheckBox11;
    private javax.swing.JCheckBox jCheckBox12;
    private javax.swing.JCheckBox jCheckBox13;
    private javax.swing.JCheckBox jCheckBox14;
    private javax.swing.JCheckBox jCheckBox15;
    private javax.swing.JCheckBox jCheckBox16;
    private javax.swing.JCheckBox jCheckBox17;
    private javax.swing.JCheckBox jCheckBox18;
    private javax.swing.JCheckBox jCheckBox19;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox20;
    private javax.swing.JCheckBox jCheckBox21;
    private javax.swing.JCheckBox jCheckBox22;
    private javax.swing.JCheckBox jCheckBox23;
    private javax.swing.JCheckBox jCheckBox24;
    private javax.swing.JCheckBox jCheckBox25;
    private javax.swing.JCheckBox jCheckBox26;
    private javax.swing.JCheckBox jCheckBox27;
    private javax.swing.JCheckBox jCheckBox28;
    private javax.swing.JCheckBox jCheckBox29;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox30;
    private javax.swing.JCheckBox jCheckBox31;
    private javax.swing.JCheckBox jCheckBox32;
    private javax.swing.JCheckBox jCheckBox33;
    private javax.swing.JCheckBox jCheckBox34;
    private javax.swing.JCheckBox jCheckBox35;
    private javax.swing.JCheckBox jCheckBox36;
    private javax.swing.JCheckBox jCheckBox37;
    private javax.swing.JCheckBox jCheckBox38;
    private javax.swing.JCheckBox jCheckBox39;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox40;
    private javax.swing.JCheckBox jCheckBox41;
    private javax.swing.JCheckBox jCheckBox42;
    private javax.swing.JCheckBox jCheckBox43;
    private javax.swing.JCheckBox jCheckBox44;
    private javax.swing.JCheckBox jCheckBox45;
    private javax.swing.JCheckBox jCheckBox46;
    private javax.swing.JCheckBox jCheckBox47;
    private javax.swing.JCheckBox jCheckBox48;
    private javax.swing.JCheckBox jCheckBox49;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JCheckBox jCheckBox50;
    private javax.swing.JCheckBox jCheckBox51;
    private javax.swing.JCheckBox jCheckBox52;
    private javax.swing.JCheckBox jCheckBox53;
    private javax.swing.JCheckBox jCheckBox54;
    private javax.swing.JCheckBox jCheckBox55;
    private javax.swing.JCheckBox jCheckBox56;
    private javax.swing.JCheckBox jCheckBox57;
    private javax.swing.JCheckBox jCheckBox58;
    private javax.swing.JCheckBox jCheckBox59;
    private javax.swing.JCheckBox jCheckBox6;
    private javax.swing.JCheckBox jCheckBox60;
    private javax.swing.JCheckBox jCheckBox61;
    private javax.swing.JCheckBox jCheckBox62;
    private javax.swing.JCheckBox jCheckBox63;
    private javax.swing.JCheckBox jCheckBox64;
    private javax.swing.JCheckBox jCheckBox65;
    private javax.swing.JCheckBox jCheckBox66;
    private javax.swing.JCheckBox jCheckBox67;
    private javax.swing.JCheckBox jCheckBox68;
    private javax.swing.JCheckBox jCheckBox69;
    private javax.swing.JCheckBox jCheckBox7;
    private javax.swing.JCheckBox jCheckBox70;
    private javax.swing.JCheckBox jCheckBox71;
    private javax.swing.JCheckBox jCheckBox72;
    private javax.swing.JCheckBox jCheckBox73;
    private javax.swing.JCheckBox jCheckBox74;
    private javax.swing.JCheckBox jCheckBox75;
    private javax.swing.JCheckBox jCheckBox76;
    private javax.swing.JCheckBox jCheckBox77;
    private javax.swing.JCheckBox jCheckBox78;
    private javax.swing.JCheckBox jCheckBox79;
    private javax.swing.JCheckBox jCheckBox8;
    private javax.swing.JCheckBox jCheckBox80;
    private javax.swing.JCheckBox jCheckBox81;
    private javax.swing.JCheckBox jCheckBox82;
    private javax.swing.JCheckBox jCheckBox83;
    private javax.swing.JCheckBox jCheckBox9;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel43;
    private javax.swing.JLabel jLabel44;
    private javax.swing.JLabel jLabel45;
    private javax.swing.JLabel jLabel46;
    private javax.swing.JLabel jLabel47;
    private javax.swing.JLabel jLabel48;
    private javax.swing.JLabel jLabel49;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel50;
    private javax.swing.JLabel jLabel51;
    private javax.swing.JLabel jLabel56;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel19;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel20;
    private javax.swing.JPanel jPanel21;
    private javax.swing.JPanel jPanel22;
    private javax.swing.JPanel jPanel23;
    private javax.swing.JPanel jPanel24;
    private javax.swing.JPanel jPanel25;
    private javax.swing.JPanel jPanel26;
    private javax.swing.JPanel jPanel27;
    private javax.swing.JPanel jPanel28;
    private javax.swing.JPanel jPanel29;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel30;
    private javax.swing.JPanel jPanel31;
    private javax.swing.JPanel jPanel32;
    private javax.swing.JPanel jPanel33;
    private javax.swing.JPanel jPanel34;
    private javax.swing.JPanel jPanel35;
    private javax.swing.JPanel jPanel36;
    private javax.swing.JPanel jPanel37;
    private javax.swing.JPanel jPanel38;
    private javax.swing.JPanel jPanel39;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel41;
    private javax.swing.JPanel jPanel42;
    private javax.swing.JPanel jPanel43;
    private javax.swing.JPanel jPanel44;
    private javax.swing.JPanel jPanel45;
    private javax.swing.JPanel jPanel46;
    private javax.swing.JPanel jPanel47;
    private javax.swing.JPanel jPanel48;
    private javax.swing.JPanel jPanel49;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel50;
    private javax.swing.JPanel jPanel51;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane10;
    private javax.swing.JScrollPane jScrollPane11;
    private javax.swing.JScrollPane jScrollPane12;
    private javax.swing.JScrollPane jScrollPane13;
    private javax.swing.JScrollPane jScrollPane14;
    private javax.swing.JScrollPane jScrollPane15;
    private javax.swing.JScrollPane jScrollPane16;
    private javax.swing.JScrollPane jScrollPane17;
    private javax.swing.JScrollPane jScrollPane18;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane20;
    private javax.swing.JScrollPane jScrollPane21;
    private javax.swing.JScrollPane jScrollPane22;
    private javax.swing.JScrollPane jScrollPane23;
    private javax.swing.JScrollPane jScrollPane24;
    private javax.swing.JScrollPane jScrollPane25;
    private javax.swing.JScrollPane jScrollPane26;
    private javax.swing.JScrollPane jScrollPane27;
    private javax.swing.JScrollPane jScrollPane28;
    private javax.swing.JScrollPane jScrollPane29;
    private javax.swing.JScrollPane jScrollPane30;
    private javax.swing.JScrollPane jScrollPane31;
    private javax.swing.JScrollPane jScrollPane32;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JScrollPane jScrollPane9;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JSplitPane jSplitPane13;
    private javax.swing.JSplitPane jSplitPane14;
    private javax.swing.JSplitPane jSplitPane15;
    private javax.swing.JSplitPane jSplitPane16;
    private javax.swing.JSplitPane jSplitPane17;
    private javax.swing.JSplitPane jSplitPane18;
    private javax.swing.JSplitPane jSplitPane19;
    private javax.swing.JSplitPane jSplitPane2;
    private javax.swing.JSplitPane jSplitPane20;
    private javax.swing.JSplitPane jSplitPane3;
    private javax.swing.JSplitPane jSplitPane4;
    private javax.swing.JSplitPane jSplitPane5;
    private javax.swing.JSplitPane jSplitPane6;
    private javax.swing.JSplitPane jSplitPane7;
    private javax.swing.JSplitPane jSplitPane8;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable10;
    private javax.swing.JTable jTable11;
    private javax.swing.JTable jTable12;
    private javax.swing.JTable jTable13;
    private javax.swing.JTable jTable14;
    private javax.swing.JTable jTable15;
    private javax.swing.JTable jTable16;
    private javax.swing.JTable jTable17;
    private javax.swing.JTable jTable18;
    private javax.swing.JTable jTable19;
    private javax.swing.JTable jTable2;
    private javax.swing.JTable jTable20;
    private javax.swing.JTable jTable21;
    private javax.swing.JTable jTable22;
    private javax.swing.JTable jTable23;
    private javax.swing.JTable jTable24;
    private javax.swing.JTable jTable3;
    private javax.swing.JTable jTable4;
    private javax.swing.JTable jTable5;
    private javax.swing.JTable jTable6;
    private javax.swing.JTable jTable7;
    private javax.swing.JTable jTable8;
    private javax.swing.JTable jTable9;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField10;
    private javax.swing.JTextField jTextField11;
    private javax.swing.JTextField jTextField12;
    private javax.swing.JTextField jTextField13;
    private javax.swing.JTextField jTextField14;
    private javax.swing.JTextField jTextField15;
    private javax.swing.JTextField jTextField16;
    private javax.swing.JTextField jTextField17;
    private javax.swing.JTextField jTextField18;
    private javax.swing.JTextField jTextField19;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField20;
    private javax.swing.JTextField jTextField21;
    private javax.swing.JTextField jTextField22;
    private javax.swing.JTextField jTextField23;
    private javax.swing.JTextField jTextField24;
    private javax.swing.JTextField jTextField25;
    private javax.swing.JTextField jTextField26;
    private javax.swing.JTextField jTextField27;
    private javax.swing.JTextField jTextField28;
    private javax.swing.JTextField jTextField29;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField30;
    private javax.swing.JTextField jTextField31;
    private javax.swing.JTextField jTextField32;
    private javax.swing.JTextField jTextField33;
    private javax.swing.JTextField jTextField34;
    private javax.swing.JTextField jTextField35;
    private javax.swing.JTextField jTextField36;
    private javax.swing.JTextField jTextField37;
    private javax.swing.JTextField jTextField38;
    private javax.swing.JTextField jTextField39;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField40;
    private javax.swing.JTextField jTextField41;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    private javax.swing.JTextField jTextField8;
    private javax.swing.JTextField jTextField9;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables
}
