package com.jdcm.eltrx;

import com.jdcm.common.C_Packet;

/**
 * I_Main.java Created on 29 nov. 2007, 22:06:59
 * 
 * interface of MAIN to plug in ports on others...
 * 
 * @author Marc GIBOIN
 */
public interface I_Main {

    public void Arcv(Object index, Object message, String msgtype);

    //to send log from matrix
    public void addMatStat(C_Packet pack);

    public void addpacket(String pack, long time, String pos, String type);
    // read & write data from/to matrix

    public void read(C_Packet d);

    public void read(java.util.List<C_Packet> packets);

    public void write(C_Packet d);

    // for updates
    public I_Port addCX(C_Port listner, String type);

    public java.util.List<I_Port> getPorts();

    public void addTab(javax.swing.JPanel p, String title, javax.swing.Icon i);

    public void removeTab(javax.swing.JPanel p);

    public java.util.List<java.lang.reflect.Method> getmethodes(I_Command com);
    //public java.util.List<Object[]> getobjects(I_Command com) ;

    public void CXremove(I_Port port);

    public boolean isConsoleOut();

    public boolean isConsoleErr();

    public void setConsoleOut(boolean bool);

    public void setConsoleErr(boolean bool);


    // command commanded object
    //for all exept shell

    public Object command(Object dest, String function, String value) throws java.lang.Exception;
    //for shell

    public Object command(Object dest, java.lang.reflect.Method methode, Object value) throws java.lang.Exception;
    
    public boolean isConf_Enabled();
    public void setConf_Enabled(boolean bool);

    public void setShell(boolean bool, String type);

    public boolean isShell();
//    public javax.swing.JFrame getframe();
}
