package com.jdcm.modifiers.matrix;

import com.jdcm.eltrx.T_Matrice;


/**
 * This FREE matrix allow to route elemmant according a Editable array
 * 
 * @author  M.Marc GIBOIN
 */
public class mat_FREE extends mat_base {

    public mat_FREE(T_Matrice p) {
        Parent = p;
    }

    public static String getComment() {
        return "Free matrix";
    }
    public static javax.swing.Icon getIcon(){
       return (new com.jdcm.common.D_Utils()).getIcon("mat_free.gif");
    }
    @Override
    public void mx_init() {
        // in fact do ... NOTHING!!!keep previous values

    }

    @Override
    public void setConnection(int src, int dest, boolean bool) {
         Parent.getmodel().setValueAt(bool, src, dest + 1);
    }


    @Override
    public int getRowCount(boolean[][] boolArray) {
        return boolArray.length;
    }

    @Override
    public void update(boolean[][] oldBools, boolean[][] newBools) {
        if (newBools != null) {
            for (int i = 0; i < Math.min(oldBools.length, newBools.length); i++) {
                       System.arraycopy(oldBools[i], 0, newBools[i], 0, Math.min(oldBools.length, newBools.length));
            }
            Parent.setmodelbools(newBools);
        }else{
           for (int i = 0; i <Parent.getmodel().getRowCount(); i++) {
               //don't forget the "title" left column (table reCode...)
            Parent.getmodel().setValueAt(Parent.isMat_Echo(), i, i+1) ;
            }
        }
        mx_init();
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        return null;
    }

    @Override
    public void setValueAt(Object value, int aRow, int aColumn) {
    }

    @Override
    public boolean isCellEditable(int row, int column) {
          /* if (row == column - 1 && (Parent.ismat_echo())) {
                return false;
            }*/
           if (Parent.getmodel().getValueAt(row, column) instanceof Boolean ==false){
               return false;
           }
            return !Parent.isMat_Bidir() || column - 1 >= row;
    }
}
