package com.jdcm.modifiers.matrix;

import com.jdcm.eltrx.T_Matrice;

/**
 *  This RING matrix route all data a port to next one,and last to first.
 * 
 * @author  M.Marc GIBOIN
 */
public class mat_RING extends mat_base {


    public mat_RING(T_Matrice p) {
        Parent = p;
    }

    public static String getComment() {
        return "Full matrix";
    }
    public static javax.swing.Icon getIcon(){
       return (new com.jdcm.common.D_Utils()).getIcon("mat_ring.gif");
    }
    @Override
    public void mx_init() {
        for (int i = 0; i < Parent.getPorts().size(); i++) {
            for (int j = 0; j < Parent.getPorts().size(); j++) {
                  if (i == j) {
                    Parent.getmodel().setValueAt(Parent.isMat_Echo(), i, j + 1);
                }else        if (i == j + 1
                        || j == i + 1
                        || (i == Parent.getPorts().size() - 1 && j == 0)
                        || (j == Parent.getPorts().size() - 1 && i == 0)) {
                    Parent.getmodel().setValueAt(true, i, j + 1);
                //    TDeb.wri("mx_initring(): i/j:" + i + "/" + j + "true");
                } else {
                    Parent.getmodel().setValueAt(false, i, j + 1);
                 //   TDeb.wri("mx_initring(): i/j:" + i + "/" + j + "false");
                }
            }
        }
    }

    @Override
    public void setConnection(int src, int dest, boolean bool) {
        // no connexion to set, matrix is  full
    }

    @Override
    public int getRowCount(boolean[][] boolArray) {
        return boolArray.length;
    }

    @Override
    public void update(boolean[][] oldBools, boolean[][] newBools) {
        if (newBools != null) {
            Parent.setmodelbools(newBools);
        }
        mx_init();
    }

    @Override
    public Object getValueAt(int aRow, int aColumn) {
        return null;
    }

    @Override
    public void setValueAt(Object value, int aRow, int aColumn) {
    }

    @Override
    public boolean isCellEditable(int row, int column) {
        return false;
    }
}
