package com.jdcm.modifiers.stacks;
import com.jdcm.common.C_Packet;
/**
 *Default Stack element do nothing (used for descriptor enable?!)
 * 
 * @author Marc Giboin
 */
public class Stack_0NULL extends Stack_base{

    public Stack_0NULL(){
        super();
    }

    public static String getComment() {
        return "undecoded frame protocol";
    }


    public static double getosi() {
        return 0.0;
    }
        /**
     * decapsule packet, check header and provide payload
     *
     * @param packet
     * @return the payload
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> receive(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
         liste.add(packet);
        return liste;
    }
        /**
     * encapsule payload in header to form packet
     *
     * @param packet
     * @return the packet
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> transmit(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        liste.add(packet);
         return liste;
    }
}
