package com.jdcm.modifiers.stacks;
import com.jdcm.common.C_Packet;
/**
 *Default Stack element do nothing (used for descriptor enable?!)
 * 
 * @author Marc Giboin
 */
public class Stack_ZCB2A_Auto extends Stack_base{

    public Stack_ZCB2A_Auto(){
        super();
    }

    public static String getComment() {
        return "CB2A Autorisation";
    }


    public static double getosi() {
        return 8.0;
    }
        /**
     * decapsule packet, check header and provide payload
     *
     * @param packet
     * @return the payload
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> receive(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        // liste.add(packet);
        return liste;
    }
        /**
     * encapsule payload in header to form packet
     *
     * @param packet
     * @return the packet
     * @throws java.lang.Exception
     */
    @Override
    public java.util.List<C_Packet> transmit(C_Packet packet) throws Exception {
        java.util.List<C_Packet> liste = new java.util.ArrayList<>();
        //liste.add(packet);
         return liste;
    }
     @Override
    public double matchProtocol(C_Packet pack) {
        double res = 0.0;
        if (pack.isbuffer() && pack.getProtocols()!=null) {
            boolean isCB2A=false;
            if(pack.getProtocols().isEmpty()==false){
                if (pack.getProtocols().get(pack.getProtocols().size()-1) instanceof Stack_ZCB2A){
                    isCB2A=true;
                }
            }
                if (pack.getBytes().length > 12)  {//message type are 01:00&110 && 200 &210
                    if (isCB2A) {
                    res = 0.90;
                    }
                }

        }
        return res;
    }
}
